/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(X){for(var e=[],R=0,r=X.length;R<r;R++)e[R]=ne[X[R]];return e};define(ne[110],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function R(k,T){if(!k)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=R;function r(k,T="Unreachable"){throw new Error(T)}e.assertNever=r}),define(ne[50],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(b,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=R;class r{constructor(b,P,I){this.id=b,this.definition=P,this.description=I,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function k(A,b){const P=["codicon","codicon-"+A];return b&&P.push("codicon-modifier-"+b),P}e.getClassNamesArray=k;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(w){if(w instanceof r)return["codicon","codicon-"+w.id];const p=b.exec(w.id);if(!p)return P(r.error);const[,y,d]=p,S=["codicon","codicon-"+y];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=P;function I(w){return P(w).join(" ")}A.asClassName=I;function E(w){return"."+P(w).join(".")}A.asCSSSelector=E})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[60],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(b,P,I)=>{let E=null,w=null;if(typeof I.value=="function"?(E="value",w=I.value):typeof I.get=="function"&&(E="get",w=I.get),!w)throw new Error("not supported");I[E]=A(w,P)}}e.createDecorator=R;function r(A,b,P){let I=null,E=null;if(typeof P.value=="function"?(I="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(I="get",E=P.get),!E)throw new Error("not supported");const w=`$memoize$${b}`;P[I]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,p)}),this[w]}}e.memoize=r;function k(A,b,P){return R((I,E)=>{const w=`$debounce$${E}`,p=`$debounce$result$${E}`;return function(...y){this[p]||(this[p]=P?P():void 0),clearTimeout(this[w]),b&&(this[p]=b(this[p],...y),y=[this[p]]),this[w]=setTimeout(()=>{I.apply(this,y),this[p]=P?P():void 0},A)}})}e.debounce=k;function T(A,b,P){return R((I,E)=>{const w=`$throttle$timer$${E}`,p=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...S){if(this[p]||(this[p]=P?P():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...S)),this[d])return;const C=this[y]+A;C<=Date.now()?(this[y]=Date.now(),I.apply(this,[this[p]]),this[p]=P?P():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),I.apply(this,[this[p]]),this[p]=P?P():void 0},C-Date.now()))}})}e.throttle=T}),define(ne[10],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=R,e.errorHandler=new R;function r(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=r;function k(c){P(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function T(c){P(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function A(c){if(c instanceof Error){const{name:n,message:s}=c,t=c.stacktrace||c.stack;return{$isError:!0,name:n,message:s,stack:t,noTelemetry:l.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=A;const b="Canceled";function P(c){return c instanceof I?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=P;class I extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=I;function E(){const c=new Error(b);return c.name=c.message,c}e.canceled=E;function w(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=w;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=p;function y(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function S(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=S;class C extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=C;class m extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=m;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const s=new l;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=l;class f extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],se([0,1,10]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(Q,ie=0){return Q[Q.length-(1+ie)]}e.tail=r;function k(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.tail2=k;function T(Q,ie,re=(ue,he)=>ue===he){if(Q===ie)return!0;if(!Q||!ie||Q.length!==ie.length)return!1;for(let ue=0,he=Q.length;ue<he;ue++)if(!re(Q[ue],ie[ue]))return!1;return!0}e.equals=T;function A(Q,ie){const re=Q.length-1;ie<re&&(Q[ie]=Q[re]),Q.pop()}e.removeFastWithoutKeepingOrder=A;function b(Q,ie,re){return P(Q.length,ue=>re(Q[ue],ie))}e.binarySearch=b;function P(Q,ie){let re=0,ue=Q-1;for(;re<=ue;){const he=(re+ue)/2|0,ve=ie(he);if(ve<0)re=he+1;else if(ve>0)ue=he-1;else return he}return-(re+1)}e.binarySearch2=P;function I(Q,ie){let re=0,ue=Q.length;if(ue===0)return 0;for(;re<ue;){const he=Math.floor((re+ue)/2);ie(Q[he])?ue=he:re=he+1}return re}e.findFirstInSorted=I;function E(Q,ie,re){if(Q=Q|0,Q>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=re(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return Q<he.length?E(Q,he,re):Q<he.length+we.length?we[0]:E(Q-(he.length+we.length),ve,re)}e.quickSelect=E;function w(Q,ie){const re=[];let ue;for(const he of Q.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],re.push(ue)):ue.push(he);return re}e.groupBy=w;function p(Q,ie,re){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const ze=ue[ue.length-1];ze&&ze.start+ze.deleteCount===Ee?(ze.deleteCount+=Pe,ze.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===Q.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,Q.length-ve,[]);break}const Ee=Q[ve],Pe=ie[we],Ue=re(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=p;function y(Q,ie,re){const ue=p(Q,ie,re),he=[],ve=[];for(const we of ue)he.push(...Q.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=y;function d(Q,ie,re){if(re===0)return[];const ue=Q.slice(0,re).sort(ie);return C(Q,ie,ue,re,Q.length),ue}e.top=d;function S(Q,ie,re,ue,he){return re===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Q.length,Pe=Q.slice(0,re).sort(ie);for(let Ue=re,ze=Math.min(re+ue,Ee);Ue<Ee;Ue=ze,ze=Math.min(ze+ue,Ee)){if(Ue>re&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new R.CancellationError;C(Q,ie,Pe,Ue,ze)}return Pe})().then(ve,we)})}e.topAsync=S;function C(Q,ie,re,ue,he){for(const ve=re.length;ue<he;ue++){const we=Q[ue];if(ie(we,re[ve-1])<0){re.pop();const Ee=I(re,Pe=>ie(we,Pe)<0);re.splice(Ee,0,we)}}}function m(Q){return Q.filter(ie=>!!ie)}e.coalesce=m;function g(Q){let ie=0;for(let re=0;re<Q.length;re++)Q[re]&&(Q[ie]=Q[re],ie+=1);Q.length=ie}e.coalesceInPlace=g;function l(Q,ie,re){Q.splice(re,0,Q.splice(ie,1)[0])}e.move=l;function f(Q){return!Array.isArray(Q)||Q.length===0}e.isFalsyOrEmpty=f;function c(Q){return Array.isArray(Q)&&Q.length>0}e.isNonEmptyArray=c;function n(Q,ie=re=>re){const re=new Set;return Q.filter(ue=>{const he=ie(ue);return re.has(he)?!1:(re.add(he),!0)})}e.distinct=n;function s(Q){const ie=new Set;return re=>{const ue=Q(re);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function t(Q,ie){const re=i(Q,ie);if(re!==-1)return Q[re]}e.findLast=t;function i(Q,ie){for(let re=Q.length-1;re>=0;re--){const ue=Q[re];if(ie(ue))return re}return-1}e.lastIndex=i;function o(Q,ie){return Q.length>0?Q[0]:ie}e.firstOrDefault=o;function u(Q,ie){return Q.length>0?Q[Q.length-1]:ie}e.lastOrDefault=u;function a(Q,ie,re=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(Q.length,ie.length);he<ve&&re(Q[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=a;function h(Q){return[].concat(...Q)}e.flatten=h;function v(Q,ie){let re=typeof ie=="number"?Q:0;typeof ie=="number"?re=Q:(re=0,ie=Q);const ue=[];if(re<=ie)for(let he=re;he<ie;he++)ue.push(he);else for(let he=re;he>ie;he--)ue.push(he);return ue}e.range=v;function D(Q,ie,re){return Q.reduce((ue,he)=>(ue[ie(he)]=re?re(he):he,ue),Object.create(null))}e.index=D;function M(Q,ie){return Q.push(ie),()=>F(Q,ie)}e.insert=M;function F(Q,ie){const re=Q.indexOf(ie);if(re>-1)return Q.splice(re,1),ie}e.remove=F;function O(Q,ie,re){const ue=Q.slice(0,ie),he=Q.slice(ie);return ue.concat(re,he)}e.arrayInsert=O;function L(Q,ie){let re;if(typeof ie=="number"){let ue=ie;re=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else re=Math.random;for(let ue=Q.length-1;ue>0;ue-=1){const he=Math.floor(re()*(ue+1)),ve=Q[ue];Q[ue]=Q[he],Q[he]=ve}}e.shuffle=L;function N(Q,ie){const re=Q.indexOf(ie);re>-1&&(Q.splice(re,1),Q.unshift(ie))}e.pushToStart=N;function $(Q,ie){const re=Q.indexOf(ie);re>-1&&(Q.splice(re,1),Q.push(ie))}e.pushToEnd=$;function V(Q,ie){for(const re of ie)Q.push(re)}e.pushMany=V;function J(Q,ie){return Array.isArray(Q)?Q.map(ie):ie(Q)}e.mapArrayOrNot=J;function H(Q){return Array.isArray(Q)?Q:[Q]}e.asArray=H;function G(Q){return Q[Math.floor(Math.random()*Q.length)]}e.getRandomElement=G;function q(Q,ie){for(const re of Q){const ue=ie(re);if(ue!==void 0)return ue}}e.mapFind=q;function x(Q,ie,re){const ue=te(Q,ie),he=Q.length,ve=re.length;Q.length=he+ve;for(let we=he-1;we>=ue;we--)Q[we+ve]=Q[we];for(let we=0;we<ve;we++)Q[we+ue]=re[we]}e.insertInto=x;function Y(Q,ie,re,ue){const he=te(Q,ie),ve=Q.splice(he,re);return x(Q,he,ue),ve}e.splice=Y;function te(Q,ie){return ie<0?Math.max(ie+Q.length,0):Math.min(ie,Q.length)}var ce;(function(Q){function ie(he){return he<0}Q.isLessThan=ie;function re(he){return he>0}Q.isGreaterThan=re;function ue(he){return he===0}Q.isNeitherLessOrGreaterThan=ue,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(Q,ie){return(re,ue)=>ie(Q(re),Q(ue))}e.compareBy=z;function B(...Q){return(ie,re)=>{for(const ue of Q){const he=ue(ie,re);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=B;const _=(Q,ie)=>Q-ie;e.numberComparator=_;function U(Q,ie){if(Q.length===0)return;let re=Q[0];for(let ue=1;ue<Q.length;ue++){const he=Q[ue];ie(he,re)>0&&(re=he)}return re}e.findMaxBy=U;function W(Q,ie){if(Q.length===0)return;let re=Q[0];for(let ue=1;ue<Q.length;ue++){const he=Q[ue];ie(he,re)>=0&&(re=he)}return re}e.findLastMaxBy=W;function j(Q,ie){return U(Q,(re,ue)=>-ie(re,ue))}e.findMinBy=j;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let re=this.firstIdx;for(;re<this.items.length&&ie(this.items[re]);)re++;const ue=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,ue}takeFromEndWhile(ie){let re=this.lastIdx;for(;re>=0&&ie(this.items[re]);)re--;const ue=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const re=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,re}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(re=>(ie(re),!0))}toArray(){const ie=[];return this.iterate(re=>(ie.push(re),!0)),ie}filter(ie){return new oe(re=>this.iterate(ue=>ie(ue)?re(ue):!0))}map(ie){return new oe(re=>this.iterate(ue=>re(ie(ue))))}some(ie){let re=!1;return this.iterate(ue=>(re=ie(ue),!re)),re}findFirst(ie){let re;return this.iterate(ue=>ie(ue)?(re=ue,!1):!0),re}findLast(ie){let re;return this.iterate(ue=>(ie(ue)&&(re=ue),!0)),re}findLastMaxBy(ie){let re,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,re)))&&(ue=!1,re=he),!0)),re}}e.CallbackIterable=oe,oe.empty=new oe(Q=>{})}),define(ne[74],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(r){const k=this;let T=!1,A;return function(){return T||(T=!0,A=r.apply(k,arguments)),A}}e.once=R}),define(ne[51],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(r){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}r.is=k;const T=Object.freeze([]);function A(){return T}r.empty=A;function*b(s){yield s}r.single=b;function P(s){return s||T}r.from=P;function I(s){return!s||s[Symbol.iterator]().next().done===!0}r.isEmpty=I;function E(s){return s[Symbol.iterator]().next().value}r.first=E;function w(s,t){for(const i of s)if(t(i))return!0;return!1}r.some=w;function p(s,t){for(const i of s)if(t(i))return i}r.find=p;function*y(s,t){for(const i of s)t(i)&&(yield i)}r.filter=y;function*d(s,t){let i=0;for(const o of s)yield t(o,i++)}r.map=d;function*S(...s){for(const t of s)for(const i of t)yield i}r.concat=S;function*C(s){for(const t of s)for(const i of t)yield i}r.concatNested=C;function m(s,t,i){let o=i;for(const u of s)o=t(o,u);return o}r.reduce=m;function g(s,t){let i=0;for(const o of s)t(o,i++)}r.forEach=g;function*l(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}r.slice=l;function f(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const o=s[Symbol.iterator]();for(let u=0;u<t;u++){const a=o.next();if(a.done)return[i,r.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return o}}]}r.consume=f;function c(s){return f(s)[0]}r.collect=c;function n(s,t,i=(o,u)=>o===u){const o=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const a=o.next(),h=u.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!i(a.value,h.value))return!1}}r.equals=n})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var r;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(n,s=!1){let t=0;const i=n.length;let o="",u=0,a=16,h=0;function v($){let V=0,J=0;for(;V<$;){const H=n.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,V++}return V<$&&(J=-1),J}function D($){t=$,o="",u=0,a=16,h=0}function M(){const $=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&I(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&I(n.charCodeAt(t)))for(t++;t<n.length&&I(n.charCodeAt(t));)t++;else return h=3,n.substring($,t);let V=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&I(n.charCodeAt(t))){for(t++;t<n.length&&I(n.charCodeAt(t));)t++;V=t}else h=3;return n.substring($,V)}function F(){let $="",V=t;for(;;){if(t>=i){$+=n.substring(V,t),h=2;break}const J=n.charCodeAt(t);if(J===34){$+=n.substring(V,t),t++;break}if(J===92){if($+=n.substring(V,t),t++,t>=i){h=2;break}switch(n.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const G=v(4);G>=0?$+=String.fromCharCode(G):h=4;break}default:h=5}V=t;continue}if(J>=0&&J<=31)if(P(J)){$+=n.substring(V,t),h=2;break}else h=6;t++}return $}function O(){if(o="",h=0,u=t,t>=i)return u=i,a=17;let $=n.charCodeAt(t);if(b($)){do t++,o+=String.fromCharCode($),$=n.charCodeAt(t);while(b($));return a=15}if(P($))return t++,o+=String.fromCharCode($),$===13&&n.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch($){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=F(),a=10;case 47:{const V=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!P(n.charCodeAt(t));)t++;return o=n.substring(V,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const J=i-1;let H=!1;for(;t<J;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,h=1),o=n.substring(V,t),a=13}return o+=String.fromCharCode($),t++,a=16}case 45:if(o+=String.fromCharCode($),t++,t===i||!I(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),a=11;default:for(;t<i&&L($);)t++,$=n.charCodeAt(t);if(u!==t){switch(o=n.substring(u,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode($),t++,a=16}}function L($){if(b($)||P($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=O();while($>=12&&$<=15);return $}return{setPosition:D,getPosition:()=>t,scan:s?N:O,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>h}}e.createScanner=A;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function I(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function w(n,s){const t=[],i=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(v,D,M,F){u.value=v,u.offset=D,u.length=M,u.type=F,u.colonOffset=void 0,o=u}try{l(n,{onObjectBegin:(v,D)=>{if(s<=v)throw i;o=void 0,a=s>v,t.push("")},onObjectProperty:(v,D,M)=>{if(s<D||(h(v,D,M,"property"),t[t.length-1]=v,s<=D+M))throw i},onObjectEnd:(v,D)=>{if(s<=v)throw i;o=void 0,t.pop()},onArrayBegin:(v,D)=>{if(s<=v)throw i;o=void 0,t.push(0)},onArrayEnd:(v,D)=>{if(s<=v)throw i;o=void 0,t.pop()},onLiteralValue:(v,D,M)=>{if(s<D||(h(v,D,M,c(v)),s<=D+M))throw i},onSeparator:(v,D,M)=>{if(s<=D)throw i;if(v===":"&&o&&o.type==="property")o.colonOffset=D,a=!1,o=void 0;else if(v===","){const F=t[t.length-1];typeof F=="number"?t[t.length-1]=F+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(v){if(v!==i)throw v}return{path:t,previousNode:o,isAtPropertyKey:a,matches:v=>{let D=0;for(let M=0;D<v.length&&M<t.length;M++)if(v[D]===t[M]||v[D]==="*")D++;else if(v[D]!=="**")return!1;return D===v.length}}}e.getLocation=w;function p(n,s=[],t=T.DEFAULT){let i=null,o=[];const u=[];function a(v){Array.isArray(o)?o.push(v):i!==null&&(o[i]=v)}return l(n,{onObjectBegin:()=>{const v={};a(v),u.push(o),o=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const v=[];a(v),u.push(o),o=v,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:a,onError:(v,D,M)=>{s.push({error:v,offset:D,length:M})}},t),o[0]}e.parse=p;function y(n,s=[],t=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){i.type==="property"&&(i.length=v-i.offset,i=i.parent)}function u(v){return i.children.push(v),v}l(n,{onObjectBegin:v=>{i=u({type:"object",offset:v,length:-1,parent:i,children:[]})},onObjectProperty:(v,D,M)=>{i=u({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:v,offset:D,length:M,parent:i})},onObjectEnd:(v,D)=>{i.length=v+D-i.offset,i=i.parent,o(v+D)},onArrayBegin:(v,D)=>{i=u({type:"array",offset:v,length:-1,parent:i,children:[]})},onArrayEnd:(v,D)=>{i.length=v+D-i.offset,i=i.parent,o(v+D)},onLiteralValue:(v,D,M)=>{u({type:c(v),offset:D,length:M,parent:i,value:v}),o(D+M)},onSeparator:(v,D,M)=>{i.type==="property"&&(v===":"?i.colonOffset=D:v===","&&o(D))},onError:(v,D,M)=>{s.push({error:v,offset:D,length:M})}},t);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=y;function d(n,s){if(!n)return;let t=n;for(const i of s)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===i){t=u.children[1],o=!0;break}if(!o)return}else{const o=i;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=d;function S(n){if(!n.parent||!n.parent.children)return[];const s=S(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;s.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&s.push(t)}return s}e.getNodePath=S;function C(n){switch(n.type){case"array":return n.children.map(C);case"object":{const s=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(s[t.children[0].value]=C(i))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=C;function m(n,s,t=!1){return s>=n.offset&&s<n.offset+n.length||t&&s===n.offset+n.length}e.contains=m;function g(n,s,t=!1){if(m(n,s,t)){const i=n.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=s;o++){const u=g(i[o],s,t);if(u)return u}return n}}e.findNodeAtOffset=g;function l(n,s,t=T.DEFAULT){const i=A(n,!1);function o(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(z){return z?B=>z(B,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=o(s.onObjectBegin),h=u(s.onObjectProperty),v=o(s.onObjectEnd),D=o(s.onArrayBegin),M=o(s.onArrayEnd),F=u(s.onLiteralValue),O=u(s.onSeparator),L=o(s.onComment),N=u(s.onError),$=t&&t.disallowComments,V=t&&t.allowTrailingComma;function J(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(z){case 12:case 13:$?H(10):L();break;case 16:H(1);break;case 15:case 14:break;default:return z}}}function H(z,B=[],_=[]){if(N(z),B.length+_.length>0){let U=i.getToken();for(;U!==17;){if(B.indexOf(U)!==-1){J();break}else if(_.indexOf(U)!==-1)break;U=J()}}}function G(z){const B=i.getTokenValue();return z?F(B):h(B),J(),!0}function q(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&(H(2),z=0)}catch{H(2)}F(z);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return J(),!0}function x(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(O(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){a(),J();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||H(4,[],[]),O(","),J(),i.getToken()===2&&V)break}else z&&H(6,[],[]);x()||H(4,[],[2,5]),z=!0}return v(),i.getToken()!==2?H(7,[2],[]):J(),!0}function te(){D(),J();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||H(4,[],[]),O(","),J(),i.getToken()===4&&V)break}else z&&H(6,[],[]);ce()||H(4,[],[4,5]),z=!0}return M(),i.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(i.getToken()){case 3:return te();case 1:return Y();case 10:return G(!0);default:return q()}}return J(),i.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=l;function f(n,s){const t=A(n),i=[];let o,u=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==a&&i.push(n.substring(u,a)),s!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,s)),u=t.getPosition();break}while(o!==17);return i.join("")}e.stripComments=f;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ne[52],se([0,1,35]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(I,E,w){let p,y,d,S,C;if(E){for(S=E.offset,C=S+E.length,d=S;d>0&&!P(I,d-1);)d--;let a=C;for(;a<I.length&&!P(I,a);)a++;y=I.substring(d,a),p=A(y,w)}else y=I,p=0,d=0,S=0,C=I.length;const m=b(w,I);let g=!1,l=0,f;w.insertSpaces?f=T(" ",w.tabSize||4):f="	";const c=(0,R.createScanner)(y,!1);let n=!1;function s(){return m+T(f,p+l)}function t(){let a=c.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=c.scan();return n=a===16||c.getTokenError()!==0,a}const i=[];function o(a,h,v){!n&&h<C&&v>S&&I.substring(h,v)!==a&&i.push({offset:h,length:v-h,content:a})}let u=t();if(u!==17){const a=c.getTokenOffset()+d,h=T(f,p);o(h,d,a)}for(;u!==17;){let a=c.getTokenOffset()+c.getTokenLength()+d,h=t(),v="";for(;!g&&(h===12||h===13);){const M=c.getTokenOffset()+d;o(" ",a,M),a=c.getTokenOffset()+c.getTokenLength()+d,v=h===12?s():"",h=t()}if(h===2)u!==1&&(l--,v=s());else if(h===4)u!==3&&(l--,v=s());else{switch(u){case 3:case 1:l++,v=s();break;case 5:case 12:v=s();break;case 13:g?v=s():v=" ";break;case 6:v=" ";break;case 10:if(h===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?v=" ":h!==5&&h!==17&&(n=!0);break;case 16:n=!0;break}g&&(h===12||h===13)&&(v=s())}const D=c.getTokenOffset()+d;o(v,a,D),u=h}return i}e.format=r;function k(I,E){const w=JSON.stringify(I,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?w.replace(/\r\n|\r|\n/g,E.eol):w}e.toFormattedString=k;function T(I,E){let w="";for(let p=0;p<E;p++)w+=I;return w}function A(I,E){let w=0,p=0;const y=E.tabSize||4;for(;w<I.length;){const d=I.charAt(w);if(d===" ")p++;else if(d==="	")p+=y;else break;w++}return Math.floor(p/y)}function b(I,E){for(let w=0;w<E.length;w++){const p=E.charAt(w);if(p==="\r")return w+1<E.length&&E.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=b;function P(I,E){return`\r
`.indexOf(I.charAt(E))!==-1}e.isEOL=P}),define(ne[75],se([0,1,35,52]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(I,E,w){return T(I,E,void 0,w)}e.removeProperty=k;function T(I,E,w,p,y){const d=E.slice(),S=[],C=(0,R.parseTree)(I,S);let m,g;for(;d.length>0&&(g=d.pop(),m=(0,R.findNodeAtLocation)(C,d),m===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(m)if(m.type==="object"&&typeof g=="string"&&Array.isArray(m.children)){const l=(0,R.findNodeAtLocation)(m,[g]);if(l!==void 0)if(w===void 0){if(!l.parent)throw new Error("Malformed AST");const f=m.children.indexOf(l.parent);let c,n=l.parent.offset+l.parent.length;if(f>0){const s=m.children[f-1];c=s.offset+s.length}else c=m.offset+1,m.children.length>1&&(n=m.children[1].offset);return A(I,{offset:c,length:n-c,content:""},p)}else return A(I,{offset:l.offset,length:l.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,c=y?y(m.children.map(s=>s.children[0].value)):m.children.length;let n;if(c>0){const s=m.children[c-1];n={offset:s.offset+s.length,length:0,content:","+f}}else m.children.length===0?n={offset:m.offset+1,length:0,content:f}:n={offset:m.offset+1,length:0,content:f+","};return A(I,n,p)}}else if(m.type==="array"&&typeof g=="number"&&Array.isArray(m.children))if(w!==void 0){const l=`${JSON.stringify(w)}`;let f;if(m.children.length===0||g===0)f={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const c=g===-1||g>m.children.length?m.children.length:g,n=m.children[c-1];f={offset:n.offset+n.length,length:0,content:","+l}}return A(I,f,p)}else{const l=g,f=m.children[l];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const n=m.children[l-1],s=n.offset+n.length,t=m.offset+m.length;c={offset:s,length:t-2-s,content:""}}else c={offset:f.offset,length:m.children[l+1].offset-f.offset,content:""};return A(I,c,p)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},p)}}e.setProperty=T;function A(I,E,w){let p=b(I,E),y=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;y>0&&!(0,r.isEOL)(p,y-1);)y--;for(;d<p.length&&!(0,r.isEOL)(p,d);)d++}const S=(0,r.format)(p,{offset:y,length:d-y},w);for(let m=S.length-1;m>=0;m--){const g=S[m];p=b(p,g),y=Math.min(y,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const C=I.length-(p.length-d)-y;return[{offset:y,length:C,content:p.substring(y,d)}]}e.withFormatting=A;function b(I,E){return I.substring(0,E.offset)+E.content+I.substring(E.offset+E.length)}e.applyEdit=b;function P(I,E){const w=E.slice(0).sort((y,d)=>{const S=y.offset-d.offset;return S===0?y.length-d.length:S});let p=I.length;for(let y=w.length-1;y>=0;y--){const d=w[y];if(d.offset+d.length<=p)I=b(I,d);else throw new Error("Overlapping edit");p=d.offset}return I}e.applyEdits=P}),define(ne[111],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new R(()=>k(this.getValue()))}}e.Lazy=R}),define(ne[2],se([0,1,74,51]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,k){const o="__is_disposable_tracked__";A(new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[o]||console.log(a)},3e3)}setParent(u,a){if(u&&u!==g.None)try{u[o]=!0}catch{}}markAsDisposed(u){if(u&&u!==g.None)try{u[o]=!0}catch{}}markAsSingleton(u){}})}function b(o){return T?.trackDisposable(o),o}function P(o){T?.markAsDisposed(o)}function I(o,u){T?.setParent(o,u)}function E(o,u){if(!!T)for(const a of o)T.setParent(a,u)}function w(o){return T?.markAsSingleton(o),o}e.markAsSingleton=w;function p(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=p;function y(o){if(r.Iterable.is(o)){const u=[];for(const a of o)if(a)try{a.dispose()}catch(h){u.push(h)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=y;function d(o){for(const u of o)p(u)&&u.dispose();return[]}e.disposeIfDisposable=d;function S(...o){const u=C(()=>y(o));return E(o,u),u}e.combinedDisposable=S;function C(o){const u=b({dispose:(0,R.once)(()=>{P(u),o()})});return u}e.toDisposable=C;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{y(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return I(u,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,b(this),I(this._store,this)}dispose(){P(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&I(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&I(u,null),u}}e.MutableDisposable=l;class f{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(u){let a=u;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,P(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(u,...a){let h=this.references.get(u);h||(h={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,h));const{object:v}=h,D=(0,R.once)(()=>{--h.counter===0&&(this.destroyReferencedObject(u,h.object),this.references.delete(u))});return h.counter++,{object:v,dispose:D}}}e.ReferenceCollection=n;class s{constructor(u){this.referenceCollection=u}async acquire(u,...a){const h=this.referenceCollection.acquire(u,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(v){throw h.dispose(),v}}}e.AsyncReferenceCollection=s;class t{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=t;function i(o){const u=new m;try{o(u)}finally{u.dispose()}}e.disposeOnReturn=i}),define(ne[112],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class r{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const A=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const b=new R(T);if(this._first===R.Undefined)this._first=b,this._last=b;else if(A){const I=this._last;this._last=b,b.prev=I,I.next=b}else{const I=this._first;this._first=b,b.next=I,I.prev=b}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(b))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=r}),function(){function X(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function A(P){T.push(P,Date.now())}function b(){const P=[];for(let I=0;I<T.length;I+=2)P.push({name:T[I],startTime:T[I+1]});return P}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(k+A.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function R(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=R(r))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var r in R)(typeof exports=="object"?exports:X)[r]=R[r]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function R(r){if(e[r])return e[r].exports;var k=e[r]={i:r,l:!1,exports:{}};return X[r].call(k.exports,k,k.exports,R),k.l=!0,k.exports}return R.m=X,R.c=e,R.d=function(r,k,T){R.o(r,k)||Object.defineProperty(r,k,{enumerable:!0,get:T})},R.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},R.t=function(r,k){if(1&k&&(r=R(r)),8&k||4&k&&typeof r=="object"&&r&&r.__esModule)return r;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:r}),2&k&&typeof r!="string")for(var A in r)R.d(T,A,function(b){return r[b]}.bind(null,A));return T},R.n=function(r){var k=r&&r.__esModule?function(){return r.default}:function(){return r};return R.d(k,"a",k),k},R.o=function(r,k){return Object.prototype.hasOwnProperty.call(r,k)},R.p="",R(R.s=0)}([function(X,e,R){(function(r){var k;e=X.exports=_,k=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],P=e.src=[],I=0,E=I++;P[E]="0|[1-9]\\d*";var w=I++;P[w]="[0-9]+";var p=I++;P[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=I++;P[y]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var d=I++;P[d]="("+P[w]+")\\.("+P[w]+")\\.("+P[w]+")";var S=I++;P[S]="(?:"+P[E]+"|"+P[p]+")";var C=I++;P[C]="(?:"+P[w]+"|"+P[p]+")";var m=I++;P[m]="(?:-("+P[S]+"(?:\\."+P[S]+")*))";var g=I++;P[g]="(?:-?("+P[C]+"(?:\\."+P[C]+")*))";var l=I++;P[l]="[0-9A-Za-z-]+";var f=I++;P[f]="(?:\\+("+P[l]+"(?:\\."+P[l]+")*))";var c=I++,n="v?"+P[y]+P[m]+"?"+P[f]+"?";P[c]="^"+n+"$";var s="[v=\\s]*"+P[d]+P[g]+"?"+P[f]+"?",t=I++;P[t]="^"+s+"$";var i=I++;P[i]="((?:<|>)?=?)";var o=I++;P[o]=P[w]+"|x|X|\\*";var u=I++;P[u]=P[E]+"|x|X|\\*";var a=I++;P[a]="[v=\\s]*("+P[u]+")(?:\\.("+P[u]+")(?:\\.("+P[u]+")(?:"+P[m]+")?"+P[f]+"?)?)?";var h=I++;P[h]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[g]+")?"+P[f]+"?)?)?";var v=I++;P[v]="^"+P[i]+"\\s*"+P[a]+"$";var D=I++;P[D]="^"+P[i]+"\\s*"+P[h]+"$";var M=I++;P[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=I++;P[F]="(?:~>?)";var O=I++;P[O]="(\\s*)"+P[F]+"\\s+",b[O]=new RegExp(P[O],"g");var L=I++;P[L]="^"+P[F]+P[a]+"$";var N=I++;P[N]="^"+P[F]+P[h]+"$";var $=I++;P[$]="(?:\\^)";var V=I++;P[V]="(\\s*)"+P[$]+"\\s+",b[V]=new RegExp(P[V],"g");var J=I++;P[J]="^"+P[$]+P[a]+"$";var H=I++;P[H]="^"+P[$]+P[h]+"$";var G=I++;P[G]="^"+P[i]+"\\s*("+s+")$|^$";var q=I++;P[q]="^"+P[i]+"\\s*("+n+")$|^$";var x=I++;P[x]="(\\s*)"+P[i]+"\\s*("+s+"|"+P[a]+")",b[x]=new RegExp(P[x],"g");var Y=I++;P[Y]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var te=I++;P[te]="^\\s*("+P[h]+")\\s+-\\s+("+P[h]+")\\s*$";var ce=I++;P[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,P[z]),b[z]||(b[z]=new RegExp(P[z]));function B(ae,de){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>T||!(de?b[t]:b[c]).test(ae))return null;try{return new _(ae,de)}catch{return null}}function _(ae,de){if(ae instanceof _){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof _))return new _(ae,de);k("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?b[t]:b[c]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<A)return Ie}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=B,e.valid=function(ae,de){var fe=B(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=B(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),W(this.major,ae.major)||W(this.minor,ae.minor)||W(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=ae.prerelease[de];if(k("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return W(fe,Ce)}while(++de)},_.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new _(ae,fe).inc(de,Ce).version}catch{return null}},e.diff=function(ae,de){if(Q(ae,de))return null;var fe=B(ae),Ce=B(de);if(fe.prerelease.length||Ce.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=W;var U=/^[0-9]+$/;function W(ae,de){var fe=U.test(ae),Ce=U.test(de);return fe&&Ce&&(ae=+ae,de=+de),fe&&!Ce?-1:Ce&&!fe?1:ae<de?-1:ae>de?1:0}function j(ae,de,fe){return new _(ae,fe).compare(new _(de,fe))}function Z(ae,de,fe){return j(ae,de,fe)>0}function oe(ae,de,fe){return j(ae,de,fe)<0}function Q(ae,de,fe){return j(ae,de,fe)===0}function ie(ae,de,fe){return j(ae,de,fe)!==0}function re(ae,de,fe){return j(ae,de,fe)>=0}function ue(ae,de,fe){return j(ae,de,fe)<=0}function he(ae,de,fe,Ce){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=Q(ae,fe,Ce);break;case"!=":Ie=ie(ae,fe,Ce);break;case">":Ie=Z(ae,fe,Ce);break;case">=":Ie=re(ae,fe,Ce);break;case"<":Ie=oe(ae,fe,Ce);break;case"<=":Ie=ue(ae,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);k("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,de){return W(de,ae)},e.major=function(ae,de){return new _(ae,de).major},e.minor=function(ae,de){return new _(ae,de).minor},e.patch=function(ae,de){return new _(ae,de).patch},e.compare=j,e.compareLoose=function(ae,de){return j(ae,de,!0)},e.rcompare=function(ae,de,fe){return j(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=Z,e.lt=oe,e.eq=Q,e.neq=ie,e.gte=re,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,de){if(ae instanceof Ee)return ae.loose===de?ae:new Ee(ae.raw,de);if(ae instanceof ve)return new Ee(ae.value,de);if(!(this instanceof Ee))return new Ee(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee){return((de=Pe(fe)?"":Pe(Ce)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+Ce+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function ze(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(k(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var Ce=ae[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ve(ae,de,fe){try{de=new Ee(de,fe)}catch{return!1}return de.test(ae)}function We(ae,de,fe,Ce){var Ie,Me,De,$e,Ae;switch(ae=new _(ae,Ce),de=new Ee(de,Ce),fe){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=re,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var _e=de.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:De(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&De(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?b[G]:b[q],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new _(fe[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new _(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ee(ae.value,de),Ve(this.value,fe,de);if(ae.operator==="")return fe=new Ee(this.value,de),Ve(ae.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&De||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),k("range",ae,de);var fe=de?b[te]:b[Y];ae=ae.replace(fe,Ue),k("hyphen replace",ae),ae=ae.replace(b[x],"$1$2$3"),k("comparator trim",ae,b[x]),ae=(ae=(ae=ae.replace(b[O],"$1~")).replace(b[V],"$1^")).split(/\s+/).join(" ");var Ce=de?b[G]:b[q],Ie=ae.split(" ").map(function(Me){return function(De,$e){return k("comp",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){k("caret",ke,ee);var le=ee?b[H]:b[J];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return k("caret",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+Re+" <"+(+ge+1)+".0.0"):(k("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),k("caret return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),k("caret",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?b[N]:b[L];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return k("tilde",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",k("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),k("tildes",De),De=function(Ae,Fe){return k("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?b[D]:b[v];return ke.replace(le,function(me,ge,Se,be,Re,Te){k("xRange",ke,me,ge,Se,be,Re,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(Re);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(Re=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,Re=0):Ne&&(be=+be+1,Re=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+Re):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),k("xRange return",me),me})}(_e,Fe)}).join(" ")}(De,$e),k("xrange",De),De=function(Ae,Fe){return k("replaceStars",Ae,Fe),Ae.trim().replace(b[ce],"")}(De,$e),k("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ee.prototype.intersects=function(ae,de){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ee(ae,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var de=0;de<this.set.length;de++)if(ze(this.set[de],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new _(Ce=De,fe)))}),Ce},e.minSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new _(Ce=De,fe)))}),Ce},e.validRange=function(ae,de){try{return new Ee(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return We(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return We(ae,de,">",fe)},e.outside=We,e.prerelease=function(ae,de){var fe=B(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ee(ae,fe),de=new Ee(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var de=ae.match(b[M]);return de==null?null:B((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(X,e){var R,r,k=X.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(C){if(R===setTimeout)return setTimeout(C,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(C,0);try{return R(C,0)}catch{try{return R.call(null,C,0)}catch{return R.call(this,C,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{r=typeof clearTimeout=="function"?clearTimeout:A}catch{r=A}})();var P,I=[],E=!1,w=-1;function p(){E&&P&&(E=!1,P.length?I=P.concat(I):w=-1,I.length&&y())}function y(){if(!E){var C=b(p);E=!0;for(var m=I.length;m;){for(P=I,I=[];++w<m;)P&&P[w].run();w=-1,m=I.length}P=null,E=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===A||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(C)}}function d(C,m){this.fun=C,this.array=m}function S(){}k.nextTick=function(C){var m=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)m[g-1]=arguments[g];I.push(new d(C,m)),I.length!==1||E||b(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[113],se([0,1]),function(X,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(b,P,I){this.level=b,this.key=P,this.value=I,this.forward=[]}}const k=void 0;class T{constructor(b,P=2**16){this.comparator=b,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new r(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,k,k)}has(b){return Boolean(T._search(this,b,this.comparator))}get(b){return T._search(this,b,this.comparator)?.value}set(b,P){return T._insert(this,b,P,this.comparator)&&(this._size+=1),this}delete(b){const P=T._delete(this,b,this.comparator);return P&&(this._size-=1),P}forEach(b,P){let I=this._header.forward[0];for(;I;)b.call(P,I.value,I.key,this),I=I.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",P=this._header.forward[0];for(;P;)b+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return b}static _search(b,P,I){let E=b._header;for(let w=b._level-1;w>=0;w--)for(;E.forward[w]&&I(E.forward[w].key,P)<0;)E=E.forward[w];if(E=E.forward[0],E&&I(E.key,P)===0)return E}static _insert(b,P,I,E){const w=[];let p=b._header;for(let y=b._level-1;y>=0;y--){for(;p.forward[y]&&E(p.forward[y].key,P)<0;)p=p.forward[y];w[y]=p}if(p=p.forward[0],p&&E(p.key,P)===0)return p.value=I,!1;{const y=T._randomLevel(b);if(y>b._level){for(let d=b._level;d<y;d++)w[d]=b._header;b._level=y}p=new r(y,P,I);for(let d=0;d<y;d++)p.forward[d]=w[d].forward[d],w[d].forward[d]=p;return!0}}static _randomLevel(b,P=.5){let I=1;for(;Math.random()<P&&I<b._maxLevel;)I+=1;return I}static _delete(b,P,I){const E=[];let w=b._header;for(let p=b._level-1;p>=0;p--){for(;w.forward[p]&&I(w.forward[p].key,P)<0;)w=w.forward[p];E[p]=w}if(w=w.forward[0],!w||I(w.key,P)!==0)return!1;for(let p=0;p<b._level&&E[p].forward[p]===w;p++)E[p].forward[p]=w.forward[p];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=T}),define(ne[41],se([0,1,10,2]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=k;function T(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=T;function A(f){const c=f;return c?T(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function b(f,c){return new P(f,c)}e.newWriteableStream=b;class P{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(n);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(f,c){const n=[];let s;for(;(s=f.read())!==null;)n.push(s);return c(n)}e.consumeReadable=I;function E(f,c,n){const s=[];let t;for(;(t=f.read())!==null&&s.length<n;)s.push(t);return t===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return f.read()}}}e.peekReadable=E;function w(f,c){return new Promise((n,s)=>{const t=[];p(f,{onData:i=>{c&&t.push(i)},onError:i=>{c?s(i):n(void 0)},onEnd:()=>{n(c?c(t):void 0)}})})}e.consumeStream=w;function p(f,c){let n=!1;return f.on("error",s=>{n||c.onError(s)}),f.on("end",()=>{n||c.onEnd()}),f.on("data",s=>{n||c.onData(s)}),(0,r.toDisposable)(()=>n=!0)}e.listenStream=p;function y(f,c){return new Promise((n,s)=>{const t=new r.DisposableStore,i=[],o=h=>{if(i.push(h),i.length>c)return t.dispose(),f.pause(),n({stream:f,buffer:i,ended:!1})},u=h=>s(h),a=()=>n({stream:f,buffer:i,ended:!0});t.add((0,r.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),t.add((0,r.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,r.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function d(f,c){const n=b(c);return n.end(f),n}e.toStream=d;function S(){const f=b(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function C(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=C;function m(f,c,n){const s=b(n);return p(f,{onData:t=>s.write(c.data(t)),onError:t=>s.error(c.error?c.error(t):t),onEnd:()=>s.end()}),s}e.transform=m;function g(f,c,n){let s=!1;return{read:()=>{const t=c.read();return s?t:(s=!0,t!==null?n([f,t]):f)}}}e.prefixedReadable=g;function l(f,c,n){let s=!1;const t=b(n);return p(c,{onData:i=>s?t.write(i):(s=!0,t.write(n([f,i]))),onError:i=>t.error(i),onEnd:()=>{s||(s=!0,t.write(f)),t.end()}}),t}e.prefixedStream=l}),define(ne[16],se([0,1,41]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let k,T;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return r?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return r&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&r?new A(Buffer.from(h)):(k||(k=new TextEncoder),new A(k.encode(h)))}static fromByteArray(h){const v=A.alloc(h.length);for(let D=0,M=h.length;D<M;D++)v.buffer[D]=h[D];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let F=0,O=h.length;F<O;F++)v+=h[F].byteLength}const D=A.alloc(v);let M=0;for(let F=0,O=h.length;F<O;F++){const L=h[F];D.set(L,M),M+=L.byteLength}return D}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return r?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(h,v){return new A(this.buffer.subarray(h,v))}set(h,v){if(h instanceof A)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return I(this.buffer,h)}writeUInt32BE(h,v){E(this.buffer,h,v)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,v){p(this.buffer,h,v)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,v){d(this.buffer,h,v)}}e.VSBuffer=A;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=b;function P(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255}e.writeUInt16LE=P;function I(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=I;function E(a,h,v){a[v+3]=h,h=h>>>8,a[v+2]=h,h=h>>>8,a[v+1]=h,h=h>>>8,a[v]=h}e.writeUInt32BE=E;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=w;function p(a,h,v){a[v+0]=h&255,h=h>>>8,a[v+1]=h&255,h=h>>>8,a[v+2]=h&255,h=h>>>8,a[v+3]=h&255}e.writeUInt32LE=p;function y(a,h){return a[h]}e.readUInt8=y;function d(a,h,v){a[v]=h}e.writeUInt8=d;function S(a){return R.consumeReadable(a,h=>A.concat(h))}e.readableToBuffer=S;function C(a){return R.toReadable(a)}e.bufferToReadable=C;function m(a){return R.consumeStream(a,h=>A.concat(h))}e.streamToBuffer=m;async function g(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=g;function l(a){return R.toStream(a,h=>A.concat(h))}e.bufferToStream=l;function f(a){return R.transform(a,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=f;function c(a){return R.newWriteableStream(h=>A.concat(h),a)}e.newWriteableBufferStream=c;function n(a,h){return R.prefixedReadable(a,h,v=>A.concat(v))}e.prefixedBufferReadable=n;function s(a,h){return R.prefixedStream(a,h,v=>A.concat(v))}e.prefixedBufferStream=s;function t(a){let h=0,v=0,D=0;const M=new Uint8Array(Math.floor(a.length/4*3)),F=L=>{switch(v){case 3:M[D++]=h|L,v=0;break;case 2:M[D++]=h|L>>>2,h=L<<6,v=3;break;case 1:M[D++]=h|L>>>4,h=L<<4,v=2;break;default:h=L<<2,v=1}};for(let L=0;L<a.length;L++){const N=a.charCodeAt(L);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[L]}`)}}const O=D;for(;v>0;)F(0);return A.wrap(M).slice(0,O)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},h=!0,v=!1){const D=v?o:i;let M="";const F=a.byteLength%3;let O=0;for(;O<a.byteLength-F;O+=3){const L=a[O+0],N=a[O+1],$=a[O+2];M+=D[L>>>2],M+=D[(L<<4|N>>>4)&63],M+=D[(N<<2|$>>>6)&63],M+=D[$&63]}if(F===1){const L=a[O+0];M+=D[L>>>2],M+=D[L<<4&63],h&&(M+="==")}else if(F===2){const L=a[O+0],N=a[O+1];M+=D[L>>>2],M+=D[(L<<4|N>>>4)&63],M+=D[N<<2&63],h&&(M+="=")}return M}e.encodeBase64=u}),define(ne[14],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function r(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=r;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function T(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=T;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=b;function P(s){return s===!0||s===!1}e.isBoolean=P;function I(s){return typeof s>"u"}e.isUndefined=I;function E(s){return!w(s)}e.isDefined=E;function w(s){return I(s)||s===null}e.isUndefinedOrNull=w;function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function y(s){if(w(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=y;function d(...s){const t=[];for(let i=0;i<s.length;i++){const o=s[i];if(w(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(o)}return t}e.assertAllDefined=d;const S=Object.prototype.hasOwnProperty;function C(s){if(!k(s))return!1;for(const t in s)if(S.call(s,t))return!1;return!0}e.isEmptyObject=C;function m(s){return typeof s=="function"}e.isFunction=m;function g(...s){return s.length>0&&s.every(m)}e.areFunctions=g;function l(s,t){const i=Math.min(s.length,t.length);for(let o=0;o<i;o++)f(s[o],t[o])}e.validateConstraints=l;function f(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(s instanceof t)return}catch{}if(!w(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(s){return s===null?void 0:s}e.withNullAsUndefined=c;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(ne[31],se([0,1,14]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const g=Array.isArray(m)?[]:{};return Object.keys(m).forEach(l=>{m[l]&&typeof m[l]=="object"?g[l]=r(m[l]):g[l]=m[l]}),g}e.deepClone=r;function k(m){if(!m||typeof m!="object")return m;const g=[m];for(;g.length>0;){const l=g.shift();Object.freeze(l);for(const f in l)if(T.call(l,f)){const c=l[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,R.isTypedArray)(c)&&g.push(c)}}return m}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function A(m,g){return b(m,g,new Set)}e.cloneAndChange=A;function b(m,g,l){if((0,R.isUndefinedOrNull)(m))return m;const f=g(m);if(typeof f<"u")return f;if(Array.isArray(m)){const c=[];for(const n of m)c.push(b(n,g,l));return c}if((0,R.isObject)(m)){if(l.has(m))throw new Error("Cannot clone recursive data-structure");l.add(m);const c={};for(const n in m)T.call(m,n)&&(c[n]=b(m[n],g,l));return l.delete(m),c}return m}function P(m,g,l=!0){return(0,R.isObject)(m)?((0,R.isObject)(g)&&Object.keys(g).forEach(f=>{f in m?l&&((0,R.isObject)(m[f])&&(0,R.isObject)(g[f])?P(m[f],g[f],l):m[f]=g[f]):m[f]=g[f]}),m):g}e.mixin=P;function I(m,g){if(m===g)return!0;if(m==null||g===null||g===void 0||typeof m!=typeof g||typeof m!="object"||Array.isArray(m)!==Array.isArray(g))return!1;let l,f;if(Array.isArray(m)){if(m.length!==g.length)return!1;for(l=0;l<m.length;l++)if(!I(m[l],g[l]))return!1}else{const c=[];for(f in m)c.push(f);c.sort();const n=[];for(f in g)n.push(f);if(n.sort(),!I(c,n))return!1;for(l=0;l<c.length;l++)if(!I(m[c[l]],g[c[l]]))return!1}return!0}e.equals=I;function E(m){const g=new Set;return JSON.stringify(m,(l,f)=>{if((0,R.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=E;function w(m,g){const l=Object.create(null);return!m||!g||Object.keys(g).forEach(c=>{const n=m[c],s=g[c];I(n,s)||(l[c]=s)}),l}e.distinct=w;function p(m,g){const l=g.toLowerCase(),f=Object.keys(m).find(c=>c.toLowerCase()===l);return f?m[f]:m[g]}e.getCaseInsensitive=p;function y(m,g){const l=Object.create(null);for(const[f,c]of Object.entries(m))g(f,c)&&(l[f]=c);return l}e.filter=y;function d(m){let g=[],l=Object.getPrototypeOf(m);for(;Object.prototype!==l;)g=g.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return g}e.getAllPropertyNames=d;function S(m){const g=[];for(const l of d(m))typeof m[l]=="function"&&g.push(l);return g}e.getAllMethodNames=S;function C(m,g){const l=c=>function(){const n=Array.prototype.slice.call(arguments,0);return g(c,n)},f={};for(const c of m)f[c]=l(c);return f}e.createProxyObject=C}),define(ne[30],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(k){return R.test(k)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let P=0;P<b.length;P++)b[P]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let P=0,I="";return I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I}}()}),define(ne[114],se([0,1,37]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const b=A.replace(/\-/g,":").toLowerCase();return!r.has(b)}function T(){const A=(0,R.networkInterfaces)();for(const b in A){const P=A[b];if(P){for(const{mac:I}of P)if(k(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[115],se([0,1,76]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(b,P,I,E=1){let w=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!w)return w=!0,p(0)},I);k(b,P,E,d=>{if(!w)return w=!0,clearTimeout(y),p(d)})})}e.findFreePort=r;function k(b,P,I,E){if(P===0)return E(0);const w=new R.Socket;w.once("connect",()=>(A(w),k(b+I,P-1,I,E))),w.once("data",()=>{}),w.once("error",p=>(A(w),p.code!=="ECONNREFUSED"?k(b+I,P-1,I,E):E(b))),w.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(b,P,I){let E=!1,w,p=1;const y=R.createServer({pauseOnConnect:!0});function d(S,C){E||(E=!0,y.removeAllListeners(),y.close(),w&&clearTimeout(w),C(S))}return new Promise(S=>{w=setTimeout(()=>{d(0,S)},I),y.on("listening",()=>{d(b,S)}),y.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&p<P?(b++,p++,y.listen(b,"127.0.0.1")):d(0,S)}),y.on("close",()=>{d(0,S)}),y.listen(b,"127.0.0.1")})}e.findFreePortFaster=T;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(P){console.error(P)}}}),define(ne[116],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function r(T){return T instanceof k?!0:T instanceof Error&&T.name===R&&T.message===R}e.isOfflineError=r;class k extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=k}),define(ne[117],se([0,1,16,10,116]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(P,I){if(!navigator.onLine)throw new k.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((w,p)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=y=>p(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=y=>{w({res:{statusCode:E.status,headers:b(E)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=y=>p(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),I.onCancellationRequested(()=>{E.abort(),p((0,r.canceled)())})})}e.request=T;function A(P,I){if(I.headers){e:for(const E in I.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,I.headers[E])}}}function b(P){const I=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const w=E.indexOf(":");I[E.substr(0,w).trim().toLowerCase()]=E.substr(w+1).trim()}return I}}),define(ne[118],se([11,12]),function(X,e){return X.create("vs/base/common/date",e)}),define(ne[61],se([0,1,118]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,k=r*60,T=k*24,A=T*7,b=T*30,P=T*365;function I(w,p,y){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,R.localize)(0,null,I(new Date().getTime()+d*1e3,!1));if(d<30)return(0,R.localize)(1,null);let S;return d<r?(S=d,p?S===1?y?(0,R.localize)(2,null,S):(0,R.localize)(3,null,S):y?(0,R.localize)(4,null,S):(0,R.localize)(5,null,S):S===1?y?(0,R.localize)(6,null,S):(0,R.localize)(7,null,S):y?(0,R.localize)(8,null,S):(0,R.localize)(9,null,S)):d<k?(S=Math.floor(d/r),p?S===1?y?(0,R.localize)(10,null,S):(0,R.localize)(11,null,S):y?(0,R.localize)(12,null,S):(0,R.localize)(13,null,S):S===1?y?(0,R.localize)(14,null,S):(0,R.localize)(15,null,S):y?(0,R.localize)(16,null,S):(0,R.localize)(17,null,S)):d<T?(S=Math.floor(d/k),p?S===1?y?(0,R.localize)(18,null,S):(0,R.localize)(19,null,S):y?(0,R.localize)(20,null,S):(0,R.localize)(21,null,S):S===1?y?(0,R.localize)(22,null,S):(0,R.localize)(23,null,S):y?(0,R.localize)(24,null,S):(0,R.localize)(25,null,S)):d<A?(S=Math.floor(d/T),p?S===1?(0,R.localize)(26,null,S):(0,R.localize)(27,null,S):S===1?(0,R.localize)(28,null,S):(0,R.localize)(29,null,S)):d<b?(S=Math.floor(d/A),p?S===1?y?(0,R.localize)(30,null,S):(0,R.localize)(31,null,S):y?(0,R.localize)(32,null,S):(0,R.localize)(33,null,S):S===1?y?(0,R.localize)(34,null,S):(0,R.localize)(35,null,S):y?(0,R.localize)(36,null,S):(0,R.localize)(37,null,S)):d<P?(S=Math.floor(d/b),p?S===1?y?(0,R.localize)(38,null,S):(0,R.localize)(39,null,S):y?(0,R.localize)(40,null,S):(0,R.localize)(41,null,S):S===1?y?(0,R.localize)(42,null,S):(0,R.localize)(43,null,S):y?(0,R.localize)(44,null,S):(0,R.localize)(45,null,S)):(S=Math.floor(d/P),p?S===1?y?(0,R.localize)(46,null,S):(0,R.localize)(47,null,S):y?(0,R.localize)(48,null,S):(0,R.localize)(49,null,S):S===1?y?(0,R.localize)(50,null,S):(0,R.localize)(51,null,S):y?(0,R.localize)(52,null,S):(0,R.localize)(53,null,S))}e.fromNow=I;function E(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ne[119],se([11,12]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ne[38],se([0,1,18,14,119]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(w,p){return p&&(w.stack||w.stacktrace)?k.localize(0,null,b(w),A(w.stack)||A(w.stacktrace)):b(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function b(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function P(w=null,p=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const y=R.coalesce(w),d=P(y[0],p);return y.length>1?k.localize(4,null,d,y.length):d}if(r.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return T(y.error,p);if(y.exception)return T(y.exception,p)}return w.stack?T(w,p):w.message?w.message:k.localize(5,null)}e.toErrorMessage=P;function I(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=I;function E(w,p){let y;return typeof w=="string"?y=new Error(w):y=w,y.actions=p,y}e.createErrorWithActions=E}),define(ne[120],se([11,12]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ne[121],se([0,1,120]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(k){switch(k){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[122],se([11,12]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ne[4],se([0,1,122]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const r="en";let k=!1,T=!1,A=!1,b=!1,P=!1,I=!1,E=!1,w=!1,p=!1,y,d=r,S,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const g=typeof m?.versions?.electron=="string",l=g&&m?.type==="renderer";if(typeof navigator=="object"&&!l)C=navigator.userAgent,k=C.indexOf("Windows")>=0,T=C.indexOf("Macintosh")>=0,w=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=C.indexOf("Linux")>=0,I=!0,y=R.getConfiguredDefaultLocale(R.localize(0,null))||r,d=y;else if(typeof m=="object"){k=m.platform==="win32",T=m.platform==="darwin",A=m.platform==="linux",b=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,E=g,p=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=r,d=r;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),v=h.availableLanguages["*"];y=h.locale,d=v||r,S=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;T?n=1:k?n=3:A&&(n=2),e.isWindows=k,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=b,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isCI=p,e.platform=n,e.userAgent=C,e.language=d;var s;(function(a){function h(){return e.language}a.value=h;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=v;function D(){return e.language==="en"}a.isDefault=D})(s=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let D=0,M=a.length;D<M;D++){const F=a[D];if(F.id===v.data.vscodeScheduleAsyncWork){a.splice(D,1),F.callback();return}}});let h=0;return v=>{const D=++h;a.push({id:D,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:D},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||w?2:k?1:3;let i=!0,o=!1;function u(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],se([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const k=R.globals.vscode.process;r={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[9],se([0,1,36]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,k=97,T=90,A=122,b=46,P=47,I=92,E=58,w=63;class p extends Error{constructor(f,c,n){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const t=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${t} ${s} of type ${c}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function y(l,f){if(typeof l!="string")throw new p(f,"string",l)}function d(l){return l===P||l===I}function S(l){return l===P}function C(l){return l>=r&&l<=T||l>=k&&l<=A}function m(l,f,c,n){let s="",t=0,i=-1,o=0,u=0;for(let a=0;a<=l.length;++a){if(a<l.length)u=l.charCodeAt(a);else{if(n(u))break;u=P}if(n(u)){if(!(i===a-1||o===1))if(o===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const h=s.lastIndexOf(c);h===-1?(s="",t=0):(s=s.slice(0,h),t=s.length-1-s.lastIndexOf(c)),i=a,o=0;continue}else if(s.length!==0){s="",t=0,i=a,o=0;continue}}f&&(s+=s.length>0?`${c}..`:"..",t=2)}else s.length>0?s+=`${c}${l.slice(i+1,a)}`:s=l.slice(i+1,a),t=a-i-1;i=a,o=0}else u===b&&o!==-1?++o:o=-1}return s}function g(l,f){if(f===null||typeof f!="object")throw new p("pathObject","Object",f);const c=f.dir||f.root,n=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${n}`:`${c}${l}${n}`:n}e.win32={resolve(...l){let f="",c="",n=!1;for(let s=l.length-1;s>=-1;s--){let t;if(s>=0){if(t=l[s],y(t,"path"),t.length===0)continue}else f.length===0?t=R.cwd():(t=R.env[`=${f}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===I)&&(t=`${f}\\`));const i=t.length;let o=0,u="",a=!1;const h=t.charCodeAt(0);if(i===1)d(h)&&(o=1,a=!0);else if(d(h))if(a=!0,d(t.charCodeAt(1))){let v=2,D=v;for(;v<i&&!d(t.charCodeAt(v));)v++;if(v<i&&v!==D){const M=t.slice(D,v);for(D=v;v<i&&d(t.charCodeAt(v));)v++;if(v<i&&v!==D){for(D=v;v<i&&!d(t.charCodeAt(v));)v++;(v===i||v!==D)&&(u=`\\\\${M}\\${t.slice(D,v)}`,o=v)}}}else o=1;else C(h)&&t.charCodeAt(1)===E&&(u=t.slice(0,2),o=2,i>2&&d(t.charCodeAt(2))&&(a=!0,o=3));if(u.length>0)if(f.length>0){if(u.toLowerCase()!==f.toLowerCase())continue}else f=u;if(n){if(f.length>0)break}else if(c=`${t.slice(o)}\\${c}`,n=a,a&&f.length>0)break}return c=m(c,!n,"\\",d),n?`${f}\\${c}`:`${f}${c}`||"."},normalize(l){y(l,"path");const f=l.length;if(f===0)return".";let c=0,n,s=!1;const t=l.charCodeAt(0);if(f===1)return S(t)?"\\":l;if(d(t))if(s=!0,d(l.charCodeAt(1))){let o=2,u=o;for(;o<f&&!d(l.charCodeAt(o));)o++;if(o<f&&o!==u){const a=l.slice(u,o);for(u=o;o<f&&d(l.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&!d(l.charCodeAt(o));)o++;if(o===f)return`\\\\${a}\\${l.slice(u)}\\`;o!==u&&(n=`\\\\${a}\\${l.slice(u,o)}`,c=o)}}}else c=1;else C(t)&&l.charCodeAt(1)===E&&(n=l.slice(0,2),c=2,f>2&&d(l.charCodeAt(2))&&(s=!0,c=3));let i=c<f?m(l.slice(c),!s,"\\",d):"";return i.length===0&&!s&&(i="."),i.length>0&&d(l.charCodeAt(f-1))&&(i+="\\"),n===void 0?s?`\\${i}`:i:s?`${n}\\${i}`:`${n}${i}`},isAbsolute(l){y(l,"path");const f=l.length;if(f===0)return!1;const c=l.charCodeAt(0);return d(c)||f>2&&C(c)&&l.charCodeAt(1)===E&&d(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,c;for(let t=0;t<l.length;++t){const i=l[t];y(i,"path"),i.length>0&&(f===void 0?f=c=i:f+=`\\${i}`)}if(f===void 0)return".";let n=!0,s=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++s;const t=c.length;t>1&&d(c.charCodeAt(1))&&(++s,t>2&&(d(c.charCodeAt(2))?++s:n=!1))}if(n){for(;s<f.length&&d(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(l,f){if(y(l,"from"),y(f,"to"),l===f)return"";const c=e.win32.resolve(l),n=e.win32.resolve(f);if(c===n||(l=c.toLowerCase(),f=n.toLowerCase(),l===f))return"";let s=0;for(;s<l.length&&l.charCodeAt(s)===I;)s++;let t=l.length;for(;t-1>s&&l.charCodeAt(t-1)===I;)t--;const i=t-s;let o=0;for(;o<f.length&&f.charCodeAt(o)===I;)o++;let u=f.length;for(;u-1>o&&f.charCodeAt(u-1)===I;)u--;const a=u-o,h=i<a?i:a;let v=-1,D=0;for(;D<h;D++){const F=l.charCodeAt(s+D);if(F!==f.charCodeAt(o+D))break;F===I&&(v=D)}if(D!==h){if(v===-1)return n}else{if(a>h){if(f.charCodeAt(o+D)===I)return n.slice(o+D+1);if(D===2)return n.slice(o+D)}i>h&&(l.charCodeAt(s+D)===I?v=D:D===2&&(v=3)),v===-1&&(v=0)}let M="";for(D=s+v+1;D<=t;++D)(D===t||l.charCodeAt(D)===I)&&(M+=M.length===0?"..":"\\..");return o+=v,M.length>0?`${M}${n.slice(o,u)}`:(n.charCodeAt(o)===I&&++o,n.slice(o,u))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const c=f.charCodeAt(2);if(c!==w&&c!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(C(f.charCodeAt(0))&&f.charCodeAt(1)===E&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return l},dirname(l){y(l,"path");const f=l.length;if(f===0)return".";let c=-1,n=0;const s=l.charCodeAt(0);if(f===1)return d(s)?l:".";if(d(s)){if(c=n=1,d(l.charCodeAt(1))){let o=2,u=o;for(;o<f&&!d(l.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&d(l.charCodeAt(o));)o++;if(o<f&&o!==u){for(u=o;o<f&&!d(l.charCodeAt(o));)o++;if(o===f)return l;o!==u&&(c=n=o+1)}}}}else C(s)&&l.charCodeAt(1)===E&&(c=f>2&&d(l.charCodeAt(2))?3:2,n=c);let t=-1,i=!0;for(let o=f-1;o>=n;--o)if(d(l.charCodeAt(o))){if(!i){t=o;break}}else i=!1;if(t===-1){if(c===-1)return".";t=c}return l.slice(0,t)},basename(l,f){f!==void 0&&y(f,"ext"),y(l,"path");let c=0,n=-1,s=!0,t;if(l.length>=2&&C(l.charCodeAt(0))&&l.charCodeAt(1)===E&&(c=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,o=-1;for(t=l.length-1;t>=c;--t){const u=l.charCodeAt(t);if(d(u)){if(!s){c=t+1;break}}else o===-1&&(s=!1,o=t+1),i>=0&&(u===f.charCodeAt(i)?--i===-1&&(n=t):(i=-1,n=o))}return c===n?n=o:n===-1&&(n=l.length),l.slice(c,n)}for(t=l.length-1;t>=c;--t)if(d(l.charCodeAt(t))){if(!s){c=t+1;break}}else n===-1&&(s=!1,n=t+1);return n===-1?"":l.slice(c,n)},extname(l){y(l,"path");let f=0,c=-1,n=0,s=-1,t=!0,i=0;l.length>=2&&l.charCodeAt(1)===E&&C(l.charCodeAt(0))&&(f=n=2);for(let o=l.length-1;o>=f;--o){const u=l.charCodeAt(o);if(d(u)){if(!t){n=o+1;break}continue}s===-1&&(t=!1,s=o+1),u===b?c===-1?c=o:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||s===-1||i===0||i===1&&c===s-1&&c===n+1?"":l.slice(c,s)},format:g.bind(null,"\\"),parse(l){y(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const c=l.length;let n=0,s=l.charCodeAt(0);if(c===1)return d(s)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(d(s)){if(n=1,d(l.charCodeAt(1))){let v=2,D=v;for(;v<c&&!d(l.charCodeAt(v));)v++;if(v<c&&v!==D){for(D=v;v<c&&d(l.charCodeAt(v));)v++;if(v<c&&v!==D){for(D=v;v<c&&!d(l.charCodeAt(v));)v++;v===c?n=v:v!==D&&(n=v+1)}}}}else if(C(s)&&l.charCodeAt(1)===E){if(c<=2)return f.root=f.dir=l,f;if(n=2,d(l.charCodeAt(2))){if(c===3)return f.root=f.dir=l,f;n=3}}n>0&&(f.root=l.slice(0,n));let t=-1,i=n,o=-1,u=!0,a=l.length-1,h=0;for(;a>=n;--a){if(s=l.charCodeAt(a),d(s)){if(!u){i=a+1;break}continue}o===-1&&(u=!1,o=a+1),s===b?t===-1?t=a:h!==1&&(h=1):t!==-1&&(h=-1)}return o!==-1&&(t===-1||h===0||h===1&&t===o-1&&t===i+1?f.base=f.name=l.slice(i,o):(f.name=l.slice(i,t),f.base=l.slice(i,o),f.ext=l.slice(t,o))),i>0&&i!==n?f.dir=l.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",c=!1;for(let n=l.length-1;n>=-1&&!c;n--){const s=n>=0?l[n]:R.cwd();y(s,"path"),s.length!==0&&(f=`${s}/${f}`,c=s.charCodeAt(0)===P)}return f=m(f,!c,"/",S),c?`/${f}`:f.length>0?f:"."},normalize(l){if(y(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===P,c=l.charCodeAt(l.length-1)===P;return l=m(l,!f,"/",S),l.length===0?f?"/":c?"./":".":(c&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return y(l,"path"),l.length>0&&l.charCodeAt(0)===P},join(...l){if(l.length===0)return".";let f;for(let c=0;c<l.length;++c){const n=l[c];y(n,"path"),n.length>0&&(f===void 0?f=n:f+=`/${n}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(y(l,"from"),y(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const c=1,n=l.length,s=n-c,t=1,i=f.length-t,o=s<i?s:i;let u=-1,a=0;for(;a<o;a++){const v=l.charCodeAt(c+a);if(v!==f.charCodeAt(t+a))break;v===P&&(u=a)}if(a===o)if(i>o){if(f.charCodeAt(t+a)===P)return f.slice(t+a+1);if(a===0)return f.slice(t+a)}else s>o&&(l.charCodeAt(c+a)===P?u=a:a===0&&(u=0));let h="";for(a=c+u+1;a<=n;++a)(a===n||l.charCodeAt(a)===P)&&(h+=h.length===0?"..":"/..");return`${h}${f.slice(t+u)}`},toNamespacedPath(l){return l},dirname(l){if(y(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===P;let c=-1,n=!0;for(let s=l.length-1;s>=1;--s)if(l.charCodeAt(s)===P){if(!n){c=s;break}}else n=!1;return c===-1?f?"/":".":f&&c===1?"//":l.slice(0,c)},basename(l,f){f!==void 0&&y(f,"ext"),y(l,"path");let c=0,n=-1,s=!0,t;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,o=-1;for(t=l.length-1;t>=0;--t){const u=l.charCodeAt(t);if(u===P){if(!s){c=t+1;break}}else o===-1&&(s=!1,o=t+1),i>=0&&(u===f.charCodeAt(i)?--i===-1&&(n=t):(i=-1,n=o))}return c===n?n=o:n===-1&&(n=l.length),l.slice(c,n)}for(t=l.length-1;t>=0;--t)if(l.charCodeAt(t)===P){if(!s){c=t+1;break}}else n===-1&&(s=!1,n=t+1);return n===-1?"":l.slice(c,n)},extname(l){y(l,"path");let f=-1,c=0,n=-1,s=!0,t=0;for(let i=l.length-1;i>=0;--i){const o=l.charCodeAt(i);if(o===P){if(!s){c=i+1;break}continue}n===-1&&(s=!1,n=i+1),o===b?f===-1?f=i:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||n===-1||t===0||t===1&&f===n-1&&f===c+1?"":l.slice(f,n)},format:g.bind(null,"/"),parse(l){y(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const c=l.charCodeAt(0)===P;let n;c?(f.root="/",n=1):n=0;let s=-1,t=0,i=-1,o=!0,u=l.length-1,a=0;for(;u>=n;--u){const h=l.charCodeAt(u);if(h===P){if(!o){t=u+1;break}continue}i===-1&&(o=!1,i=u+1),h===b?s===-1?s=u:a!==1&&(a=1):s!==-1&&(a=-1)}if(i!==-1){const h=t===0&&c?1:t;s===-1||a===0||a===1&&s===i-1&&s===t+1?f.base=f.name=l.slice(h,i):(f.name=l.slice(h,s),f.base=l.slice(h,i),f.ext=l.slice(s,i))}return t>0?f.dir=l.slice(0,t-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[123],se([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(E){const w=(0,R.extname)(E),p=r[w.toLowerCase()];return p!==void 0?p:A(E)}e.getMediaOrTextMime=T;function A(E){const w=(0,R.extname)(E);return k[w.toLowerCase()]}e.getMediaMime=A;function b(E){for(const w in k)if(k[w]===E)return w}e.getExtensionForMimeType=b;const P=/^(.+)\/(.+?)(;.+)?$/;function I(E,w){const p=P.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:w?void 0:E}e.normalizeMimeType=I}),define(ne[77],se([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(b,...P){const I=P.reduce((p,y)=>(p[y]=!0,p),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!I[p]).forEach(p=>{for(let y=0;y<E.length;y++)if(p.search(E[y])!==-1){delete b[p];break}})}e.sanitizeProcessEnvironment=T;function A(b){!b||(delete b.DEBUG,R.isMacintosh&&delete b.DYLD_LIBRARY_PATH,R.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[124],se([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=R.globals.performance&&typeof R.globals.performance.now=="function";class k{constructor(A){this._highResolution=r&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],se([0,1,10,74,2,112,124]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,P=!1;var I;(function(u){u.None=()=>k.Disposable.None;function a(U){if(P){const{onListenerDidAdd:W}=U,j=d.create();let Z=0;U.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),W?.()}}}function h(U){return(W,j=null,Z)=>{let oe=!1,Q;return Q=U(ie=>{if(!oe)return Q?Q.dispose():oe=!0,W.call(j,ie)},null,Z),oe&&Q.dispose(),Q}}u.once=h;function v(U,W,j){return N((Z,oe=null,Q)=>U(ie=>Z.call(oe,W(ie)),null,Q),j)}u.map=v;function D(U,W,j){return N((Z,oe=null,Q)=>U(ie=>{W(ie),Z.call(oe,ie)},null,Q),j)}u.forEach=D;function M(U,W,j){return N((Z,oe=null,Q)=>U(ie=>W(ie)&&Z.call(oe,ie),null,Q),j)}u.filter=M;function F(U){return U}u.signal=F;function O(...U){return(W,j=null,Z)=>(0,k.combinedDisposable)(...U.map(oe=>oe(Q=>W.call(j,Q),null,Z)))}u.any=O;function L(U,W,j,Z){let oe=j;return v(U,Q=>(oe=W(oe,Q),oe),Z)}u.reduce=L;function N(U,W){let j;const Z={onFirstListenerAdd(){j=U(oe.fire,oe)},onLastListenerRemove(){j?.dispose()}};W||a(Z);const oe=new C(Z);return W?.add(oe),oe.event}function $(U,W,j=100,Z=!1,oe,Q){let ie,re,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=U(Ee=>{he++,re=W(re,Ee),Z&&!ue&&(we.fire(re),re=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=re;re=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},j)})},onLastListenerRemove(){ie.dispose()}};Q||a(ve);const we=new C(ve);return Q?.add(we),we.event}u.debounce=$;function V(U,W=(Z,oe)=>Z===oe,j){let Z=!0,oe;return M(U,Q=>{const ie=Z||!W(Q,oe);return Z=!1,oe=Q,ie},j)}u.latch=V;function J(U,W,j){return[u.filter(U,W,j),u.filter(U,Z=>!W(Z),j)]}u.split=J;function H(U,W=!1,j=[]){let Z=j.slice(),oe=U(re=>{Z?Z.push(re):ie.fire(re)});const Q=()=>{Z?.forEach(re=>ie.fire(re)),Z=null},ie=new C({onFirstListenerAdd(){oe||(oe=U(re=>ie.fire(re)))},onFirstListenerDidAdd(){Z&&(W?setTimeout(Q):Q())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}u.buffer=H;class G{constructor(W){this.event=W,this.disposables=new k.DisposableStore}map(W){return new G(v(this.event,W,this.disposables))}forEach(W){return new G(D(this.event,W,this.disposables))}filter(W){return new G(M(this.event,W,this.disposables))}reduce(W,j){return new G(L(this.event,W,j,this.disposables))}latch(){return new G(V(this.event,void 0,this.disposables))}debounce(W,j=100,Z=!1,oe){return new G($(this.event,W,j,Z,oe,this.disposables))}on(W,j,Z){return this.event(W,j,Z)}once(W,j,Z){return h(this.event)(W,j,Z)}dispose(){this.disposables.dispose()}}function q(U){return new G(U)}u.chain=q;function x(U,W,j=Z=>Z){const Z=(...re)=>ie.fire(j(...re)),oe=()=>U.on(W,Z),Q=()=>U.removeListener(W,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:Q});return ie.event}u.fromNodeEventEmitter=x;function Y(U,W,j=Z=>Z){const Z=(...re)=>ie.fire(j(...re)),oe=()=>U.addEventListener(W,Z),Q=()=>U.removeEventListener(W,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:Q});return ie.event}u.fromDOMEventEmitter=Y;function te(U){return new Promise(W=>h(U)(W))}u.toPromise=te;function ce(U,W){return W(void 0),U(j=>W(j))}u.runAndSubscribe=ce;function z(U,W){let j=null;function Z(Q){j?.dispose(),j=new k.DisposableStore,W(Q,j)}Z(void 0);const oe=U(Q=>Z(Q));return(0,k.toDisposable)(()=>{oe.dispose(),j?.dispose()})}u.runAndSubscribeWithStore=z;class B{constructor(W,j){this.obs=W,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{W.addObserver(this)},onLastListenerRemove:()=>{W.removeObserver(this)}};j||a(Z),this.emitter=new C(Z),j&&j.add(this.emitter)}beginUpdate(W){this._counter++}handleChange(W,j){this._hasChanged=!0}endUpdate(W){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function _(U,W){return new B(U,W).emitter.event}u.fromObservable=_})(I=e.Event||(e.Event={}));class E{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${E._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let w=-1;function p(u){const a=w;return w=u,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=p;class y{constructor(a,h=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,h){let v=w;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let M,F=0;for(const[O,L]of this._stacks)(!M||F<L)&&(M=O,F=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this._stacks.get(a.value)||0;this._stacks.set(a.value,M-1)}}}class d{constructor(a){this.value=a}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(a,h,v){this.callback=a,this.callbackThis=h,this.stack=v,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class C{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,h,v)=>{this._listeners||(this._listeners=new T.LinkedList);const D=this._listeners.isEmpty();D&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,F;this._leakageMon&&this._listeners.size>=30&&(F=d.create(),M=this._leakageMon.check(F,this._listeners.size+1)),b&&(F=F??d.create());const O=new S(a,h,F),L=this._listeners.push(O);D&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,h);const N=O.subscription.set(()=>{M?.(),this._disposed||(L(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof k.DisposableStore?v.add(N):Array.isArray(v)&&v.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const h of this._listeners)this._deliveryQueue.push(this,h,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class m{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(a,h,v){this._queue.push(new l(a,h,v))}clear(a){const h=new T.LinkedList;for(const v of this._queue)v.emitter!==a&&h.push(v);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){(0,R.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=m;class g extends m{clear(a){this._queue.clear()}}class l{constructor(a,h,v){this.emitter=a,this.listener=h,this.event=v}}class f extends C{async fireAsync(a,h,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const D of this._listeners)this._asyncDeliveryQueue.push([D,a]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[D,M]=this._asyncDeliveryQueue.shift(),F=[],O={...M,token:h,waitUntil:L=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");v&&(L=v(L,D.callback)),F.push(L)}};try{D.invoke(O)}catch(L){(0,R.onUnexpectedError)(L);continue}Object.freeze(F),await Promise.allSettled(F).then(L=>{for(const N of L)N.status==="rejected"&&(0,R.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=f;class c extends C{constructor(a){super(a),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class n extends c{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class s extends C{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const h={event:a,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const v=()=>{this.hasListeners&&this.unhook(h);const D=this.events.indexOf(h);this.events.splice(D,1)};return(0,k.toDisposable)((0,r.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(h=>this.emitter.fire(h))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(a){return(h,v,D)=>a(M=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>h.call(v,M)):h.call(v,M)},void 0,D)}bufferEvents(a){const h=[];this.buffers.push(h);const v=a();return this.buffers.pop(),h.forEach(D=>D()),v}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[21],se([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(b,P){const I=setTimeout(b.bind(P),0);return{dispose(){clearTimeout(I)}}});var k;(function(b){function P(I){return I===b.None||I===b.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=P,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ne[125],se([0,1,21]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new R.CancellationTokenSource,P=this.task(b.token);return this.result={promise:P,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=r;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const P=JSON.stringify(b);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class T{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const P=this.fn(b);return this._map.set(b,P),P}}e.CachedFunction=T}),define(ne[78],se([0,1,3,2]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=k;class T extends r.Disposable{constructor(b){super(),this._value=b,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=T}),define(ne[24],se([0,1,125,111]),function(X,e,R,r){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function b(ee,...le){return le.length===0?ee:ee.replace(A,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=b;const P=/{([^}]+)}/g;function I(ee,le){return ee.replace(P,(me,ge)=>le[ge]??me)}e.format2=I;function E(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=E;function w(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function p(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=p;function y(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=y;function d(ee,le=" "){const me=S(ee,le);return C(me,le)}e.trim=d;function S(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=S;function C(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=C;function m(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function l(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=w(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=l;function f(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=n;function s(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function i(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=i;function o(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function u(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=u;function a(ee,le){return ee<le?-1:ee>le?1:0}e.compare=a;function h(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=h;function v(ee,le){return D(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=v;function D(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return h(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);F(qe)&&(qe-=32),F(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=D;function M(ee){return ee>=48&&ee<=57}e.isAsciiDigit=M;function F(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=F;function O(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=O;function L(ee,le){return ee.length===le.length&&D(ee,le)===0}e.equalsIgnoreCase=L;function N(ee,le){const me=le.length;return le.length>ee.length?!1:D(ee,le,0,me)===0}e.startsWithIgnoreCase=N;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function V(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=V;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function G(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=G;function q(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return G(ge,Se)}return ge}e.getNextCodePoint=q;function x(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return G(ge,me)}return me}class Y{constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=x(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=q(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{constructor(le,me=0){this._iterator=new Y(le,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=le.getGraphemeBreakType(me.nextCodePoint());if(fe(Se,Re)){me.setOffset(be);break}Se=Re}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=le.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,Se)){me.setOffset(be);break}Se=Re}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function z(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=z;function B(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-z(ee,me),me]}e.getCharContainingOffset=B;let _;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(ee){return _||(_=U()),_.test(ee)}e.containsRTL=W;const j=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return j.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function Q(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=Q;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function re(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=re;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const Re=ge.indexOf(le[Se],be+1);if(Re<0)return!1;be=Re,Se++}return!0}e.fuzzyContains=Ue;function ze(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=ze;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function We(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=We;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function de(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=de;function fe(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{constructor(){this._data=Me()}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=De;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{constructor(le){this.confusableDictionary=le}static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,k=_e,_e.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new R.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let je=0;je<Le.length;je+=2)Ne.set(Le[je],Le[je+1]);return Ne}function me(Le,Ne){const je=new Map(Le);for(const[Xe,Ze]of Ne)je.set(Xe,Ze);return je}function ge(Le,Ne){if(!Le)return Ne;const je=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&je.set(Xe,Ze);return je}const Se=k.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Ne=le(Se[Le]);Re=ge(Re,Ne)}const Te=le(Se._common),qe=me(Te,Re);return new _e(qe)}),_e._locales=new r.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[46],se([0,1,9,4,24,14]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function b(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=b;function P(o){return o.indexOf("/")===-1&&(o=b(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function I(o,u=R.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let D=3;const M=D;for(;D<a&&!A(o.charCodeAt(D));D++);if(M!==D&&!A(o.charCodeAt(D+1))){for(D+=1;D<a;D++)if(A(o.charCodeAt(D)))return o.slice(0,D+1).replace(/[\\/]/g,u)}}return u}else if(m(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<a;v++)if(A(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=I;function E(o){if(!r.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let a=2;const h=a;for(;a<o.length&&(u=o.charCodeAt(a),u!==92);a++);return!(h===a||(u=o.charCodeAt(a+1),isNaN(u)||u===92))}e.isUNC=E;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,u=r.isWindows){const a=u?w:p;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||u&&y.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function S(o,u,a){const h=o===u;return!a||h?h:!o||!u?!1:(0,k.equalsIgnoreCase)(o,u)}e.isEqual=S;function C(o,u,a,h=R.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let D=u.length;return u.charAt(u.length-1)===h&&D--,o.charAt(D)===h}return u.charAt(u.length-1)!==h&&(u+=h),o.indexOf(u)===0}e.isEqualOrParent=C;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function g(o,u){return r.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(u,o)),o=(0,R.normalize)(o),r.isWindows?(o=(0,k.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,k.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function l(o){const u=(0,R.normalize)(o);return r.isWindows?o.length>3?!1:f(u)&&(o.length===2||u.charCodeAt(2)===92):u===R.posix.sep}e.isRootOrDriveLetter=l;function f(o,u=r.isWindows){return u?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(o){return f(o)?o[0]:void 0}e.getDriveLetter=c;function n(o,u,a){return u.length>o.length?-1:o===u?0:(a&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=n;function s(o){const u=o.split(":");let a,h,v;for(const D of u){const M=Number(D);(0,T.isNumber)(M)?h===void 0?h=M:v===void 0&&(v=M):a=a?[a,D].join(":"):D}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,u,a=8){let h="";for(let D=0;D<a;D++)h+=t.charAt(Math.floor(Math.random()*t.length));let v;return u?v=`${u}-${h}`:v=h,o?(0,R.join)(o,v):v}e.randomPath=i}),define(ne[62],se([0,1,24]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(m){return k(m,0)}e.hash=r;function k(m,g){switch(typeof m){case"object":return m===null?T(349,g):Array.isArray(m)?P(m,g):I(m,g);case"string":return b(m,g);case"boolean":return A(m,g);case"number":return T(m,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(m,g){return(g<<5)-g+m|0}e.numberHash=T;function A(m,g){return T(m?433:863,g)}function b(m,g){g=T(149417,g);for(let l=0,f=m.length;l<f;l++)g=T(m.charCodeAt(l),g);return g}e.stringHash=b;function P(m,g){return g=T(104579,g),m.reduce((l,f)=>k(f,l),g)}function I(m,g){return g=T(181387,g),Object.keys(m).sort().reduce((l,f)=>(l=b(f,l),k(m[f],l)),g)}class E{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=E;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(m,g,l=32){const f=l-g,c=~((1<<f)-1);return(m<<g|(c&m)>>>f)>>>0}function y(m,g=0,l=m.byteLength,f=0){for(let c=0;c<l;c++)m[g+c]=f}function d(m,g,l="0"){for(;m.length<g;)m=l+m;return m}function S(m,g=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),g/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const l=g.length;if(l===0)return;const f=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,s,t;for(n!==0?(s=n,t=-1,n=0):(s=g.charCodeAt(0),t=0);;){let i=s;if(R.isHighSurrogate(s))if(t+1<l){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,i=R.computeCodePoint(s,o)):i=65533}else{n=s;break}else R.isLowSurrogate(s)&&(i=65533);if(c=this._push(f,c,i),t++,t<l)s=g.charCodeAt(t);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(g,l,f){return f<128?g[l++]=f:f<2048?(g[l++]=192|(f&1984)>>>6,g[l++]=128|(f&63)>>>0):f<65536?(g[l++]=224|(f&61440)>>>12,g[l++]=128|(f&4032)>>>6,g[l++]=128|(f&63)>>>0):(g[l++]=240|(f&1835008)>>>18,g[l++]=128|(f&258048)>>>12,g[l++]=128|(f&4032)>>>6,g[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,l=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,p(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this._h0,c=this._h1,n=this._h2,s=this._h3,t=this._h4,i,o,u;for(let a=0;a<80;a++)a<20?(i=c&n|~c&s,o=1518500249):a<40?(i=c^n^s,o=1859775393):a<60?(i=c&n|c&s|n&s,o=2400959708):(i=c^n^s,o=3395469782),u=p(f,5)+i+t+o+g.getUint32(a*4,!1)&4294967295,t=s,s=n,n=p(c,30),c=f,f=u;this._h0=this._h0+f&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],se([0,1,18,24]),function(X,e,R,r){"use strict";var k,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(t,i,o){let u=t.get(i);return u===void 0&&(u=o,t.set(i,u)),u}e.getOrSet=b;function P(t){const i=[];return t.forEach((o,u)=>{i.push(`${u} => ${o}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=P;function I(t){const i=[];return t.forEach(o=>{i.push(o)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=I;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return o-u}value(){return this._value[this._pos]}}e.StringIterator=E;class w{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class p{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const u=this._value.charCodeAt(o);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,r.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class m{constructor(i){this._iter=i}static forUris(i=()=>!1,o=()=>!1){return new m(new d(i,o))}static forPaths(i=!1){return new m(new p(void 0,!i))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new w)}clear(){this._root=void 0}fill(i,o){if(o){const u=o.slice(0);(0,R.shuffle)(u);for(const a of u)this.set(a,i)}else{const u=i.slice(0);(0,R.shuffle)(u);for(const a of u)this.set(a[0],a[1])}}set(i,o){const u=this._iter.reset(i);let a;this._root||(this._root=new S,this._root.segment=u.value());const h=[];for(a=this._root;;){const D=u.cmp(a.segment);if(D>0)a.left||(a.left=new S,a.left.segment=u.value()),h.push([-1,a]),a=a.left;else if(D<0)a.right||(a.right=new S,a.right.segment=u.value()),h.push([1,a]),a=a.right;else if(u.hasNext())u.next(),a.mid||(a.mid=new S,a.mid.segment=u.value()),h.push([0,a]),a=a.mid;else break}const v=a.value;a.value=o,a.key=i;for(let D=h.length-1;D>=0;D--){const M=h[D][1];M.updateHeight();const F=M.balanceFactor();if(F<-1||F>1){const O=h[D][0],L=h[D+1][0];if(O===1&&L===1)h[D][1]=M.rotateLeft();else if(O===-1&&L===-1)h[D][1]=M.rotateRight();else if(O===1&&L===-1)M.right=h[D+1][1]=h[D+1][1].rotateRight(),h[D][1]=M.rotateLeft();else if(O===-1&&L===1)M.left=h[D+1][1]=h[D+1][1].rotateLeft(),h[D][1]=M.rotateRight();else throw new Error;if(D>0)switch(h[D-1][0]){case-1:h[D-1][1].left=h[D][1];break;case 1:h[D-1][1].right=h[D][1];break;case 0:h[D-1][1].mid=h[D][1];break}else this._root=h[0][1]}}return v}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let u=this._root;for(;u;){const a=o.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else break}return u}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const u=this._iter.reset(i),a=[];let h=this._root;for(;h;){const v=u.cmp(h.segment);if(v>0)a.push([-1,h]),h=h.left;else if(v<0)a.push([1,h]),h=h.right;else if(u.hasNext())u.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right),{key:D,value:M,segment:F}=v;this._delete(v.key,!1),h.key=D,h.value=M,h.segment=F}else{const v=h.left??h.right;if(a.length>0){const[D,M]=a[a.length-1];switch(D){case-1:M.left=v;break;case 0:M.mid=v;break;case 1:M.right=v;break}}else this._root=v}for(let v=a.length-1;v>=0;v--){const D=a[v][1];D.updateHeight();const M=D.balanceFactor();if(M>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),a[v][1]=D.rotateLeft()):M<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),a[v][1]=D.rotateRight()),v>0)switch(a[v-1][0]){case-1:a[v-1][1].left=a[v][1];break;case 1:a[v-1][1].right=a[v][1];break;case 0:a[v-1][1].mid=a[v][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let u=this._root,a;for(;u;){const h=o.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(o.hasNext())o.next(),a=u.value||a,u=u.mid;else break}return u&&u.value||a}findSuperstr(i){const o=this._iter.reset(i);let u=this._root;for(;u;){const a=o.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(o.hasNext())o.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[o,u]of this)i(u,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const u=o.balanceFactor();return u<-1||u>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=m;class g{constructor(i,o){this.uri=i,this.value=o}}class l{constructor(i,o){this[k]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=o??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new g(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o<"u"&&(i=i.bind(o));for(const[u,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=t=>t.toString();class f{constructor(i,o){this[T]="ResourceSet",!i||typeof i=="function"?this._map=new l(i):(this._map=new l(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((u,a)=>i.call(o,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class n{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const u=this._map.get(i);if(!!u)return o!==0&&this.touch(u,o),u.value}set(i,o,u=0){let a=this._map.get(i);if(a)a.value=o,u!==0&&this.touch(a,u);else{switch(a={key:i,value:o,next:void 0,previous:void 0},u){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const u=this._state;let a=this._head;for(;a;){if(o?i.bind(o)(a.value,a.key,this):i(a.value,a.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,o=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:u.key,done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return a}values(){const i=this,o=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:u.value,done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return a}entries(){const i=this,o=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const h={value:[u.key,u.value],done:!1};return u=u.next,h}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,u=this.size;for(;o&&u>i;)this._map.delete(o.key),o=o.next,u--;this._head=o,this._size=u,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,u=i.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const u=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(u.previous=a,a.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const u=i.next,a=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=a,a.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,u)=>{i.push([u,o])}),i}fromJSON(i){this.clear();for(const[o,u]of i)this.set(o,u)}}e.LinkedMap=n;class s extends n{constructor(i,o=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[79],se([0,1,34]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new R.LRUCache(1e4);function k(I){return P(I,"NFC",r)}e.normalizeNFC=k;const T=new R.LRUCache(1e4);function A(I){return P(I,"NFD",T)}e.normalizeNFD=A;const b=/[^\u0000-\u0080]/;function P(I,E,w){if(!I)return I;const p=w.get(I);if(p)return p;let y;return b.test(I)?y=I.normalize(E):y=I,w.set(I,y),y}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(E){return A(E).replace(I,"")}}()}),define(ne[80],se([0,1,24]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(r||(r={})),function(k){const T="error",A="warning",b="warn",P="info",I="ignore";function E(p){return p?R.equalsIgnoreCase(T,p)?k.Error:R.equalsIgnoreCase(A,p)||R.equalsIgnoreCase(b,p)?k.Warning:R.equalsIgnoreCase(P,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function w(p){switch(p){case k.Error:return T;case k.Warning:return A;case k.Info:return P;default:return I}}k.toString=w}(r||(r={})),e.default=r}),define(ne[7],se([0,1,9,4]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function b(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,i){return!t&&!i?"file":t}function I(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==w&&(i=w+i):i=w;break}return i}const E="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,o,u,a,h,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,v),this.authority=o||E,this.path=I(this.scheme,u||E),this.query=a||E,this.fragment=h||E,b(this,v))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:u,path:a,query:h,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),u===void 0?u=this.authority:u===null&&(u=E),a===void 0?a=this.path:a===null&&(a=E),h===void 0?h=this.query:h===null&&(h=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&u===this.authority&&a===this.path&&h===this.query&&v===this.fragment?this:new S(o,u,a,h,v)}static parse(i,o=!1){const u=p.exec(i);return u?new S(u[2]||E,s(u[4]||E),s(u[5]||E),s(u[7]||E),s(u[9]||E),o):new S(E,E,E,E,E)}static file(i){let o=E;if(r.isWindows&&(i=i.replace(/\\/g,w)),i[0]===w&&i[1]===w){const u=i.indexOf(w,2);u===-1?(o=i.substring(2),i=w):(o=i.substring(2,u),i=i.substring(u)||w)}return new S("file",o,i,E,E)}static from(i){const o=new S(i.scheme,i.authority,i.path,i.query,i.fragment);return b(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&i.scheme==="file"?u=y.file(R.win32.join(l(i,!0),...o)).path:u=R.posix.join(i.path,...o),i.with({path:u})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const o=new S(i);return o._formatted=i.external,o._fsPath=i._sep===d?i.fsPath:null,o}}else return i}}e.URI=y;const d=r.isWindows?1:void 0;class S extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(t,i){let o,u=-1;for(let a=0;a<t.length;a++){const h=t.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)u!==-1&&(o+=encodeURIComponent(t.substring(u,a)),u=-1),o!==void 0&&(o+=t.charAt(a));else{o===void 0&&(o=t.substr(0,a));const v=C[h];v!==void 0?(u!==-1&&(o+=encodeURIComponent(t.substring(u,a)),u=-1),o+=v):u===-1&&(u=a)}}return u!==-1&&(o+=encodeURIComponent(t.substring(u))),o!==void 0?o:t}function g(t){let i;for(let o=0;o<t.length;o++){const u=t.charCodeAt(o);u===35||u===63?(i===void 0&&(i=t.substr(0,o)),i+=C[u]):i!==void 0&&(i+=t[o])}return i!==void 0?i:t}function l(t,i){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,r.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=l;function f(t,i){const o=i?g:m;let u="",{scheme:a,authority:h,path:v,query:D,fragment:M}=t;if(a&&(u+=a,u+=":"),(h||a==="file")&&(u+=w,u+=w),h){let F=h.indexOf("@");if(F!==-1){const O=h.substr(0,F);h=h.substr(F+1),F=O.indexOf(":"),F===-1?u+=o(O,!1):(u+=o(O.substr(0,F),!1),u+=":",u+=o(O.substr(F+1),!1)),u+="@"}h=h.toLowerCase(),F=h.indexOf(":"),F===-1?u+=o(h,!1):(u+=o(h.substr(0,F),!1),u+=h.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const F=v.charCodeAt(1);F>=65&&F<=90&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const F=v.charCodeAt(0);F>=65&&F<=90&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}u+=o(v,!0)}return D&&(u+="?",u+=o(D,!1)),M&&(u+="#",u+=i?M:m(M,!1)),u}function c(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+c(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(n)?t.replace(n,i=>c(i)):t}}),define(ne[126],se([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(I){const E=I;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=r;function k(I){const E=[];let w;try{const p=JSON.parse(I.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),w=y.__$stack),E.push(...p)}catch{E.push("Unable to log remote console arguments",I.arguments)}return{args:E,stack:w}}e.parse=k;function T(I){if(typeof I!="string")return T(k(I).stack);const E=I;if(E){const w=A(E),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:R.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=T;function A(I){if(!I)return I;const E=I.indexOf(`
`);return E===-1?I:I.substring(0,E)}function b(I,E){const{args:w,stack:p}=k(I),y=typeof w[0]=="string"&&w.length===1;let d=A(p);d&&(d=`(${d.trim()})`);let S=[];if(typeof w[0]=="string"?d&&y?S=[`%c[${E}] %c${w[0]} %c${d}`,P("blue"),P(""),P("grey")]:S=[`%c[${E}] %c${w[0]}`,P("blue"),P(""),...w.slice(1)]:S=[`%c[${E}]%`,P("blue"),...w],d&&!y&&S.push(d),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,S)}e.log=b;function P(I){return`color: ${I}`}}),define(ne[63],se([0,1,16,24,7]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,b)}e.stringify=T;function A(I){let E=JSON.parse(I);return E=P(E),E}e.parse=A;function b(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,r.regExpFlags)(E)}:E}function P(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return k.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof R.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let w=0;w<I.length;++w)I[w]=P(I[w],E+1);else for(const w in I)Object.hasOwnProperty.call(I,w)&&(I[w]=P(I[w],E+1))}return I}e.revive=P}),define(ne[20],se([0,1,4,7]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${k.vscodeRemoteResource}`}set(P,I,E){this._hosts[P]=I,this._ports[P]=E}setConnectionToken(P,I){this._connectionTokens[P]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const I=P.authority;let E=this._hosts[I];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const w=this._ports[I],p=this._connectionTokens[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),r.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${w}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new T;class A{asBrowserUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==A.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,I){return r.URI.isUri(P)?P:r.URI.parse(I.toUrl(P))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[17],se([0,1,46,20,9,4,24,7]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(y){return(0,b.uriToFsPath)(y,!0)}e.originalFSPath=P;class I{constructor(d){this._ignorePathCasing=d}compare(d,S,C=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,C),this.getComparisonKey(S,C))}isEqual(d,S,C=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,C)===this.getComparisonKey(S,C)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,C=!1){if(d.scheme===S.scheme){if(d.scheme===r.Schemas.file)return R.isEqualOrParent(P(d),P(S),this._ignorePathCasing(d))&&d.query===S.query&&(C||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return R.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(C||d.fragment===S.fragment)}return!1}joinPath(d,...S){return b.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===r.Schemas.file?S=b.URI.file(k.dirname(P(d))).path:(S=k.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===r.Schemas.file?S=b.URI.file(k.normalize(P(d))).path:S=k.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===r.Schemas.file){const g=k.relative(P(d),P(S));return T.isWindows?R.toSlashes(g):g}let C=d.path||"/";const m=S.path||"/";if(this._ignorePathCasing(d)){let g=0;for(const l=Math.min(C.length,m.length);g<l&&!(C.charCodeAt(g)!==m.charCodeAt(g)&&C.charAt(g).toLowerCase()!==m.charAt(g).toLowerCase());g++);C=m.substr(0,g)+C.substr(g)}return k.posix.relative(C,m)}resolvePath(d,S){if(d.scheme===r.Schemas.file){const C=b.URI.file(k.resolve(P(d),S));return d.with({authority:C.authority,path:C.path})}return S=R.toPosixPath(S),d.with({path:k.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=k.sep){if(d.scheme===r.Schemas.file){const C=P(d);return C.length>R.getRoot(C).length&&C[C.length-1]===S}else{const C=d.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=k.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=k.sep){let C=!1;if(d.scheme===r.Schemas.file){const m=P(d);C=m!==void 0&&m.length===R.getRoot(m).length&&m[m.length-1]===S}else{S="/";const m=d.path;C=m.length===1&&m.charCodeAt(m.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(y=>y.scheme===r.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(y,d){const S=[];for(let C=0;C<y.length;C++){const m=d(y[C]);y.some((g,l)=>l===C?!1:(0,e.isEqualOrParent)(m,d(g)))||S.push(y[C])}return S}e.distinctParents=E;var w;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,c]=l.split(":");f&&c&&C.set(f,c)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&C.set(y.META_DATA_MIME,g),C}y.parseMetaData=d})(w=e.DataUri||(e.DataUri={}));function p(y,d,S){if(d){let C=y.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),y.with({scheme:S,authority:d,path:C})}return y.with({scheme:S})}e.toLocalResource=p}),define(ne[6],se([0,1,21,10,3,2,17,4]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(B){return!!B&&typeof B.then=="function"}e.isThenable=P;function I(B){const _=new R.CancellationTokenSource,U=B(_.token),W=new Promise((j,Z)=>{const oe=_.token.onCancellationRequested(()=>{oe.dispose(),_.dispose(),Z(new r.CancellationError)});Promise.resolve(U).then(Q=>{oe.dispose(),_.dispose(),j(Q)},Q=>{oe.dispose(),_.dispose(),Z(Q)})});return new class{cancel(){_.cancel()}then(j,Z){return W.then(j,Z)}catch(j){return this.then(void 0,j)}finally(j){return W.finally(j)}}}e.createCancelablePromise=I;function E(B,_,U){return new Promise((W,j)=>{const Z=_.onCancellationRequested(()=>{Z.dispose(),W(U)});B.then(W,j).finally(()=>Z.dispose())})}e.raceCancellation=E;function w(B,_){return new Promise((U,W)=>{const j=_.onCancellationRequested(()=>{j.dispose(),W(new r.CancellationError)});B.then(U,W).finally(()=>j.dispose())})}e.raceCancellationError=w;async function p(B){let _=-1;const U=B.map((j,Z)=>j.then(oe=>(_=Z,oe))),W=await Promise.race(U);return B.forEach((j,Z)=>{Z!==_&&j.cancel()}),W}e.raceCancellablePromises=p;function y(B,_,U){let W;const j=setTimeout(()=>{W?.(void 0),U?.()},_);return Promise.race([B.finally(()=>clearTimeout(j)),new Promise(Z=>W=Z)])}e.raceTimeout=y;function d(B){return new Promise((_,U)=>{const W=B();P(W)?W.then(_,U):_(W)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(U,U).then(W)})}return new Promise((U,W)=>{this.queuedPromise.then(U,W)})}return this.activePromise=_(),new Promise((U,W)=>{this.activePromise.then(j=>{this.activePromise=null,U(j)},j=>{this.activePromise=null,W(j)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=C;class m{constructor(){this.promiseMap=new Map}queue(_,U){const j=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===j&&this.promiseMap.delete(_)});return this.promiseMap.set(_,j),j}}e.SequencerByKey=m;const g=(B,_)=>{let U=!0;const W=setTimeout(()=>{U=!1,_()},B);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},l=B=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,B())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Z)=>{this.doResolve=j,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const W=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?l(W):g(U,W),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(_){this.delayer=new f(_),this.throttler=new S}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(B,_){return _?new Promise((U,W)=>{const j=setTimeout(()=>{Z.dispose(),U()},B),Z=_.onCancellationRequested(()=>{clearTimeout(j),Z.dispose(),W(new r.CancellationError)})}):I(U=>t(B,U))}e.timeout=t;function i(B,_=0){const U=setTimeout(B,_);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=i;function o(B){const _=[];let U=0;const W=B.length;function j(){return U<W?B[U++]():null}function Z(oe){oe!=null&&_.push(oe);const Q=j();return Q?Q.then(Z):Promise.resolve(_)}return Promise.resolve(null).then(Z)}e.sequence=o;function u(B,_=W=>!!W,U=null){let W=0;const j=B.length,Z=()=>{if(W>=j)return Promise.resolve(U);const oe=B[W++];return Promise.resolve(oe()).then(ie=>_(ie)?Promise.resolve(ie):Z())};return Z()}e.first=u;function a(B,_=W=>!!W,U=null){if(B.length===0)return Promise.resolve(U);let W=B.length;const j=()=>{W=-1;for(const Z of B)Z.cancel?.()};return new Promise((Z,oe)=>{for(const Q of B)Q.then(ie=>{--W>=0&&_(ie)?(j(),Z(ie)):W===0&&Z(U)}).catch(ie=>{--W>=0&&(j(),oe(ie))})})}e.firstParallel=a;class h{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,W)=>{this.outstandingPromises.push({factory:_,c:U,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new q;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,U=A.extUri){const W=U.getComparisonKey(_);let j=this.queues.get(W);return j||(j=new v,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(W),this.onDidQueueDrain()}),this.queues.set(W,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class M{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=M;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=F;class O{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class L{constructor(_,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=L;class N extends O{constructor(_,U){super(_,U),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class $ extends T.Disposable{constructor(_,U){super(),this.options=_,this.handler=U,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,b.setTimeout0)(()=>{if(_)return;const U=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(B,_)=>{const U=requestIdleCallback(B,typeof _=="number"?{timeout:_}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class V{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function J(B,_,U){let W;for(let j=0;j<U;j++)try{return await B()}catch(Z){W=Z,await t(_)}throw W}e.retry=J;class H{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,U,W){return this._pending={taskId:_,cancel:()=>W?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,W;const j=new Promise((Z,oe)=>{U=Z,W=oe});this._next={run:_,promise:j,promiseResolve:U,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=H;class G{constructor(_,U=()=>Date.now()){this.interval=_,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback(new r.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=q;var x;(function(B){async function _(W){let j;const Z=await Promise.all(W.map(oe=>oe.then(Q=>Q,Q=>{j||(j=Q)})));if(typeof j<"u")throw j;return Z}B.settled=_;function U(W){return new Promise(async(j,Z)=>{try{await W(j,Z)}catch(oe){Z(oe)}})}B.withAsyncBody=U})(x=e.Promises||(e.Promises={}));var Y;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(Y||(Y={}));class te{constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const U={emitOne:W=>this.emitOne(W),emitMany:W=>this.emitMany(W),reject:W=>this.reject(W)};try{await Promise.resolve(_(U)),this.resolve()}catch(W){this.reject(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(_){return new te(U=>{U.emitMany(_)})}static fromPromise(_){return new te(async U=>{U.emitMany(await _)})}static fromPromises(_){return new te(async U=>{await Promise.all(_.map(async W=>U.emitOne(await W)))})}static merge(_){return new te(async U=>{await Promise.all(_.map(async W=>{for await(const j of W)U.emitOne(j)}))})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,U){return new te(async W=>{for await(const j of _)W.emitOne(U(j))})}map(_){return te.map(this,_)}static filter(_,U){return new te(async W=>{for await(const j of _)U(j)&&W.emitOne(j)})}filter(_){return te.filter(this,_)}static coalesce(_){return te.filter(_,U=>!!U)}coalesce(){return te.coalesce(this)}static async toPromise(_){const U=[];for await(const W of _)U.push(W);return U}toPromise(){return te.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(_,U){super(U),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(B){const _=new R.CancellationTokenSource,U=B(_.token);return new ce(_,async W=>{const j=_.token.onCancellationRequested(()=>{j.dispose(),_.dispose(),W.reject(new r.CancellationError)});try{for await(const Z of U){if(_.token.isCancellationRequested)return;W.emitOne(Z)}j.dispose(),_.dispose()}catch(Z){j.dispose(),_.dispose(),W.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(ne[81],se([0,1,18,6,46,34,9,4,24]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",w="[^/\\\\]",p=/\//g;function y(q,x){switch(q){case 0:return"";case 1:return`${w}*?`;default:return`(?:${E}|${w}+${E}${x?`|${E}${w}+`:""})*?`}}function d(q,x){if(!q)return[];const Y=[];let te=!1,ce=!1,z="";for(const B of q){switch(B){case x:if(!te&&!ce){Y.push(z),z="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=B}return z&&Y.push(z),Y}e.splitGlobAware=d;function S(q){if(!q)return"";let x="";const Y=d(q,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;Y.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(te)return;x+=y(2,z===Y.length-1)}else{let B=!1,_="",U=!1,W="";for(const j of ce){if(j!=="}"&&B){_+=j;continue}if(U&&(j!=="]"||!W)){let Z;j==="-"?Z=j:(j==="^"||j==="!")&&!W?Z="^":j===e.GLOB_SPLIT?Z="":Z=(0,P.escapeRegExpCharacters)(j),W+=Z;continue}switch(j){case"{":B=!0;continue;case"[":U=!0;continue;case"}":{x+=`(?:${d(_,",").map(Q=>S(Q)).join("|")})`,B=!1,_="";break}case"]":{x+="["+W+"]",U=!1,W="";break}case"?":x+=w;continue;case"*":x+=y(1);continue;default:x+=(0,P.escapeRegExpCharacters)(j)}}z<Y.length-1&&(Y[z+1]!==e.GLOBSTAR||z+2<Y.length)&&(x+=E)}te=ce===e.GLOBSTAR})}return x}const C=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.LRUCache(1e4),s=function(){return!1},t=function(){return null};function i(q,x){if(!q)return t;let Y;typeof q!="string"?Y=q.pattern:Y=q,Y=Y.trim();const te=`${Y}_${!!x.trimForExclusions}`;let ce=n.get(te);if(ce)return o(ce,q);let z;return C.test(Y)?ce=a(Y.substr(4),Y):(z=m.exec(u(Y,x)))?ce=h(z[1],Y):(x.trimForExclusions?l:g).test(Y)?ce=v(Y,x):(z=f.exec(u(Y,x)))?ce=D(z[1].substr(1),Y,!0):(z=c.exec(u(Y,x)))?ce=D(z[1],Y,!1):ce=M(Y),n.set(te,ce),o(ce,q)}function o(q,x){if(typeof x=="string")return q;const Y=function(te,ce){return(0,k.isEqualOrParent)(te,x.base,!b.isLinux)?q(te.substr(x.base.length+1),ce):null};return Y.allBasenames=q.allBasenames,Y.allPaths=q.allPaths,Y.basenames=q.basenames,Y.patterns=q.patterns,Y}function u(q,x){return x.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function a(q,x){return function(Y,te){return typeof Y=="string"&&Y.endsWith(q)?x:null}}function h(q,x){const Y=`/${q}`,te=`\\${q}`,ce=function(B,_){return typeof B!="string"?null:_?_===q?x:null:B===q||B.endsWith(Y)||B.endsWith(te)?x:null},z=[q];return ce.basenames=z,ce.patterns=[x],ce.allBasenames=z,ce}function v(q,x){const Y=H(q.slice(1,-1).split(",").map(_=>i(_,x)).filter(_=>_!==t),q),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(_,U){for(let W=0,j=Y.length;W<j;W++)if(Y[W](_,U))return q;return null},z=Y.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const B=Y.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return B.length&&(ce.allPaths=B),ce}function D(q,x,Y){const te=A.sep===A.posix.sep,ce=te?q:q.replace(p,A.sep),z=A.sep+ce,B=A.posix.sep+q;let _;return Y?_=function(U,W){return typeof U=="string"&&(U===ce||U.endsWith(z)||!te&&(U===q||U.endsWith(B)))?x:null}:_=function(U,W){return typeof U=="string"&&(U===ce||!te&&U===q)?x:null},_.allPaths=[(Y?"*/":"./")+q],_}function M(q){try{const x=new RegExp(`^${S(q)}$`);return function(Y){return x.lastIndex=0,typeof Y=="string"&&x.test(Y)?q:null}}catch{return t}}function F(q,x,Y){return!q||typeof x!="string"?!1:O(q)(x,void 0,Y)}e.match=F;function O(q,x={}){if(!q)return s;if(typeof q=="string"||L(q)){const Y=i(q,x);if(Y===t)return s;const te=function(ce,z){return!!Y(ce,z)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return V(q,x)}e.parse=O;function L(q){const x=q;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=L;function N(q){return q.allBasenames||[]}e.getBasenameTerms=N;function $(q){return q.allPaths||[]}e.getPathTerms=$;function V(q,x){const Y=H(Object.getOwnPropertyNames(q).map(_=>J(_,q[_],x)).filter(_=>_!==t)),te=Y.length;if(!te)return t;if(!Y.some(_=>!!_.requiresSiblings)){if(te===1)return Y[0];const _=function(j,Z){let oe;for(let Q=0,ie=Y.length;Q<ie;Q++){const re=Y[Q](j,Z);if(typeof re=="string")return re;(0,r.isThenable)(re)&&(oe||(oe=[]),oe.push(re))}return oe?(async()=>{for(const Q of oe){const ie=await Q;if(typeof ie=="string")return ie}return null})():null},U=Y.find(j=>!!j.allBasenames);U&&(_.allBasenames=U.allBasenames);const W=Y.reduce((j,Z)=>Z.allPaths?j.concat(Z.allPaths):j,[]);return W.length&&(_.allPaths=W),_}const ce=function(_,U,W){let j,Z;for(let oe=0,Q=Y.length;oe<Q;oe++){const ie=Y[oe];ie.requiresSiblings&&W&&(U||(U=(0,A.basename)(_)),j||(j=U.substr(0,U.length-(0,A.extname)(_).length)));const re=ie(_,U,j,W);if(typeof re=="string")return re;(0,r.isThenable)(re)&&(Z||(Z=[]),Z.push(re))}return Z?(async()=>{for(const oe of Z){const Q=await oe;if(typeof Q=="string")return Q}return null})():null},z=Y.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const B=Y.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return B.length&&(ce.allPaths=B),ce}function J(q,x,Y){if(x===!1)return t;const te=i(q,Y);if(te===t)return t;if(typeof x=="boolean")return te;if(x){const ce=x.when;if(typeof ce=="string"){const z=(B,_,U,W)=>{if(!W||!te(B,_))return null;const j=ce.replace("$(basename)",U),Z=W(j);return(0,r.isThenable)(Z)?Z.then(oe=>oe?q:null):Z?q:null};return z.requiresSiblings=!0,z}}return te}function H(q,x){const Y=q.filter(_=>!!_.basenames);if(Y.length<2)return q;const te=Y.reduce((_,U)=>{const W=U.basenames;return W?_.concat(W):_},[]);let ce;if(x){ce=[];for(let _=0,U=te.length;_<U;_++)ce.push(x)}else ce=Y.reduce((_,U)=>{const W=U.patterns;return W?_.concat(W):_},[]);const z=function(_,U){if(typeof _!="string")return null;if(!U){let j;for(j=_.length;j>0;j--){const Z=_.charCodeAt(j-1);if(Z===47||Z===92)break}U=_.substr(j)}const W=te.indexOf(U);return W!==-1?ce[W]:null};z.basenames=te,z.patterns=ce,z.allBasenames=te;const B=q.filter(_=>!_.basenames);return B.push(z),B}function G(q,x){return(0,R.equals)(q,x,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=G}),define(ne[127],se([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(E){return E.toJSON()}class k{constructor(w){this._uriTransformer=w}transformIncoming(w){const p=this._uriTransformer.transformIncoming(w);return p===w?w:r(R.URI.from(p))}transformOutgoing(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:r(R.URI.from(p))}transformOutgoingURI(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:R.URI.from(p)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function T(E,w,p){if(!E||p>200)return null;if(typeof E=="object"){if(E instanceof R.URI)return w.transformOutgoing(E);for(const y in E)if(Object.hasOwnProperty.call(E,y)){const d=T(E[y],w,p+1);d!==null&&(E[y]=d)}}return null}function A(E,w){const p=T(E,w,0);return p===null?E:p}e.transformOutgoingURIs=A;function b(E,w,p,y){if(!E||y>200)return null;if(typeof E=="object"){if(E.$mid===1)return p?R.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const S=b(E[d],w,p,y+1);S!==null&&(E[d]=S)}}return null}function P(E,w){const p=b(E,w,!1,0);return p===null?E:p}e.transformIncomingURIs=P;function I(E,w){const p=b(E,w,!0,0);return p===null?E:p}e.transformAndReviveIncomingURIs=I}),define(ne[128],se([0,1,37,10,34,30,114]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,w=0;const p=(0,R.networkInterfaces)();for(const y in p){const d=p[y];if(d)for(const{mac:S,internal:C}of d)C||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(E+=1))}this._value=w>0?E/w:0}return this._value}};let b;async function P(){return b||(b=(async()=>await I()||T.generateUuid())()),b}e.getMachineId=P;async function I(){try{const E=await new Promise((p,y)=>{X(["crypto"],p,y)}),w=(0,A.getMac)();return E.createHash("sha256").update(w,"utf8").digest("hex")}catch(E){r.onUnexpectedError(E);return}}}),define(ne[27],se([0,1,53,37,269,6,46,79,9,4,17,7]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function y(V,J=p.UNLINK){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?S(V):d(V)}async function d(V){try{const J=(0,A.randomPath)((0,r.tmpdir)());try{await R.promises.rename(V,J)}catch{return S(V)}S(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(V){return(0,k.promisify)(R.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function C(V){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function m(V,J){return f(await(J?g(V):(0,k.promisify)(R.readdir)(V)))}async function g(V){try{return await(0,k.promisify)(R.readdir)(V,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const J=[],H=await m(V);for(const G of H){let q=!1,x=!1,Y=!1;try{const te=await e.Promises.lstat((0,P.join)(V,G));q=te.isFile(),x=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:G,isFile:()=>q,isDirectory:()=>x,isSymbolicLink:()=>Y})}return J}function l(V){return f(R.readdirSync(V))}e.readdirSync=l;function f(V){return V.map(J=>typeof J=="string"?I.isMacintosh?(0,b.normalizeNFC)(J):J:(J.name=I.isMacintosh?(0,b.normalizeNFC)(J.name):J.name,J))}async function c(V){const J=await m(V),H=[];for(const G of J)await s.existsDirectory((0,P.join)(V,G))&&H.push(G);return H}function n(V,J=1e3){return new Promise(H=>{let G=!1;const q=setInterval(()=>{G||(G=!0,R.access(V,x=>{G=!1,x&&(clearInterval(q),H(void 0))}))},J)})}e.whenDeleted=n;var s;(function(V){async function J(q){let x;try{if(x=await e.Promises.lstat(q),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(I.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw Y}}V.stat=J;async function H(q){try{const{stat:x,symbolicLink:Y}=await V.stat(q);return x.isFile()&&Y?.dangling!==!0}catch{}return!1}V.existsFile=H;async function G(q){try{const{stat:x,symbolicLink:Y}=await V.stat(q);return x.isDirectory()&&Y?.dangling!==!0}catch{}return!1}V.existsDirectory=G})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function i(V,J,H){return t.queueFor(w.URI.file(V),E.extUriBiasedIgnorePathCase).queue(()=>{const G=v(H);return new Promise((q,x)=>a(V,J,G,Y=>Y?x(Y):q()))})}let o=!0;function u(V){o=V}e.configureFlushOnWrite=u;function a(V,J,H,G){if(!o)return R.writeFile(V,J,{mode:H.mode,flag:H.flag},G);R.open(V,H.flag,H.mode,(q,x)=>{if(q)return G(q);R.writeFile(x,J,Y=>{if(Y)return R.close(x,()=>G(Y));R.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),u(!1)),R.close(x,ce=>G(ce))))})})}function h(V,J,H){const G=v(H);if(!o)return R.writeFileSync(V,J,{mode:G.mode,flag:G.flag});const q=R.openSync(V,G.flag,G.mode);try{R.writeFileSync(q,J);try{R.fdatasyncSync(q)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),u(!1)}}finally{R.closeSync(q)}}e.writeFileSync=h;function v(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function D(V,J){if(V!==J)try{await e.Promises.rename(V,J)}catch(H){if(V.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||V.endsWith("."))await M(V,J,{preserveSymlinks:!1}),await y(V,p.MOVE);else throw H}}async function M(V,J,H){return O(V,J,{root:{source:V,target:J},options:H,handledSourcePaths:new Set})}const F=511;async function O(V,J,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:G,symbolicLink:q}=await s.stat(V);if(q){if(H.options.preserveSymlinks)try{return await $(V,J,H)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(q.dangling)return}return G.isDirectory()?L(V,J,G.mode&F,H):N(V,J,G.mode&F)}async function L(V,J,H,G){await e.Promises.mkdir(J,{recursive:!0,mode:H});const q=await m(V);for(const x of q)await O((0,P.join)(V,x),(0,P.join)(J,x),G)}async function N(V,J,H){await e.Promises.copyFile(V,J),await e.Promises.chmod(J,H)}async function $(V,J,H){let G=await e.Promises.readlink(V);(0,A.isEqualOrParent)(G,H.root.source,!I.isLinux)&&(G=(0,P.join)(H.root.target,G.substr(H.root.source.length+1))),await e.Promises.symlink(G,J)}e.Promises=new class{get access(){return(0,k.promisify)(R.access)}get stat(){return(0,k.promisify)(R.stat)}get lstat(){return(0,k.promisify)(R.lstat)}get utimes(){return(0,k.promisify)(R.utimes)}get read(){return(V,J,H,G,q)=>new Promise((x,Y)=>{R.read(V,J,H,G,q,(te,ce,z)=>te?Y(te):x({bytesRead:ce,buffer:z}))})}get readFile(){return(0,k.promisify)(R.readFile)}get write(){return(V,J,H,G,q)=>new Promise((x,Y)=>{R.write(V,J,H,G,q,(te,ce,z)=>te?Y(te):x({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,k.promisify)(R.appendFile)}get fdatasync(){return(0,k.promisify)(R.fdatasync)}get truncate(){return(0,k.promisify)(R.truncate)}get rename(){return(0,k.promisify)(R.rename)}get copyFile(){return(0,k.promisify)(R.copyFile)}get open(){return(0,k.promisify)(R.open)}get close(){return(0,k.promisify)(R.close)}get symlink(){return(0,k.promisify)(R.symlink)}get readlink(){return(0,k.promisify)(R.readlink)}get chmod(){return(0,k.promisify)(R.chmod)}get mkdir(){return(0,k.promisify)(R.mkdir)}get unlink(){return(0,k.promisify)(R.unlink)}get rmdir(){return(0,k.promisify)(R.rmdir)}get realpath(){return(0,k.promisify)(R.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return y}get move(){return D}get copy(){return M}}}),define(ne[129],se([0,1,53,9,4,24,27]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(p){if(k.isLinux)return p;const y=(0,r.dirname)(p);if(p===y)return p;const d=((0,r.basename)(p)||p).toLowerCase();try{const C=(0,A.readdirSync)(y).filter(m=>m.toLowerCase()===d);if(C.length===1){const m=b(y);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(d);if(m>=0){const g=b(y);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcaseSync=b;async function P(p){if(k.isLinux)return p;const y=(0,r.dirname)(p);if(p===y)return p;const d=((0,r.basename)(p)||p).toLowerCase();try{const C=(await A.Promises.readdir(y)).filter(m=>m.toLowerCase()===d);if(C.length===1){const m=await P(y);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(d);if(m>=0){const g=await P(y);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcase=P;async function I(p){try{return await A.Promises.realpath(p)}catch{const d=w(p);return await A.Promises.access(d,R.constants.R_OK),d}}e.realpath=I;function E(p){try{return R.realpathSync(p)}catch{const d=w(p);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=E;function w(p){return(0,T.rtrim)((0,r.normalize)(p),r.sep)}}),define(ne[82],se([0,1,37,9,27]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var P;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(P||(P={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class w{constructor(c,n,s){this.exePath=c,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?I===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:f=!1,findPreview:c=!1}={}){const n=p({useAlternateBitness:f});if(!n)return null;const s=r.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let t=-1,i=null;for(const a of await k.Promises.readdir(s)){let h=-1;if(c){const D=a.indexOf("-");if(D<0)continue;const M=a.substring(0,D);if(!T.test(M)||a.substring(D+1)!=="preview")continue;h=parseInt(M,10)}else{if(!T.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const v=r.join(s,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(v)||(i=v,t=h)}if(!i)return null;const o=n.includes("x86")?" (x86)":"",u=c?" Preview":"";return new w(i,`PowerShell${u}${o}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=f?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(c))if(n.test(t)){const i=r.join(c,t,"pwsh.exe");return new w(i,s)}return null}function S(){const f=r.join(R.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function C(){const f=r.join(process.env.windir,I===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*m(){let f=await y();f&&(yield f),f=await y({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=S(),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await y({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=C(),f&&(yield f)}async function*g(){for await(const f of m())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function l(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=l}),define(ne[83],se([0,1,9,4,36,77,14,27]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function P(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=P;function I(w){let p=[],y=!1;const d=function(S){if(y){p.push(S);return}(!w.send(S,m=>{if(m&&console.error(m),y=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(l=>d(l))}})||r.isWindows)&&(y=!0)};return{send:d}}e.createQueuedSender=I;var E;(function(w){async function p(y,d,S){if(R.isAbsolute(y))return y;if(d===void 0&&(d=k.cwd()),R.dirname(y)!=="."||(S===void 0&&A.isString(k.env.PATH)&&(S=k.env.PATH.split(R.delimiter)),S===void 0||S.length===0))return R.join(d,y);async function m(g){if(await b.Promises.exists(g)){let l;try{l=await b.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(l=await b.Promises.lstat(g))}return l?!l.isDirectory():!1}return!1}for(const g of S){let l;if(R.isAbsolute(g)?l=R.join(g,y):l=R.join(d,g,y),await m(l))return l;let f=l+".com";if(await m(f)||(f=l+".exe",await m(f)))return f}return R.join(d,y)}w.findExecutable=p})(E=e.win32||(e.win32={}))}),define(ne[130],se([0,1,54,20]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((b,P)=>{let I;const E=new Map;function w(y,d,S,C,m){const g=E.get(d);if(y===A||g){const l={name:p(S),cmd:S,pid:y,ppid:d,load:C,mem:m};E.set(y,l),y===A&&(I=l),g&&(g.children||(g.children=[]),g.children.push(l),g.children.length>1&&(g.children=g.children.sort((f,c)=>f.pid-c.pid)))}}function p(y){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,l=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(l.exec(y))return"electron-crash-reporter";if(f.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let s=n.exec(y);if(s&&s.length===2){if(s[1]==="renderer")return d.exec(y)?"shared-process":S.exec(y)?"issue-reporter":C.exec(y)?"process-explorer":"window";if(s[1]==="utility"){if(m.exec(y))return"utility-network-service";if(g.exec(y))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let i="";do s=t.exec(y),s&&(i+=s+" ");while(s);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{X(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){P(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,C=>{const m=new Map;C.forEach(g=>{const l=y(g.commandLine||"");m.set(g.pid,{name:p(l),cmd:l,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),I=m.get(A),I?(m.forEach(g=>{const l=m.get(g.ppid);l&&(l.children||(l.children=[]),l.children.push(g))}),m.forEach(g=>{g.children&&(g.children=g.children.sort((l,f)=>l.pid-f.pid))}),b(I)):P(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[I];const S=[];for(;d.length;){const m=d.shift();m&&(S.push(m.pid),m.children&&(d=d.concat(m.children)))}let C=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);C+=" "+S.join(" "),(0,R.exec)(C,{},(m,g,l)=>{if(m||l)P(m||new Error(l.toString()));else{const f=g.toString().split(`
`);for(let c=0;c<S.length;c++){const n=E.get(S[c]);n.load=parseFloat(f[c])}if(!I){P(new Error(`Root process ${A} not found`));return}b(I)}})};(0,R.exec)("which ps",{},(d,S,C)=>{if(d||C)if(process.platform!=="linux")P(d||new Error(C.toString()));else{const m=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,R.exec)(m,{},(g,l,f)=>{g||f?P(g||new Error(f.toString())):(T(l,w),y())})}else{const m=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${m} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,f,c)=>{l||c&&!c.includes("screen size is bogus")?P(l||new Error(c.toString())):(T(f,w),process.platform==="linux"?y():I?b(I):P(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function T(A,b){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=A.toString().split(`
`);for(const E of I){const w=P.exec(E.trim());w&&w.length===6&&b(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[131],se([0,1,37,4,82,83]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,d){return y===1?r.isWindows?w():T.getWindowsShell(d):I(y,d)}e.getSystemShell=A;function b(y,d){return y===1?r.isWindows?p(d):T.getWindowsShell(d):I(y,d)}e.getSystemShellSync=b;let P=null;function I(y,d){if(r.isLinux&&y===2||r.isMacintosh&&y===3)return"/bin/bash";if(!P){let S;if(r.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let E=null;async function w(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function p(y){if(E)return E;const d=r.isWindows&&parseFloat((0,R.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?C:T.getWindowsShell(y)}});var pe=this&&this.__decorate||function(X,e,R,r){var k=arguments.length,T=k<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,R):r,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(X,e,R,r);else for(var b=X.length-1;b>=0;b--)(A=X[b])&&(T=(k<3?A(T):k>3?A(e,R,T):A(e,R))||T);return k>3&&T&&Object.defineProperty(e,R,T),T};define(ne[39],se([0,1,18,6,16,21,60,10,3,2,63,24,14]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));class g{constructor(x){this.buffer=x,this.pos=0}read(x){const Y=this.buffer.slice(this.pos,this.pos+x);return this.pos+=Y.byteLength,Y}}class l{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var f;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(f||(f={}));function c(q){const x=k.VSBuffer.alloc(4);return x.writeUInt32BE(q,0),x}function n(q){return q.read(4).readUInt32BE(0)}function s(q){const x=k.VSBuffer.alloc(1);return x.writeUInt8(q,0),x}const t={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},i=typeof Buffer<"u";function o(q,x){if(typeof x>"u")q.write(t.Undefined);else if(typeof x=="string"){const Y=k.VSBuffer.fromString(x);q.write(t.String),q.write(c(Y.byteLength)),q.write(Y)}else if(i&&Buffer.isBuffer(x)){const Y=k.VSBuffer.wrap(x);q.write(t.Buffer),q.write(c(Y.byteLength)),q.write(Y)}else if(x instanceof k.VSBuffer)q.write(t.VSBuffer),q.write(c(x.byteLength)),q.write(x);else if(Array.isArray(x)){q.write(t.Array),q.write(c(x.length));for(const Y of x)o(q,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(x));q.write(t.Object),q.write(c(Y.byteLength)),q.write(Y)}}function u(q){switch(q.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return q.read(n(q)).toString();case f.Buffer:return q.read(n(q)).buffer;case f.VSBuffer:return q.read(n(q));case f.Array:{const Y=n(q),te=[];for(let ce=0;ce<Y;ce++)te.push(u(q));return te}case f.Object:return JSON.parse(q.read(n(q)).toString())}}class a{constructor(x,Y,te=null,ce=1e3){this.protocol=x,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(x,Y){this.channels.set(x,Y),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const Y=this.send([x.type]);this.logger?.logOutgoing(Y,0,1,C(x.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(Y,x.id,1,C(x.type),x.data);return}}}send(x,Y=void 0){const te=new l;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const Y=new g(x),te=u(Y),ce=u(Y),z=te[0];switch(z){case 100:return this.logger?.logIncoming(x.byteLength,te[1],1,`${d(z)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(x.byteLength,te[1],1,`${d(z)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(x.byteLength,te[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:te[1]});case 103:return this.logger?.logIncoming(x.byteLength,te[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:te[1]})}}onPromise(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=new T.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,x.name,x.arg,te.token)}catch(_){ce=Promise.reject(_)}const z=x.id;ce.then(_=>{this.sendResponse({id:z,data:_,type:201}),this.activeRequests.delete(x.id)},_=>{_ instanceof Error?this.sendResponse({id:z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:z,data:_,type:203}),this.activeRequests.delete(x.id)});const B=(0,I.toDisposable)(()=>te.cancel());this.activeRequests.set(x.id,B)}onEventListen(x){const Y=this.channels.get(x.channelName);if(!Y){this.collectPendingRequest(x);return}const te=x.id,z=Y.listen(this.ctx,x.name,x.arg)(B=>this.sendResponse({id:te,data:B,type:204}));this.activeRequests.set(x.id,z)}disposeActiveRequest(x){const Y=this.activeRequests.get(x.id);Y&&(Y.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let Y=this.pendingRequests.get(x.channelName);Y||(Y=[],this.pendingRequests.set(x.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:x,timeoutTimer:te})}flushPendingRequests(x){const Y=this.pendingRequests.get(x);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(x,Y=null){this.protocol=x,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(x){const Y=this;return{call(te,ce,z){return Y.isDisposed?Promise.reject(new b.CancellationError):Y.requestPromise(x,te,ce,z)},listen(te,ce){return Y.isDisposed?P.Event.None:Y.requestEvent(x,te,ce)}}}requestPromise(x,Y,te,ce=T.CancellationToken.None){const z=this.lastRequestId++,_={id:z,type:100,channelName:x,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new b.CancellationError);let U;return new Promise((j,Z)=>{if(ce.isCancellationRequested)return Z(new b.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),j(he.data);break;case 202:{this.handlers.delete(z);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(z),Z(he.data);break}};this.handlers.set(z,ue),this.sendRequest(_)};let Q=null;this.state===m.Idle?oe():(Q=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),Q.then(()=>{Q=null,oe()}));const ie=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:z,type:101}),Z(new b.CancellationError)},re=ce.onCancellationRequested(ie);U=(0,I.combinedDisposable)((0,I.toDisposable)(ie),re),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(x,Y,te){const ce=this.lastRequestId++,B={id:ce,type:102,channelName:x,name:Y,arg:te};let _=null;const U=new P.Emitter({onFirstListenerAdd:()=>{_=(0,r.createCancelablePromise)(j=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(B)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:ce,type:103}))}}),W=j=>U.fire(j.data);return this.handlers.set(ce,W),U.event}sendRequest(x){switch(x.type){case 100:case 102:{const Y=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(Y,x.id,0,`${d(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const Y=this.send([x.type,x.id]);this.logger?.logOutgoing(Y,x.id,0,d(x.type));return}}}send(x,Y=void 0){const te=new l;return o(te,x),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const Y=new g(x),te=u(Y),ce=u(Y),z=te[0];switch(z){case 200:return this.logger?.logIncoming(x.byteLength,0,0,C(z)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,te[1],0,C(z),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(x){if(x.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class D{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:Y,onDidClientDisconnect:te})=>{P.Event.once(Y.onMessage)(z=>{const B=new g(z),_=u(B),U=new a(Y,_),W=new v(Y);this.channels.forEach((Z,oe)=>U.registerChannel(oe,Z));const j={channelServer:U,channelClient:W,ctx:_};this._connections.add(j),this._onDidAddConnection.fire(j),te(()=>{U.dispose(),W.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const x=[];return this._connections.forEach(Y=>x.push(Y)),x}getChannel(x,Y){const te=this;return{call(ce,z,B){let _;if((0,p.isFunction)(Y)){const W=(0,R.getRandomElement)(te.connections.filter(Y));_=W?Promise.resolve(W):P.Event.toPromise(P.Event.filter(te.onDidAddConnection,Y))}else _=Y.routeCall(te,ce,z);const U=_.then(W=>W.channelClient.getChannel(x));return F(U).call(ce,z,B)},listen(ce,z){if((0,p.isFunction)(Y))return te.getMulticastEvent(x,Y,ce,z);const B=Y.routeEvent(te,ce,z).then(_=>_.channelClient.getChannel(x));return F(B).listen(ce,z)}}}getMulticastEvent(x,Y,te,ce){const z=this;let B=new I.DisposableStore;const _=new P.Emitter({onFirstListenerAdd:()=>{B=new I.DisposableStore;const U=new P.EventMultiplexer,W=new Map,j=oe=>{const ie=oe.channelClient.getChannel(x).listen(te,ce),re=U.add(ie);W.set(oe,re)},Z=oe=>{const Q=W.get(oe);!Q||(Q.dispose(),W.delete(oe))};z.connections.filter(Y).forEach(j),P.Event.filter(z.onDidAddConnection,Y)(j,void 0,B),z.onDidRemoveConnection(Z,void 0,B),U.event(_.fire,_,B),B.add(U)},onLastListenerRemove:()=>{B.dispose()}});return _.event}registerChannel(x,Y){this.channels.set(x,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(x,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class M{constructor(x,Y,te=null){const ce=new l;o(ce,Y),x.send(ce.buffer),this.channelClient=new v(x,te),this.channelServer=new a(x,Y,te)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,Y){this.channelServer.registerChannel(x,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function F(q){return{call(x,Y,te){return q.then(ce=>ce.call(x,Y,te))},listen(x,Y){const te=new P.Relay;return q.then(ce=>te.input=ce.listen(x,Y)),te.event}}}e.getDelayedChannel=F;function O(q){let x=!1;return{call(Y,te,ce){return x?q.call(Y,te,ce):(0,r.timeout)(0).then(()=>x=!0).then(()=>q.call(Y,te,ce))},listen(Y,te){if(x)return q.listen(Y,te);const ce=new P.Relay;return(0,r.timeout)(0).then(()=>x=!0).then(()=>ce.input=q.listen(Y,te)),ce.event}}}e.getNextTickChannel=O;class L{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const Y of x.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await P.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=L;var N;(function(q){function x(z,B){const _=z,U=B&&B.disableMarshalling,W=new Map;for(const j in _)te(j)&&W.set(j,P.Event.buffer(_[j],!0));return new class{listen(j,Z,oe){const Q=W.get(Z);if(Q)return Q;if(ce(Z)){const ie=_[Z];if(typeof ie=="function")return ie.call(_,oe)}throw new Error(`Event not found: ${Z}`)}call(j,Z,oe){const Q=_[Z];if(typeof Q=="function"){if(!U&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,E.revive)(oe[ie]);return Q.apply(_,oe)}throw new Error(`Method not found: ${Z}`)}}}q.fromService=x;function Y(z,B){const _=B&&B.disableMarshalling;return new Proxy({},{get(U,W){if(typeof W=="string")return B?.properties?.has(W)?B.properties.get(W):ce(W)?function(j){return z.listen(W,j)}:te(W)?z.listen(W):async function(...j){let Z;B&&!(0,p.isUndefinedOrNull)(B.context)?Z=[B.context,...j]:Z=j;const oe=await z.call(W,Z);return _?oe:(0,E.revive)(oe)};throw new Error(`Property not found: ${String(W)}`)}})}q.toService=Y;function te(z){return z[0]==="o"&&z[1]==="n"&&w.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&w.isUpperAsciiLetter(z.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const x=q.toString();if(x!=="[object Object]")return x}return q}function J(q){return Array.isArray(q)?q.map(V):V(q)}function H(q,x,Y,te,ce,z,B){B=J(B);const _=$[ce],U=_[te%_.length];let W=[`%c[${q}]%c[${String(x).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(z)?(W=W.concat(B),W.push(")")):W.push(B),console.log.apply(console,W)}e.logWithColors=H;class G{constructor(x,Y){this._outgoingPrefix=x,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,Y,te,ce,z){this._totalOutgoing+=x,H(this._outgoingPrefix,this._totalOutgoing,x,Y,te,ce,z)}logIncoming(x,Y,te,ce,z){this._totalIncoming+=x,H(this._incomingPrefix,this._totalIncoming,x,Y,te,ce,z)}}e.IPCLogger=G}),define(ne[132],se([0,1,16,3,39]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(P){this.port=P,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",I=>R.VSBuffer.wrap(I.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends k.IPCClient{constructor(P,I){const E=new T(P);super(E,I),this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[84],se([0,1,16,3,2,39]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let u=0;function a(v,D){if(!o.has(v)){const M=String(++u);o.set(v,M)}return o.get(v)}function h(v,D,M,F){if(!i.enableDiagnostics)return;const O=a(v,D);if(F instanceof R.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const L=R.VSBuffer.alloc(F.byteLength);L.set(F),i.records.push({timestamp:Date.now(),id:O,label:D,type:M,buff:L})}else i.records.push({timestamp:Date.now(),id:O,label:D,type:M,data:F})}i.traceSocketEvent=h})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function E(){return I||(I=R.VSBuffer.alloc(0)),I}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return E();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const D=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),D}if(this._chunks[0].byteLength>o){const D=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),D}const a=R.VSBuffer.alloc(o);let h=0,v=0;for(;o>0;){const D=this._chunks[v];if(D.byteLength>o){const M=D.slice(0,o);a.set(M,h),h+=o,u&&(this._chunks[v]=D.slice(o),this._totalLength-=o),o-=o}else a.set(D,h),h+=D.byteLength,u?(this._chunks.shift(),this._totalLength-=D.byteLength):v++,o-=D.byteLength}return a}}e.ChunkStream=w;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,u,a,h){this.type=o,this.id=u,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(o){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new S(a,h,v,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=R.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(u,o.data)}_bufferAdd(o,u){const a=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,a}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends k.Disposable{constructor(o){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class l extends T.IPCClient{constructor(o,u,a=null){super(o,u,a),this.protocol=o}static fromSocket(o,u){return new l(new g(o),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=l;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(o){this.data=o,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let o=0,u=this._first;for(;u;)u=u.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let u=0,a=this._first;for(;a;)o[u++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new c(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<s._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=u&&a++;return 1-a/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,u=null,a=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,E());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,E());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,E());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o);const u=this._outgoingUnackMsg.toArray();for(let a=0,h=u.length;a<h;a++)this._socketWriter.write(u[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new S(6,0,0,E())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let a=0,h=u.length;a<h;a++)this._socketWriter.write(u[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new S(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const u=new S(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:a});return}const v=Math.max(2e4-u,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o)}_sendKeepAlive(){const o=new S(9,0,0,E());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[133],se([0,1,85,3,39,132]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const P=r.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(I,E)=>E);return r.Event.map(P,I=>{const{port1:E,port2:w}=new MessageChannel,y={protocol:new T.Protocol(E),onDidClientDisconnect:r.Event.fromDOMEventEmitter(E,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[w]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[64],se([0,1,54,6,16,21,126,10,3,2,31,83,77,39]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(m){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new r.Delayer(l),this.child=null,this._client=null}getChannel(m){const g=this;return{call(l,f,c){return g.requestPromise(m,l,f,c)},listen(l,f){return g.requestEvent(m,l,f)}}}requestPromise(m,g,l,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),n=(0,r.createCancelablePromise)(i=>c.call(g,l,i)),s=f.onCancellationRequested(()=>n.cancel()),t=(0,I.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(m,g,l){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let f;const c=new P.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(m).listen(g,l)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,m,g);const l=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}l.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,n=o=>this.child&&this.child.connected&&c.send(o.buffer.toString("base64")),s=l.event,t={send:n,onMessage:s};this._client=new y.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,u)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,I.dispose)(a)),this.activeRequests.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:u})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[134],se([0,1,16,10,3,2,9,4,30,39,84]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:X.__$__nodeRequire("crypto"),zlib:X.__$__nodeRequire("zlib"),net:X.__$__nodeRequire("net"),os:X.__$__nodeRequire("os")}}class p{constructor(a,h=""){this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=v=>{if(this.traceSocketEvent("error",{code:v?.code,message:v?.message}),v){if(v.code==="EPIPE")return;(0,r.onUnexpectedError)(v)}},this.socket.on("error",this._errorListener)}traceSocketEvent(a,h){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(a){const h=v=>{this.traceSocketEvent("read",v),a(R.VSBuffer.wrap(v))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=v=>{this.traceSocketEvent("close",{hadError:v}),a({type:0,hadError:v,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{this.traceSocketEvent("nodeEndReceived"),a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!this.socket.destroyed)try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,r.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,r.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=p;var y;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var d;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(d||(d={}));class S extends T.Disposable{constructor(a,h,v,D){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:v?.byteLength||0,recordInflateBytes:D}),this._flowManager=this._register(new C(this,h,v,D,this._onData,(M,F)=>this._write(M,F))),this._register(this._flowManager.onError(M=>{console.error(M),(0,r.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(M=>this._onClose.fire(M)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let v=2;a.byteLength<126?v+=0:a.byteLength<2**16?v+=2:v+=8;const D=R.VSBuffer.alloc(v);if(h?D.writeUInt8(194,0):D.writeUInt8(130,0),a.byteLength<126)D.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){D.writeUInt8(126,1);let M=1;D.writeUInt8(a.byteLength>>>8&255,++M),D.writeUInt8(a.byteLength>>>0&255,++M)}else{D.writeUInt8(127,1);let M=1;D.writeUInt8(0,++M),D.writeUInt8(0,++M),D.writeUInt8(0,++M),D.writeUInt8(0,++M),D.writeUInt8(a.byteLength>>>24&255,++M),D.writeUInt8(a.byteLength>>>16&255,++M),D.writeUInt8(a.byteLength>>>8&255,++M),D.writeUInt8(a.byteLength>>>0&255,++M)}this.socket.write(R.VSBuffer.concat([D,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),v=h.readUInt8(0),D=(v&128)>>>7,M=(v&64)>>>6,F=h.readUInt8(1),O=(F&128)>>>7,L=F&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(L===126?2:0)+(L===127?8:0),this._state.fin=D,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(M)),this._state.firstFrameOfMessage=Boolean(D),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),v=h.readUInt8(1),D=(v&128)>>>7;let M=v&127,F=1;M===126?M=h.readUInt8(++F)*2**8+h.readUInt8(++F):M===127&&(M=h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*0+h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F));let O=0;D&&(O=h.readUInt8(++F)*2**24+h.readUInt8(++F)*2**16+h.readUInt8(++F)*2**8+h.readUInt8(++F)),this._state.state=3,this._state.readLen=M,this._state.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),l(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends T.Disposable{constructor(a,h,v,D,M,F){super(),this._tracer=a,this._onData=M,this._writeFn=F,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new m(this._tracer,D,v,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(O=>this._onError.fire(O))),this._register(this._zlibDeflateStream.onError(O=>this._onError.fire(O)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(h,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,h){return new Promise((v,D)=>{a.write(h),a.flush(M=>v(M))})}acceptFrame(a,h,v){this._readQueue.push({data:a,isCompressed:h,isLastFrameOfMessage:v}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,h,v){return new Promise((D,M)=>{a.write(h),v&&a.write(R.VSBuffer.fromByteArray([0,0,255,255])),a.flush(F=>D(F))})}}class m extends T.Disposable{constructor(a,h,v,D){super(),this._tracer=a,this._recordInflateBytes=h,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(D),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(R.VSBuffer.wrap(M))}),v&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",v.buffer),this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(h)})}}class g extends T.Disposable{constructor(a,h){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",v=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:v?.message,code:v?.code}),this._onError.fire(v)}),this._zlibDeflate.on("data",v=>{this._tracer.traceSocketEvent("zlibDeflateData",v),this._pendingDeflateData.push(R.VSBuffer.wrap(v))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function l(u,a){if(a===0)return;const h=u.byteLength>>>2;for(let L=0;L<h;L++){const N=u.readUInt32BE(L*4);u.writeUInt32BE(N^a,L*4)}const v=h*4,D=u.byteLength-v,M=a>>>24&255,F=a>>>16&255,O=a>>>8&255;D>=1&&u.writeUInt8(u.readUInt8(v)^M,v),D>=2&&u.writeUInt8(u.readUInt8(v+1)^F,v+1),D>=3&&u.writeUInt8(u.readUInt8(v+2)^O,v+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const u=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):a=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${u}.sock`),s(a),a}e.createRandomIPCHandle=c;function n(u,a,h){const v=w().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${h}-${a}-sock`;let D;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?D=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${h}-${a}.sock`):D=(0,A.join)(u,`${h}-${a}.sock`),s(D),D}e.createStaticIPCHandle=n;function s(u){const a=f[b.platform];typeof a=="number"&&u.length>=a&&console.warn(`WARNING: IPC handle "${u}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends I.IPCServer{constructor(a){super(t.toClientConnectionEvent(a)),this.server=a}static toClientConnectionEvent(a){const h=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(h,v=>({protocol:new E.Protocol(new p(v,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(u){return new Promise((a,h)=>{const v=w().net.createServer();v.on("error",h),v.listen(u,()=>{v.removeListener("error",h),a(new t(v))})})}e.serve=i;function o(u,a){return new Promise((h,v)=>{const D=w().net.createConnection(u,()=>{D.removeListener("error",v),h(E.Client.fromSocket(new p(D,`ipc-client${a}`),a))});D.once("error",v)})}e.connect=o}),define(ne[86],se([0,1,6,3,2,14]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function b(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var P;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class I extends k.Disposable{constructor(p,y=Object.create(null)){super(),this.database=p,this.options=y,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((y,d)=>this.accept(d,y)),p.deleted?.forEach(y=>this.accept(y,void 0))}accept(p,y){if(this.state===P.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(y)?d=this.cache.delete(p):this.cache.get(p)!==y&&(this.cache.set(p,y),d=!0),d&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,y){const d=this.cache.get(p);return(0,T.isUndefinedOrNull)(d)?y:d}getBoolean(p,y){const d=this.get(p);return(0,T.isUndefinedOrNull)(d)?y:d==="true"}getNumber(p,y){const d=this.get(p);return(0,T.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(p,y){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(y))return this.delete(p);const d=String(y);if(this.cache.get(p)!==d)return this.cache.set(p,d),this.pendingInserts.set(p,d),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===P.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((y,d)=>this.items.set(d,y)),p.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=E}),define(ne[135],se([11,12]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ne[136],se([11,12]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[137],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ne[138],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ne[139],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[140],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[141],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[142],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[143],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[144],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[145],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[146],se([11,12]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[147],se([11,12]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ne[148],se([11,12]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ne[149],se([11,12]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ne[150],se([11,12]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[151],se([11,12]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[152],se([11,12]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ne[153],se([11,12]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ne[154],se([11,12]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[155],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[156],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[157],se([11,12]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[158],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[159],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[160],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[161],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[162],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[163],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[164],se([11,12]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ne[87],se([0,1,61,60,20,9,36,17,7]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(S,C,m){this._args=S,this.paths=C,this.productService=m,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("",X).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(P.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,T.resolve)(S):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const C=A.env.VSCODE_EXTENSIONS;if(C)return C;const m=A.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?P.URI.parse(C):P.URI.file((0,T.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?P.URI.parse(S):P.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return P.URI.file((0,T.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}pe([r.memoize],I.prototype,"appRoot",null),pe([r.memoize],I.prototype,"userHome",null),pe([r.memoize],I.prototype,"userDataPath",null),pe([r.memoize],I.prototype,"appSettingsHome",null),pe([r.memoize],I.prototype,"tmpDir",null),pe([r.memoize],I.prototype,"cacheHome",null),pe([r.memoize],I.prototype,"stateResource",null),pe([r.memoize],I.prototype,"userRoamingDataHome",null),pe([r.memoize],I.prototype,"userDataSyncHome",null),pe([r.memoize],I.prototype,"userDataSyncLogResource",null),pe([r.memoize],I.prototype,"editSessionsLogResource",null),pe([r.memoize],I.prototype,"sync",null),pe([r.memoize],I.prototype,"machineSettingsResource",null),pe([r.memoize],I.prototype,"workspaceStorageHome",null),pe([r.memoize],I.prototype,"localHistoryHome",null),pe([r.memoize],I.prototype,"keyboardLayoutResource",null),pe([r.memoize],I.prototype,"argvResource",null),pe([r.memoize],I.prototype,"isExtensionDevelopment",null),pe([r.memoize],I.prototype,"untitledWorkspacesHome",null),pe([r.memoize],I.prototype,"installSourcePath",null),pe([r.memoize],I.prototype,"builtinExtensionsPath",null),pe([r.memoize],I.prototype,"extensionsPath",null),pe([r.memoize],I.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],I.prototype,"extensionDevelopmentKind",null),pe([r.memoize],I.prototype,"extensionTestsLocationURI",null),pe([r.memoize],I.prototype,"debugExtensionHost",null),pe([r.memoize],I.prototype,"serviceMachineIdResource",null),pe([r.memoize],I.prototype,"telemetryLogResource",null),pe([r.memoize],I.prototype,"disableWorkspaceTrust",null),pe([r.memoize],I.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=I;function E(d,S){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=E;function w(d,S){return y(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=w;function p(d,S){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=p;function y(d,S,C,m,g,l){const c=Number(S||d)||(m?null:C),n=c?Boolean(!!S):!1;let s;if(l)try{s=JSON.parse(l)}catch{}return{port:c,break:n,debugId:g,env:s}}}),define(ne[165],se([0,1,270,4,137]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,S,C=A){const m={},g=["_"],l=[];for(const s in S){const t=S[s];t.alias&&(m[s]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(s),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(l.push(s),t.deprecates&&l.push(...t.deprecates))}const f=R(d,{string:g,boolean:l,alias:m}),c={},n=f;c._=f._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(const s in S){const t=S[s];t.alias&&delete n[t.alias];let i=n[s];if(t.deprecates)for(const o of t.deprecates)n.hasOwnProperty(o)&&(i||(i=n[o],i&&C.onDeprecatedOption(o,t.deprecationMessage||(0,k.localize)(35,null,s))),delete n[o]);if(typeof i<"u"){if(t.type==="string[]"){if(Array.isArray(i)||(i=[i]),!t.allowEmptyValue){const o=i.filter(u=>u.length>0);o.length!==i.length&&(C.onEmptyValue(s),i=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(i)?(i=i.pop(),C.onMultipleValues(s,i)):!i&&!t.allowEmptyValue&&(C.onEmptyValue(s),i=void 0));c[s]=i,t.deprecationMessage&&C.onDeprecatedOption(s,t.deprecationMessage)}delete n[s]}for(const s in n)C.onUnknownOption(s);return c}e.parseArgs=b;function P(d,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${d}${C}`:`--${d}${C}`}function I(d,S){let C=0;const m=[];for(const c in d){const n=d[c],s=P(c,n);C=Math.max(C,s.length),m.push([s,n.description])}const g=C+2+1;if(S-g<25)return m.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=S-g-1,f=[];for(const c of m){const n=c[0],s=w(c[1],l),t=E(g-n.length-2);f.push("  "+n+t+s[0]);for(let i=1;i<s.length;i++)f.push(E(g)+s[i])}return f}e.formatOptions=I;function E(d){return" ".repeat(d)}function w(d,S){const C=[];for(;d.length;){const m=d.length<S?d.length:d.lastIndexOf(" ",S),g=d.slice(0,m).trim();d=d.slice(m),C.push(g)}return C}function p(d,S,C,m,g){const l=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${d} ${C}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${S} [${(0,k.localize)(38,null)}]${f}`),c.push(""),g?.noPipe!==!0&&(r.isWindows?c.push((0,k.localize)(39,null,S)):c.push((0,k.localize)(40,null,S)),c.push(""));const n={};for(const s in m){const t=m[s];if(t.description&&t.cat){let i=n[t.cat];i||(n[t.cat]=i={}),i[s]=t}}for(const s in n){const t=s,i=n[t];i&&(c.push(T[t]),c.push(...I(i,l)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=p;function y(d,S){return`${d||(0,k.localize)(41,null)}
${S||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ne[166],se([0,1,271,138,165]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(p,y){const d={onUnknownOption:C=>{console.warn((0,r.localize)(0,null,C))},onMultipleValues:(C,m)=>{console.warn((0,r.localize)(1,null,C,m))},onEmptyValue:C=>{console.warn((0,r.localize)(2,null,C))},onDeprecatedOption:(C,m)=>{console.warn((0,r.localize)(3,null,C,m))}},S=(0,k.parseArgs)(p,k.OPTIONS,y?d:void 0);return S.goto&&S._.forEach(C=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,r.localize)(4,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),S}function b(p){const y=p.findIndex(d=>!/^-/.test(d));if(y>-1)return[...p.slice(0,y),...p.slice(y+1)]}function P(p){let[,...y]=p;process.env.VSCODE_DEV&&(y=b(y)||[]);const d=!w(process.env);return A(y,d)}e.parseMainProcessArgv=P;function I(p){const[,,...y]=p;return A(y,!0)}e.parseCLIProcessArgv=I;function E(p,...y){const d=p.indexOf("--");return d===-1?p.push(...y):p.splice(d,0,...y),p}e.addArg=E;function w(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function X(e,R,r,k){function T(b){const P=A(b),I=[P];return e.isAbsolute(P)||I.unshift(k),e.resolve(...I)}function A(b){const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,r);const E=b["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(w,"AppData","Roaming")}break;case"darwin":I=e.join(R.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,r)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[167],se([0,272,37,20,17,36]),function(e,R,r,k,T,A){const b=T.dirname(k.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(T.joinPath(b,"package.json").fsPath);return X(R,r,P.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),r=require("os");module.exports=X(R,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[168],se([0,1,37,87,167]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends r.AbstractNativeEnvironmentService{constructor(b,P){super(b,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b)},P)}}e.NativeEnvironmentService=T}),define(ne[169],se([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,b=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(C){const m=C.match(A);return m?m[1]:null}function E(C){if(C.indexOf("://")===-1){const m=C.match(r);return m?I(m[2]):null}try{const m=R.URI.parse(C);if(m.authority)return I(m.authority)}catch{}return null}function w(C,m){const g=new Set;let l;for(;l=b.exec(C);){const c=E(l[1]);c&&g.add(c)}const f=new Set(m);return Array.from(g).map(c=>f.has(c)?c:c.replace(P,"a"))}e.getDomainsOfRemotes=w;function p(C){const m=C.match(T);return m?m[2]:null}function y(C,m,g){return C&&m?(g&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${C}${m}`:`${C}/${m}`):null}function d(C,m){if(C.indexOf("://")===-1){const g=C.match(k);if(g)return y(g[2],g[3],m)}try{const g=R.URI.parse(C);if(g.authority)return y(p(g.authority),g.path,m)}catch{}return null}function S(C,m=!1){const g=[];let l;for(;l=b.exec(C);){const f=d(l[1],m);f&&g.push(f)}return g}e.getRemotes=S}),define(ne[170],se([0,1,14,141]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,b,P){try{T(A,b,P)}catch{}return A}e.localizeManifest=k;function T(A,b,P){const I=(E,w,p)=>{const y=E[w];if((0,R.isString)(y)){const d=y,S=d.length;if(S>1&&d[0]==="%"&&d[S-1]==="%"){const C=d.substr(1,S-2);let m=b[C];m===void 0&&P&&(m=P[C]);const g=typeof m=="string"?m:m.message;if(g!==void 0){const l=P?.[C],f=typeof l=="string"?l:l?.message;if(p&&(w==="title"||w==="category")&&f&&f!==g){const c={value:g,original:f};E[w]=c}else E[w]=g}else console.warn(`[${A.name}]: ${(0,r.localize)(0,null,C)}`)}}else if((0,R.isObject)(y))for(const d in y)y.hasOwnProperty(d)&&(d==="commands"?I(y,d,!0):I(y,d,p));else if(Array.isArray(y))for(let d=0;d<y.length;d++)I(y,d,p)};for(const E in A)A.hasOwnProperty(E)&&I(A,E)}}),define(ne[171],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,b,P){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,b,P])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class r{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,b){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(b[0],b[1],b[2],b[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[65],se([0,1,17,80,146,55]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function P(m){return m=m.trim(),m==="*"||A.test(m)}e.isValidVersionStr=P;function I(m){if(!P(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=m.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function E(m){if(!m)return null;const g=m.majorBase,l=m.majorMustEqual,f=m.minorBase;let c=m.minorMustEqual;const n=m.patchBase;let s=m.patchMustEqual;m.hasCaret&&(g===0||(c=!1),s=!1);let t=0;if(m.preRelease){const i=b.exec(m.preRelease);if(i){const[,o,u,a]=i;t=Date.UTC(Number(o),Number(u)-1,Number(a))}}return{majorBase:g,majorMustEqual:l,minorBase:f,minorMustEqual:c,patchBase:n,patchMustEqual:s,isMinimum:m.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function w(m,g,l){let f;typeof m=="string"?f=E(I(m)):f=m;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let n;if(typeof l=="string"?n=E(I(l)):n=l,!f||!n)return!1;const s=f.majorBase,t=f.minorBase,i=f.patchBase;let o=n.majorBase,u=n.minorBase,a=n.patchBase;const h=n.notBefore;let v=n.majorMustEqual,D=n.minorMustEqual,M=n.patchMustEqual;return n.isMinimum?s>o?!0:s<o?!1:t>u?!0:t<u||c&&c<h?!1:i>=a:(s===1&&o===0&&(!v||!D||!M)&&(o=1,u=0,a=0,v=!0,D=!1,M=!1),s<o?!1:s>o?!v:t<u?!1:t>u?!D:i<a?!1:i>a?!M:!(c&&c<h))}e.isValidVersion=w;function p(m,g,l,f,c){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([r.default.Error,k.localize(0,null)]),n;if(typeof f.name!="string")return n.push([r.default.Error,k.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([r.default.Error,k.localize(2,null,"version")]),n;if(!f.engines)return n.push([r.default.Error,k.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([r.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!C(f.extensionDependencies))return n.push([r.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!C(f.activationEvents))return n.push([r.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([r.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([r.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([r.default.Error,k.localize(9,null,"main")]),n;{const i=(0,R.joinPath)(l,f.main);(0,R.isEqualOrParent)(i,l)||n.push([r.default.Warning,k.localize(10,null,i.path,l.path)])}if(typeof f.activationEvents>"u")return n.push([r.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([r.default.Error,k.localize(12,null,"browser")]),n;{const i=(0,R.joinPath)(l,f.browser);(0,R.isEqualOrParent)(i,l)||n.push([r.default.Warning,k.localize(13,null,i.path,l.path)])}if(typeof f.activationEvents>"u")return n.push([r.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!T.valid(f.version))return n.push([r.default.Error,k.localize(15,null)]),n;const s=[];if(!y(m,g,f,c,s))for(const i of s)n.push([r.default.Error,i]);return n}e.validateExtensionManifest=p;function y(m,g,l,f,c){return f||typeof l.main>"u"&&typeof l.browser>"u"?!0:S(m,g,l.engines.vscode,c)}e.isValidExtensionVersion=y;function d(m,g,l){return m==="*"||S(g,l,m)}e.isEngineValid=d;function S(m,g,l,f=[]){const c=E(I(l));if(!c)return f.push(k.localize(16,null,l)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(k.localize(17,null,l)),!1}else if(!c.majorMustEqual)return f.push(k.localize(18,null,l)),!1;return w(m,g,c)?!0:(f.push(k.localize(19,null,m,l)),!1)}function C(m){if(!Array.isArray(m))return!1;for(let g=0,l=m.length;g<l;g++)if(typeof m[g]!="string")return!1;return!0}}),define(ne[47],se([0,1,16,30]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,A,b){let P=b&&b.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await A.readFile(T.serviceMachineIdResource)).value.toString();P=(0,r.isUUID)(E)?E:null}catch{P=null}if(!P){P=(0,r.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(P))}catch{}}return b?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=k}),define(ne[56],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(k,T=[],A=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(ne[88],se([0,1,56]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const r=[];function k(A,b,P){b instanceof R.SyncDescriptor||(b=new R.SyncDescriptor(b,[],P)),r.push([A,b])}e.registerSingleton=k;function T(){return r}e.getSingletonServiceDescriptors=T}),define(ne[172],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class r{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const b=this.lookupOrInsertNode(T),P=this.lookupOrInsertNode(A);b.outgoing.set(this._hashFn(A),P),P.incoming.set(this._hashFn(T),b)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(const b of this._nodes.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let b=this._nodes.get(A);return b||(b=new R(T),this._nodes.set(A,b)),b}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[A,b]of this._nodes)T.push(`${A}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this._nodes){const b=new Set([T]),P=this._findCycle(A,b);if(P)return P}}_findCycle(T,A){for(const[b,P]of T.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const I=this._findCycle(P,A);if(I)return I;A.delete(b)}}}e.Graph=r}),define(ne[5],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(P){return P[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(R=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function r(A,b,P){b[R.DI_TARGET]===b?b[R.DI_DEPENDENCIES].push({id:A,index:P}):(b[R.DI_DEPENDENCIES]=[{id:A,index:P}],b[R.DI_TARGET]=b)}function k(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const b=function(P,I,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(b,P,E)};return b.toString=()=>A,R.serviceIds.set(A,b),b}e.createDecorator=k;function T(A){return A}e.refineServiceDecorator=T}),define(ne[173],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[19],se([0,1,14,7,5]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationOverrides=T;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=A;var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(m,g){const l=Object.create(null);for(const f in m)E(l,f,m[f],g);return l}e.toValuesTree=I;function E(m,g,l,f){const c=g.split("."),n=c.pop();let s=m;for(let t=0;t<c.length;t++){const i=c[t];let o=s[i];switch(typeof o){case"undefined":o=s[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${c.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[n]=l}catch{f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=E;function w(m,g){const l=g.split(".");p(m,l)}e.removeFromValueTree=w;function p(m,g){const l=g.shift();if(g.length===0){delete m[l];return}if(Object.keys(m).indexOf(l)!==-1){const f=m[l];typeof f=="object"&&!Array.isArray(f)&&(p(f,g),Object.keys(f).length===0&&delete m[l])}}function y(m,g,l){function f(s,t){let i=s;for(const o of t){if(typeof i!="object"||i===null)return;i=i[o]}return i}const c=g.split("."),n=f(m,c);return typeof n>"u"?l:n}e.getConfigurationValue=y;function d(m,g,l){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in m?R.isObject(m[f])&&R.isObject(g[f])?d(m[f],g[f],l):l&&(m[f]=g[f]):m[f]=g[f])})}e.merge=d;function S(m,g,l){const f=m.inspect(g),c=m.inspect(l);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:f.defaultValue}e.getMigratedSettingValue=S;function C(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[174],se([0,1,4,24,5]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",R.isEdge),T.set("isFirefox",R.isFirefox),T.set("isChrome",R.isChrome),T.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var b;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(L){return y.create(L)}static equals(L,N){return d.create(L,N)}static notEquals(L,N){return m.create(L,N)}static regex(L,N){return t.create(L,N)}static in(L,N){return S.create(L,N)}static notIn(L,N){return C.create(L,N)}static not(L){return g.create(L)}static and(...L){return u.create(L,null)}static or(...L){return a.create(L,null,!0)}static greater(L,N){return f.create(L,N)}static greaterEquals(L,N){return c.create(L,N)}static smaller(L,N){return n.create(L,N)}static smallerEquals(L,N){return s.create(L,N)}static deserialize(L,N=!1){if(!!L)return this._deserializeOrExpression(L,N)}static _deserializeOrExpression(L,N){const $=L.split("||");return a.create($.map(V=>this._deserializeAndExpression(V,N)),null,!0)}static _deserializeAndExpression(L,N){const $=L.split("&&");return u.create($.map(V=>this._deserializeOne(V,N)),null)}static _deserializeOne(L,N){if(L=L.trim(),L.indexOf("!=")>=0){const $=L.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],N))}if(L.indexOf("==")>=0){const $=L.split("==");return d.create($[0].trim(),this._deserializeValue($[1],N))}if(L.indexOf("=~")>=0){const $=L.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],N))}if(L.indexOf(" not in ")>=0){const $=L.split(" not in ");return C.create($[0].trim(),$[1].trim())}if(L.indexOf(" in ")>=0){const $=L.split(" in ");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const $=L.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const $=L.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const $=L.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const $=L.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(L)?g.create(L.substr(1).trim()):y.create(L)}static _deserializeValue(L,N){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const $=/^'([^']*)'$/.exec(L);return $?$[1].trim():L}static _deserializeRegexValue(L,N){if((0,r.isFalsyOrWhitespace)(L)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=L.indexOf("/"),V=L.lastIndexOf("/");if($===V||$<0){if(N)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const J=L.slice($+1,V),H=L[V+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(G){if(N)throw new Error(`bad regexp-value '${L}', parse error: ${G}`);return console.warn(`bad regexp-value '${L}', parse error: ${G}`),null}}}e.ContextKeyExpr=P;function I(O,L){const N=O?O.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!N&&!$?!0:!N||!$?!1:N.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function E(O,L){return O.cmp(L)}class w{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class y{constructor(L,N){this.key=L,this.negated=N,this.type=2}static create(L,N=null){const $=T.get(L);return typeof $=="boolean"?$?p.INSTANCE:w.INSTANCE:new y(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:w.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=4}static create(L,N,$=null){if(typeof N=="boolean")return N?y.create(L,$):g.create(L,$);const V=T.get(L);return typeof V=="boolean"?N===(V?"true":"false")?p.INSTANCE:w.INSTANCE:new d(L,N,$)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?p.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(L,N){this.key=L,this.valueKey=N,this.type=10,this.negated=null}static create(L,N){return new S(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.valueKey),$=L.getValue(this.key);return Array.isArray(N)?N.includes($):typeof $=="string"&&typeof N=="object"&&N!==null?A.call(N,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{constructor(L,N){this.key=L,this.valueKey=N,this.type=11,this._negated=S.create(L,N)}static create(L,N){return new C(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class m{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=5}static create(L,N,$=null){if(typeof N=="boolean")return N?g.create(L,$):y.create(L,$);const V=T.get(L);return typeof V=="boolean"?N===(V?"true":"false")?w.INSTANCE:p.INSTANCE:new m(L,N,$)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?w.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class g{constructor(L,N){this.key=L,this.negated=N,this.type=3}static create(L,N=null){const $=T.get(L);return typeof $=="boolean"?$?w.INSTANCE:p.INSTANCE:new g(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function l(O,L){if(typeof O=="string"){const N=parseFloat(O);isNaN(N)||(O=N)}return typeof O=="string"||typeof O=="number"?L(O):w.INSTANCE}class f{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=12}static create(L,N,$=null){return l(N,V=>new f(L,V,$))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class c{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=13}static create(L,N,$=null){return l(N,V=>new c(L,V,$))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class n{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=14}static create(L,N,$=null){return l(N,V=>new n(L,V,$))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class s{constructor(L,N,$){this.key=L,this.value=N,this.negated=$,this.type=15}static create(L,N,$=null){return l(N,V=>new s(L,V,$))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{constructor(L,N){this.key=L,this.regexp=N,this.type=7,this.negated=null}static create(L,N){return new t(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const N=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return N<$?-1:N>$?1:0}equals(L){if(L.type===this.type){const N=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return this.key===L.key&&N===$}return!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class i{constructor(L){this._actual=L,this.type=8}static create(L){return new i(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new i(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(O){let L=null;for(let N=0,$=O.length;N<$;N++){const V=O[N].substituteConstants();if(O[N]!==V&&L===null){L=[];for(let J=0;J<N;J++)L[J]=O[J]}L!==null&&(L[N]=V)}return L===null?O:L}class u{constructor(L,N){this.expr=L,this.negated=N,this.type=6}static create(L,N){return u._normalizeArr(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const V=E(this.expr[N],L.expr[N]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].evaluate(L))return!1;return!0}static _normalizeArr(L,N){const $=[];let V=!1;for(const J of L)if(!!J){if(J.type===1){V=!0;continue}if(J.type===0)return w.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&V)return p.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(E);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),G=$.length===0,q=a.create(J.expr.map(x=>u.create([x,H],null)),null,G);q&&($.push(q),$.sort(E))}return $.length===1?$[0]:new u($,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new u(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());this.negated=a.create(L,this,!0)}return this.negated}}class a{constructor(L,N){this.expr=L,this.negated=N,this.type=9}static create(L,N,$){return a._normalizeArr(L,N,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,$=this.expr.length;N<$;N++){const V=E(this.expr[N],L.expr[N]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,$=this.expr.length;N<$;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.negated,!1)}evaluate(L){for(let N=0,$=this.expr.length;N<$;N++)if(this.expr[N].evaluate(L))return!0;return!1}static _normalizeArr(L,N,$){let V=[],J=!1;if(L){for(let H=0,G=L.length;H<G;H++){const q=L[H];if(!!q){if(q.type===0){J=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){V=V.concat(q.expr);continue}V.push(q)}}if(V.length===0&&J)return w.INSTANCE;V.sort(E)}if(V.length!==0){if(V.length===1)return V[0];for(let H=1;H<V.length;H++)V[H-1].equals(V[H])&&(V.splice(H,1),H--);if(V.length===1)return V[0];if($){for(let H=0;H<V.length;H++)for(let G=H+1;G<V.length;G++)M(V[H],V[G])&&(V.splice(G,1),G--);if(V.length===1)return V[0]}return new a(V,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new a(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());for(;L.length>1;){const N=L.shift(),$=L.shift(),V=[];for(const H of F(N))for(const G of F($))V.push(u.create([H,G],null));const J=L.length===0;L.unshift(a.create(V,null,J))}this.negated=L[0]}return this.negated}}class h extends y{constructor(L,N,$){super(L,null),this._defaultValue=N,typeof $=="object"?h._info.push({...$,key:L}):$!==!0&&h._info.push({key:L,description:$,type:N!=null?typeof N:void 0})}static all(){return h._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return d.create(this.key,L)}notEqualsTo(L){return m.create(this.key,L)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(O,L){return O<L?-1:O>L?1:0}function D(O,L,N,$){return O<N?-1:O>N?1:L<$?-1:L>$?1:0}function M(O,L){if(L.type===6&&O.type!==9&&O.type!==6){for(const V of L.expr)if(O.equals(V))return!0}const N=O.negate(),$=F(N).concat(F(L));$.sort(E);for(let V=0;V<$.length;V++){const H=$[V].negate();for(let G=V+1;G<$.length;G++){const q=$[G];if(H.equals(q))return!0}}return!1}e.implies=M;function F(O){return O.type===9?O.expr:[O]}}),define(ne[89],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function r(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=r;class k{async getPerformanceInfo(A,b){return{}}async getSystemInfo(A,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,b){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ne[90],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[15],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],se([0,1,140,5]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function b(m,g){return g==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function P(m,g,l){return b(g,l)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===l?!0:I(l).includes(m)}e.isTargetPlatformCompatible=P;function I(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=E;var w;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var S;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,l){super(g),this.code=l,this.name=l}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,r.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,r.createDecorator)("IExtensionManagementCLIService")}),define(ne[175],se([0,1,3,2,63,31,7,127,29]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(C,m){return A.URI.revive(m?m.transformIncoming(C):C)}function E(C,m){return m?m.transformOutgoingURI(C):C}function w(C,m){m=m||b.DefaultURITransformer;const g=C.manifest;return{...(0,b.transformAndReviveIncomingURIs)({...C,manifest:void 0},m),manifest:g}}function p(C,m){return m?(0,T.cloneAndChange)(C,g=>g instanceof A.URI?m.transformOutgoingURI(g):void 0):C}class y{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const l=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?p(c.local,l):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,l){const f=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(w(l[0],f)).then(c=>E(c,f));case"unzip":return this.service.unzip(I(l[0],f));case"install":return this.service.install(I(l[0],f),(0,k.revive)(l[1]));case"getManifest":return this.service.getManifest(I(l[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(l[0]);case"installFromGallery":return this.service.installFromGallery(l[0],(0,k.revive)(l[1]));case"uninstall":return this.service.uninstall(w(l[0],f),(0,k.revive)(l[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(l[0],f));case"getInstalled":return this.service.getInstalled(l[0],A.URI.revive(l[1])).then(c=>c.map(n=>p(n,f)));case"getMetadata":return this.service.getMetadata(w(l[0],f));case"updateMetadata":return this.service.updateMetadata(w(l[0],f),l[1]).then(c=>p(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(w(l[0],f),l[1]).then(c=>p(c,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class d extends r.Disposable{constructor(m){super(),this.channel=m,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(l=>({...l,local:l.local?w(l.local,null):l.local,source:this.isUriComponents(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(l=>(0,P.isTargetPlatformCompatible)(l,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>A.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(l=>w(l,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(l=>w(l,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,g){return Promise.resolve(this.channel.call("getInstalled",[m,g])).then(l=>l.map(f=>w(f,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(l=>w(l,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(l=>w(l,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,l){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[91],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],se([0,1,34,9,24,14,7,148,5]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function I(H){return H.create===!0}e.isFileOpenForWriteOptions=I;var E;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var w;(function(H){H[H.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var p;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function d(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=d;function S(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=S;function C(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function g(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var l;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(G,q){super(G),this.code=q}}e.FileSystemProviderError=f;function c(H,G){const q=new f(H.toString(),G);return s(q,G),q}e.createFileSystemProviderError=c;function n(H){return H||c((0,b.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=n;function s(H,G){return H.name=G?`${G} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return l.Unknown;if(H instanceof f)return H.code;const G=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!G)return l.Unknown;switch(G[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=t;function i(H){if(H instanceof D)return H.fileOperationResult;switch(t(H)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class u{constructor(G,q,x){this.resource=G,this.operation=q,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=u;var a;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(G,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const Y of G){const te=x.get(Y.type);switch(te?te.push([Y.resource,Y]):x.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of x)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>q),this.added.fill(te);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>q),this.updated.fill(te);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>q),this.deleted.fill(te);break}}contains(G,...q){return this.doContains(G,{includeChildren:!1},...q)}affects(G,...q){return this.doContains(G,{includeChildren:!0},...q)}doContains(G,q,...x){if(!G)return!1;const Y=x.length>0;return!!((!Y||x.includes(1))&&(this.added?.get(G)||q.includeChildren&&this.added?.findSuperstr(G))||(!Y||x.includes(0))&&(this.updated?.get(G)||q.includeChildren&&this.updated?.findSuperstr(G))||(!Y||x.includes(2))&&(this.deleted?.findSubstr(G)||q.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(H,G,q){return!H||!G||H===G||G.length>H.length?!1:(G.charAt(G.length-1)!==r.sep&&(G+=r.sep),q?(0,k.startsWithIgnoreCase)(H,G):H.indexOf(G)===0)}e.isParent=v;class D extends Error{constructor(G,q,x){super(G),this.fileOperationResult=q,this.options=x}}e.FileOperationError=D;class M extends D{constructor(G,q,x){super(G,2,x),this.stat=q}}e.NotModifiedSinceFileOperationError=M;var F;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=L;async function N(H,G){if(!G.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(q=>{const x=G.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(x.dispose(),q())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<$.KB?(0,b.localize)(1,null,G.toFixed(0)):G<$.MB?(0,b.localize)(2,null,(G/$.KB).toFixed(2)):G<$.GB?(0,b.localize)(3,null,(G/$.MB).toFixed(2)):G<$.TB?(0,b.localize)(4,null,(G/$.GB).toFixed(2)):(0,b.localize)(5,null,(G/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var V;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(X,e){return function(R,r){e(R,r,X)}};define(ne[176],se([0,1,177,41,13]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(b){this.fileService=b}async checksum(b){const P=(await this.fileService.readFileStream(b)).value;return new Promise((I,E)=>{const w=(0,R.createHash)("md5");(0,r.listenStream)(P,{onData:p=>w.update(p.buffer),onError:p=>E(p),onEnd:()=>I(w.digest("base64").replace(/=+$/,""))})})}};T=pe([K(0,k.IFileService)],T),e.ChecksumService=T}),define(ne[178],se([0,1,16,38,10,3,2,41,7,30,13]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(y,d){super(),this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:S}=await this.channel.call("readFile",[y,d]);return S}readFileStream(y,d,S){const C=(0,b.newWriteableStream)(g=>R.VSBuffer.concat(g.map(l=>R.VSBuffer.wrap(l))).buffer),m=this.channel.listen("readFileStream",[y,d])(g=>{if(g instanceof R.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let l=g;l instanceof Error||(l=(0,E.createFileSystemProviderError)((0,r.toErrorMessage)(l),E.FileSystemProviderErrorCode.Unknown)),C.error(l),C.end()}m.dispose()}});return S.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),m.dispose()}),C}writeFile(y,d,S){return this.channel.call("writeFile",[y,R.VSBuffer.wrap(d),S])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,S,C,m){const[g,l]=await this.channel.call("read",[y,d,m]);return S.set(g.buffer.slice(0,l),C),l}write(y,d,S,C,m){return this.channel.call("write",[y,d,R.VSBuffer.wrap(S),C,m])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,S){return this.channel.call("rename",[y,d,S])}copy(y,d,S){return this.channel.call("copy",[y,d,S])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(S=>({resource:P.URI.revive(S.resource),type:S.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const S=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(ne[92],se([0,1,16,10,149,13]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(E,w,p,y,d,S){let C;try{await b(E,w,p,y,d,S)}catch(m){C=m}finally{C&&d.errorTransformer&&(C=d.errorTransformer(C)),typeof C<"u"&&p.error(C),p.end()}}e.readFileIntoStream=A;async function b(E,w,p,y,d,S){P(S);const C=await E.open(w,{create:!1});try{P(S);let m=0,g=0,l=d&&typeof d.length=="number"?d.length:void 0,f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,n=0;do g=await E.read(C,c,f.buffer,n,f.byteLength-n),c+=g,n+=g,m+=g,typeof l=="number"&&(l-=g),n===f.byteLength&&(await p.write(y(f)),f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),n=0);while(g>0&&(typeof l!="number"||l>0)&&P(S)&&I(m,d));if(n>0){let s=n;typeof l=="number"&&(s=Math.min(n,l)),p.write(y(f.slice(0,s)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await E.close(C)}}function P(E){if(E.isCancellationRequested)throw(0,r.canceled)();return!0}function I(E,w){if(w?.limits){if(typeof w.limits.memory=="number"&&E>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&E>w.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],se([0,1,81,2,9,4,7,13]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(m){return m.recursive===!0}e.isRecursiveWatchRequest=P;class I extends r.Disposable{constructor(g,l,f,c){super(),this.onFileChanges=g,this.onLogMessage=l,this.verboseLogging=f,this.options=c,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new r.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(l=>this.onFileChanges(l))),g.add(this.watcher.onDidLogMessage(l=>this.onLogMessage(l))),g.add(this.watcher.onDidError(l=>this.onError(l)))}onError(g){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class E extends I{constructor(g,l,f){super(g,l,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class w extends I{constructor(g,l,f){super(g,l,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function p(m){return m.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=p;function y(m){const g=new C;for(const l of m)g.processEvent(l);return g.coalesce()}e.coalesceEvents=y;function d(m,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:m,pattern:g}:g}e.normalizeWatcherPattern=d;function S(m,g){const l=[];for(const f of g)l.push((0,R.parse)(d(m,f)));return l}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return T.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const l=this.mapPathToChange.get(this.toKey(g));let f=!1;if(l){const c=l.type,n=g.type;l.path!==g.path&&(g.type===2||g.type===1)?f=!0:c===1&&n===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(l)):c===2&&n===1?l.type=0:c===1&&n===0||(l.type=n)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],l=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>l.some(c=>(0,b.isParent)(f.path,c,!T.isLinux))?!1:(l.push(f.path),!0)).concat(g)}}}),define(ne[179],se([0,1,53,6,21,46,2,79,9,4,129,27,57]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(C,m,g,l){super(),this.request=C,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=l,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await w.Promises.stat(C);this._register(await this.doWatch(C,m.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let m=C.path;try{m=await w.Promises.realpath(C.path),C.path===m&&(m=await(0,E.realcase)(C.path)??C.path),C.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${m})`)}catch{}return m}async doWatch(C,m){if(I.isMacintosh&&(0,T.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),l=new A.DisposableStore;try{const f=(0,P.basename)(C),c=(0,R.watch)(C);l.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${C}'`);const n=new Set;if(m)try{for(const t of await w.Promises.readdir(C))n.add(t)}catch(t){this.error(t)}const s=new Map;l.add((0,A.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),c.on("error",(t,i)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),c.on("change",(t,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let o="";if(i&&(o=i.toString(),I.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(m)if(t==="rename"){s.get(o)?.dispose();const u=setTimeout(async()=>{if(s.delete(o),o===f&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(C,o));if(g.token.isCancellationRequested)return;let h;a?n.has(o)?h=0:(h=1,n.add(o)):(n.delete(o),h=2),this.onFileChange({path:(0,P.join)(this.request.path,o),type:h})},y.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,A.toDisposable)(()=>clearTimeout(u)))}else{let u;n.has(o)?u=0:(u=1,n.add(o)),this.onFileChange({path:(0,P.join)(this.request.path,o),type:u})}else if(t==="rename"||o!==f){const u=setTimeout(async()=>{const a=await w.Promises.exists(C);g.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),l.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,A.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),l.dispose()})}async onFileChange(C,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!m&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const l=(0,p.coalesceEvents)(g);if(l.length>0){if(this.verboseLogging)for(const c of l)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(l)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(I.isLinux)return w.Promises.exists(C);try{const m=(0,P.basename)(C);return(await w.Promises.readdir((0,P.dirname)(C))).some(l=>l===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,C,m,g,l=512){const f=await w.Promises.open(S,"r"),c=Buffer.allocUnsafe(l),n=new k.CancellationTokenSource(g);let s,t=!1;const i={path:S,excludes:[],recursive:!1},o=new y(i,u=>{(async()=>{for(const{type:a}of u)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await w.Promises.read(f,c,0,l,null);if(!h||n.token.isCancellationRequested)break;C(c.slice(0,h))}}catch(h){s=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,m(),new Promise((u,a)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await w.Promises.close(f)}catch(h){s=new Error(h)}s?a(s):u()})})}e.watchFileContents=d}),define(ne[180],se([0,1,3,81,2,4,179]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const E=this.normalizeRequests(I),w=E.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,r.patternsEquals)(d.request.excludes,y.excludes)||!(0,r.patternsEquals)(d.request.includes,y.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:y})=>!E.find(d=>d.path===y.path&&(0,r.patternsEquals)(d.excludes,y.excludes)&&(0,r.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);w.length&&this.trace(`Request to start watching: ${w.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const y of p)this.stopWatching(y);for(const y of w)this.startWatching(y)}startWatching(I){const E=new A.NodeJSFileWatcherLibrary(I,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),w={request:I,instance:E};this.watchers.set(I.path,w)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const E=this.watchers.get(I);E&&(this.watchers.delete(I),E.instance.dispose())}normalizeRequests(I){const E=new Map;for(const w of I){const p=T.isLinux?w.path:w.path.toLowerCase();E.set(p,w)}return Array.from(E.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,E]of this.watchers)E.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,E){return E?`[File Watcher (node.js)] ${I} (path: ${E.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=b}),define(ne[181],se([0,1,57,180]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends R.AbstractNonRecursiveWatcherClient{constructor(A,b,P){super(A,b,P),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[182],se([0,1,20,39,64,57]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(P,I,E){super(P,I,E),this.init()}createWatcher(P){const I=P.add(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(I.onDidProcessExit(({code:E,signal:w})=>this.onError(`terminated by itself with code ${E}, signal: ${w}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[93],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...k){this._entries=new Map;for(const[T,A]of k)this.set(T,A)}set(k,T){const A=this._entries.get(k);return this._entries.set(k,T),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=R}),define(ne[183],se([0,1,6,10,56,172,5,93]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class I extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class E{constructor(d=new b.ServiceCollection,S=!1,C){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=C,this._services.set(A.IInstantiationService,this)}createChild(d){return new E(d,this._strict,this)}invokeFunction(d,...S){const C=p.traceInvocation(d);let m=!1;try{return d({get:l=>{if(m)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(l,C);if(!f)throw new Error(`[invokeFunction] unknown service '${l}'`);return f}},...S)}finally{m=!0,C.stop()}}createInstance(d,...S){let C,m;return d instanceof k.SyncDescriptor?(C=p.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(S),C)):(C=p.traceCreation(d),m=this._createInstance(d,S,C)),C.stop(),m}_createInstance(d,S=[],C){const m=A._util.getServiceDependencies(d).sort((f,c)=>f.index-c.index),g=[];for(const f of m){const c=this._getOrCreateServiceInstance(f.id,C);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(c)}const l=m.length>0?m[0].index:S.length;if(S.length!==l){console.trace(`[createInstance] First service dependency of ${d.name} at position ${l+1} conflicts with ${S.length} static arguments`);const f=l-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,l)}return new d(...S,...g)}_setServiceInstance(d,S){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const C=this._getServiceInstanceOrDescriptor(d);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,C,S.branch(d,!0)):(S.branch(d,!1),C)}_safeCreateAndCacheServiceInstance(d,S,C){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,C)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,C){const m=new T.Graph(f=>f.id.toString());let g=0;const l=[{id:d,desc:S,_trace:C}];for(;l.length;){const f=l.pop();if(m.lookupOrInsertNode(f),g++>1e3)throw new I(m);for(const c of A._util.getServiceDependencies(f.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),n instanceof k.SyncDescriptor){const s={id:c.id,desc:n,_trace:f._trace.branch(c.id,!0)};m.insertEdge(f,s),l.push(s)}}}for(;;){const f=m.roots();if(f.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:c}of f){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,C=[],m,g){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(S,C,m,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,C,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],C,m){if(C){const g=new R.IdleValue(()=>this._createInstance(d,S,m));return new Proxy(Object.create(null),{get(l,f){if(f in l)return l[f];const c=g.value;let n=c[f];return typeof n!="function"||(n=n.bind(c),l[f]=n),n},set(l,f,c){return g.value[f]=c,!0}})}else return this._createInstance(d,S,m)}_throwIfStrict(d,S){if(S&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=E;var w;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(w||(w={}));class p{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return P?new p(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(d){return P?new p(0,d.name):p._None}branch(d,S){const C=new p(2,d.toString());return this._dep.push([d,S,C]),C}stop(){const d=Date.now()-this._start;p._totals+=d;let S=!1;function C(g,l){const f=[],c=new Array(g+1).join("	");for(const[n,s,t]of l._dep)if(s&&t){S=!0,f.push(`${c}CREATES -> ${n}`);const i=C(g+1,t);i&&f.push(i)}else f.push(`${c}uses -> ${n}`);return f.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(m.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ne[184],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=R}),define(ne[94],se([0,1,39,56,88,5]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,d,S){const C=S.getChannel(y);return b(d)?new d.channelClientCtor(C):R.ProxyChannel.toService(C,d?.proxyOptions)}}function b(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let P=class extends A{constructor(y,d,S){super(y,d,S)}};P=pe([K(2,e.IMainProcessService)],P);function I(p,y,d){(0,k.registerSingleton)(p,new r.SyncDescriptor(P,[y,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let E=class extends A{constructor(y,d,S){super(y,d,S)}};E=pe([K(2,e.ISharedProcessService)],E);function w(p,y,d){(0,k.registerSingleton)(p,new r.SyncDescriptor(E,[y,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(ne[66],se([0,1,21,2,4,151,29,5]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let P=class extends r.Disposable{constructor(E){super(),this.extensionGalleryService=E}async getAvailableLanguages(){const E=new R.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const y=w.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],C=this.getLocale(d);return{...this.createQuickPickItem(C,S,d),extensionId:d.identifier.id,galleryExtension:d}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(E){return E.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(E,w,p){const y=w??E;let d;if(y!==E&&(d=`(${E})`),E.toLowerCase()===k.language.toLowerCase()&&(d??="",d+=(0,T.localize)(0,null)),p?.installCount){d??="";const S=p.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),d+=` $(cloud-download) ${C}`}return{id:E,label:y,description:d}}};P=pe([K(0,A.IExtensionGalleryService)],P),e.LanguagePackBaseService=P}),define(ne[185],se([0,1,2,66]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends R.Disposable{constructor(A){super(),this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=pe([K(0,r.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],se([0,1,38,3,2,4,5]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function b(){return new Date().toISOString()}var P;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(P=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=P.Info;function I(s,t,i){switch(t){case P.Trace:s.trace(i);break;case P.Debug:s.debug(i);break;case P.Info:s.info(i);break;case P.Warning:s.warn(i);break;case P.Error:s.error(i);break;case P.Critical:s.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function E(s){let t="";for(let i=0;i<s.length;i++){let o=s[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(i>0?" ":"")+o}return t}e.format=E;class w extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class p extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(P.Trace)&&this.log(P.Trace,E([t,...i]))}debug(t,...i){this.checkLogLevel(P.Debug)&&this.log(P.Debug,E([t,...i]))}info(t,...i){this.checkLogLevel(P.Info)&&this.log(P.Info,E([t,...i]))}warn(t,...i){this.checkLogLevel(P.Warning)&&this.log(P.Warning,E([t,...i]))}error(t,...i){if(this.checkLogLevel(P.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(P.Error,E(o))}else this.log(P.Error,E([t,...i]))}critical(t,...i){this.checkLogLevel(P.Critical)&&this.log(P.Critical,E([t,...i]))}flush(){}}e.AbstractMessageLogger=p;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!T.isWindows}trace(t,...i){this.getLevel()<=P.Trace&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}debug(t,...i){this.getLevel()<=P.Debug&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}info(t,...i){this.getLevel()<=P.Info&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}warn(t,...i){this.getLevel()<=P.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,t,...i):console.warn(`[main ${b()}]`,t,...i))}error(t,...i){this.getLevel()<=P.Error&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}critical(t,...i){this.getLevel()<=P.Critical&&(this.useColors?console.error(`\x1B[90m[main ${b()}]\x1B[0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...i){this.getLevel()<=P.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=P.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=P.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=P.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=P.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=P.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends w{constructor(t,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=P.Trace&&this.adapter.log(P.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=P.Debug&&this.adapter.log(P.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=P.Info&&this.adapter.log(P.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=P.Warning&&this.adapter.log(P.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=P.Error&&this.adapter.log(P.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=P.Critical&&this.adapter.log(P.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=P.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class m extends k.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=m;class g extends k.Disposable{constructor(t,i){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,i?.always?P.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class l{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return P.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=l;function f(s){if(s.verbose)return P.Trace;if(typeof s.logLevel=="string"){const t=c(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function c(s){switch(s){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Critical;case"off":return P.Off}}e.parseLogLevel=c;function n(s){switch(s){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Critical:return"critical";case P.Off:return"off"}}e.LogLevelToString=n}),define(ne[186],se([0,1,6,10,2,9,27,15,8]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends k.Disposable{constructor(w,p){super(),this.environmentService=w,this.logService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),p=(0,T.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(p)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==w),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(m=>A.Promises.rm((0,T.join)(p,m)))))}catch(w){(0,r.onUnexpectedError)(w)}}};I=pe([K(0,b.IEnvironmentService),K(1,P.ILogService)],I),e.LogsDataCleaner=I}),define(ne[187],se([0,1,6,10,2,9,27,15,8]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class gt extends k.Disposable{constructor(w,p,y){super(),this.backupWorkspacesPath=w,this.environmentService=p,this.logService=y,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(w).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||S===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(w){(0,r.onUnexpectedError)(w)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",I=pe([K(1,b.INativeEnvironmentService),K(2,P.ILogService)],I),e.StorageDataCleaner=I}),define(ne[188],se([0,1,18,6,10,3,2,9,57,8]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends A.Disposable{constructor(p,y){super(),this.logService=p,this.options=y,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(p,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,y):this.watchNonRecursive(p,y)}watchUniversal(p,y){const d={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,R.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,P.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&p.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,y){const d={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,R.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,P.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,b.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(ne[189],se([0,1,18,6,16,21,3,62,51,2,34,20,190,17,41,147,13,92,8]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends I.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${c}`);const s=new I.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),s.add(n.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,I.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){n.push(s)}}),!this.provider.has(c)&&await r.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,y.isAbsolutePath)(c))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,S.localize)(1,null,c.toString()),s}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n)||(0,C.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(s){throw(0,C.toFileSystemProviderErrorCode)(s)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,C.ensureFileSystemProviderError)(s)}}async doResolveFile(c,n){const s=await this.withProvider(c),t=this.isPathCaseSensitive(s),i=n?.resolveTo,o=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,a=await s.stat(c);let h;return this.toFileStat(s,c,a,void 0,!!u,(v,D)=>(h||(h=E.TernarySearchTree.forUris(()=>!t),h.set(c,!0),i&&h.fill(!0,i)),h.get(v.resource)||h.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?D===1:!1))}async toFileStat(c,n,s,t,i,o){const{providerExtUri:u}=this.getExtUri(c),a={resource:n,name:u.basename(n),isFile:(s.type&C.FileType.File)!==0,isDirectory:(s.type&C.FileType.Directory)!==0,isSymbolicLink:(s.type&C.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&C.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,C.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const h=await c.readdir(n),v=await r.Promises.settled(h.map(async([D,M])=>{try{const F=u.joinPath(n,D),O=i?await c.stat(F):{type:M};return await this.toFileStat(c,F,O,h.length,i,o)}catch(F){return this.logService.trace(F),null}}));a.children=(0,R.coalesce)(v)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(c){return r.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),s=await n.stat(c);return this.toFileStat(n,c,s,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(s){return s}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=k.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const t=await this.writeFile(c,n);return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,t)),t}async writeFile(c,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(t);try{await this.validateWriteFile(t,c,s)||await this.mkdirp(t,i.dirname(c));let u;if((0,C.hasReadWriteCapability)(t)&&!(n instanceof k.VSBuffer))if((0,d.isReadableStream)(n)){const a=await(0,d.peekStream)(n,3);a.ended?u=k.VSBuffer.concat(a.buffer):u=a}else u=(0,d.peekReadable)(n,a=>k.VSBuffer.concat(a),3);else u=n;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&u instanceof k.VSBuffer?await this.doWriteUnbuffered(t,c,s,u):await this.doWriteBuffered(t,c,s,u instanceof k.VSBuffer?(0,k.bufferToReadable)(u):u),this._onDidRunOperation.fire(new C.FileOperationEvent(c,4))}catch(o){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(n)));let i;try{i=await c.stat(n)}catch{return}if((i.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,i),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==C.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&s.mtime<i.mtime&&s.etag!==(0,C.etag)({mtime:s.mtime,size:i.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,s);return i}async readFile(c,n,s){const t=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(t,c,n,s):this.doReadFile(t,c,n,s)}async doReadFileAtomic(c,n,s,t){return new Promise((i,o)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(c,n,s,t);i(u)}catch(u){o(u)}})})}async doReadFile(c,n,s,t){const i=await this.doReadFileStream(c,n,{...s,preferUnbuffered:!0},t);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(c,n,s){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,n,s)}async doReadFileStream(c,n,s,t){const i=new T.CancellationTokenSource(t),o=this.validateReadFile(n,s).then(a=>a,a=>{throw i.cancel(),a});let u;try{return typeof s?.etag=="string"&&s.etag!==C.ETAG_DISABLED&&await o,s?.atomic&&(0,C.hasFileAtomicReadCapability)(c)||!((0,C.hasOpenReadWriteCloseCapability)(c)||(0,C.hasFileReadStreamCapability)(c))||(0,C.hasReadWriteCapability)(c)&&s?.preferUnbuffered?u=this.readFileUnbuffered(c,n,s):(0,C.hasFileReadStreamCapability)(c)?u=this.readFileStreamed(c,n,i.token,s):u=this.readFileBuffered(c,n,i.token,s),{...await o,value:u}}catch(a){u&&await(0,d.consumeStream)(u);const h=(0,S.localize)(8,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(a).toString());throw a instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(h,a.stat,s):new C.FileOperationError(h,(0,C.toFileOperationResult)(a),s)}}readFileStreamed(c,n,s,t=Object.create(null)){const i=c.readFileStream(n,t,s);return(0,d.transform)(i,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}readFileBuffered(c,n,s,t=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,n,i,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(n),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},s),i}readFileUnbuffered(c,n,s){const t=(0,d.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;s?.atomic&&(0,C.hasFileAtomicReadCapability)(c)?i=await c.readFile(n,{atomic:!0}):i=await c.readFile(n),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.validateReadFileLimits(n,i.byteLength,s),t.end(k.VSBuffer.wrap(i))}catch(i){t.error(i),t.end()}})(),t}async validateReadFile(c,n){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==C.ETAG_DISABLED&&n.etag===s.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),s,n);return this.validateReadFileLimits(c,s.size,n),s}validateReadFileLimits(c,n,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&n>s.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),t)}}async canMove(c,n,s){return this.doCanMoveCopy(c,n,"move",s)}async canCopy(c,n,s){return this.doCanMoveCopy(c,n,"copy",s)}async doCanMoveCopy(c,n,s,t){if(c.toString()!==n.toString())try{const i=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(i,c,o,n,s,t)}catch(i){return i}return!0}async move(c,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(t,c,i,n,"move",!!s),u=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="move"?2:3,u)),u}async copy(c,n,s){const t=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(t,c,i,n,"copy",!!s),u=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,o==="copy"?3:2,u)),u}async doMoveCopy(c,n,s,t,i,o){if(n.toString()===t.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,n,s,t,i,o);if(u&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),i==="copy"){if(c===s&&(0,C.hasFileFolderCopyCapability)(c))await c.copy(n,t,{overwrite:o});else{const h=await this.resolve(n);h.isDirectory?await this.doCopyFolder(c,h,s,t):await this.doCopyFile(c,n,s,t)}return i}else return c===s?(await c.rename(n,t,{overwrite:o}),i):(await this.doMoveCopy(c,n,s,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,s,t){if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,n,s,t);if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,n,s,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,n,s,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,n,s,t)}async doCopyFolder(c,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await r.Promises.settled(n.children.map(async i=>{const o=this.getExtUri(s).providerExtUri.joinPath(t,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),s,o):this.doCopyFile(c,i.resource,s,o)}))}async doValidateMoveCopy(c,n,s,t,i,o){let u=!1;if(c===s){const{providerExtUri:h,isPathCaseSensitive:v}=this.getExtUri(c);if(v||(u=h.isEqual(n,t)),u&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(n),this.resourceForError(t)));if(!u&&h.isEqualOrParent(t,n))throw new Error((0,S.localize)(15,null,this.resourceForError(n),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!u){if(!o)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(n),this.resourceForError(t)),4);if(c===s){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(n,t))throw new Error((0,S.localize)(17,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,s)),s}async mkdirp(c,n){const s=[],{providerExtUri:t}=this.getExtUri(c);for(;!t.isEqual(n,t.dirname(n));)try{if(((await c.stat(n)).type&C.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(n)));break}catch(i){if((0,C.toFileSystemProviderErrorCode)(i)!==C.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(t.basename(n)),n=t.dirname(n)}for(let i=s.length-1;i>=0;i--){n=t.joinPath(n,s[i]);try{await c.mkdir(n)}catch(o){if((0,C.toFileSystemProviderErrorCode)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(s){return s}return!0}async doValidateDelete(c,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));let i;try{i=await s.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const u=await this.resolve(c);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return s}async del(c,n){const s=await this.doValidateDelete(c,n),t=!!n?.useTrash,i=!!n?.recursive;await s.delete(c,{recursive:i,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(c,1))}async cloneFile(c,n){const s=await this.withProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(s===t&&this.getExtUri(s).providerExtUri.isEqual(c,n))return;if(s===t&&(0,C.hasFileCloneCapability)(s))return s.cloneFile(c,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const i=this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri);return s===t&&(0,C.hasFileFolderCopyCapability)(s)?i.queue(()=>s.copy(c,n,{overwrite:!0})):i.queue(()=>this.doCopyFile(s,c,t,n))}watch(c,n={recursive:!1,excludes:[]}){const s=new I.DisposableStore;let t=!1,i=()=>{t=!0};return s.add((0,I.toDisposable)(()=>i())),(async()=>{try{const o=await this.doWatch(c,n);t?(0,I.dispose)(o):i=()=>(0,I.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(c,n){const s=await this.withProvider(c),t=(0,b.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(c),n]);let i=this.activeWatchers.get(t);return i||(i={count:0,disposable:s.watch(c,n)},this.activeWatchers.set(t,i)),i.count+=1,(0,I.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,I.dispose)(i.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,I.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,s,t){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(c,i,t):await this.doWriteReadableBufferedQueued(c,i,t)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,n,s){let t=0,i;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=k.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,n,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((o,u)=>{(0,d.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(c,n,a,a.byteLength,t,0)}catch(h){return u(h)}t+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>u(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,n,s){let t=0,i;for(;(i=s.read())!==null;)await this.doWriteBuffer(c,n,i,i.byteLength,t,0),t+=i.byteLength}async doWriteBuffer(c,n,s,t,i,o){let u=0;for(;u<t;)u+=await c.write(n,i+u,s.buffer,o+u,t-u)}async doWriteUnbuffered(c,n,s,t){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,s,t))}async doWriteUnbufferedQueued(c,n,s,t){let i;t instanceof k.VSBuffer?i=t:(0,d.isReadableStream)(t)?i=await(0,k.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?i=await(0,k.bufferedStreamToBuffer)(t):i=(0,k.readableToBuffer)(t),await c.writeFile(n,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,n,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,s,t))}async doPipeBufferedQueued(c,n,s,t){let i,o;try{i=await c.open(n,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const u=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,v=0;do v=await c.read(i,a,u.buffer,h,u.byteLength-h),await this.doWriteBuffer(s,o,u,v,a,h),a+=v,h+=v,h===u.byteLength&&(h=0);while(v>0)}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await r.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,n,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,s,t))}async doPipeUnbufferedQueued(c,n,s,t){return s.writeFile(t,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,s,t))}async doPipeUnbufferedToBufferedQueued(c,n,s,t){const i=await s.open(t,{create:!0,unlock:!1});try{const o=await c.readFile(n);await this.doWriteBuffer(s,i,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await s.close(i)}}async doPipeBufferedToUnbuffered(c,n,s,t){const i=await(0,k.streamToBuffer)(this.readFileBuffered(c,n,T.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,i)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};l=pe([K(0,g.ILogService)],l),e.FileService=l}),define(ne[191],se([0,1,53,273,6,34,16,3,46,2,9,4,17,41,27,150,13,92,188,38,182,181]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(s)}`)}})();class n extends g.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new T.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,u.name))).type:a=this.toType(u),o.push([u.name,a])}catch(a){this.logService.trace(a)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let o;return i?.dangling?o=C.FileType.Unknown:t.isFile()?o=C.FileType.File:t.isDirectory()?o=C.FileType.Directory:o=C.FileType.Unknown,i&&(o|=C.FileType.SymbolicLink),o}async createResourceLock(t){const i=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const u=new k.Barrier;return this.resourceLocks.set(t,u),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===u&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(t,i){let o;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const u=this.toFilePath(t);return await d.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{o?.dispose()}}readFileStream(t,i,o){const u=(0,y.newWriteableStream)(a=>A.VSBuffer.concat(a.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,m.readFileIntoStream)(this,t,u,a=>a.buffer,{...i,bufferSize:256*1024},o),u}async writeFile(t,i,o){let u;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i){const o=this.toFilePath(t);let u;(0,C.isFileOpenForWriteOptions)(i)&&(u=await this.createResourceLock(t));let a;try{if((0,C.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:v}=await d.SymlinkSupport.stat(o);v.mode&128||await d.Promises.chmod(o,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,C.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await d.Promises.truncate(o,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";a=await d.Promises.open(o,h)}catch(h){throw u?.dispose(),(0,C.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,C.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,t),u){const h=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,u),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await d.Promises.fdatasync(t)}catch(o){n.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,o,u,a){const h=this.normalizePos(t,i);let v=null;try{v=(await d.Promises.read(t,o,u,a,h)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(t,h,v)}return v}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,o){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,u+o):this.mapHandleToPos.delete(t)))}async write(t,i,o,u,a){return(0,k.retry)(()=>this.doWrite(t,i,o,u,a),100,3)}async doWrite(t,i,o,u,a){const h=this.normalizePos(t,i);let v=null;try{v=(await d.Promises.write(t,o,u,a,h)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),D)}finally{this.updatePos(t,h,v)}return v}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const o=this.toFilePath(t);i.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,i,o){const u=this.toFilePath(t),a=this.toFilePath(i);if(u!==a)try{await this.validateTargetDeleted(t,i,"move",o.overwrite),await d.Promises.move(u,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,E.basename)(u),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(t,i,o){const u=this.toFilePath(t),a=this.toFilePath(i);if(u!==a)try{await this.validateTargetDeleted(t,i,"copy",o.overwrite),await d.Promises.copy(u,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,E.basename)(u),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(t,i,o,u){const a=this.toFilePath(t),h=this.toFilePath(i);let v=!1;if(!!(this.capabilities&1024)||(v=(0,P.isEqual)(a,h,!0)),v&&o==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!v&&await d.Promises.exists(h)){if(!u)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,o){const u=this.toFilePath(t),a=this.toFilePath(i),h=!!(this.capabilities&1024);if((0,P.isEqual)(u,a,!h))return;const v=new I.DisposableStore;try{const[D,M]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);v.add(D),v.add(M),o&&await d.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await d.Promises.copyFile(u,a)}catch(D){if(D.code==="ENOENT"&&!o)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(D)}finally{v.dispose()}}createUniversalWatcher(t,i,o){return new f.UniversalWatcherClient(u=>t(u),u=>i(u),o)}createNonRecursiveWatcher(t,i,o){return new c.NodeJSWatcherClient(u=>t(u),u=>i(u),o)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=C.FileSystemProviderErrorCode.NoPermissions;break;default:i=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let o=this.toFileSystemProviderError(i);if(t&&o.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await d.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(o=(0,C.createFileSystemProviderError)(i,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}}e.DiskFileSystemProvider=n,n.canFlush=!0}),define(ne[95],se([0,1,3,7,8]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(p){this.service=p,this.onDidChangeLogLevel=R.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(p,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=T;class A{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){A.setLevel(this.channel,p)}static setLevel(p,y){return p.call("setLevel",y)}}e.LogLevelChannelClient=A;class b{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,y){throw new Error(`Event not found: ${y}`)}async call(p,y,d){switch(y){case"createLogger":this.createLogger(r.URI.revive(d[0]),d[1]);return;case"log":return this.log(r.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(p,y){this.loggers.set(p.toString(),this.loggerService.createLogger(p,y))}consoleLog(p,y){let d=console.log;switch(p){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(p,y){const d=this.loggers.get(p.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,C]of y)(0,k.log)(d,S,C)}}e.LoggerChannel=b;class P extends k.AbstractLoggerService{constructor(p,y,d){super(p,y),this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(p,y)=>{this.channel.call("consoleLog",[p,y])}})}doCreateLogger(p,y,d){return new I(this.channel,p,y,d)}}e.LoggerChannelClient=P;class I extends k.AbstractMessageLogger{constructor(p,y,d,S){super(S?.always),this.channel=p,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,y){const d=[[p,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(p){this.channel.call("log",[this.file,p])}}class E extends k.LogService{constructor(p,y){super(y),this.parent=p,this._register(p.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=E}),define(ne[67],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[58],se([0,1,3,51,2,5]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(I){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...I,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(I),r.Iterable.reduce(this.policies.entries(),(w,[p,y])=>({...w,[p]:y}),{})}getPolicyValue(I){return this.policies.get(I)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(I,[E,w])=>({...I,[E]:{definition:w,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=A;class b{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(ne[192],se([0,1,3,2,58]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(P){this.service=P,this.disposables=new r.DisposableStore}listen(P,I){switch(I){case"onDidChange":return R.Event.map(this.service.onDidChange,E=>E.reduce((w,p)=>({...w,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${I}`)}call(P,I,E){switch(I){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${I}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends k.AbstractPolicyService{constructor(P,I){super(),this.channel=I;for(const E in P){const{definition:w,value:p}=P[E];this.policyDefinitions[E]=w,p!==void 0&&this.policies.set(E,p)}this.channel.listen("onDidChange")(E=>{for(const w in E){const p=E[w];p===null?this.policies.delete(w):this.policies.set(w,p)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(P){const I=await this.channel.call("registerPolicyDefinitions",P);for(const E in I)this.policies.set(E,I[E])}}e.PolicyChannelClient=A}),define(ne[96],se([0,1,20,4,36,17]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const b=r.globals.vscode.context.configuration();if(b)A=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const b=(0,T.dirname)(R.FileAccess.asFileUri("",X));A=X.__$__nodeRequire((0,T.joinPath)(b,"product.json").fsPath);const P=X.__$__nodeRequire((0,T.joinPath)(b,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:P.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[25],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[193],se([0,1,6,10,2,9,27,8,25]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends k.Disposable{constructor(w,p,y){super(),this.productService=p,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),y=(0,T.dirname)(w),d=(0,T.basename)(w),S=await A.Promises.readdir(y);await Promise.all(S.map(async C=>{if(C===d)return;const m=(0,T.join)(y,C),g=await A.Promises.stat(m);if(g.isDirectory()&&p-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(m)}))}catch(p){(0,r.onUnexpectedError)(p)}}};I=pe([K(1,P.IProductService),K(2,b.ILogService)],I),e.CodeCacheCleaner=I}),define(ne[194],se([0,1,6,10,2,9,27,15,8,25]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends k.Disposable{constructor(p,y,d){super(),this.environmentService=p,this.logService=y,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(y)){const l=y[g];p[`${l.hash}.${g}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const C=await A.Promises.readdir(d);for(const g of C){if(p[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,T.join)(d,g))}const m=Date.now();for(const g of Object.keys(p)){const l=(0,T.join)(d,g),f=await A.Promises.readdir(l);for(const c of f){if(c==="tcf.json")continue;const n=(0,T.join)(l,c),s=await A.Promises.stat(n);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(g,c)}`),await A.Promises.rm(n))}}}catch(p){(0,r.onUnexpectedError)(p)}}};E=pe([K(0,b.INativeEnvironmentService),K(1,P.ILogService),K(2,I.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(ne[195],se([0,1,9,5]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var k;(function(T){function A(b,P="noAbsolutePaths"){for(const I of b.nodes)I.callFrame&&I.callFrame.url&&((0,R.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(I.callFrame.url))&&(I.callFrame.url=(0,R.join)(P,(0,R.basename)(I.callFrame.url)));return b}T.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ne[196],se([0,1,30]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(T){const b=await(await new Promise((I,E)=>{X(["v8-inspect-profiler"],I,E)})).startProfiling({port:T.port,checkForPaused:!0}),P=(0,R.generateUuid)();return this._sessions.set(P,b),P}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const b=await A.stop();return this._sessions.delete(T),b.profile}}e.InspectProfilingService=r}),define(ne[40],se([0,1,110,14]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,b){R.ok(r.isString(A)),R.ok(r.isObject(b)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,b)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ne[97],se([0,1,3,40]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,I){this.schemasById[k(P)]=I,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;r.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],se([0,1,18,3,14,136,19,97,40]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=P.Registry.as(b.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const t=this.doRegisterConfigurations(n,s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const s=this.doDeregisterConfigurations(n);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const t=[];t.push(...this.doDeregisterConfigurations(s)),t.push(...this.doRegisterConfigurations(n,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(n){const s=[],t=[];for(const{overrides:i,source:o}of n)for(const u in i)if(s.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.configurationDefaultsOverrides.get(u),h=a?.valuesSources??new Map;if(o)for(const F of Object.keys(i[u]))h.set(F,o);const v={...a?.value||{},...i[u]};this.configurationDefaultsOverrides.set(u,{source:o,value:v,valuesSources:h});const D=(0,A.getLanguageTagSettingPlainKey)(u),M={type:"object",default:v,description:T.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(u)),this.configurationProperties[u]=M,this.defaultLanguageConfigurationOverridesNode.properties[u]=M}else{this.configurationDefaultsOverrides.set(u,{value:i[u],source:o});const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:t,source:i}of n)for(const o in t){const u=this.configurationDefaultsOverrides.get(o),a=k.isString(i)?i:i?.id,h=k.isString(u?.source)?u?.source:u?.source?.id;if(a===h)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const v=this.configurationProperties[o];v&&(this.updatePropertyDefaultValue(o,v),this.updateSchema(o,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s){const t=[];return n.forEach(i=>{t.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),t}doDeregisterConfigurations(n){const s=[],t=i=>{if(i.properties)for(const o in i.properties){s.push(o);const u=this.configurationProperties[o];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>t(o))};for(const i of n){t(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(n,s=!0,t,i,o=3){o=k.isUndefinedOrNull(n.scope)?o:n.scope;const u=[],a=n.properties;if(a)for(const v in a){const D=a[v];if(s&&l(v,D)){delete a[v];continue}if(D.source=t,D.defaultDefaultValue=a[v].default,this.updatePropertyDefaultValue(v,D),e.OVERRIDE_PROPERTY_REGEX.test(v)?D.scope=void 0:(D.scope=k.isUndefinedOrNull(D.scope)?o:D.scope,D.restricted=k.isUndefinedOrNull(D.restricted)?!!i?.includes(v):D.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v],a[v].policy?.name&&this.policyConfigurations.set(a[v].policy.name,v);!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),u.push(v)}const h=n.allOf;if(h)for(const v of h)u.push(...this.validateAndRegisterProperties(v,s,t,i,o));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=t=>{const i=t.properties;if(i)for(const u in i)this.updateSchema(u,i[u]);t.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,o=t?.source;k.isUndefined(i)&&(i=s.defaultDefaultValue,o=void 0),k.isUndefined(i)&&(i=m(s.type)),s.default=i,s.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=d.exec(c);for(;s?.length;){const t=s[1].trim();t&&n.push(t),s=d.exec(c)}}return(0,R.distinct)(n)}e.overrideIdentifiersFromKey=S;function C(c){return c.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=C;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new p;P.Registry.add(e.Extensions.Configuration,g);function l(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,c,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.validateProperty=l;function f(){const c=[],n=g.getConfigurationProperties();for(const s of Object.keys(n))c.push([s,n[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(ne[68],se([0,1,18,3,35,2,34,31,14,7,19,42,40]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(n={},s=[],t=[]){this._contents=n,this._keys=s,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,E.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,s){const t=this.getContentsForOverrideIdentifer(s);return t?n?(0,E.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return R.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=b.deepClone(this.contents),t=b.deepClone(this.overrides),i=[...this.keys];for(const o of n)if(!o.isEmpty()){this.mergeContents(s,o.contents);for(const u of o.overrides){const[a]=t.filter(h=>R.equals(h.identifiers,u.identifiers));a?(this.mergeContents(a.contents,u.contents),a.keys.push(...u.keys),a.keys=R.distinct(a.keys)):t.push(b.deepClone(u))}for(const u of o.keys)i.indexOf(u)===-1&&i.push(u)}return new y(s,i,t)}freeze(){return this.frozen=!0,this}clone(){return new y(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const i of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[i];const u=s[i];u&&(typeof o=="object"&&typeof u=="object"?(o=b.deepClone(o),this.mergeContents(o,u)):o=u),t[i]=o}return new y(t,this.keys,this.overrides)}mergeContents(n,s){for(const t of Object.keys(s)){if(t in n&&P.isObject(n[t])&&P.isObject(s[t])){this.mergeContents(n[t],s[t]);continue}n[t]=b.deepClone(s[t])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?b.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let s=null,t=null;const i=o=>{o&&(t?this.mergeContents(t,o):t=b.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[n])?s=o.contents:o.identifiers.includes(n)&&i(o.contents);return i(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,s){this.addKey(n),(0,E.addToValueTree)(this.contents,n,s,t=>{throw new Error(t)})}removeValue(n){this.removeKey(n)&&(0,E.removeFromValueTree)(this.contents,n)}addKey(n){let s=this.keys.length;for(let t=0;t<s;t++)n.indexOf(this.keys[t])===0&&(s=t);this.keys.splice(s,1,n)}removeKey(n){const s=this.keys.indexOf(n);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!P.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:t,keys:i,overrides:o,restricted:u}=this.doParseRaw(n,s);this._configurationModel=new y(t,i,o),this._restrictedConfigurations=u||[]}doParseContent(n){let s={},t=null,i=[];const o=[],u=[];function a(v){Array.isArray(i)?i.push(v):t!==null&&(i[t]=v)}const h={onObjectBegin:()=>{const v={};a(v),o.push(i),i=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const v=[];a(v),o.push(i),i=v,t=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(v,D,M)=>{u.push({error:v,offset:D,length:M})}};if(n)try{k.visit(n,h),s=i[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return s}doParseRaw(n,s){const t=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,t,!0,s);n=i.raw;const o=(0,E.toValuesTree)(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),u=Object.keys(n),a=this.toOverrides(n,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:o,keys:u,overrides:a,restricted:i.restricted}}filter(n,s,t,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:n,restricted:[]};const o={},u=[];for(const a in n)if(w.OVERRIDE_PROPERTY_REGEX.test(a)&&t){const h=this.filter(n[a],s,!1,i);o[a]=h.raw,u.push(...h.restricted)}else{const h=s[a],v=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(a),(v===void 0||i.scopes===void 0||i.scopes.includes(v))&&(i.skipRestricted&&h?.restricted||(o[a]=n[a]))}return{raw:o,restricted:u}}toOverrides(n,s){const t=[];for(const i of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(i)){const o={};for(const u in n[i])o[u]=n[i][u];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(o),contents:(0,E.toValuesTree)(o,s)})}return t}}e.ConfigurationModelParser=d;class S extends T.Disposable{constructor(n,s,t,i){super(),this.userSettingsResource=n,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(n,s,t,i,o=new y,u=new y,a=new A.ResourceMap,h=new y,v=new A.ResourceMap,D=!0){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,s,t){return this.getConsolidatedConfigurationModel(n,s,t).getValue(n)}updateValue(n,s,t={}){let i;t.resource?(i=this._memoryConfigurationByResource.get(t.resource),i||(i=new y,this._memoryConfigurationByResource.set(t.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(n):i.setValue(n,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,t){const i=this.getConsolidatedConfigurationModel(n,s,t),o=this.getFolderConfigurationModelForResource(s.resource,t),u=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,a=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),v=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),D=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),M=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),F=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),O=t?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,L=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(n):o.freeze().getValue(n):void 0,N=s.overrideIdentifier?u.override(s.overrideIdentifier).getValue(n):u.getValue(n),$=i.getValue(n),V=R.distinct(i.overrides.map(J=>J.identifiers).flat()).filter(J=>i.getOverrideValue(n,J)!==void 0);return{defaultValue:a,policyValue:h,applicationValue:v,userValue:D,userLocalValue:M,userRemoteValue:F,workspaceValue:O,workspaceFolderValue:L,memoryValue:N,value:$,default:a!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,application:v!==void 0?{value:v,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o?.freeze().getValue(n),override:s.overrideIdentifier?o?.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:u.getValue(n),override:s.overrideIdentifier?u.getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:i,updated:o,removed:u}=l(this._defaultConfiguration,n);s=[...i,...o,...u]}for(const i of s)for(const o of(0,w.overrideIdentifiersFromKey)(i)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(o),a=n.getKeysForOverrideIdentifier(o),h=[...a.filter(v=>u.indexOf(v)===-1),...u.filter(v=>a.indexOf(v)===-1),...u.filter(v=>!b.equals(this._defaultConfiguration.override(o).getValue(v),n.override(o).getValue(v)))];t.push([o,h])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:i}=l(this._policyConfiguration,n),o=[...s,...t,...i];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:i,overrides:o}=l(this.applicationConfiguration,n),u=[...s,...t,...i];return u.length&&this.updateApplicationConfiguration(n),{keys:u,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:i,overrides:o}=l(this.localUserConfiguration,n),u=[...s,...t,...i];return u.length&&this.updateLocalUserConfiguration(n),{keys:u,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:i,overrides:o}=l(this.remoteUserConfiguration,n),u=[...s,...t,...i];return u.length&&this.updateRemoteUserConfiguration(n),{keys:u,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:i,overrides:o}=l(this.workspaceConfiguration,n),u=[...s,...t,...i];return u.length&&this.updateWorkspaceConfiguration(n),{keys:u,overrides:o}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:i,updated:o,removed:u,overrides:a}=l(t,s),h=[...i,...o,...u];return(h.length||!t)&&this.updateFolderConfiguration(n,s),{keys:h,overrides:a}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:i,removed:o,overrides:u}=l(s,void 0);return{keys:[...t,...i,...o],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,t){let i=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(i=i.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:n},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const i=s.getFolder(n);i&&(t=this.getFolderConsolidatedConfiguration(i.uri)||t);const o=this._memoryConfigurationByResource.get(n);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(s=t.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(n,s)):s=t}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:t,overrides:i,keys:o}=this._folderConfigurations.get(s);return n.push([s,{contents:t,overrides:i,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>n.add(s)),this.userConfiguration.freeze().keys.forEach(s=>n.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),i=this.parseConfigurationModel(n.application),o=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((h,v)=>(h.set(I.URI.revive(v[0]),this.parseConfigurationModel(v[1])),h),new A.ResourceMap);return new C(s,t,i,o,new y,u,a,new y,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new y(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=C;function m(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,s=new Map;for(const i of c)i.keys.forEach(o=>n.add(o)),i.overrides.forEach(([o,u])=>{const a=(0,A.getOrSet)(s,o,new Set);u.forEach(h=>a.add(h))});const t=[];return s.forEach((i,o)=>t.push([o,[...i.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=m;class g{constructor(n,s,t,i){this.change=n,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(a=>o.add(a)),n.overrides.forEach(([,a])=>a.forEach(h=>o.add(h))),this.affectedKeys=[...o.values()];const u=new y;this.affectedKeys.forEach(a=>u.setValue(a,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(s){const t=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!b.equals(t,i)}return!0}return!1}doesAffectedKeysTreeContains(n,s){let t=(0,E.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof t=="object"&&(i=Object.keys(t)[0]);){if(n=n[i],!n)return!1;t=t[i]}return!0}}e.ConfigurationChangeEvent=g;function l(c,n){const{added:s,removed:t,updated:i}=f(n,c),o=[],u=c?.getAllOverrideIdentifiers()||[],a=n?.getAllOverrideIdentifiers()||[];if(n){const h=a.filter(v=>!u.includes(v));for(const v of h)o.push([v,n.getKeysForOverrideIdentifier(v)])}if(c){const h=u.filter(v=>!a.includes(v));for(const v of h)o.push([v,c.getKeysForOverrideIdentifier(v)])}if(n&&c){for(const h of u)if(a.includes(h)){const v=f({contents:c.getOverrideValue(void 0,h)||{},keys:c.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});o.push([h,[...v.added,...v.removed,...v.updated]])}}return{added:s,removed:t,updated:i,overrides:o}}function f(c,n){const s=c?n?c.keys.filter(o=>n.keys.indexOf(o)===-1):[...c.keys]:[],t=n?c?n.keys.filter(o=>c.keys.indexOf(o)===-1):[...n.keys]:[],i=[];if(c&&n){for(const o of n.keys)if(c.keys.indexOf(o)!==-1){const u=(0,E.getConfigurationValue)(n.contents,o),a=(0,E.getConfigurationValue)(c.contents,o);b.equals(u,a)||i.push(o)}}return{added:s,removed:t,updated:i}}}),define(ne[197],se([0,1,18,3,2,31,14,19,68,42,8,58,40]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.onDidUpdateConfiguration(g,l))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,l){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class d extends P.ConfigurationModel{constructor(g={}){const l=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(l),c=Object.create(null),n=[];for(const s in l){const t=g[s],i=t!==void 0?t:l[s].default;(0,b.addToValueTree)(c,s,i,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(c))I.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,I.overrideIdentifiersFromKey)(s),keys:Object.keys(c[s]),contents:(0,b.toValuesTree)(c[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(c,f,n)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends k.Disposable{constructor(g,l,f){super(),this.defaultConfiguration=g,this.policyService=l,this.logService=f,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const l={},f=[],c=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const n of g){const s=c[n];if(!s){f.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(n),l[s.policy.name]={type:s.type}}}return(0,A.isEmptyObject)(l)||await this.policyService.registerPolicyDefinitions(l),f}onDidChangePolicies(g){const l=p.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(g.map(c=>l.get(c)));this.update(f,!0)}update(g,l){const f=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const s of g){const t=f[s]?.policy?.name;if(t){const i=this.policyService.getPolicyValue(t);(n?i!==void 0:!(0,T.equals)(this._configurationModel.getValue(s),i))&&c.push([s,i])}else this._configurationModel.getValue(s)!==void 0&&c.push([s,void 0])}if(c.length){const s=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of s.keys)this._configurationModel.setValue(t,s.getValue(t));for(const[t,i]of c)i===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,i);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=pe([K(1,w.IPolicyService),K(2,E.ILogService)],C),e.PolicyConfiguration=C}),define(ne[198],se([0,1,6,3,2,17,19,68,197,58]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(p,y,d,S){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=d instanceof I.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,y)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:m})=>this.onDidDefaultConfigurationChange(C,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,y,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(p,y,new b.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(p,y){const d=typeof p=="string"?p:void 0,S=(0,A.isConfigurationOverrides)(p)?p:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,S,void 0)}updateValue(p,y,d,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(d,y,2)}onDidDefaultConfigurationChange(p,y){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,y);this.trigger(S,d,7)}onDidPolicyConfigurationChange(p){const y=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(d,y,7)}trigger(p,y,d){const S=new b.ConfigurationChangeEvent(p,{data:y},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(ne[199],se([0,1,10,5]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends R.ErrorNoTelemetry{constructor(b,P=k.Unknown,I){super(b),this._message=b,this._code=P,this._detail=I,this.isHandled=P===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(b){return b instanceof T&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof T&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof T&&b.isHandled}}e.RemoteAuthorityResolverError=T}),define(ne[98],se([0,1,20]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(I){return I.scheme===R.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=r;function k(I){if(!I)return;const E=I.indexOf("+");return E<0?I:I.substr(0,E)}e.getRemoteName=k;function T(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=T;function A(I){const{host:E,port:w}=P(I);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:w}}e.parseAuthorityWithPort=A;function b(I,E){let{host:w,port:p}=P(I);return typeof p>"u"&&(p=E),{host:w,port:p}}e.parseAuthorityWithOptionalPort=b;function P(I){const E=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const w=I.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=I.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:I,port:void 0}}}),define(ne[43],se([0,1,24,5,98]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var P;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S>"u"||S===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const m=typeof S=="string"?S:S.value,g=typeof C=="string"?C:C.value;return R.equalsIgnoreCase(m,g)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=I;function E(d){return w(d)}e.isApplicationScopedExtension=E;function w(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function y(d,S){if(S){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return d.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],se([0,1,24,29,43,4,7,10,36]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,R.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(t,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=t.id}static create(t){const i=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,i,o)}static parse(t){const i=E.exec(t);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const t=p.exec(s);return t&&t[1]?[S(t[1]),t[2]]:[S(s),void 0]}e.getIdAndVersion=y;function d(s,t){return`${s}.${t}`}e.getExtensionId=d;function S(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(s,t){return S(d(s,t))}e.getGalleryExtensionId=C;function m(s,t){const i=[],o=u=>{for(const a of i)if(a.some(h=>I(t(h),t(u))))return a;return null};for(const u of s){const a=o(u);a?a.push(u):i.push([u])}return i}e.groupByExtension=m;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function l(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=l,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(s,t){const i=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&i.every(a=>!I(a.identifier,{id:u}))){const a=s.filter(h=>I(h.identifier,{id:u}));a.length===1&&(i.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=f;async function c(s,t){if(!T.isLinux)return!1;let i;try{i=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(u))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(s,t){const i=await c(s,t),o=(0,r.getTargetPlatform)(i?"alpine":T.platform,P.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=n}),define(ne[48],se([0,1,6,16,2,34,7,32,13,5,8]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let w=class extends k.Disposable{constructor(y,d){super(),this.fileService=y,this.logService=d,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,d){return this.withProfileExtensions(d,S=>(S=S.filter(C=>y.some(([m])=>!(0,b.areSameExtensions)(C.identifier,m.identifier))),S.push(...y.map(([C,m])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:m}))),S))}removeExtensionFromProfile(y,d){return this.withProfileExtensions(d,S=>S.filter(C=>!(0,b.areSameExtensions)(C.identifier,y)))}async withProfileExtensions(y,d){return this.getResourceAccessQueue(y).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(y),m=JSON.parse(C.value.toString());for(const g of m){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(d){S=d(S);const C=S.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(y,r.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(y){let d=this.resourcesAccessQueueMap.get(y);return d||(d=new R.Queue,this.resourcesAccessQueueMap.set(y,d)),d}};w=pe([K(0,P.IFileService),K(1,E.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ne[200],se([0,1,21,32]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(T,A,b,P,I){try{const E=await T.getExtensionsControlManifest();if(!E.deprecated)return;const w=await T.getInstalled(1);for(const[p,y]of Object.entries(E.deprecated)){if(!y?.extension)continue;const{id:d,autoMigrate:S,preRelease:C}=y.extension;if(!S)continue;const m=w.find(l=>(0,r.areSameExtensions)(l.identifier,{id:p}));if(!m)continue;const g=(await A.getExtensions([{id:d,preRelease:C}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){I.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{I.info(`Migrating '${m.identifier.id}' extension to '${d}' extension...`);const l=!P.getDisabledExtensions().some(c=>(0,r.areSameExtensions)(c,m.identifier));await T.uninstall(m),I.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let f=w.find(c=>(0,r.areSameExtensions)(c.identifier,{id:d}));(!f||!f.isPreReleaseVersion&&l)&&(f=await T.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),I.info(`Installed the pre-release extension '${f.identifier.id}'`),l||(await P.disableExtension(f.identifier),I.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),S.storage&&(b.addToMigrationList((0,r.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,r.getExtensionId)(f.manifest.publisher,f.manifest.name)),I.info("Added pre-release extension to the storage migration list"))),I.info(`Migrated '${m.identifier.id}' extension to '${d}' extension.`)}catch(l){I.error(l)}}}catch(E){I.error(E)}}e.migrateUnsupportedExtensions=k}),define(ne[201],se([0,1,6,10,2,4,17,55,7,30,27,15,29,32,13,8]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends k.Disposable{constructor(g,l,f,c){super(),this.fileService=l,this.extensionGalleryService=f,this.logService=c,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,l){await this.cleanUpPromise;const f=this.getName(g),c=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(c)){const n=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(g,n,l);try{await this.rename(n,c,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(n)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,n.path),s}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,l,f){try{await E.Promises.rename(g.fsPath,l.fsPath)}catch(c){if(T.isWindows&&c&&c.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${l} with 'EPERM' error. Trying again...`),this.rename(g,l,f);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const l=[],f=[];for(const s of g.children){const t=y.ExtensionKey.parse(s.name);t&&f.push([t,s])}const c=(0,y.groupByExtension)(f,([s])=>s),n=[];for(const s of c)s.sort((t,i)=>b.rcompare(t[0].version,i[0].version)),l.push(...s.slice(1).map(t=>t[1].resource)),n.push(s[0][1]);n.sort((s,t)=>s.mtime-t.mtime),l.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(s=>s.resource)),await R.Promises.settled(l.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?y.ExtensionKey.create(g).toString().toLowerCase():(0,I.generateUuid)()}};C=pe([K(0,w.INativeEnvironmentService),K(1,d.IFileService),K(2,p.IExtensionGalleryService),K(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[202],se([0,1,2,9,27,43]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(P,I){super(),this.environmentService=P,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(I.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(P){P.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(P){P.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[203],se([0,1,177,18,6,2,20,9,27,15,29,32,8,66]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends y.LanguagePackBaseService{constructor(g,l,f,c){super(f),this.extensionManagementService=g,this.logService=c,this.cache=this._register(new S(l,c)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),l=Object.keys(g).map(f=>{const c=g[f];return{...this.createQuickPickItem(f,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return l.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),l.sort((f,c)=>f.label.localeCompare(c.label)),l}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const l=await this.cache.getLanguagePacks();Object.keys(l).some(f=>l[f]&&l[f].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(l);return!(0,r.equals)(Object.keys(g),Object.keys(f))}};d=pe([K(0,E.IExtensionManagementService),K(1,I.INativeEnvironmentService),K(2,E.IExtensionGalleryService),K(3,p.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends T.Disposable{constructor(g,l){super(),this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(l=>{Object.keys(l).forEach(f=>delete l[f]),this.createLanguagePacksFromExtensions(l,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...l){for(const f of l)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,l){const f=l.identifier,c=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const n of c)if(l.location.scheme===A.Schemas.file&&C(n)){let s=g[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},g[n.languageId]=s);const t=s.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,f))[0];t?t.version=l.manifest.version:s.extensions.push({extensionIdentifier:f,version:l.manifest.version});for(const i of n.translations)s.translations[i.id]=(0,b.join)(l.location.fsPath,i.path)}}updateHash(g){if(g){const l=(0,R.createHash)("md5");for(const f of g.extensions)l.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=l.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(l=g(f),f)).then(f=>{for(const n of Object.keys(f))f[n]||delete f[n];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),P.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>l,f=>this.logService.error(f))})}};S=pe([K(0,I.INativeEnvironmentService),K(1,p.ILogService)],S);function C(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const g of m.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(ne[204],se([0,1,6,16,21,10,3,2,30,84,199,98]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(z){const B=new k.CancellationTokenSource;return setTimeout(()=>B.cancel(),z),B.token}function C(z,B){if(z.isCancellationRequested||B.isCancellationRequested)return k.CancellationToken.Cancelled;const _=new k.CancellationTokenSource;return z.onCancellationRequested(()=>_.cancel()),B.onCancellationRequested(()=>_.cancel()),_.token}class m{constructor(B){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((_,U)=>{this._resolvePromise=_,this._rejectPromise=U}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function g(z,B){const _=new m(B);return _.registerDisposable(z.onControlMessage(U=>{const W=JSON.parse(U.toString()),j=q(W);j?_.reject(j):_.resolve(W)})),_.promise}function l(z,B,_,U,W,j,Z,oe){const Q=new m(oe);return B.connect(_,U,W,j,Z,(ie,re)=>{Q.didTimeout?(ie&&z.error(ie),re?.dispose()):ie||!re?Q.reject(ie):Q.resolve(re)}),Q.promise}function f(z,B){const _=new m(B);return z.then(U=>{_.didTimeout||_.resolve(U)},U=>{_.didTimeout||_.reject(U)}),_.promise}async function c(z,B,_,U){const W=te(z,B);z.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let j;try{j=await l(z.logService,z.socketFactory,z.host,z.port,(0,w.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(B)}-${z.reconnectionToken}`,U)}catch(re){throw z.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),z.logService.error(re),re}z.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let Z,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(j,null),Z=z.reconnectionProtocol,oe=!1):(Z=new I.PersistentProtocol(j,null),oe=!0),z.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Q=await f(z.signService.createNewMessage((0,P.generateUuid)()),U),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:Q.data};Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const re=await g(Z,C(U,S(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${W} 4/6. received SignRequest control message.`),!await f(z.signService.validate(Q,re.signedData),U)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await f(z.signService.sign(re.data),U),ve={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:B};return _&&(ve.args=_),z.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(z.logService.error(`${W} the handshake timed out. Error:`),z.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${W} received error control message when negotiating connection. Error:`),z.logService.error(re)),oe&&G(Z),re}}async function n(z,B,_,U){const W=Date.now(),j=te(z,B),{protocol:Z,ownsProtocol:oe}=await c(z,B,_,U),Q=new m(U);return Q.registerDisposable(Z.onControlMessage(ie=>{const re=JSON.parse(ie.toString()),ue=q(re);ue?(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&G(Z),Q.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),Q.resolve({protocol:Z,firstMessage:re}))})),Q.promise}async function s(z,B){const{protocol:_}=await n(z,1,void 0,B);return{protocol:_}}async function t(z,B,_){const{protocol:U,firstMessage:W}=await n(z,2,B,_),j=W&&W.debugPort;return{protocol:U,debugPort:j}}async function i(z,B,_){const U=Date.now(),W=te(z,3),{protocol:j}=await c(z,3,B,_);return z.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),j}async function o(z,B,_){const{host:U,port:W,connectionToken:j}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:U,port:W,connectionToken:j,reconnectionToken:B,reconnectionProtocol:_,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function u(z,B,_){return h(z,async U=>{const{protocol:W}=await s(U,k.CancellationToken.None);return new J(z,B,_,U.reconnectionToken,W)})}e.connectRemoteAgentManagement=u;async function a(z,B){return h(z,async _=>{const{protocol:U,debugPort:W}=await t(_,B,k.CancellationToken.None);return new H(z,B,_.reconnectionToken,U,W)})}e.connectRemoteAgentExtensionHost=a;async function h(z,B){for(let U=1;;U++)try{const W=(0,P.generateUuid)(),j=await o(z,W,null);return await B(j)}catch(W){if(U<5)z.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(W);else throw z.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(W),V.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(W)),W}}async function v(z,B,_){const U=await o(z,(0,P.generateUuid)(),null);return await i(U,{host:B,port:_},k.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function D(z){return(0,R.createCancelablePromise)(B=>new Promise((_,U)=>{const W=setTimeout(_,z*1e3);B.onCancellationRequested(()=>{clearTimeout(W),_()})}))}var M;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(B,_){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=F;class O{constructor(B,_,U,W){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.durationSeconds=U,this.cancellableTimer=W,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class L{constructor(B,_,U){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=L;class N{constructor(B,_,U){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(B,_,U,W){this.reconnectionToken=B,this.millisSinceLastIncomingData=_,this.attempt=U,this.handled=W,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class V extends b.Disposable{constructor(B,_,U,W,j){super(),this._connectionType=B,this._options=_,this.reconnectionToken=U,this.protocol=W,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(W.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(W.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),V._instances.push(this),this._register((0,b.toDisposable)(()=>{const Z=V._instances.indexOf(this);Z>=0&&V._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(B,_,U){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=_,this._permanentFailureHandled=U,this._instances.forEach(W=>W._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(B=>B._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(B=>B._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||V._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const B=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const W=U<_.length?_[U]:_[_.length-1];try{if(W>0){const Z=D(W);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,Z)),this._options.logService.info(`${B} waiting for ${W} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this._options.logService.info(`${B} resolving connection...`);const j=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(p)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,T.isCancellationError)(j)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,E.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(B,_,U){this._reconnectionFailureIsFatal?V.triggerPermanentFailure(B,_,U):this._gotoPermanentFailure(B,_,U)}_gotoPermanentFailure(B,_,U){this._onDidStateChange.fire(new $(this.reconnectionToken,B,_,U)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=V,V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class J extends V{constructor(B,_,U,W,j){super(1,B,W,j,!0),this.client=this._register(new I.Client(j,{remoteAuthority:_,clientId:U},B.ipcLogger))}async _reconnect(B,_){await s(B,_)}}e.ManagementPersistentConnection=J;class H extends V{constructor(B,_,U,W,j){super(2,B,U,W,!1),this._startArguments=_,this.debugPort=j}async _reconnect(B,_){await t(B,this._startArguments,_)}}e.ExtensionHostPersistentConnection=H;function G(z){try{z.acceptDisconnect();const B=z.getSocket();z.dispose(),B.dispose()}catch(B){(0,T.onUnexpectedError)(B)}}function q(z){if(z&&z.type==="error"){const B=new Error(`Connection error: ${z.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(z,B){for(;z.length<B;)z+=" ";return z}function Y(z,B,_){return`[remote-connection][${x(d(z),13)}][${B.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function te(z,B){return`${Y(B,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(ne[205],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[206],se([0,1,76,134]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,T,A,b,P,I){const E=p=>I(p,void 0),w=R.createConnection({host:k,port:T},()=>{w.removeListener("error",E);const p=Buffer.alloc(16);for(let C=0;C<16;C++)p[C]=Math.round(Math.random()*256);const y=p.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${T}${A}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];w.write(d.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),I(void 0,new r.NodeSocket(w,P)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",E)}}}),define(ne[207],se([0,1,117,19,8]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(b,P){this.configurationService=b,this.logService=P}async request(b,P){this.logService.trace("RequestService#request (browser) - begin",b.url),b.proxyAuthorization||(b.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const I=await(0,R.request)(b,P);return this.logService.trace("RequestService#request (browser) - success",b.url),I}catch(I){throw this.logService.error("RequestService#request (browser) - error",b.url,I),I}}async resolveProxy(b){}};T=pe([K(0,r.IConfigurationService),K(1,k.ILogService)],T),e.RequestService=T}),define(ne[44],se([0,1,16,152,42,5,40]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=b;function P(S){return S.res.statusCode===204}async function I(S){return P(S)?null:(await(0,R.streamToBuffer)(S.stream)).toString()}e.asText=I;async function E(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return I(S)}e.asTextOrError=E;async function w(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(P(S))return null;const m=(await(0,R.streamToBuffer)(S.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=w;function p(S){d(S)}e.updateProxyConfigurationsScope=p;let y;function d(S){const C=A.Registry.as(k.Extensions.Configuration),m=y;y={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[y],remove:m?[m]:[]})}d(2)}),define(ne[208],se([0,1,21,20,13,44]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(P,I){this.requestService=P,this.fileService=I}async download(P,I,E=R.CancellationToken.None){if(P.scheme===r.Schemas.file||P.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(P,I);return}const w={type:"GET",url:P.toString(!0)},p=await this.requestService.request(w,E);if(p.res.statusCode===200)await this.fileService.writeFile(I,p.stream);else{const y=await(0,T.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${y}`)}}};A=pe([K(0,T.IRequestService),K(1,k.IFileService)],A),e.DownloadService=A}),define(ne[209],se([0,1,18,21,2,17,169,13,8,25,44]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends k.Disposable{constructor(y,d,S,C){super(),this.fileService=y,this.productService=d,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,m])=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const d=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==y.scheme))try{const m=await this.fileService.readFile((0,T.joinPath)(y,S)),g=new Map;Object.entries(C.recommendations).forEach(([f,c])=>{if((0,R.isNonEmptyArray)(c.remotes))for(const n of c.remotes)g.set(n,{extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled});else d.push({extensionId:f,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})});const l=(0,A.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const f of l){const c=g.get(f);c&&d.push(c)}}catch{}return d}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const y=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(y.res.statusCode!==200)return[];const d=await(0,E.asJson)(y);return d?d.workspaceRecommendations||[]:[]}catch(y){return this.logService.error(y),[]}}};w=pe([K(0,b.IFileService),K(1,I.IProductService),K(2,E.IRequestService),K(3,P.ILogService)],w),e.ExtensionTipsService=w}),define(ne[210],se([0,1,16,21]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,P){throw new Error("Invalid listen")}call(b,P,I,E=r.CancellationToken.None){switch(P){case"request":return this.service.request(I[0],E).then(async({res:w,stream:p})=>{const y=await(0,R.streamToBuffer)(p);return[{statusCode:w.statusCode,headers:w.headers},y]});case"resolveProxy":return this.service.resolveProxy(I[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class T{constructor(b){this.channel=b}async request(b,P){const[I,E]=await this.channel.call("request",[b],P);return{res:I,stream:(0,R.bufferToStream)(E)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=T}),define(ne[211],se([0,1,207,210]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,b,P){this.configurationService=b,this.logService=P,this.browserRequestService=new R.RequestService(b,P),this.mainRequestService=new r.RequestChannelClient(A.getChannel("request"))}request(A,b){return this.getRequestService().request(A,b)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[99],se([0,1,62,5]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(T){return(0,R.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[212],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[213],se([0,1,85,6,21,3,2,20,30,8,99,212]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const m=(0,E.hash)(S);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const g=new k.CancellationTokenSource;let l,f,c;this.processeDisposables.set(m,i=>{g.dispose(!0),l?.terminate(S,k.CancellationToken.None),f?.close(),c?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:i}))}),l=await this.getOrCreateWebWorker(S);const n=new Promise(i=>{this.processResolvers.set(m,i)});if(g.token.isCancellationRequested)return n;const{port1:s,port2:t}=new MessageChannel;return f=s,c=t,await l.spawn(S,c,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),n}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const m=new y(S.process.type,this.logService);C=m.init(),m.onDidProcessSelfTerminate(({configuration:g,reason:l})=>{this.doDisposeWorker(g,l)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const m=this.processeDisposables.get((0,E.hash)(S));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),m(C))}};p=pe([K(0,I.ILogService)],p),e.SharedProcessWorkerService=p;class y extends A.Disposable{constructor(S,C){super(),this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new r.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},C.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},C.onmessage=m=>{const{id:g,message:l,configuration:f,nonce:c}=m.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(c){const n=this.mapMessageNonceToPendingMessageResolve.get(c);n&&(this.mapMessageNonceToPendingMessageResolve.delete(c),n())}break;case w.SharedProcessWorkerMessages.SelfTerminated:f&&l&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(l)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,l);break;case w.SharedProcessWorkerMessages.Info:l&&this.logService.info(l);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,l);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,l);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,m){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(l=>{const f=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,l);const c={...S,nonce:f};m?g.postMessage(c,[m]):g.postMessage(c),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&l()})})}spawn(S,C,m){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",X).fsPath}};return this.send(g,m,C)}terminate(S,C){const m={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(m,C)}}}),define(ne[214],se([0,1,60,20,168]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([R.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[215],se([0,1,54,9,153,21,38,10,4,30,131,166,6]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function S(m,g,l){return g["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(l)&&!g["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(l)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=p.Promises.withAsyncBody(async(f,c)=>{const n=new T.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),c(new Error((0,k.localize)(0,null)))},y);try{f(await C(m,n.token))}catch(t){!(0,b.isCancellationError)(t)&&!n.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):f({})}finally{clearTimeout(s),n.dispose()}})),d)}e.getResolvedShellEnv=S;async function C(m,g){const l=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",l);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",f);const c=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const t=await(0,E.getSystemShell)(P.OS,s);return m.trace("getUnixShellEnvironment#shell",t),new Promise((i,o)=>{if(g.isCancellationRequested)return o((0,b.canceled)());const u=(0,r.basename)(t);let a,h;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${v} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${v} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,u==="tcsh"?h=["-ic"]:h=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const D=(0,R.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(D.kill(),o((0,b.canceled)()))),D.on("error",O=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(O)),o(O)});const M=[];D.stdout.on("data",O=>M.push(O));const F=[];D.stderr.on("data",O=>F.push(O)),D.on("close",(O,L)=>{const N=Buffer.concat(M).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const $=Buffer.concat(F).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),O||L)return o(new Error((0,k.localize)(2,null,O,L)));const V=n.exec(N),J=V?V[1]:"{}";try{const H=JSON.parse(J);l?H.ELECTRON_RUN_AS_NODE=l:delete H.ELECTRON_RUN_AS_NODE,f?H.ELECTRON_NO_ATTACH_CONSOLE=f:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",H),i(H)}catch(H){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(H)),o(H)}})})}}),define(ne[100],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[216],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((k,T)=>X(["vsda"],k,T))}async createNewMessage(k){try{const T=await this.vsda(),A=new T.validator;if(A){const b=String(R._nextId++);return this.validators.set(b,A),{id:b,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,T){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(k){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=R,R._nextId=1}),define(ne[217],se([0,1,3,2]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends r.Disposable{constructor(E,w,p){super(),this.channel=E,this.profile=w,this.workspace=p}async getItems(){const E={profile:this.profile,workspace:this.workspace},w=await this.channel.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.profile,workspace:this.workspace};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.channel.call("updateItems",w)}}class T extends k{constructor(E,w){super(E,w,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class A extends T{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class b extends T{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=b;class P extends k{constructor(E,w){super(E,void 0,w),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P}),define(ne[101],se([0,1,4,36,7,30]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(R.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function b(I,E,w,p,y,d,S,C,m,g){const l=Object.create(null);l["common.machineId"]=S,l.sessionID=(0,T.generateUuid)()+Date.now(),l.commitHash=y,l.version=d,l["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,R.PlatformToString)(R.platform),l["common.nodePlatform"]=r.platform,l["common.nodeArch"]=p,l["common.product"]=g||"desktop",C&&(l["common.msftInternal"]=C);let f=0;const c=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),R.isLinuxSnap&&(l["common.snap"]="true");const n=A(w);n&&(l["common.platformDetail"]=n);try{const s=await I.readFile(k.URI.file(m));l["common.source"]=s.value.toString().slice(0,30)}catch{}return l}e.resolveCommonProperties=b;function P(I){const E=r.env.USERDNSDOMAIN;if(!E)return!1;const w=E.toLowerCase();return I.some(p=>w===p)}e.verifyMicrosoftInternalDomain=P}),define(ne[22],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[218],se([0,1,37,51,6,35,20,9,4,7,128,27,130,89,13,25,22]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(s,t){const i=`${s}::${t.join(":")}`,o=m.get(i);if(o)return o;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,h=new Map,v=2e4;function D(F,O,L,N){const $=O.substring(F.length+1);return k.Promises.withAsyncBody(async V=>{let J;try{J=await w.Promises.readdir(O,{withFileTypes:!0})}catch{V();return}if(N.count>=v){N.count+=J.length,N.maxReached=!0,V();return}let H=J.length;if(H===0){V();return}let G=J;N.count+J.length>v&&(N.maxReached=!0,H=v-N.count,G=J.slice(0,H)),N.count+=J.length;for(const q of G)if(q.isDirectory()){if(L.includes(q.name)||await D(F,(0,b.join)(O,q.name),L,N),--H===0){V();return}}else{const x=q.name.lastIndexOf(".");if(x>=0){const Y=q.name.substring(x+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of u)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(q.name)&&h.set(Y.tag,(h.get(Y.tag)??0)+1);if(--H===0){V();return}}})}const M=k.Promises.withAsyncBody(async F=>{const O={count:0,maxReached:!1};await D(s,s,t,O);const L=await c(s);F({configFiles:l(h),fileTypes:l(a),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:L})});return m.set(i,M),M}e.collectWorkspaceStats=g;function l(s){return[...r.Iterable.map(s.entries(),([t,i])=>({name:t,count:i}))].sort((t,i)=>i.count-t.count)}function f(){const s={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=f;async function c(s){try{const t=new Map,i=(0,b.join)(s,".vscode","launch.json"),o=await w.Promises.readFile(i),u=[],a=(0,T.parse)(o.toString(),u);if(u.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const v=h.type;v&&(t.has(v)?t.set(v,t.get(v)+1):t.set(v,1))}return l(t)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(t,i){this.telemetryService=t,this.productService=i}formatMachineInfo(t){const i=[];return i.push(`OS Version:       ${t.os}`),i.push(`CPUs:             ${t.cpus}`),i.push(`Memory (System):  ${t.memory}`),i.push(`VM:               ${t.vmHint}`),i.join(`
`)}formatEnvironment(t){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${R.loadavg().map(u=>Math.round(u)).join(", ")}`),i.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${t.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(t,i){return Promise.all([(0,p.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[u,a]=o,h=this.formatProcessList(t,u);return i.forEach(v=>{if((0,y.isRemoteDiagnosticError)(v))h+=`
${v.errorMessage}`,a+=`
${v.errorMessage}`;else if(h+=`

Remote: ${v.hostName}`,v.processes&&(h+=`
${this.formatProcessList(t,v.processes)}`),v.workspaceMetadata){a+=`
|  Remote: ${v.hostName}`;for(const D of Object.keys(v.workspaceMetadata)){const M=v.workspaceMetadata[D];let F=`${M.fileCount} files`;M.maxFilesReached&&(F=`more than ${F}`),a+=`|    Folder (${D}): ${F}`,a+=this.formatWorkspaceStats(M)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(t,i){const{memory:o,vmHint:u,os:a,cpus:h}=f(),v={os:a,memory:o,cpus:h,vmHint:u,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(v.load=`${R.loadavg().map(D=>Math.round(D)).join(", ")}`),P.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(t,i){const o=[];return(0,p.listProcesses)(t.mainPID).then(async u=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,u)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),i.forEach(a=>{if((0,y.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const v=a.workspaceMetadata[h];let D=`${v.fileCount} files`;v.maxFilesReached&&(D=`more than ${D}`),o.push(`Folder (${h}): ${D}`),o.push(this.formatWorkspaceStats(v))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const i=[];let u=0;const a=(M,F)=>{const O=` ${M}(${F})`;u+O.length>60?(i.push(h),h="|                 ",u=h.length):u+=O.length,h+=O};let h="|      File types:";const v=10,D=t.fileTypes.length>v?v:t.fileTypes.length;for(let M=0;M<D;M++){const F=t.fileTypes[M];a(F.name,F.count)}if(i.push(h),t.configFiles.length>=0&&(h="|      Conf files:",u=0,t.configFiles.forEach(M=>{a(M.name,M.count)}),i.push(h)),t.launchConfigFiles.length>0){let M="|      Launch Configs:";t.launchConfigFiles.forEach(F=>{M+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),i.push(M)}return i.join(`
`)}expandGPUFeatures(t){const i=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const i=[],o=[];return t.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(i.push(`|  Window (${u.title})`),u.folderURIs.forEach(a=>{const h=I.URI.revive(a);if(h.scheme===A.Schemas.file){const v=h.fsPath;o.push(g(v,["node_modules",".git"]).then(D=>{let M=`${D.fileCount} files`;D.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,b.basename)(v)}): ${M}`),i.push(this.formatWorkspaceStats(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${v} (${D.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(u=>i.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(t,i){const o=new Map;t.windows.forEach(a=>o.set(a.pid,a.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(t.mainPID,o,u,i,0),u.join(`
`)}formatProcessItem(t,i,o,u,a){const h=a===0;let v;h?v=u.pid===t?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(a)} ${u.name}`,u.name==="window"&&(v=`${v} (${i.get(u.pid)})`));const D=process.platform==="win32"?u.mem:R.totalmem()*(u.mem/100);o.push(`${u.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(u.children)&&u.children.forEach(M=>this.formatProcessItem(t,i,o,M,a+1))}async getWorkspaceFileExtensions(t){const i=new Set;for(const{uri:o}of t.folders){const u=I.URI.revive(o);if(u.scheme!==A.Schemas.file)continue;const a=u.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(v=>i.add(v.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(t){for(const{uri:i}of t.folders){const o=I.URI.revive(i);if(o.scheme!==A.Schemas.file)continue;const u=o.fsPath;try{const a=await g(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};n=pe([K(0,C.ITelemetryService),K(1,S.IProductService)],n),e.DiagnosticsService=n}),define(ne[102],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:b,data:P}){return this.appenders.forEach(I=>I.log(b,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class r{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[49],se([0,1,31,78,14,19,101,22]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(n,s){return Promise.resolve(void 0)}publicLog2(n,s){return this.publicLog(n,s)}publicLogError(n,s){return Promise.resolve(void 0)}publicLogError2(n,s){return this.publicLogError(n,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class I{async publicLog(n,s,t){}async publicLogError(n,s,t){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(c,n){return n.onDidChangeConfiguration(s=>{s.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(s.source),configurationKeys:m(s.sourceConfig)})})}e.configurationTelemetry=E;function w(c,n){return!(n.disableTelemetry||!c.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(c){const n=c.getValue(b.TELEMETRY_SETTING_ID),s=c.getValue("telemetry.enableCrashReporter");if(c.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function y(c){const n={},s={},t={};C(c,t);for(let i in t){i=i.length>150?i.substr(i.length-149):i;const o=t[i];typeof o=="number"?s[i]=o:typeof o=="boolean"?s[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),n[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[i]=o)}return{properties:n,measurements:s}}e.validateTelemetryData=y;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(c){if(!c)return"none";for(const n of d)if(c.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=S;function C(c,n,s=0,t){if(!!c)for(const i of Object.getOwnPropertyNames(c)){const o=c[i],u=t?t+i:i;Array.isArray(o)?n[u]=(0,R.safeStringify)(o):o instanceof Date?n[u]=o.toISOString():(0,k.isObject)(o)?s<2?C(o,n,s+1,u+"."):n[u]=(0,R.safeStringify)(o):n[u]=o}}function m(c){if(!c)return[];const n=[];return g(n,"",c),n}function g(c,n,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>g(c,n?`${n}.${t}`:t,s[t])):c.push(n)}function l(c,n){const s=c.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(s)||t}e.isInternalTelemetry=l;function f(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[219],se([0,1,47,49]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,A,b,P,I,E,w){const p={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},y=await(0,R.getServiceMachineId)(b,I,E),{sessionId:d}=await w.getTelemetryInfo();return(0,r.supportsTelemetry)(A,b)&&(0,r.getTelemetryLevel)(P)===3&&(p["X-Market-User-Id"]=y,p["VSCode-SessionId"]=d),p}e.resolveMarketplaceHeaders=k}),define(ne[220],se([0,1,10,31,49]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(P,I,E){const w=await new Promise((C,m)=>{X(["@microsoft/1ds-core-js"],C,m)}),p=await new Promise((C,m)=>{X(["@microsoft/1ds-post-js"],C,m)}),y=new w.AppInsightsCore,d=new p.PostChannel,S={instrumentationKey:P,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(E){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:E};S.extensionConfig[d.identifier]=C}return y.initialize(S,[]),y.addTelemetryInitializer(C=>{I&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),y}class b{constructor(I,E,w,p,y){this._isInternalTelemetry=I,this._eventPrefix=E,this._defaultData=w,this._xhrOverride=y,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{I(E)},E=>{(0,R.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this._aiCoreOrKey)return;E=(0,r.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E);const w=this._eventPrefix+"/"+I;try{this._withAIClient(p=>{p.pluginVersionString=E?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(ne[103],se([0,1,2,15,8,49]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(P,I,E=""){super(),this.prefix=E;const w=P.getLogger(I.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(P.createLogger(I.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,I){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,T.validateTelemetryData)(I))}};A=pe([K(0,k.ILoggerService),K(1,r.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[104],se([0,1,2,31,78,4,24,154,19,42,96,25,40,22,49]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,l,f){this._configurationService=l,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,l){this._experimentProperties[g]=l}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const l=this._productService.enabledTelemetryLevels;if(l){this._sendErrorTelemetry=this.sendErrorTelemetry?l.error:!1;const f=l.usage?3:l.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,l=g.sessionID,f=g["common.machineId"],c=g["common.firstSessionDate"],n=g["common.msftInternal"];return{sessionId:l,machineId:f,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(g,l,f,c){return this.telemetryLevel.value<l?Promise.resolve(void 0):this._commonProperties.then(n=>{f=(0,r.mixin)(f,n),f=(0,r.mixin)(f,this._experimentProperties),f=(0,r.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,c)}),this._appenders.forEach(s=>s.log(g,f))},n=>{console.error(n)})}publicLog(g,l,f){return this._log(g,3,l,f)}publicLog2(g,l,f){return this.publicLog(g,l,f)}publicLogError(g,l){return this._sendErrorTelemetry?this._log(g,2,l,!0):Promise.resolve(void 0)}publicLogError2(g,l){return this.publicLogError(g,l)}_anonymizeFilePaths(g){let l=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const i=t.exec(g);if(!i)break;f.push([i.index,t.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(l="";;){const t=n.exec(g);if(!t)break;!c.test(t[0])&&f.every(([i,o])=>t.index<i||t.index>=o)&&(l+=g.substring(s,t.index)+"<REDACTED: user-file-path>",s=n.lastIndex)}return s<g.length&&(l+=g.substr(s)),l}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const l=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of f)if(c.regex.test(l))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,l){let f=g;l&&(f=this._anonymizeFilePaths(f));for(const c of this._cleanupPatterns)f=f.replace(c,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([K(1,P.IConfigurationService),K(2,w.IProductService)],S),e.TelemetryService=S;function C(){const m=(0,b.localize)(0,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=T.isWeb?"":(0,b.localize)(3,null),f=(0,b.localize)(4,null),c=(0,b.localize)(5,null),n=(0,b.localize)(6,null),s=(0,b.localize)(7,null),t=`
|       | ${f} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,b.localize)(8,null);return`
${m} ${g} ${l}

&nbsp;

${s}
${t}

&nbsp;

${i}
`}p.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,b.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,b.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[221],se([0,1,274,220]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends r.AbstractOneDataSystemAppender{constructor(A,b,P,I){const E={sendPOST:(w,p)=>{const y={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const d=R.request(w.urlString,y,S=>{S.on("data",function(C){p(S.statusCode??200,S.headers,C.toString())}),S.on("error",function(C){p(0,{})})});d.write(w.data),d.end()}catch{p(0,{})}}};super(A,b,P,I,E)}}e.OneDataSystemAppender=k}),define(ne[222],se([0,1,20,64,19,15,8,25,22,102,103,104]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(d,S,C,m,g){this.configurationService=d,this.telemetryService=S,this.loggerService=C,this.environmentService=m,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=S,m["common.vscodesessionid"]=C;const g=[d.id,JSON.stringify(m),d.aiKey],f=new r.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new I.TelemetryAppenderClient(f),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new w.TelemetryService({appenders:c,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,C){await(await this.getCustomTelemetryService(d)).publicLog(S,C)}async publicLogError(d,S,C){await(await this.getCustomTelemetryService(d)).publicLogError(S,C)}};p=pe([K(0,k.IConfigurationService),K(1,P.ITelemetryService),K(2,A.ILoggerService),K(3,T.IEnvironmentService),K(4,b.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[223],se([0,1,6,21,3,2,8]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let b=class extends T.Disposable{constructor(I,E){super(),this._logService=E,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((E,w)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,E),this._onCreateRequest.fire({requestId:p,...I});const y=new r.CancellationTokenSource;(0,R.timeout)(this._timeout,y.token).then(()=>w(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,T.toDisposable)(()=>y.cancel())])})}acceptReply(I,E){const w=this._pendingRequests.get(I);w?(this._pendingRequests.delete(I),(0,T.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),w(E)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};b=pe([K(1,A.ILogService)],b),e.RequestStore=b}),define(ne[105],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(l){l.Shell="terminal.integrated.shell.",l.ShellArgs="terminal.integrated.shellArgs.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(l){l.ShellLinux="terminal.integrated.shell.linux",l.ShellMacOs="terminal.integrated.shell.osx",l.ShellWindows="terminal.integrated.shell.windows",l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationShellLinux="terminal.integrated.automationShell.linux",l.AutomationShellMacOs="terminal.integrated.automationShell.osx",l.AutomationShellWindows="terminal.integrated.automationShell.windows",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ShellArgsLinux="terminal.integrated.shellArgs.linux",l.ShellArgsMacOs="terminal.integrated.shellArgs.osx",l.ShellArgsWindows="terminal.integrated.shellArgs.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(l){l.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var b;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.Log="log",l.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var E;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(l){l.TerminalView="view",l.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var m;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[224],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[225],se([0,1,37,20,31,9,4,36,24,14,27]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let c=0;return f&&f.length===4&&(c=parseInt(f[3])),c}e.getWindowsBuildNumber=w;async function p(f,c,n,s=b.env,t=E.Promises.exists){if(T.isAbsolute(f))return await t(f)?f:void 0;if(c===void 0&&(c=b.cwd()),T.dirname(f)!=="."){const a=T.join(c,f);return await t(a)?a:void 0}const o=(0,k.getCaseInsensitive)(s,"PATH");if(n===void 0&&(0,I.isString)(o)&&(n=o.split(T.delimiter)),n===void 0||n.length===0){const a=T.join(c,f);return await t(a)?a:void 0}for(const a of n){let h;if(T.isAbsolute(a)?h=T.join(a,f):h=T.join(c,a,f),await t(h))return h;if(A.isWindows){let v=h+".com";if(await t(v)||(v=h+".exe",await t(v)))return v}}const u=T.join(c,f);return await t(u)?u:void 0}e.findExecutable=p;function y(f,c,n){if(!c.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const s=f.args,t=b.platform==="win32"?T.basename(f.executable).toLowerCase():T.basename(f.executable),i=T.dirname(r.FileAccess.asFileUri("",X).fsPath);let o;const u={VSCODE_INJECTION:"1"};if(A.isWindows){if(t==="pwsh.exe")return!s||g(s)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o&&(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,"")),{newArgs:o,envMixin:u}):void 0;n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(t){case"bash":return!s||s.length===0?o=e.shellIntegrationArgs.get(d.Bash):l(s)&&(u.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i),{newArgs:o,envMixin:u}):void 0;case"pwsh":return!s||g(s)?o=e.shellIntegrationArgs.get(d.Pwsh):m(s)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,""),{newArgs:o,envMixin:u}):void 0;case"zsh":{if(!s||s.length===0?o=e.shellIntegrationArgs.get(d.Zsh):l(s)?o=e.shellIntegrationArgs.get(d.ZshLogin):(s===e.shellIntegrationArgs.get(d.Zsh)||s===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=s),!o)return;o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i);const a=T.join(R.tmpdir(),"vscode-zsh");u.ZDOTDIR=a;const h=[];return h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(a,".zshrc")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(a,".zprofile")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(a,".zshenv")}),h.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(a,".zlogin")}),{newArgs:o,envMixin:u,filesToCopy:h}}}n.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=y;var d;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function m(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(C.includes(f[0].toLowerCase())||C.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?C.includes(f.toLowerCase()):f.length===0||f?.length===1&&C.includes(f[0].toLowerCase())}function l(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(ne[226],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function r(T){return T===R.HIGH_CONTRAST_DARK||T===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function k(T){return T===R.DARK||T===R.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[106],se([0,1,50,3,2,5,40,226]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var P;(function(C){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=m})(P=e.ThemeColor||(e.ThemeColor={}));function I(C){return{id:C}}e.themeColorFromId=I;var E;(function(C){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||P.isThemeColor(i.color))}C.isThemeIcon=m;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function l(i){const o=g.exec(i);if(!o)return;const[,u]=o;return{id:u}}C.fromString=l;function f(i){return{id:i}}C.fromId=f;function c(i,o){let u=i.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),o&&(u=`${u}~${o}`),{id:u}}C.modify=c;function n(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}C.getModifier=n;function s(i,o){return i.id===o.id&&i.color?.id===o.color?.id}C.isEqual=s;function t(i,o){return{id:i.id,color:o?I(o):void 0}}C.asThemeIcon=t,C.asClassNameArray=R.CSSIcon.asClassNameArray,C.asClassName=R.CSSIcon.asClassName,C.asCSSSelector=R.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function w(C){switch(C){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(m);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new p;A.Registry.add(e.Extensions.ThemingContribution,y);function d(C){return y.onColorThemeChange(C)}e.registerThemingParticipant=d;class S extends k.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,g){let l=this.theme.getColor(m);return l&&g&&(l=g(l,this.theme)),l?l.toString():null}}e.Themable=S}),define(ne[227],se([0,1,50,7,156,106]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(p,y){const d=[{name:null,description:(0,k.localize)(0,null)}];return d.push(...p.map(S=>({name:S.profileName,description:b(S)}))),y&&d.push(...y.map(S=>({name:S.title,description:P(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function b(p){let y=`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?y+=`
- args: "${p.args}"`:y+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(y+=`
- overrideName: ${p.overrideName}`),p.color&&(y+=`
- color: ${p.color}`),p.env&&(y+=`
- env: ${JSON.stringify(p.env)}`),y}function P(p){return`$(${T.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:R.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function I(p,y){if(!p&&!y)return!0;if(typeof p=="string"&&typeof y=="string")return p===y;if(Array.isArray(p)&&Array.isArray(y)){if(p.length!==y.length)return!1;for(let d=0;d<p.length;d++)if(p[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=I;function E(p,y){if(!p&&!y)return!0;if(!p||!y)return!1;if(T.ThemeIcon.isThemeIcon(p)&&T.ThemeIcon.isThemeIcon(y))return p.id===y.id&&p.color===y.color;if(typeof p=="object"&&p&&"light"in p&&"dark"in p&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=p,S=y;if((r.URI.isUri(d.light)||w(d.light))&&(r.URI.isUri(d.dark)||w(d.dark))&&(r.URI.isUri(S.light)||w(S.light))&&(r.URI.isUri(S.dark)||w(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(y)||w(p)||w(y)){const d=p,S=y;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=E;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=w}),define(ne[228],se([0,1,50,155,42,40,227]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)};const b={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},I={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...b}},E=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){T.Registry.as(k.Extensions.Configuration).registerConfiguration(C),l()}e.registerTerminalPlatformConfiguration=m;let g;function l(f,c){const n=T.Registry.as(k.Extensions.Configuration);let s;f&&(s=(0,A.createProfileSchemaEnums)(f?.profiles,c));const t=g;g={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=l}),define(ne[229],se([0,1,54,50,9,4,27,82,225,106]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,w=!0;function p(s,t,i,o,u=process.env,a,h,v,D){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?y(i,a,u,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),D,v):f(a,h,i,s&&typeof s=="object"?{...s}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),D,v,u)}e.detectAvailableProfiles=p;async function y(s,t,i,o,u,a,h,v,D){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let O=!1;(0,P.getWindowsBuildNumber)()>=16299&&(O=!0),await C(v);const L=new Map;s&&(L.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Windows PowerShell",{path:`${F}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),L.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),L.set("Command Prompt",{path:`${F}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),c(a,L);const N=await d(L.entries(),h,t,i,o,D);if(s||!s&&u)try{const $=await g(`${F}\\${O?"wsl":"bash"}.exe`,h);for(const V of $)(!a||!(V.profileName in a))&&N.push(V)}catch{w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return N}async function d(s,t,i,o=process.env,u,a){const h=[];for(const[v,D]of s){if(D===null)continue;let M,F,O;if("source"in D){const $=E?.get(D.source);if(!$)continue;M=$.paths,F=D.args||$.args,D.icon?O=S(D.icon):$.icon&&(O=$.icon)}else M=Array.isArray(D.path)?D.path:[D.path],F=T.isWindows||Array.isArray(D.args)?D.args:void 0,O=S(D.icon);const L=await a?.(M)||M.slice(),N=await n(v,t,L,i,o,F,D.env,D.overrideName,D.isAutoDetected,u);N?(N.isAutoDetected=D.isAutoDetected,N.icon=O,N.color=D.color,h.push(N)):u?.debug("Terminal profile not validated",v,M)}return u?.debug("Validated terminal profiles",h),h}function S(s){return typeof s=="string"?{id:s}:s}async function C(s){E&&!s||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),E.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:I.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const t of(0,b.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function g(s,t){const i=[],o=await new Promise((h,v)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(D,M)=>{if(D)return v("Problem occurred when getting wsl distros");h(M)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),a=o.split(u).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const v=`${h} (WSL)`,D={profileName:v,path:s,args:["-d",`${h}`],isDefault:v===t,icon:l(h),isAutoDetected:!1};i.push(D)}return i}function l(s){return s.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):s.includes("Debian")?I.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function f(s,t,i,o,u,a,h,v){const D=new Map;if(i){const M=(await s.readFile("/etc/shells")).toString(),F=a||M.split(`
`).filter(L=>L.trim().indexOf("#")!==0&&L.trim().length>0),O=new Map;for(const L of F){let N=(0,k.basename)(L),$=O.get(N)||0;$++,$>1&&(N=`${N} (${$})`),O.set(N,$),D.set(N,{path:L,isAutoDetected:!0})}}return c(o,D),await d(D.entries(),u,s,v,t,h)}function c(s,t){if(!!s)for(const[i,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(i):(o.icon=o.icon||t.get(i)?.icon,t.set(i,o))}async function n(s,t,i,o,u,a,h,v,D,M){if(i.length===0)return Promise.resolve(void 0);const F=i.shift();if(F==="")return n(s,t,i,o,u,a,h,v,D);const O={profileName:s,path:F,args:a,env:h,overrideName:v,isAutoDetected:D,isDefault:s===t};if((0,k.basename)(F)===F){const N=u.PATH?u.PATH.split(k.delimiter):void 0,$=await(0,P.findExecutable)(F,void 0,N,void 0,o.existsFile);return $?(O.path=$,O.isFromPath=!0,O):n(s,t,i,o,u,a)}return await o.existsFile((0,k.normalize)(F))?O:n(s,t,i,o,u,a,h,v,D)}}),define(ne[230],se([0,1,3,2,20,4,39,64,19,15,87,215,8,95,223,105,228,229]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let l=0,f=class extends r.Disposable{constructor(n,s,t,i){super(),this._reconnectConstants=n,this._configurationService=s,this._environmentService=t,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,E.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?n.debugBrk=s.port:!s.break&&s.port&&(n.debug=s.port));const t=new b.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,n);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(a=>this._onProcessData.fire(a))),this._register(u.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(u.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(u.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(u.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(u.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(u.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,s,t,i,o,u,a,h,v,D,M){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(n,s,t,i,o,u,a,h,v,D,M);return clearTimeout(F),l=Math.max(l,O),O}updateTitle(n,s,t){return this._proxy.updateTitle(n,s,t)}updateIcon(n,s,t){return this._proxy.updateIcon(n,s,t)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,s){return this._proxy.detachFromProcess(n,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,s){return this._proxy.shutdown(n,s)}input(n,s){return this._proxy.input(n,s)}processBinary(n,s){return this._proxy.processBinary(n,s)}resize(n,s,t){return this._proxy.resize(n,s,t)}acknowledgeDataEvent(n,s){return this._proxy.acknowledgeDataEvent(n,s)}setUnicodeVersion(n,s){return this._proxy.setUnicodeVersion(n,s)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,s){return this._proxy.installAutoReply(n,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,s,t,i=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(s,t,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,s){return this._proxy.requestDetachInstance(n,s)}async acceptDetachInstanceReply(n,s){return this._proxy.acceptDetachInstanceReply(n,s)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,s){return this._proxy.reviveTerminalProcesses(n,s)}async refreshProperty(n,s){return this._proxy.refreshProperty(n,s)}async updateProperty(n,s,t){return this._proxy.updateProperty(n,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:s})}async acceptPtyHostResolvedVariables(n,s){this._resolveVariablesRequestStore.acceptReply(n,s)}};f=pe([K(1,P.IConfigurationService),K(2,I.IEnvironmentService),K(3,p.ILogService)],f),e.PtyHostService=f}),define(ne[69],se([0,1,3,4,5,8]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function p(S,C){return C?C!==1&&S<1024:!r.isWindows&&S<1024}e.isPortPrivileged=p;class y{constructor(C,m,g){this.remoteAddress=C,this.localAddress=m,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let d=class{constructor(C){this.logService=C,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],m=Array.from(this._tunnels.values());for(const g of m){const l=Array.from(g.values());for(const f of l){const c=await f.value;c&&C.push(c)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:m}of C.values())await m.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,m,g,l,f=!1,c,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${g} on local port ${l}.`),!C)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(C,m,g,l,f,c,n);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==m||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const m=this._tunnels.get(C.tunnelRemoteHost);if(m){const g=m.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,m,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${m}.`);const l=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(m),l}}async closeTunnel(C,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${m} `);const g=this._tunnels.get(C);if(g&&g.has(m)){const l=g.get(m);l.refcount=0,await this.tryDisposeTunnel(C,m,l)}}addTunnelToMap(C,m,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(m,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,m){const g=this._tunnels.get(C);g&&(await g.get(m)||g.delete(m),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,m){const g=[C];E(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const l=g.map(f=>this._tunnels.get(f));for(const f of l){const c=f?.get(m);if(c)return c}}canTunnel(C){return!!I(C)}createWithProvider(C,m,g,l,f,c,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${g} on local port ${l}.`);const s=g;this._factoryInProgress.add(s);const i={elevationRequired:f?p(l===void 0?g:l):!1},o={remoteAddress:{host:m,port:g},localAddressPort:l,privacy:c,public:c?c!==b.Private:void 0,protocol:n},u=C.forwardPort(o,i);return u?(this.addTunnelToMap(m,g,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),u}};d=pe([K(0,T.ILogService)],d),e.AbstractTunnelService=d}),define(ne[231],se([0,1,8,69,2,10,6]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends k.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let P=class Ct extends k.Disposable{constructor(E,w){super(),this._tunnelService=E,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(E,w,p,y,d,S){const C=new b,m=await Promise.resolve(this._tunnelService.openTunnel(E,C,p,y,d,S));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${y} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await m.dispose(),(0,T.canceled)();return C.setTunnel(m),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${p}:${y} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(E,w){const p=this._tunnels.get(E);!p||p.setAddress(w)}async destroyTunnel(E){const w=this._tunnels.get(E);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await w.dispose();return}this._disposedTunnels.add(E)}};P._lastId=0,P=pe([K(0,r.ISharedTunnelsService),K(1,R.ILogService)],P),e.SharedProcessTunnelService=P}),define(ne[232],se([0,1,76,115,206,6,2,19,8,25,204,69,100]),function(X,e,R,r,k,T,A,b,P,I,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(g,l,f,c,n){let s;for(let t=3;t&&(s?.dispose(),s=await new d(g,l,f,c,n).waitForReady(),!(n&&r.BROWSER_RESTRICTED_PORTS[n]||!r.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));t--);return s}class d extends A.Disposable{constructor(l,f,c,n,s){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=s,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let l=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(l){l.pause();const f=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,E.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),n=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&l.write(s.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),n.destroy()}),n.on("end",()=>l.end()),n.on("close",()=>l.end()),n.on("error",()=>{l.destroy()}),l.pipe(n),n.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),n.end()})}}let S=class extends w.AbstractTunnelService{constructor(l,f,c,n,s){super(f),this.socketFactory=l,this.signService=c,this.productService=n,this.configurationService=s}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,f,c,n,s,t,i){const o=this.getTunnelFromMap(f,c);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,c,n,s,t,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${c} on local port ${n}.`);const u={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},a=y(u,this.defaultTunnelHost,f,c,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,c,a),a}}};S=pe([K(1,P.ILogService),K(2,p.ISignService),K(3,I.IProductService),K(4,b.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(l,f,c,n){super(k.nodeSocketFactory,l,f,c,n)}};C=pe([K(0,P.ILogService),K(1,p.ISignService),K(2,I.IProductService),K(3,b.IConfigurationService)],C),e.TunnelService=C;let m=class extends A.Disposable{constructor(l,f,c,n){super(),this.logService=l,this.productService=f,this.signService=c,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(l,f,c,n,s,t,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${n} on local port ${s}.`),!this._tunnelServices.has(l)){const u=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(l,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(f,c,n,s,t,i,o)}};m=pe([K(0,P.ILogService),K(1,I.IProductService),K(2,p.ISignService),K(3,b.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ne[33],se([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[233],se([0,1,3,2,7,15,32,13,8,33]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let E=class extends r.Disposable{constructor(p,y,d,S,C){super(),this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(l=>l.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(g=>this.onInstallExtension(g))),this._register(p.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(p.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const m=k.URI.file(d.extensionsPath);this._register(y.watch(m)),this._register(R.Event.filter(y.onDidFilesChange,g=>g.rawChanges.some(l=>this.doesChangeAffects(l,m)))(()=>this.onDidChange()))}doesChangeAffects(p,y){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),y)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const y of p)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),y=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,A.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,A.areSameExtensions)(C,S))?!1:p.every(C=>!(0,A.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};E=pe([K(1,b.IFileService),K(2,T.INativeEnvironmentService),K(3,P.ILogService),K(4,I.IUriIdentityService)],E),e.ExtensionsWatcher=E}),define(ne[234],se([0,1,33,88,13,17,113,3,2]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(p){this.uri=p,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let E=class{constructor(p){this._fileService=p,this._dispooables=new P.DisposableStore,this._limit=2**16;const y=new Map,d=S=>{let C=y.get(S.scheme);return C===void 0&&(C=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,C)),C};this._dispooables.add(b.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,T.normalizePath)(p));const y=this._canonicalUris.get(p);return y?y.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new I(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(p[d][0],p[d][1].touch())}};E=pe([K(0,k.IFileService)],E),e.UriIdentityService=E,(0,r.registerSingleton)(R.IUriIdentityService,E,!0)}),define(ne[235],se([0,1,3,2,13,41,34,16]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends r.Disposable{constructor(E,w,p,y){super(),this.fileSystemScheme=E,this.fileSystemProvider=w,this.userDataScheme=p,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&-5}watch(E,w){this.watchResources.set(E,E);const p=this.fileSystemProvider.watch(this.toFileSystemResource(E),w);return(0,r.toDisposable)(()=>{this.watchResources.delete(E),p.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,w,p){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(w),p)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,w,p){const y=(0,T.newWriteableStream)(d=>b.VSBuffer.concat(d.map(S=>b.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(E);y.end(d)}catch(d){y.error(d),y.end()}})(),y}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,w,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),w,p)}delete(E,w){return this.fileSystemProvider.delete(this.toFileSystemResource(E),w)}copy(E,w,p){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(w),p);throw new Error("copy not supported")}handleFileChanges(E){const w=[];for(const p of E){if(p.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(p.resource);this.watchResources.findSubstr(y)&&w.push({resource:y,type:p.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ne[59],se([0,1,75]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(A,b,P,I){const E=(0,R.setProperty)(A,b,P,I)[0];return E&&(A=A.substring(0,E.offset)+E.content+A.substring(E.offset+E.length)),A}e.edit=r;function k(A,b,P){let I=P;for(;I>=0;){if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1)return I+1;if(I--,b.length===2&&I>=0&&A.charAt(I)===b.charAt(0))return I+2}return 0}e.getLineStartOffset=k;function T(A,b,P){let I=P;for(;I>=0;)if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1||(I++,b.length===2&&I>=0&&A.charAt(I)===b.charAt(1)))return I;return A.length-1}e.getLineEndOffset=T}),define(ne[236],se([0,1,31,55,14]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(p,y,d,S,C){const m=[],g=[],l=[];if(!y){const F=p.filter(({identifier:O})=>C.every(L=>L.toLowerCase()!==O.id.toLowerCase()));return{local:{added:m,removed:g,updated:l},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}p=p.map(E),y=y.map(E),d=d?d.map(E):null;const f=new Map,c=F=>{F.uuid&&f.set(F.id.toLowerCase(),F.uuid)};p.forEach(({identifier:F})=>c(F)),y.forEach(({identifier:F})=>c(F)),d?.forEach(({identifier:F})=>c(F));const n=F=>{const O=F.identifier.uuid||f.get(F.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${F.identifier.id.toLowerCase()}`},s=(F,O)=>(F.set(n(O),O),F),t=p.reduce(s,new Map),i=y.reduce(s,new Map),o=y.reduce((F,O)=>{const L=n(O);O=(0,R.deepClone)(O);const N=t.get(L);return N&&(N.installed&&(O.installed=!0),O.version||(O.version=N.version)),s(F,O)},new Map),u=d?d.reduce(s,new Map):null,a=S.reduce(s,new Map),h=C.reduce((F,O)=>{const L=f.get(O.toLowerCase());return F.add(L?`uuid:${L}`:`id:${O.toLowerCase()}`)},new Set),v=A(t,i,h);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const F=A(u,t,h),O=A(u,i,h),L=(N,$)=>{const V=t.get(N);if(V){const J=i.get(N),H=$?J:V;return{...H,version:J.version&&(!V.installed||r.gt(J.version,V.version))?J.version:V.version,state:b(V,J,u?.get(N)),preRelease:(0,k.isUndefined)(H.preRelease)?V.preRelease:V.installed?H.preRelease:J.preRelease}}};for(const N of O.removed.values()){const $=t.get(N);$&&g.push($.identifier)}for(const N of O.added.values())if(F.added.has(N)){if(v.updated.has(N)){const $=L(N,!0);$&&(l.push(w($,N)),o.set(N,$))}}else{const $=i.get(N);$.installed&&m.push(w($,N))}for(const N of O.updated.values()){const $=L(N,!0);$&&(l.push(w($,N)),o.set(N,$))}for(const N of F.added.values())O.added.has(N)||o.set(N,t.get(N));for(const N of F.updated.values())if(!O.removed.has(N)&&!O.updated.has(N)){const $=L(N,!1);$&&(o.get(N)?.installed&&($.installed=!0),o.set(N,$))}for(const N of F.removed.values())!a.has(N)&&!O.updated.has(N)&&u?.get(N)?.installed&&o.delete(N)}const D=[],M=A(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&o.forEach((F,O)=>D.push(w(F,O))),{local:{added:m,removed:g,updated:l},remote:D.length?{added:[...M.added].map(F=>o.get(F)),updated:[...M.updated].map(F=>o.get(F)),removed:[...M.removed].map(F=>i.get(F)),all:D}:null}}e.merge=T;function A(p,y,d,{checkInstalledProperty:S,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=p?[...p.keys()].filter(n=>!d.has(n)):[],g=[...y.keys()].filter(n=>!d.has(n)),l=g.filter(n=>m.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),f=m.filter(n=>g.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),c=new Set;for(const n of m){if(f.has(n))continue;const s=p.get(n),t=y.get(n);(!t||s.disabled!==t.disabled||s.installed&&t.installed&&s.preRelease!==t.preRelease||!I(s.state,t.state)||C&&s.version!==t.version||S&&s.installed!==t.installed)&&c.add(n)}return{added:l,removed:f,updated:c}}function b(p,y,d){const S=p.state,C=y.state,m=d?.state;if(!y.version||S&&r.gt(p.version,y.version))return S;if(C&&r.gt(y.version,p.version)||!S)return C;if(!C)return S;const g=(0,R.deepClone)(S),l=m?P(m,C):{added:Object.keys(C).reduce((c,n)=>(c.add(n),c),new Set),removed:new Set,updated:new Set},f=m?P(m,S):{added:Object.keys(S).reduce((c,n)=>(c.add(n),c),new Set),removed:new Set,updated:new Set};for(const c of[...l.added.values(),...l.updated.values()])g[c]=C[c];for(const c of l.removed.values())f.updated.has(c)||delete g[c];return g}function P(p,y){const d=Object.keys(p),S=Object.keys(y),C=S.filter(l=>d.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),m=d.filter(l=>S.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),g=new Set;for(const l of d){if(m.has(l))continue;const f=p[l],c=y[l];(0,R.equals)(f,c)||g.add(l)}return{added:C,removed:m,updated:g}}function I(p={},y={}){const{added:d,removed:S,updated:C}=P(p,y);return d.size===0&&S.size===0&&C.size===0}function E(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,y){const d={identifier:{id:p.identifier.id,uuid:y.startsWith("uuid:")?y.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(d.version=p.version),p.disabled&&(d.disabled=!0),p.installed&&(d.installed=!0),p.state&&(d.state=p.state),d}}),define(ne[107],se([0,1,18,19,5]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(b){this.configurationService=b}hasToNeverSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(b.toLowerCase())}hasToAlwaysSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(`-${b.toLowerCase()}`)}updateIgnoredExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(b.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}updateSynchronizedExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(`-${b.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}getIgnoredExtensions(b){const P=b.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),E=[],w=[];if(Array.isArray(I))for(const p of I)p.startsWith("-")?w.push(p.substring(1)):E.push(p);return(0,R.distinct)([...P,...E].filter(p=>w.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let b=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return b!==void 0||(b=this.configurationService.inspect("sync.ignoredExtensions").userValue,b!==void 0)?b:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};T=pe([K(0,r.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[237],se([0,1,18,35,31,174,59]),function(X,e,R,r,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function b(f){return(0,r.parse)(f)||[]}e.parseKeybindings=b;async function P(f,c,n,s,t){const i=b(f),o=b(c),u=n?b(n):null,a=[...i,...o,...u||[]].map(J=>J.key),h=await t.resolveUserBindings(a),v=E(i,o,u,h);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const D=p(i),M=p(o),F=u?p(u):null,O=d(D,M,h),L=F?d(F,D,h):{added:[...D.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},N=F?d(F,M,h):{added:[...M.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=I(O,L,N);let V=f;for(const J of $.removed.values())$.conflicts.has(J)||(V=g(V,J,s));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=M.get(J);if(H.some(G=>G.command!==`-${J}`&&v.conflicts.has(h[G.key]))){$.conflicts.add(J);continue}V=m(V,H,s)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=M.get(J);if(H.some(G=>G.command!==`-${J}`&&v.conflicts.has(h[G.key]))){$.conflicts.add(J);continue}V=l(V,J,H,s)}return{mergeContent:V,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=P;function I(f,c,n){const s=new Set,t=new Set,i=new Set,o=new Set;for(const u of c.removed.values())n.updated.has(u)&&o.add(u);for(const u of n.removed.values())o.has(u)||(c.updated.has(u)?o.add(u):t.add(u));for(const u of c.added.values())o.has(u)||n.added.has(u)&&f.updated.has(u)&&o.add(u);for(const u of n.added.values())o.has(u)||(c.added.has(u)?f.updated.has(u)&&o.add(u):s.add(u));for(const u of c.updated.values())o.has(u)||n.updated.has(u)&&f.updated.has(u)&&o.add(u);for(const u of n.updated.values())o.has(u)||(c.updated.has(u)?f.updated.has(u)&&o.add(u):i.add(u));return{added:s,removed:t,updated:i,conflicts:o}}function E(f,c,n,s){const t=new Set,i=w(f,s),o=w(c,s),u=n?w(n,s):null,a=y(i,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=u?y(u,i):{added:[...i.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const v=u?y(u,o):{added:[...o.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:D,removed:M,updated:F,conflicts:O}=I(a,h,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:D,removed:M,updated:F,conflicts:O}}function w(f,c){const n=new Map;for(const s of f){const t=c[s.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(s)}return n}function p(f){const c=new Map;for(const n of f){const s=n.command[0]==="-"?n.command.substring(1):n.command;let t=c.get(s);t||(t=[],c.set(s,t)),t.push(n)}return c}function y(f,c){const n=[...f.keys()],s=[...c.keys()],t=s.filter(u=>n.indexOf(u)===-1).reduce((u,a)=>(u.add(a),u),new Set),i=n.filter(u=>s.indexOf(u)===-1).reduce((u,a)=>(u.add(a),u),new Set),o=new Set;for(const u of n){if(i.has(u))continue;const a=f.get(u).map(v=>({...v,key:u})),h=c.get(u).map(v=>({...v,key:u}));(0,R.equals)(a,h,(v,D)=>C(v,D))||o.add(u)}return{added:t,removed:i,updated:o}}function d(f,c,n){const s=[...f.keys()],t=[...c.keys()],i=t.filter(a=>s.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=s.filter(a=>t.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),u=new Set;for(const a of s){if(o.has(a))continue;const h=f.get(a).map(D=>({...D,key:n[D.key]})),v=c.get(a).map(D=>({...D,key:n[D.key]}));S(h,v)||u.add(a)}return{added:i,removed:o,updated:u}}function S(f,c){return!(!(0,R.equals)(f.filter(({command:n})=>n[0]!=="-"),c.filter(({command:n})=>n[0]!=="-"),(n,s)=>C(n,s))||!(0,R.equals)(f.filter(({command:n})=>n[0]==="-"),c.filter(({command:n})=>n[0]==="-"),(n,s)=>C(n,s)))}function C(f,c){if(f.command!==c.command||f.key!==c.key)return!1;const n=T.ContextKeyExpr.deserialize(f.when),s=T.ContextKeyExpr.deserialize(c.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!k.equals(f.args,c.args))}function m(f,c,n){for(const s of c)f=A.edit(f,[-1],s,n);return f}function g(f,c,n){const s=b(f);for(let t=s.length-1;t>=0;t--)(s[t].command===c||s[t].command===`-${c}`)&&(f=A.edit(f,[t],void 0,n));return f}function l(f,c,n,s){const t=b(f),i=t.findIndex(o=>o.command===c||o.command===`-${c}`);for(let o=t.length-1;o>=0;o--)(t[o].command===c||t[o].command===`-${c}`)&&(f=A.edit(f,[o],void 0,s));for(let o=n.length-1;o>=0;o--)f=A.edit(f,[i],n[o],s);return f}}),define(ne[238],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,A,b){const P={},I={},E=new Set;if(!A)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=r(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=r(b,T),y=r(b,A),d={},S={},C=new Set,m=new Set;for(const g of p.removed.values())y.updated.has(g)?P[g]=A[g]:C.add(g);for(const g of y.removed.values())m.has(g)||(p.updated.has(g)?m.add(g):E.add(g));for(const g of p.updated.values())m.has(g)||(y.updated.has(g)?w.updated.has(g)&&m.add(g):S[g]=T[g]);for(const g of y.updated.values())m.has(g)||(p.updated.has(g)?w.updated.has(g)&&m.add(g):T[g]!==void 0&&(I[g]=A[g]));for(const g of p.added.values())m.has(g)||(y.added.has(g)?w.updated.has(g)&&m.add(g):d[g]=T[g]);for(const g of y.added.values())m.has(g)||(p.added.has(g)?w.updated.has(g)&&m.add(g):P[g]=A[g]);return{local:{added:P,removed:[...E.values()],updated:I},remote:{added:d,removed:[...C.values()],updated:S},conflicts:[...m.values()]}}e.merge=R;function r(T,A){const b=T?Object.keys(T):[],P=A?Object.keys(A):[],I=P.filter(p=>b.indexOf(p)===-1).reduce((p,y)=>(p.add(y),p),new Set),E=b.filter(p=>P.indexOf(p)===-1).reduce((p,y)=>(p.add(y),p),new Set),w=new Set;for(const p of b){if(E.has(p))continue;const y=T[p],d=A[p];y!==d&&w.add(p)}return{added:I,removed:E,updated:w}}function k(T,A){const{added:b,removed:P,updated:I}=r(T,A);return b.size===0&&P.size===0&&I.size===0}e.areSame=k}),define(ne[26],se([0,1,18,17,14,162,42,29,5,97,40]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const u=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(u).filter(a=>!!u[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function p(){const u=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(u).filter(D=>!!u[D].ignoreSync),h=Object.keys(u).filter(D=>u[D].scope===2||u[D].scope===6),v=w();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...h,...v])}e.getDefaultIgnoredSettings=p,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const u="vscode://schemas/ignoredSettings",a=E.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:b.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:u,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=E.Registry.as(I.Extensions.JSONContribution),v=()=>{const D=w(),M=p().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(N=>M.indexOf(N)===-1),O=M.filter(N=>D.indexOf(N)===-1),L={items:{type:"string",enum:[...F,...O.map(N=>`-${N}`)]}};h.registerSchema(u,L)};return a.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=y;function d(u){return u&&(0,k.isObject)(u)&&(0,k.isString)(u.id)&&Array.isArray(u.scopes)}e.isAuthenticationProvider=d;var S;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function C(u,a,h){return h.joinPath(a.userDataSyncHome,u,`lastSync${u}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(u){const a={};return a[e.HEADER_EXECUTION_ID]=u,a}e.createSyncHeaders=m;var g;(function(u){u.Unauthorized="Unauthorized",u.Conflict="Conflict",u.Gone="Gone",u.PreconditionFailed="PreconditionFailed",u.TooLarge="TooLarge",u.UpgradeRequired="UpgradeRequired",u.PreconditionRequired="PreconditionRequired",u.TooManyRequests="RemoteTooManyRequests",u.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",u.RequestFailed="RequestFailed",u.RequestCanceled="RequestCanceled",u.RequestTimeout="RequestTimeout",u.RequestProtocolNotSupported="RequestProtocolNotSupported",u.RequestPathNotEscaped="RequestPathNotEscaped",u.RequestHeadersNotObject="RequestHeadersNotObject",u.NoRef="NoRef",u.EmptyResponse="EmptyResponse",u.TurnedOff="TurnedOff",u.SessionExpired="SessionExpired",u.ServiceChanged="ServiceChanged",u.DefaultServiceChanged="DefaultServiceChanged",u.LocalTooManyRequests="LocalTooManyRequests",u.LocalPreconditionFailed="LocalPreconditionFailed",u.LocalInvalidContent="LocalInvalidContent",u.LocalError="LocalError",u.IncompatibleLocalContent="IncompatibleLocalContent",u.IncompatibleRemoteContent="IncompatibleRemoteContent",u.UnresolvedConflicts="UnresolvedConflicts",u.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class l extends Error{constructor(a,h,v,D){super(a),this.code=h,this.resource=v,this.operationId=D,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=l;class f extends l{constructor(a,h,v,D,M){super(a,v,void 0,M),this.url=h,this.serverCode=D}}e.UserDataSyncStoreError=f;class c extends l{constructor(a,h){super(a,h)}}e.UserDataAutoSyncError=c,function(u){function a(h){if(h instanceof u)return h;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(v&&v[1]){const D=v[2]==="unknown"?void 0:v[2],M=v[3]==="unknown"?void 0:v[3];return new u(h.message,v[1],D,M)}return new u(h.message,"Unknown")}u.toUserDataSyncError=a}(l=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(u){u.Uninitialized="uninitialized",u.Idle="idle",u.Syncing="syncing",u.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(u){u[u.None=0]="None",u[u.Added=1]="Added",u[u.Modified=2]="Modified",u[u.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(u){u.Preview="preview",u.Conflict="conflict",u.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(u){return`sync.enable.${u}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(u,a){if(u.scheme!==e.USER_DATA_SYNC_SCHEME)return u=u.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,r.isEqualOrParent)(u,(0,r.joinPath)(a.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[239],se([0,1,31,26]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(b,P,I,E,w){if(!P)return{remote:Object.keys(b).length>0?b:null,local:{added:{},removed:[],updated:{}}};const p=T(b,P);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=I?T(I,P):{added:Object.keys(P).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},d=I?T(I,b):{added:Object.keys(b).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=R.deepClone(P),m=!I;for(const g of d.added.values())g!==r.SYNC_SERVICE_URL_TYPE&&m&&y.added.has(g)||(C[g]=b[g]);for(const g of d.updated.values())C[g]=b[g];for(const g of d.removed.values())E.unregistered.includes(g)||delete C[g];for(const g of y.added.values()){const l=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(g))continue;const f=b[g];f&&f.value===l.value||g===r.SYNC_SERVICE_URL_TYPE&&m&&d.added.has(g)||(f?S.updated[g]=l:S.added[g]=l)}for(const g of y.updated.values()){const l=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(g)||d.removed.has(g))continue;const f=b[g];f&&f.value===l.value||(S.updated[g]=l)}for(const g of y.removed.values()){if(E.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}d.updated.has(g)||d.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(C,P)?null:C}}e.merge=k;function T(b,P){const I=Object.keys(b),E=Object.keys(P),w=E.filter(d=>I.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),p=I.filter(d=>E.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),y=new Set;for(const d of I){if(p.has(d))continue;const S=b[d],C=P[d];R.equals(S,C)||y.add(d)}return{added:w,removed:p,updated:y}}function A(b,P){const{added:I,removed:E,updated:w}=T(b,P);return I.size===0&&E.size===0&&w.size===0}}),define(ne[240],se([0,1,18,35,75,52,31,59,26]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function I(a,h,v){let D=[];v?D=w(v):D=E(h);const M=[],F=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(D))for(const O of D)O.startsWith("-")?F.push(O.substring(1)):M.push(O);return(0,R.distinct)([...a,...M].filter(O=>F.indexOf(O)===-1))}e.getIgnoredSettings=I;function E(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const h=(0,r.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function p(a,h){const v=(0,r.parse)(a)||{};let D="{}";for(const M of Object.keys(v)){const F=(0,k.setProperty)(D,[M],v[M],h);D=(0,k.applyEdits)(D,F)}return D}e.removeComments=p;function y(a,h,v,D){if(v.length){const M=u(h),F=(0,r.parse)(h)||{},O=(0,r.parse)(a);if(!O)return a;const L=[];for(const N of v){const $=F[N],V=O[N];$===void 0?a=b.edit(a,[N],void 0,D):V!==void 0?a=b.edit(a,[N],$,D):L.push(n(N,M))}L.sort((N,$)=>N.startOffset-$.startOffset),L.forEach(N=>a=g(N.setting.key,h,a,D))}return a}e.updateIgnoredSettings=y;function d(a,h,v,D,M,F){const O=y(a,h,D,F),L=v!==O,N=v!==h;if(!L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(N&&!L)return{conflictsSettings:[],localContent:y(h,a,D,F),remoteContent:null,hasConflicts:!1};if(v===null&&C(a)){const j=S(a,h,D)?null:y(h,a,D,F);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let $=a,V=h;const J=(0,r.parse)(a),H=(0,r.parse)(h),G=v?(0,r.parse)(v):null,q=D.reduce((j,Z)=>(j.add(Z),j),new Set),x=m(J,H,q),Y=m(G,J,q),te=m(G,H,q),ce=new Map,z=new Set,B=j=>{z.add(j);const Z=M.filter(({key:oe})=>oe===j)[0];Z?($=b.edit($,[j],Z.value,F),V=b.edit(V,[j],Z.value,F)):ce.set(j,{key:j,localValue:J[j],remoteValue:H[j]})};for(const j of Y.removed.values())te.updated.has(j)?B(j):V=b.edit(V,[j],void 0,F);for(const j of te.removed.values())z.has(j)||(Y.updated.has(j)?B(j):$=b.edit($,[j],void 0,F));for(const j of Y.updated.values())z.has(j)||(te.updated.has(j)?x.updated.has(j)&&B(j):V=b.edit(V,[j],J[j],F));for(const j of te.updated.values())z.has(j)||(Y.updated.has(j)?x.updated.has(j)&&B(j):$=b.edit($,[j],H[j],F));for(const j of Y.added.values())z.has(j)||(te.added.has(j)?x.updated.has(j)&&B(j):V=g(j,$,V,F));for(const j of te.added.values())z.has(j)||(Y.added.has(j)?x.updated.has(j)&&B(j):$=g(j,V,$,F));const _=ce.size>0||!S($,V,D),U=_||!S($,a,[]),W=_||!S(V,h,[]);return{localContent:U?$:null,remoteContent:W?V:null,conflictsSettings:[...ce.values()],hasConflicts:_}}e.merge=d;function S(a,h,v){if(a===h)return!0;const D=(0,r.parse)(a),M=(0,r.parse)(h),F=v.reduce((N,$)=>(N.add($),N),new Set),O=u(a).filter(N=>!(N.setting&&F.has(N.setting.key))),L=u(h).filter(N=>!(N.setting&&F.has(N.setting.key)));if(O.length!==L.length)return!1;for(let N=0;N<O.length;N++){const $=O[N],V=L[N];if($.setting&&V.setting){if($.setting.key!==V.setting.key||!A.equals(D[$.setting.key],M[$.setting.key]))return!1}else if(!$.setting&&!V.setting){if($.value!==V.value)return!1}else return!1}return!0}e.areSame=S;function C(a){return a?u(a).length===0:!0}e.isEmpty=C;function m(a,h,v){const D=a?Object.keys(a).filter(N=>!v.has(N)):[],M=Object.keys(h).filter(N=>!v.has(N)),F=M.filter(N=>D.indexOf(N)===-1).reduce((N,$)=>(N.add($),N),new Set),O=D.filter(N=>M.indexOf(N)===-1).reduce((N,$)=>(N.add($),N),new Set),L=new Set;if(a)for(const N of D){if(O.has(N))continue;const $=a[N],V=h[N];A.equals($,V)||L.add(N)}return{added:F,removed:O,updated:L}}function g(a,h,v,D){const M=(0,r.parse)(h),F=u(h),O=u(v),L=l(a,F,O);return f(v,a,M[a],L,O,D)}e.addSetting=g;function l(a,h,v){const D=h.findIndex(F=>F.setting?.key===a),M=h[D-1];if(M){if(M.setting){const O=n(M.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!0}}else{const O=s(D,h);if(O){const L=n(O.setting.key,v);if(L){const N=t(v.indexOf(L),v),$=i(h,O,h[D]);if(N){const V=i(v,L,N),J=o($,V);return J?{index:v.indexOf(J),insertAfter:!0}:{index:v.indexOf(N),insertAfter:!1}}else{const V=i(v,L,v[v.length-1]),J=o($,V);return J?{index:v.indexOf(J),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const F=h[D+1];if(F)if(F.setting){const O=n(F.setting.key,v);if(O)return{index:v.indexOf(O),insertAfter:!1}}else{const O=t(D,h);if(O){const L=n(O.setting.key,v);if(L){const N=s(v.indexOf(L),v),$=i(h,h[D],O);if(N){const V=i(v,N,L),J=o($.reverse(),V.reverse());return J?{index:v.indexOf(J),insertAfter:!1}:{index:v.indexOf(N),insertAfter:!0}}else{const V=i(v,v[0],L),J=o($.reverse(),V.reverse());return J?{index:v.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function f(a,h,v,D,M,F){let O;return D.index===-1?O=(0,k.setProperty)(a,[h],v,F):O=c(a,h,v,D,M,F).map(L=>(0,k.withFormatting)(a,L,F)[0]),(0,k.applyEdits)(a,O)}function c(a,h,v,D,M,F){const O=`${JSON.stringify(h)}: ${JSON.stringify(v)}`,L=(0,T.getEOL)(F,a),N=M[D.index];if(D.insertAfter){const $=[];if(N.setting)$.push({offset:N.endOffset,length:0,content:","+O});else{const V=t(D.index,M),J=s(D.index,M),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const G=H!==void 0&&H>N.endOffset;$.push({offset:G?H+1:N.endOffset,length:0,content:V?L+O+",":L+O})}return $}else{if(N.setting)return[{offset:N.startOffset,length:0,content:O+","}];const $=(M[D.index-1]&&!M[D.index-1].setting?L:"")+O+(t(D.index,M)?",":"")+L;return[{offset:N.startOffset,length:0,content:$}]}}function n(a,h){return h.filter(v=>v.setting?.key===a)[0]}function s(a,h){for(let v=a-1;v>=0;v--)if(h[v].setting)return h[v]}function t(a,h){for(let v=a+1;v<h.length;v++)if(h[v].setting)return h[v]}function i(a,h,v){const D=a.indexOf(h),M=a.indexOf(v);return a.filter((F,O)=>D<O&&O<M)}function o(a,h){if(a.length&&h.length){let v=0;for(;v<h.length&&v<a.length;v++)if(a[v].value!==h[v].value)return h[v-1];return h[v-1]}}function u(a){const h=[];let v=-1,D,M;const F={onObjectBegin:O=>{v++},onObjectProperty:(O,L,N)=>{v===0&&(D=L,M=O)},onObjectEnd:(O,L)=>{v--,v===0&&h.push({startOffset:D,endOffset:O+L,value:a.substring(D,O+L),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(O,L)=>{v++},onArrayEnd:(O,L)=>{v--,v===0&&h.push({startOffset:D,endOffset:O+L,value:a.substring(D,O+L),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(O,L,N)=>{v===0&&h.push({startOffset:D,endOffset:L+N,value:a.substring(D,L+N),setting:{key:M,commaOffset:void 0}})},onSeparator:(O,L,N)=>{if(v===0&&O===","){let $=h.length-1;for(;$>=0&&!h[$].setting;$--);const V=h[$];V&&h.splice($,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:L}})}},onComment:(O,L)=>{v===0&&h.push({startOffset:O,endOffset:O+L,value:a.substring(O,O+L)})}};return(0,r.visit)(a,F),h}}),define(ne[70],se([0,1,3,2,5,26]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends r.Disposable{constructor(P,I){super(),this.userDataSyncStoreService=P,this.logService=I,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};A=pe([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[241],se([0,1,6,16,61,2,17,19,15,13,26]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(y,d,S,C){super(),this.environmentService=y,this.fileService=d,this.configurationService=S,this.logService=C,E.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(d);return S.children?S.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(y,d){if(!d){const S=await this.getAllRefs(y);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),C=(0,A.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,r.VSBuffer.fromString(d))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const C=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(f=>Date.now()-this.getCreationTime(f)>m);const l=C.length-g.length;l<10&&(g=g.slice(10-l)),await R.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};w=pe([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,b.IConfigurationService),K(3,E.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(ne[242],se([0,1,2,7]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(p){this.service=p}listen(p,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(p,y,d){switch(y){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(p){this.service=p}listen(p,y){throw new Error(`Event not found: ${y}`)}call(p,y,d){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=A;class b{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(p,y,d){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=b;class P{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(p,y,d){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class I{constructor(p){this.service=p}listen(p,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(p,y,d){switch(y){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class E extends R.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:r.URI.revive(p.url),type:p.type,defaultUrl:r.URI.revive(p.defaultUrl),insidersUrl:r.URI.revive(p.insidersUrl),stableUrl:r.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(ne[243],se([0,1,15,8]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends r.AbstractLogger{constructor(A,b){super(),this.logger=this._register(A.createLogger(b.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...b){this.logger.trace(A,...b)}debug(A,...b){this.logger.debug(A,...b)}info(A,...b){this.logger.info(A,...b)}warn(A,...b){this.logger.warn(A,...b)}error(A,...b){this.logger.error(A,...b)}critical(A,...b){this.logger.critical(A,...b)}flush(){this.logger.flush()}};k=pe([K(0,r.ILoggerService),K(1,R.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[244],se([0,1,3,2,7,26]),function(X,e,R,r,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(E,w){this.service=E,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(E,w){switch(w){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${w}`)}async call(E,w,p){try{return await this._call(E,w,p)}catch(y){throw this.logService.error(y),y}}async _call(E,w,p){switch(w){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],k.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(w.startsWith("manualSync/")){const y=w.substring(11),d=p[0],S=this.getManualSyncTask(d);switch(p=p.slice(1),y){case"preview":return S.preview();case"accept":return S.accept(k.URI.revive(p[0]),p[1]);case"merge":return S.merge(k.URI.revive(p[0]));case"discard":return S.discard(k.URI.revive(p[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(E){const w=this.manualSyncTasks.get(this.createKey(E));if(!w)throw new Error(`Manual sync taks not found: ${E}`);return w.manualSyncTask}async createManualSyncTask(){const E=new r.DisposableStore,w=E.add(await this.service.createManualSyncTask());return E.add(w.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:w.id,data:p}))),this.manualSyncTasks.set(this.createKey(w.id),{manualSyncTask:w,disposables:E}),{id:w.id,manifest:w.manifest,status:w.status}}disposeManualSyncTask(E){E.dispose();const w=this.createKey(E.id);this.manualSyncTasks.get(w)?.disposables.dispose(),this.manualSyncTasks.delete(w)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=A;class b extends r.Disposable{constructor(E){super(),this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,p,y){return E.call(w,p,y).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(w,p){return E.listen(w,p)}},this.channel.call("_getInitialData").then(([w,p,y])=>{this.updateStatus(w),this.updateConflicts(p),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(([p,y])=>[p,T.UserDataSyncError.toUserDataSyncError(y)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:w,status:p}=await this.channel.call("createManualSyncTask"),y=this,d=new P(E,w,p,{async call(S,C,m){return y.channel.call(`manualSync/${S}`,[E,...Array.isArray(C)?C:[C]],m)},listen(S,C){return R.Event.map(R.Event.filter(y.channel.listen(`manualSync/${S}`,C),m=>!d.isDiposed()&&m.manualSyncTaskId===E),m=>m.data)}});return d}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,w,p,y){return this.channel.call("accept",[E,w,p,y])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:y})=>({created:p,uri:k.URI.revive(y)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:y})=>({created:p,uri:k.URI.revive(y)}))}async getAssociatedResources(E,w){return(await this.channel.call("getAssociatedResources",[E,w])).map(({resource:y,comparableResource:d})=>({resource:k.URI.revive(y),comparableResource:k.URI.revive(d)}))}async getMachineId(E,w){return this.channel.call("getMachineId",[E,w])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([w,p])=>[w,p.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class P extends r.Disposable{constructor(E,w,p,y){super(),this.id=E,this.manifest=w,this._disposed=!1,this._status=p;const d=this;this.channel={async call(S,C,m){try{const g=await y.call(S,C,m);return d.isDiposed()||(d._status=await y.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(S,C){return y.listen(S,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,w){const p=await this.channel.call("accept",[E,w]);return this.deserializePreviews(p)}async merge(E){const w=await this.channel.call("merge",[E]);return this.deserializePreviews(w)}async discard(E){const w=await this.channel.call("discard",[E]);return this.deserializePreviews(w)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([w,p])=>[w,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource),acceptedResource:k.URI.revive(y.acceptedResource)}))}])}}}),define(ne[245],se([0,1,6,3,2]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:P,getActiveWindowId:I}){super(),this.disposables=this._register(new k.DisposableStore),r.Event.latch(r.Event.any(b,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>I()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[246],se([0,1,164,9,34,17,7,5,20]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function I(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function E(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}e.toWorkspaceIdentifier=E;function w(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=w;function p(t){const i=t;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=p;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function S(t){const i=t;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(i,o,u,a,h){this._id=i,this._transient=u,this._configuration=a,this._ignorePathCasing=h,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class m{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function g(t){return new m({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const l=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(t,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,i.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function c(t){let i;return A.URI.isUri(t)?i=t:i=t.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=c;function n(t,i){return!f(t,i)&&!c(t)}e.isSavedWorkspace=n;function s(t){return(typeof t=="string"?(0,r.extname)(t):(0,T.extname)(t))===l}e.hasWorkspaceFileExtension=s}),define(ne[28],se([0,1,62,3,2,17,14,7,157,15,13,5,8,246,34,33,6,30,24]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function l(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&b.URI.isUri(t.location)&&b.URI.isUri(t.globalStorageHome)&&b.URI.isUri(t.settingsResource)&&b.URI.isUri(t.keybindingsResource)&&b.URI.isUri(t.tasksResource)&&b.URI.isUri(t.snippetsHome)&&((0,A.isUndefined)(t.extensionsResource)||b.URI.isUri(t.extensionsResource)))}e.isUserDataProfile=l,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function f(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,location:b.URI.revive(s.location).with({scheme:t}),globalStorageHome:b.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:b.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:b.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:b.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:b.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:b.URI.revive(s.extensionsResource)?.with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(s,t,i,o){return{id:(0,R.hash)(t.path).toString(16),name:s,location:t,isDefault:!1,globalStorageHome:(0,T.joinPath)(t,"globalStorage"),settingsResource:(0,T.joinPath)(t,"settings.json"),keybindingsResource:(0,T.joinPath)(t,"keybindings.json"),tasksResource:(0,T.joinPath)(t,"tasks.json"),snippetsHome:(0,T.joinPath)(t,"snippets"),extensionsResource:(0,T.joinPath)(t,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:i,isTransient:o}}e.toUserDataProfile=c;let n=class extends k.Disposable{constructor(t,i,o,u){super(),this.environmentService=t,this.fileService=i,this.uriIdentityService=o,this.logService=u,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new d.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>c(a.name,a.location,a.useDefaultFlags)):[];let i;const o=new d.ResourceMap,u=c((0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...u,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?u.extensionsResource:void 0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[h,v]of Object.entries(a.workspaces)){const D=b.URI.parse(h),M=b.URI.parse(v),F=t.find(O=>this.uriIdentityService.extUri.isEqual(O.location,M));F&&o.set(D,F)}if(a.emptyWindow){const h=b.URI.parse(a.emptyWindow);i=t.find(v=>this.uriIdentityService.extUri.isEqual(v.location,h))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:i}}return this._profilesObject}async createTransientProfile(t){const i="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(i)}\\s(\\d+)`);let u=0;for(const h of this.profiles){const v=o.exec(h.name),D=v?parseInt(v[1]):0;u=D>u?D:u}const a=`${i} ${u+1}`;return this.createProfile(a,void 0,t,!0)}async createProfile(t,i,o,u){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,i,u);return o&&await this.setProfileForWorkspace(o,a),a}async doCreateProfile(t,i,o){let u=this.profileCreationPromises.get(t);return u||(u=(async()=>{try{const a=this.profiles.find(D=>D.name===t);if(a)return a;const h=c(t,(0,T.joinPath)(this.profilesHome,(0,R.hash)((0,m.generateUuid)()).toString(16)),i,o);await this.fileService.createFolder(h.location);const v=[];return this._onWillCreateProfile.fire({profile:h,join(D){v.push(D)}}),await C.Promises.settled(v),this.updateProfiles([h],[],[]),h}finally{this.profileCreationPromises.delete(t)}})(),this.profileCreationPromises.set(t,u)),u}async updateProfile(t,i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let u=this.profiles.find(a=>a.id===t.id);if(!u)throw new Error(`Profile '${t.name}' does not exist`);return u=c(i,u.location,o),this.updateProfiles([],[],[u]),u}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const i=this.profiles.find(u=>u.id===t.id);if(!i)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:i,join(u){o.push(u)}}),await C.Promises.settled(o),i.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const u of[...this.profilesObject.workspaces.keys()])i.id===this.profilesObject.workspaces.get(u)?.id&&this.profilesObject.workspaces.delete(u);this.updateStoredProfileAssociations(),this.updateProfiles([],[i],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(i.location,{recursive:!0})}catch(u){this.logService.error(u)}}getOrSetProfileForWorkspace(t,i=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=i,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,i){this.setProfileForWorkspaceSync(t,i)}setProfileForWorkspaceSync(t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(u=>u.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,i)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(i=>i.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,i.resource))).map(i=>this.fileService.del(i.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(i=>!this.isProfileAssociatedToWorkspace(i));await Promise.allSettled(t.map(i=>this.removeProfile(i)))}getProfileForWorkspace(t){const i=this.getWorkspace(t);return b.URI.isUri(i)?this.transientProfilesObject.workspaces.get(i)??this.profilesObject.workspaces.get(i):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,y.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,y.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(i=>this.uriIdentityService.extUri.isEqual(i.location,t.location)))}updateProfiles(t,i,o){const u=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let h of u)h.isDefault||i.some(v=>h.id===v.id)||(h=o.find(v=>h.id===v.id)??h,h.isTransient?this.transientProfilesObject.profiles.push(h):a.push({location:h.location,name:h.name,useDefaultFlags:h.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,i,o)}triggerProfilesChanges(t,i,o){this._onDidChangeProfiles.fire({added:t,removed:i,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,i,o){o=i?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const u=this.getWorkspace(t),a=o?this.transientProfilesObject:this.profilesObject;b.URI.isUri(u)?(a.workspaces.delete(u),i&&a.workspaces.set(u,i)):a.emptyWindow=i,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,u]of this.profilesObject.workspaces.entries())t[o.toString()]=u.location.toString();const i=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:i}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=pe([K(0,I.IEnvironmentService),K(1,E.IFileService),K(2,S.IUriIdentityService),K(3,p.ILogService)],n),e.UserDataProfilesService=n}),define(ne[247],se([0,1,6,2,28]),function(X,e,R,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends r.Disposable{constructor(b){super(),this._register(new R.RunOnceScheduler(()=>{b.cleanUp()},10*1e3)).schedule()}};T=pe([K(0,k.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(ne[248],se([0,1,18,6,21,10,3,2,4,7,139,29,32,43,8,25,22,28]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends b.Disposable{constructor(t,i,o,u,a){super(),this.galleryService=t,this.telemetryService=i,this.logService=o,this.productService=u,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(h=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const i=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,i))}async installFromGallery(t,i={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,i)}catch(o){throw c(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,i={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,i)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:i,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,i,o){const u=M=>`${p.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!I.URI.isUri(i)){const M=this.installingExtensions.get(u(i));if(M){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:F}=await M.waitUntilTaskIsFinished();return F}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],h=[],v=this.createInstallExtensionTask(t,i,o);I.URI.isUri(i)||this.installingExtensions.set(u(i),v),this._onInstallExtension.fire({identifier:v.identifier,source:i,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",v.identifier.id),a.push({task:v,manifest:t});let D=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(v.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:O,manifest:L}of F){D=D||!!L.extensionDependencies?.some($=>(0,p.areSameExtensions)({id:$},v.identifier));const N=u(O);if(this.installingExtensions.has(N))this.logService.info("Extension is already requested to install",O.identifier.id);else{const $=this.createInstallExtensionTask(L,O,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(N,$),this._onInstallExtension.fire({identifier:$.identifier,source:O,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",$.identifier.id),a.push({task:$,manifest:L})}}}catch(F){if(I.URI.isUri(v.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",v.identifier.id,F.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",v.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),F}const M=a.reduce((F,{task:O,manifest:L})=>(F.set(O.identifier.id.toLowerCase(),{task:O,manifest:L}),F),new Map);for(;M.size;){let F;const O=[...M.values()].filter(({manifest:L})=>!L.extensionDependencies?.some(N=>M.has(N.toLowerCase())));O.length?F=M.size===1?O:O.filter(({task:L})=>!(L===v&&!D)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:L})=>L.identifier.id)),F=[...M.values()]),await this.joinAllSettled(F.map(async({task:L})=>{const N=new Date().getTime();try{const{local:$}=await L.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall($,L.source,o,k.CancellationToken.None))),!I.URI.isUri(L.source)){const V=L.operation===3,J=V?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(c(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,durationSinceUpdate:J}),P.isWeb&&L.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}h.push({local:$,identifier:L.identifier,operation:L.operation,source:L.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw I.URI.isUri(L.source)||c(this.telemetryService,L.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,error:$}),this.logService.error("Error while installing the extension:",L.identifier.id),$}finally{M.delete(L.identifier.id.toLowerCase())}}))}return h.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(h),h.filter(({identifier:F})=>(0,p.areSameExtensions)(F,v.identifier))[0].local}catch(M){if(a.forEach(({task:F})=>F.cancel()),h.length)try{const F=await Promise.allSettled(h.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let O=0;O<F.length;O++){const L=F[O],{identifier:N}=h[O];L.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,T.getErrorMessage)(L.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(F),h.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(a.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const{task:M}of a)if(!I.URI.isUri(M.source)){const F=u(M.source);this.installingExtensions.delete(F)||this.logService.warn("Installation task is not found in the cache",F)}}}async joinAllSettled(t){const i=[],o=[],u=await Promise.allSettled(t);for(const a of u)a.status==="fulfilled"?i.push(a.value):o.push(a.reason);if(o.length)throw l(o);return i}async getAllDepsAndPackExtensionsToInstall(t,i,o,u,a){if(!this.galleryService.isEnabled())return[];let h=await this.getInstalled(void 0,a);const v=[t,...h.map(F=>F.identifier)],D=[],M=async(F,O)=>{const L=O.extensionDependencies||[],N=[...L];if(O.extensionPack){const $=o?h.find(V=>(0,p.areSameExtensions)(V.identifier,F)):void 0;for(const V of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:V}))||N.every(J=>!(0,p.areSameExtensions)({id:J},{id:V}))&&N.push(V)}if(N.length){const $=[...v,...D.map(J=>J.gallery.identifier)],V=N.filter(J=>$.every(H=>!(0,p.areSameExtensions)(H,{id:J})));if(V.length){const J=await this.galleryService.getExtensions(V.map(H=>({id:H,preRelease:u})),k.CancellationToken.None);for(const H of J){if($.find(x=>(0,p.areSameExtensions)(x,H.identifier)))continue;const G=L.some(x=>(0,p.areSameExtensions)({id:x},H.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(H,!1,u)}catch(x){if(x instanceof w.ExtensionManagementError&&x.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw x}D.push({gallery:q.extension,manifest:q.manifest}),await M(q.extension.identifier,q.manifest)}}}};return await M(t,i),h=await this.getInstalled(void 0,a),D.filter(F=>!h.some(O=>(0,p.areSameExtensions)(O.identifier,F.gallery.identifier)))}async checkAndGetCompatibleVersion(t,i,o){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,p.areSameExtensions)(t.identifier,v)))throw new w.ExtensionManagementError(E.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const v=await this.getTargetPlatform();throw new w.ExtensionManagementError(E.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(v)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,i,o);if(a){if(o&&!i&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(E.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(E.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const h=await this.galleryService.getManifest(a,k.CancellationToken.None);if(h===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async getCompatibleVersion(t,i,o){const u=await this.getTargetPlatform();let a=null;return!i&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,u)&&(a=t),a||(i?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,u)),a}async uninstallExtension(t,i){const o=M=>`${M.id.toLowerCase()}${i.versionOnly?`-${t.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(o(t.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),u.waitUntilTaskIsFinished();const a=(M,F)=>{const O=this.createUninstallExtensionTask(M,F);return this.uninstallingExtensions.set(o(O.extension.identifier),O),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped}),O},h=(M,F)=>{F?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),c(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(M),error:F}),this._onDidUninstallExtension.fire({identifier:M.identifier,version:M.manifest.version,error:F?.code,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped})},v=[],D=[];try{v.push(a(t,i));const M=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,M);for(const O of F)this.uninstallingExtensions.has(o(O.identifier))?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):v.push(a(O,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(v.map(F=>F.extension),M,t),await this.joinAllSettled(v.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(F.extension,i,k.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}h(F.extension)}catch(O){const L=O instanceof w.ExtensionManagementError?O:new w.ExtensionManagementError((0,T.getErrorMessage)(O),w.ExtensionManagementErrorCode.Internal);throw h(F.extension,L),L}finally{D.push(F)}}))}catch(M){const F=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,T.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const O of v){try{O.cancel()}catch{}D.includes(O)||h(O.extension,F)}throw F}finally{for(const M of v)this.uninstallingExtensions.delete(o(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(t,i,o){for(const u of t){const a=this.getDependents(u,i);if(a.length){const h=a.filter(v=>!t.some(D=>(0,p.areSameExtensions)(D.identifier,v.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(u,h,o))}}}getDependentsErrorMessage(t,i,o){return o===t?i.length===1?E.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(9,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(10,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(t,i,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const a=i.filter(v=>!v.isBuiltin&&u.some(D=>(0,p.areSameExtensions)({id:D},v.identifier))),h=[];for(const v of a)h.push(...this.getAllPackExtensionsToUninstall(v,i,o));return[...a,...h]}return[]}getDependents(t,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,i,o){return o.profileLocation&&(0,y.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,i,o)}createUninstallExtensionTask(t,i){return i.profileLocation&&t.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,i)}};g=pe([K(0,w.IExtensionGalleryService),K(1,C.ITelemetryService),K(2,d.ILogService),K(3,S.IProductService),K(4,m.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function l(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((i,o)=>new Error(`${i.message}${i.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=l;function f(s){if(s instanceof w.ExtensionManagementError)return s;const t=new w.ExtensionManagementError(s.message,w.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function c(s,t,{extensionData:i,duration:o,error:u,durationSinceUpdate:a}){const h=u?u instanceof w.ExtensionManagementError?u.code:w.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...i,success:!u,duration:o,errorcode:h,durationSinceUpdate:a})}e.reportTelemetry=c;class n{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((i,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(ne[71],se([0,1,18,6,31,16,10,35,121,2,20,9,4,17,55,80,14,7,142,15,32,43,65,13,5,8,25,3,63,48,28,33,170]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n,s,t,i,o,u,a,h,v,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(H){function G(q,x){if(q===x)return!0;const Y=Object.keys(q),te=new Set;for(const ce of Object.keys(x))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(q[ce]!==x[ce])return!1;te.delete(ce)}return te.size===0}H.equals=G})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends I.Disposable{constructor(G,q,x,Y,te,ce,z,B,_,U,W){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=q,this.extensionsControlLocation=x,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=z,this.logService=B,this.environmentService=_,this.productService=U,this.instantiationService=W,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,y.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,y.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,q,x){const[Y,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(q)]),ce=x?await this.scanExtensionsUnderDevelopment(G,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const q=[];q.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),q.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[x,Y]=await Promise.all(q);return this.applyScanOptions([...x,...Y],0,G,!1)}async scanUserExtensions(G){this.logService.trace("Started scanning user extensions");const q=await this.createExtensionScannerInput(G.profileLocation??this.userExtensionsLocation,!!G.profileLocation,1,!G.includeUninstalled,G.language);let Y=await(G.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return Y=await this.applyScanOptions(Y,1,G,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(G,q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===E.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,G.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(z=>(z.type=q.find(B=>(0,f.areSameExtensions)(B.identifier,z.identifier))?.type??z.type,this.extensionsScanner.validate(z,te)))}))).flat();return this.applyScanOptions(x,"development",G,!0)}return[]}async scanExistingExtension(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!x.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,q,x){const Y=await this.createExtensionScannerInput(G,!1,q,!0,x.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,q,x,!0)}async scanMetadata(G){const q=(0,y.joinPath)(G,"package.json"),x=(await this.fileService.readFile(q)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(G,q){const x=(0,y.joinPath)(G,"package.json"),Y=(await this.fileService.readFile(x)).value.toString(),te=JSON.parse(Y);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,te.__metadata={...te.__metadata,...q},await this.fileService.writeFile((0,y.joinPath)(G,"package.json"),T.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(G,q,x,Y){return x.includeAllVersions||(G=this.dedupExtensions(q===0?G:void 0,q===1?G:void 0,q==="development"?G:void 0,await this.getTargetPlatform(),Y)),x.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,ce)=>{const z=w.basename(te.location.fsPath),B=w.basename(ce.location.fsPath);return z<B?-1:z>B?1:0})}dedupExtensions(G,q,x,Y,te){const ce=(B,_,U)=>{if(B.isValid&&!_.isValid)return!1;if(B.isValid===_.isValid){if(te&&d.gt(B.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${B.location.path} with version ${B.manifest.version}`),!1;if(d.eq(B.manifest.version,_.manifest.version)){if(B.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${B.location.path} with same version`),!1;if(B.targetPlatform===Y)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return U?this.logService.warn(`Overwriting user extension ${B.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${B.location.path} with ${_.location.path}.`),!0},z=new Map;return G?.forEach(B=>{const _=c.ExtensionIdentifier.toKey(B.identifier.id),U=z.get(_);(!U||ce(U,B,!1))&&z.set(_,B)}),q?.forEach(B=>{const _=c.ExtensionIdentifier.toKey(B.identifier.id),U=z.get(_);if(!U&&G&&B.type===0){this.logService.debug(`Skipping obsolete system extension ${B.location.path}.`);return}(!U||ce(U,B,!1))&&z.set(_,B)}),x?.forEach(B=>{const _=c.ExtensionIdentifier.toKey(B.identifier.id),U=z.get(_);(!U||ce(U,B,!0))&&z.set(_,B),z.set(_,B)}),[...z.values()]}async scanDefaultSystemExtensions(G,q){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,q),te=await(G&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(G,q){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=q?await this.getBuiltInExtensionControl():{},te=[],ce=m.URI.file(w.normalize(w.join(E.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions")));for(const B of x){const _=Y[B.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":te.push((0,y.joinPath)(ce,B.name));break;default:te.push(m.URI.file(_));break}}const z=await Promise.all(te.map(async B=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(B,!1,0,!0,G))));return this.logService.trace("Scanned dev system extensions:",z.length),(0,R.coalesce)(z)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,q,x,Y,te,ce=!0){const z=await this.getTranslations(te??p.language),B=await this.getMtime(G),_=q?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,U=_?await this.getMtime(_):void 0;return new L(G,B,_,U,q,x,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,z)}async getMtime(G){try{const q=await this.fileService.stat(G);if(typeof q.mtime=="number")return q.mtime}catch{}}};O=pe([K(4,v.IUserDataProfilesService),K(5,h.IExtensionsProfileScannerService),K(6,s.IFileService),K(7,i.ILogService),K(8,l.IEnvironmentService),K(9,o.IProductService),K(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class L{constructor(G,q,x,Y,te,ce,z,B,_,U,W,j,Z,oe){this.location=G,this.mtime=q,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=z,this.validate=B,this.productVersion=_,this.productDate=U,this.productCommit=W,this.devMode=j,this.language=Z,this.translations=oe}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,q){return(0,y.isEqual)(G.location,q.location)&&G.mtime===q.mtime&&(0,y.isEqual)(G.applicationExtensionslocation,q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&G.profile===q.profile&&G.type===q.type&&G.excludeObsolete===q.excludeObsolete&&G.validate===q.validate&&G.productVersion===q.productVersion&&G.productDate===q.productDate&&G.productCommit===q.productCommit&&G.devMode===q.devMode&&G.language===q.language&&F.equals(G.translations,q.translations)}}let N=class extends I.Disposable{constructor(G,q,x,Y,te){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=q,this.uriIdentityService=x,this.fileService=Y,this.logService=te}async scanExtensions(G){const q=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let x={};if(G.excludeObsolete&&G.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(Y)}catch{}return(0,C.isEmptyObject)(x)?q:q.filter(Y=>!x[f.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(G){const q=await this.fileService.resolve(G.location);if(!q.children?.length)return[];const x=await Promise.all(q.children.map(async Y=>{if(!Y.isDirectory||G.type===1&&(0,y.basename)(Y.resource).indexOf(".")===0)return null;const te=new L(Y.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,R.coalesce)(x).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(G){let q=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){q=q.filter(Y=>!Y.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,G);q.push(...x)}return q}async scanExtensionsFromProfileResource(G,q,x){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(G);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(q(ce)){const z=new L(ce.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(z,ce.metadata)}return null}));return(0,R.coalesce)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,y.joinPath)(G.location,"package.json"))){const q=await this.scanExtension(G);return q?[q]:[]}else return await this.scanExtensions(G)}catch(q){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,A.getErrorMessage)(q)),[]}}async scanExtension(G,q){try{let x=await this.scanExtensionManifest(G.location);if(x){x.publisher||(x.publisher=c.UNDEFINED_PUBLISHER),q=q??x.__metadata,delete x.__metadata;const Y=(0,f.getGalleryExtensionId)(x.publisher,x.name),te=q?.id?{id:Y,uuid:q.id}:{id:Y},ce=q?.isSystem?0:G.type,z=ce===0||!!q?.isBuiltin;x=await this.translateManifest(G.location,x,L.createNlsConfiguration(G));const B={type:ce,identifier:te,manifest:x,location:G.location,isBuiltin:z,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return G.validate?this.validate(B,G):B}}catch(x){G.type!==0&&this.logService.error(x)}return null}validate(G,q){let x=!0;const Y=(0,n.validateExtensionManifest)(q.productVersion,q.productDate,q.location,G.manifest,G.isBuiltin);for(const[te,ce]of Y)te===S.default.Error&&(x=!1,this.logService.error(this.formatMessage(q.location,ce)));return G.isValid=x,G.validations=Y,G}async scanExtensionManifest(G){const q=(0,y.joinPath)(G,"package.json");let x;try{x=(await this.fileService.readFile(q)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(G,(0,g.localize)(0,null,q.path,te.message))),null}let Y;try{Y=JSON.parse(x)}catch{const ce=[];(0,b.parse)(x,ce);for(const z of ce)this.logService.error(this.formatMessage(G,(0,g.localize)(1,null,q.path,z.offset,z.length,(0,P.getParseErrorMessage)(z.error))));return null}return(0,b.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(G,(0,g.localize)(2,null,q.path))),null):Y}async translateManifest(G,q,x){const Y=await this.getLocalizedMessages(G,q,x);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(B=>{this.logService.error(this.formatMessage(G,(0,g.localize)(3,null,Y.default?.path,(0,P.getParseErrorMessage)(B.error))))}),q;if((0,b.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(G,(0,g.localize)(4,null,Y.default?.path))),q;const z=Y.values||Object.create(null);return(0,M.localizeManifest)(q,z,ce)}catch{}return q}async getLocalizedMessages(G,q,x){const Y=(0,y.joinPath)(G,"package.nls.json"),te=(_,U)=>{U.forEach(W=>{this.logService.error(this.formatMessage(G,(0,g.localize)(5,null,_?.path,(0,P.getParseErrorMessage)(W.error))))})},ce=_=>{this.logService.error(this.formatMessage(G,(0,g.localize)(6,null,_?.path)))},z=`${q.publisher}.${q.name}`,B=x.translations[z];if(B)try{const _=m.URI.file(B),U=(await this.fileService.readFile(_)).value.toString(),W=[],j=(0,b.parse)(U,W);return W.length>0?(te(_,W),{values:void 0,default:Y}):(0,b.getNodeType)(j)!=="object"?(ce(_),{values:void 0,default:Y}):{values:j.contents?j.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let U;try{U=await this.findMessageBundles(G,x)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const W=(await this.fileService.readFile(U.localized)).value.toString(),j=[],Z=(0,b.parse)(W,j);return j.length>0?(te(U.localized,j),{values:void 0,default:U.original}):(0,b.getNodeType)(Z)!=="object"?(ce(U.localized),{values:void 0,default:U.original}):{values:Z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async resolveOriginalMessageBundle(G,q){if(G)try{const x=(await this.fileService.readFile(G)).value.toString();return(0,b.parse)(x,q)}catch{}}findMessageBundles(G,q){return new Promise((x,Y)=>{const te=ce=>{const z=(0,y.joinPath)(G,`package.nls.${ce}.json`);this.fileService.exists(z).then(B=>{B&&x({localized:z,original:(0,y.joinPath)(G,"package.nls.json")});const _=ce.lastIndexOf("-");_===-1?x({localized:(0,y.joinPath)(G,"package.nls.json"),original:null}):(ce=ce.substring(0,_),te(ce))})};if(q.devMode||q.pseudo||!q.language)return x({localized:(0,y.joinPath)(G,"package.nls.json"),original:null});te(q.language)})}formatMessage(G,q){return`[${G.path}]: ${q}`}};N=pe([K(1,h.IExtensionsProfileScannerService),K(2,D.IUriIdentityService),K(3,s.IFileService),K(4,i.ILogService)],N);let $=class extends N{constructor(G,q,x,Y,te,ce){super(q,x,Y,te,ce),this.cacheFile=G,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const q=await this.readExtensionCache();if(this.input=G,q&&q.input&&L.equals(q.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),q.result.map(Y=>(Y.location=m.URI.revive(Y.location),Y));const x=await super.scanExtensions(G);return await this.writeExtensionCache({input:G,result:x}),x}async readExtensionCache(){try{const G=await this.fileService.readFile(this.cacheFile),q=JSON.parse(G.value.toString());return{result:q.result,input:(0,a.revive)(q.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(G))}return null}async writeExtensionCache(G){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(G)))}catch(q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(q))}}async validateCache(){if(!this.input)return;const G=await this.readExtensionCache();if(!G)return;const q=G.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(x,q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([K(2,h.IExtensionsProfileScannerService),K(3,D.IUriIdentityService),K(4,s.IFileService),K(5,i.ILogService)],$);function V(H,G){const q=(0,f.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:q,identifier:new c.ExtensionIdentifier(q),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:G,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=V;class J extends O{constructor(G,q,x,Y,te,ce,z,B,_,U,W){super(G,q,(0,y.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(Y,c.MANIFEST_CACHE_FOLDER),te,ce,z,B,_,U,W),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const j=await this.fileService.readFile(m.URI.file(p.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[249],se([0,1,54,6,38,3,2,20,9,27,8,28]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends A.Disposable{constructor(d,S){super(),this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new r.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${C}`)))),I.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(d,S){const C=`vscode:${S}`;if(d.location.scheme===b.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[C]=="string"){const m=d.manifest.scripts[C].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${C} should be a node script`),null):{script:(0,P.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,S,C,m,g){return new Promise((l,f)=>{const c=this.start(d,S,C,g);let n;const s=t=>{n&&(clearTimeout(n),n=null),t?f(t):l(void 0)};c.on("error",t=>{s((0,k.toErrorMessage)(t)||"Unknown")}),c.on("exit",(t,i)=>{s(t?`post-${S} process exited with code ${t}`:void 0)}),m&&(n=setTimeout(()=>{n=null,c.kill(),f("timed out")},5e3))})}start(d,S,C,m){const g={silent:!0,execArgv:void 0},l=(0,R.fork)(d,[`--type=extension-post-${S}`,...C],g);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(l.stdout,"data"),c=T.Event.fromNodeEventEmitter(l.stderr,"data");f(t=>this.logService.info(m.identifier.id,m.manifest.version,`post-${S}`,t)),c(t=>this.logService.error(m.identifier.id,m.manifest.version,`post-${S}`,t));const n=T.Event.any(T.Event.map(f,t=>({data:`%c${t}`,format:[""]})),T.Event.map(c,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(m.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),l}getExtensionStoragePath(d){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};p=pe([K(0,w.IUserDataProfilesService),K(1,E.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[250],se([0,1,7,15,48,71,13,5,8,25,28]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends T.NativeExtensionsScannerService{constructor(y,d,S,C,m,g,l){super(R.URI.file(m.builtinExtensionsPath),R.URI.file(m.extensionsPath),m.userHome,R.URI.file(m.userDataPath),y,d,S,C,m,g,l)}};w=pe([K(0,E.IUserDataProfilesService),K(1,k.IExtensionsProfileScannerService),K(2,A.IFileService),K(3,P.ILogService),K(4,r.INativeEnvironmentService),K(5,I.IProductService),K(6,b.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(ne[23],se([0,1,6,3,2,190,14,86,5,28]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(l={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super(),this.options=l,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,f){if(f===E){switch(l){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:l})}else this._onDidChangeValue.fire({scope:l,key:f,target:this.getKeyTargets(l)[f]})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,f,c){return this.getStorage(f)?.get(l,c)}getBoolean(l,f,c){return this.getStorage(f)?.getBoolean(l,c)}getNumber(l,f,c){return this.getStorage(f)?.getNumber(l,c)}store(l,f,c,n){if((0,A.isUndefinedOrNull)(f)){this.remove(l,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,c,n),this.getStorage(c)?.set(l,f)})}remove(l,f){this.withPausedEmitters(()=>{this.updateKeyTarget(l,f,void 0),this.getStorage(f)?.delete(l)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,f){const c=[],n=this.getKeyTargets(l);for(const s of Object.keys(n))n[s]===f&&c.push(s);return c}updateKeyTarget(l,f,c){const n=this.getKeyTargets(f);typeof c=="number"?n[l]!==c&&(n[l]=c,this.getStorage(f)?.set(E,JSON.stringify(n))):typeof n[l]=="number"&&(delete n[l],this.getStorage(f)?.set(E,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(l){switch(l){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(l){const f=this.get(E,l);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(l){return this.getBoolean(e.IS_NEW_KEY,l)===!0}async flush(l=w.NONE){this._onWillSaveState.fire({reason:l});const f=this.getStorage(-1),c=this.getStorage(0),n=this.getStorage(1);switch(l){case w.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(l,f,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(l,f){return this.emitWillSaveState(w.NONE),(0,I.isUserDataProfile)(l)?this.switchToProfile(l,f):this.switchToWorkspace(l,f)}canSwitchProfile(l,f){return!(l.id===f.id||S(f)&&S(l))}switchData(l,f,c,n){this.withPausedEmitters(()=>{if(n)for(const[s,t]of l)f.set(s,t);else{const s=new Set;for(const[t,i]of l)s.add(t),f.get(t)!==i&&this.emitDidChangeValue(c,t);for(const[t]of f.items)s.has(t)||this.emitDidChangeValue(c,t)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends d{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.profileStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l))),this._register(this.applicationStorage.onDidChangeStorage(l=>this.emitDidChangeValue(-1,l)))}getStorage(l){switch(l){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=C;async function m(g,l,f,c,n,s){const t=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,o=new Map;g.forEach((F,O)=>{i.set(O,F),o.set(O,t(F))});const u=new Map,a=new Map;l.forEach((F,O)=>{u.set(O,F),a.set(O,t(F))});const h=new Map,v=new Map;f.forEach((F,O)=>{h.set(O,F),v.set(O,t(F))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const D=[];if(i.forEach((F,O)=>{D.push({key:O,value:F})}),console.table(D),console.groupEnd(),console.log(o),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const F=[];u.forEach((O,L)=>{F.push({key:L,value:O})}),console.table(F),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const M=[];h.forEach((F,O)=>{M.push({key:O,value:F})}),console.table(M),console.groupEnd(),console.log(v)}e.logStorage=m}),define(ne[251],se([0,1,3,2,14,29,32,23]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends r.Disposable{constructor(w,p){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(w)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(p.onDidInstallExtensions(y=>y.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(w,p){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}async disableExtension(w,p){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const p=this.getDisabledExtensions();return p.every(y=>!(0,A.areSameExtensions)(y,w))?(p.push(w),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(w){const p=this.getDisabledExtensions();for(let y=0;y<p.length;y++){const d=p[y];if((0,A.areSameExtensions)(d,w))return p.splice(y,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,p){this.storageManger.set(w,p,0)}};P=pe([K(0,b.IStorageService),K(1,T.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class I extends r.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(w,p){let y;return p===0?((0,k.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,p)),y=this.storage[w]):y=this._get(w,p),JSON.parse(y)}set(w,p,y){const d=JSON.stringify(p.map(({id:C,uuid:m})=>({id:C,uuid:m})));this._get(w,y)!==d&&(y===0&&(p.length?this.storage[w]=d:delete this.storage[w]),this._set(w,p.length?d:void 0,y))}onDidStorageChange(w){if(w.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const y=this.get(w.key,w.scope);delete this.storage[w.key];const d=this.get(w.key,w.scope),S=y.filter(m=>!d.some(g=>(0,A.areSameExtensions)(m,g))),C=d.filter(m=>!y.some(g=>(0,A.areSameExtensions)(g,m)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(w,p){return this.storageService.get(w,p,"[]")}_set(w,p,y){p?this.storageService.store(w,p,y,1):this.storageService.remove(w,y)}}e.StorageManager=I}),define(ne[252],se([0,1,18,21,10,4,36,14,7,19,15,29,32,65,13,8,25,44,219,23,22]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,A.arch);var n;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(..._){return String(_.reduce((U,W)=>U|W,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(U=a){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,W=this.state.pageSize){return new h({...this.state,pageNumber:U,pageSize:W})}withFilter(U,...W){const j=[...this.state.criteria,...W.length?W.map(Z=>({filterType:U,value:Z})):[{filterType:U}]];return new h({...this.state,criteria:j})}withSortBy(U){return new h({...this.state,sortBy:U})}withSortOrder(U){return new h({...this.state,sortOrder:U})}withFlags(...U){return new h({...this.state,flags:U.reduce((W,j)=>W|j,0)})}withAssetTypes(...U){return new h({...this.state,assetTypes:U})}withSource(U){return new h({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:W,pageSize:j,sortBy:Z,sortOrder:oe,flags:Q,assetTypes:ie}=this.state;return{filters:[{criteria:U,pageNumber:W,pageSize:j,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:Q}}get searchText(){const U=this.state.criteria.filter(W=>W.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function v(_,U){const W=(_||[]).filter(j=>j.statisticName===U)[0];return W?W.value:0}function D(_){const U="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(j=>j.assetType.indexOf(U)===0).reduce((j,Z)=>{const oe=O(_,Z.assetType);return oe&&j.push([Z.assetType.substring(U.length),oe]),j},[])}function M(_){if(_.properties){const U=_.properties.filter(Z=>Z.key===i.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=U.filter(Z=>W.test(Z.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return O(_,i.Repository)}function F(_){return{uri:`${_.fallbackAssetUri}/${i.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${i.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function O(_,U){return _.files.filter(j=>j.assetType===U)[0]?{uri:`${_.assetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function L(_,U){const W=_.properties?_.properties.filter(Z=>Z.key===U):[],j=W.length>0&&W[0].value;return j?j.split(",").map(Z=>(0,p.adoptToGalleryExtensionId)(Z)):[]}function N(_){const U=_.properties?_.properties.filter(W=>W.key===o.Engine):[];return U.length>0&&U[0].value||""}function $(_){const U=_.properties?_.properties.filter(W=>W.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function V(_){const U=_.properties?_.properties.filter(j=>j.key===o.LocalizedLanguages):[],W=U.length>0&&U[0].value||"";return W?W.split(","):[]}function J(_){return _.properties?.find(U=>U.key===o.SponsorLink)?.value}function H(_){return _.indexOf("preview")!==-1}function G(_){return _.targetPlatform?(0,w.toTargetPlatform)(_.targetPlatform):"undefined"}function q(_){const U=(0,R.distinct)(_.versions.map(G)),W=!!_.tags?.includes(w.WEB_EXTENSION_TAG),j=U.indexOf("web");return W?j===-1&&U.push("web"):j!==-1&&U.splice(j,1),U}function x(_,U){const W=(0,w.getFallbackTargetPlarforms)(U);for(let j=0;j<_.length;j++){const Z=_[j];if(Z.version===_[j-1]?.version){let oe=j;const Q=G(Z);if(Q===U)for(;oe>0&&_[oe-1].version===Z.version;)oe--;else if(W.includes(Q))for(;oe>0&&_[oe-1].version===Z.version&&G(_[oe-1])!==U;)oe--;oe!==j&&(_.splice(j,1),_.splice(oe,0,Z))}}return _}e.sortExtensionVersions=x;function Y(_,U,W){_.telemetryData={index:U,querySource:W}}function te(_,U,W){const j=_.versions[0],Z={manifest:O(U,i.Manifest),readme:O(U,i.Details),changelog:O(U,i.Changelog),license:O(U,i.License),repository:M(U),download:F(U),icon:O(U,i.Icon),coreTranslations:D(U)};return{identifier:{id:(0,p.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:U.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(j),description:_.shortDescription||"",installCount:v(_.statistics,"install"),rating:v(_.statistics,"averagerating"),ratingCount:v(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:W,assets:Z,properties:{dependencies:L(U,o.Dependency),extensionPack:L(U,o.ExtensionPack),engine:N(U),localizedLanguages:V(U),targetPlatform:G(U),isPreReleaseVersion:$(U)},hasPreReleaseVersion:$(j),hasReleaseVersion:!0,preview:H(_.flags)}}let ce=class{constructor(U,W,j,Z,oe,Q,ie,re){this.requestService=W,this.logService=j,this.environmentService=Z,this.telemetryService=oe,this.fileService=Q,this.productService=ie,this.configurationService=re;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,W,j){const Z=r.CancellationToken.isCancellationToken(W)?{}:W,oe=r.CancellationToken.isCancellationToken(W)?W:j,Q=[],ie=[],re=[],ue=[];let he=!0;for(const Ee of U){Ee.uuid?ie.push(Ee.uuid):Q.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);re.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!Q.length)return[];let ve=new h().withPage(1,U.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),Q.length&&(ve=ve.withFilter(t.ExtensionName,...Q)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,n.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??c,includePreRelease:re,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(U,W,j){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(U,W,j))return U;const Z=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:j,compatible:!0,includePreRelease:W},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(U,W,j){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,j)||!W&&U.properties.isPreReleaseVersion)return!1;let Z=U.properties.engine;if(!Z){const oe=await this.getManifest(U,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,y.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(U,W,j,Z,oe){if(!(0,w.isTargetPlatformCompatible)(G(U),Z,oe)||W!=="any"&&$(U)!==(W==="prerelease"))return!1;if(j)try{const Q=await this.getEngine(U);if(!(0,y.isEngineValid)(Q,this.productService.version,this.productService.date))return!1}catch(Q){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,k.getErrorMessage)(Q)),!1}return!0}async query(U,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=U.text||"";const Z=U.pageSize??50;let oe=new h().withPage(1,Z);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),oe=oe.withFilter(t.SearchText,j)),oe=oe.withSortBy(0)):U.ids?oe=oe.withFilter(t.ExtensionId,...U.ids):U.names?oe=oe.withFilter(t.ExtensionName,...U.names):oe=oe.withSortBy(4),typeof U.sortBy=="number"&&(oe=oe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(oe=oe.withSortOrder(U.sortOrder)),U.source&&(oe=oe.withSource(U.source));const Q=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:c,compatible:!1,includePreRelease:!!U.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,U.source)),{extensions:we,total:Ee}},{extensions:ie,total:re}=await Q(oe,W),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new k.CancellationError;const{extensions:we}=await Q(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:re,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(U,W,j){const Z=U.flags;!!(U.flags&n.IncludeLatestVersionOnly)&&!!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(U.flags&n.IncludeLatestVersionOnly)&&!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags,n.IncludeLatestVersionOnly)),W.versions?.length&&(U=U.withFlags(U.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),U=U.withFlags(U.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:Q}=await this.queryRawGalleryExtensions(U,j);if(!(U.flags&n.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,W);we&&he.push(we)}return{extensions:he,total:Q}}const re=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(q(ve),W.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,W);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==W.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):re.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new h().withFlags(Z&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,W,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);re.push([Pe,Ee])}}return{extensions:re.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:Q}}async toGalleryExtensionWithCriteria(U,W){const j={id:(0,p.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},Z=W.versions?.find(re=>(0,p.areSameExtensions)(re,j))?.version,oe=(0,b.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(re=>(0,p.areSameExtensions)(re,j))?.includePreRelease,Q=q(U),ie=x(U.versions,W.targetPlatform);if(W.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(Q,W.targetPlatform))return null;for(let re=0;re<ie.length;re++){const ue=ie[re];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",W.compatible,Q,W.targetPlatform))return te(U,ue,Q);if(Z&&ue.version===Z)return null}}return Z||W.compatible?null:te(U,U.versions[0],Q)}async queryRawGalleryExtensions(U,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const j=await this.commonHeadersPromise,Z=JSON.stringify(U.raw),oe={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},Q=new Date().getTime();let ie,re,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},W),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,m.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw re=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-Q,success:!!ie&&(0,m.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:re?(0,k.isCancellationError)(re)?"canceled":(0,k.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(U,W,j,Z){if(!this.isEnabled())return;const oe=T.isWeb?this.api(`/itemName/${U}.${W}/version/${j}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${W}/${j}/stats?statType=${Z}`),Q=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:Q};try{await this.requestService.request({type:"POST",url:oe,headers:re},r.CancellationToken.None)}catch{}}async download(U,W,j){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const Z=(0,p.getGalleryExtensionTelemetryData)(U),oe=new Date().getTime(),Q=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=j===2?"install":j===3?"update":"",re=ie?{uri:`${U.assets.download.uri}${P.URI.parse(U.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${P.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:U.assets.download,ue=await this.getAsset(re);await this.fileService.writeFile(W,ue.stream),Q(new Date().getTime()-oe)}async getReadme(U,W){if(U.assets.readme){const j=await this.getAsset(U.assets.readme,{},W);return await(0,m.asTextOrError)(j)||""}return""}async getManifest(U,W){if(U.assets.manifest){const j=await this.getAsset(U.assets.manifest,{},W),Z=await(0,m.asTextOrError)(j);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(U,W){const j=O(U,i.Manifest);if(!j)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(j,{headers:Z});return await(0,m.asJson)(oe)}async getCoreTranslation(U,W){const j=U.assets.coreTranslations.filter(Z=>Z[0]===W.toUpperCase())[0];if(j){const Z=await this.getAsset(j[1]),oe=await(0,m.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(U,W){if(U.assets.changelog){const j=await this.getAsset(U.assets.changelog,{},W);return await(0,m.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(U,W,j){let Z=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?Z=Z.withFilter(t.ExtensionId,U.identifier.uuid):Z=Z.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,r.CancellationToken.None);if(!oe.length)return[];const Q=q(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,W?"any":"release",!0,Q,j)&&ie.push(he)}catch{}}));const re=[],ue=new Set;for(const he of x(ie,j))ue.has(he.version)||(ue.add(he.version),re.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return re}async getAsset(U,W={},j=r.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},Q={...Z,...W.headers||{}};W={...W,...oe,headers:Q};const ie=U.uri,re=U.fallbackUri,ue={...W,url:ie};try{const he=await this.requestService.request(ue,j);if(he.res.statusCode===200)return he;const ve=await(0,m.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const ve=(0,k.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...W,url:re};return this.requestService.request(we,j)}}async getEngine(U){let W=N(U);if(!W){const j=await this.getManifestFromRawExtensionVersion(U,r.CancellationToken.None);if(!j)throw new Error("Manifest was not found");W=j.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,m.asJson)(U),j=[],Z={};if(W){for(const oe of W.malicious)j.push({id:oe});if(W.migrateToPreRelease)for(const[oe,Q]of Object.entries(W.migrateToPreRelease))(!Q.engine||(0,y.isEngineValid)(Q.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[oe,Q]of Object.entries(W.deprecated))Q&&(Z[oe.toLowerCase()]=(0,b.isBoolean)(Q)?{}:Q)}return{malicious:j,deprecated:Z}}};ce=pe([K(1,m.IRequestService),K(2,S.ILogService),K(3,E.IEnvironmentService),K(4,f.ITelemetryService),K(5,d.IFileService),K(6,C.IProductService),K(7,I.IConfigurationService)],ce);let z=class extends ce{constructor(U,W,j,Z,oe,Q,ie,re){super(U,W,j,Z,oe,Q,ie,re)}};z=pe([K(0,l.IStorageService),K(1,m.IRequestService),K(2,S.ILogService),K(3,E.IEnvironmentService),K(4,f.ITelemetryService),K(5,d.IFileService),K(6,C.IProductService),K(7,I.IConfigurationService)],z),e.ExtensionGalleryService=z;let B=class extends ce{constructor(U,W,j,Z,oe,Q,ie){super(void 0,U,W,j,Z,oe,Q,ie)}};B=pe([K(0,m.IRequestService),K(1,S.ILogService),K(2,E.IEnvironmentService),K(3,f.ITelemetryService),K(4,d.IFileService),K(5,C.IProductService),K(6,I.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(ne[72],se([0,1,5,3,2,23,32,25,18,8,14]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Qe extends k.Disposable{constructor(d,S,C){super(),this.storageService=d,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=w.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const C=await d.getInstalled(),m=[];for(const[g,l]of Qe.readAllExtensionsWithKeysForSync(S)){const f=C.find(c=>(0,A.areSameExtensions)(c.identifier,{id:g}))?.manifest.version;for(const c of l)f!==c&&m.push(Qe.toKey({id:g,version:c}))}for(const g of m)S.remove(g,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,C=d.keys(0,1);for(const m of C){const g=Qe.fromKey(m);if(g){let l=S.get(g.id.toLowerCase());l||S.set(g.id.toLowerCase(),l=[]),l.push(g.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Qe.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,E.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,C=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,C)}getExtensionState(d,S){const C=this.getExtensionId(d),m=this.storageService.get(C,S?0:1);if(m)try{return JSON.parse(m)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${g}`)}}setExtensionState(d,S,C){const m=this.getExtensionId(d);S===void 0?this.storageService.remove(m,C?0:1):this.storageService.store(m,JSON.stringify(S),C?0:1,1)}setKeysForSync(d,S){this.storageService.store(Qe.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],C=this.storageService.get(Qe.toKey(d),0),m=C?JSON.parse(C):void 0;return m&&S?(0,P.distinct)([...m,...S]):m||S}addToMigrationList(d,S){if(d!==S){const C=this.migrationList.filter(m=>!m.includes(d)&&!m.includes(S));C.push([d,S]),this.migrationList=C}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,C])=>d===C);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if(Array.isArray(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([K(0,T.IStorageService),K(1,b.IProductService),K(2,I.ILogService)],p),e.ExtensionStorageService=p}),define(ne[253],se([0,1,18,6,3,9,4,36,7,143,15,29,32,209,91,13,8,67,25,44,23,22]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let t=class extends y.ExtensionTipsService{constructor(o,u,a,h,v,D,M,F,O,L){super(M,F,O,L),this.environmentService=o,this.telemetryService=u,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=v,this.extensionRecommendationNotificationService=D,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&Object.entries(F.exeBasedExtensionTips).forEach(([N,$])=>{const V=[],J=[],H=[];Object.entries($.recommendations).forEach(([G,q])=>{q.important?$.important?V.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):J.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:G,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,a)}groupImportantTipsByExe(o,u){const a=new Map;o.forEach(F=>a.set(F.extensionId.toLowerCase(),F));const{installed:h,uninstalled:v}=this.groupByInstalled([...a.keys()],u);for(const F of h){const O=a.get(F);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:O.exeName})}for(const F of v){const O=a.get(F);O&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:O.exeName})}const D=this.getPromptedExecutableTips(),M=new Map;for(const F of v){const O=a.get(F);if(O&&(!D[O.exeName]||!D[O.exeName].includes(O.extensionId))){let L=M.get(O.exeName);L||(L=[],M.set(O.exeName,L)),L.push(O)}}return M}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,r.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),u=Date.now()-o,a=7*24*60*60*1e3;if(u<a){const D=this._register((0,r.disposableTimeout)(()=>{D.dispose(),this.promptMediumImportanceExeBasedTip()},a-u));return}const[h,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(D=>{switch(D){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(v[0].exeName,v);const M=this._register((0,r.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const M=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const M=this._register((0,r.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(o){const u=await this.extensionManagementService.getInstalled(1),a=o.filter(v=>!v.whenNotInstalled||v.whenNotInstalled.every(D=>u.every(M=>!(0,p.areSameExtensions)(M.identifier,{id:D})))).map(({extensionId:v})=>v.toLowerCase()),h=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,h,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(o,u){const a=this.getPromptedExecutableTips();a[o]=u.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(o,u){const a=[],h=[],v=u.reduce((D,M)=>(D.add(M.identifier.id.toLowerCase()),D),new Set);return o.forEach(D=>{v.has(D.toLowerCase())?a.push(D):h.push(D)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const u=[],a=new Map;for(const h of o.keys()){const v=o.get(h);if(!v||!(0,R.isNonEmptyArray)(v.recommendations))continue;const D=[];A.isWindows?v.windowsPath&&D.push(v.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(D.push((0,T.join)("/usr/local/bin",h)),D.push((0,T.join)("/usr/bin",h)),D.push((0,T.join)(this.environmentService.userHome.fsPath,h)));for(const M of D){let F=a.get(M);if(F===void 0&&(F=await this.fileService.exists(P.URI.file(M)),a.set(M,F)),F)for(const{extensionId:O,extensionName:L,isExtensionPack:N,whenNotInstalled:$}of v.recommendations)u.push({extensionId:O,extensionName:L,isExtensionPack:N,exeName:h,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath,whenNotInstalled:$})}}return u}};t=pe([K(0,E.INativeEnvironmentService),K(1,c.ITelemetryService),K(2,w.IExtensionManagementService),K(3,f.IStorageService),K(4,m.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,S.IFileService),K(7,g.IProductService),K(8,l.IRequestService),K(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[254],se([0,1,6,2,17,86,23,217]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class P extends A.AbstractStorageService{constructor(E,w,p,y){super(),this.initialWorkspace=E,this.initialProfiles=w,this.mainProcessService=p,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new b.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),w=this._register(new T.Storage(E));return this._register(w.onDidChangeStorage(p=>this.emitDidChangeValue(-1,p))),w}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let w;if((0,A.isProfileUsingDefaultStorage)(E))w=this.applicationStorage;else{const p=this.profileStorageDisposables.add(new b.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.profileStorageDisposables.add(new T.Storage(p))}return this.profileStorageDisposables.add(w.onDidChangeStorage(p=>this.emitDidChangeValue(0,p))),w}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let w;if(E){const p=this.workspaceStorageDisposables.add(new b.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.workspaceStorageDisposables.add(new T.Storage(p)),this.workspaceStorageDisposables.add(w.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return w}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,w){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const p=this.profileStorage,y=p.items;p!==this.applicationStorage&&await p.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(y,this.profileStorage,0,w)}async switchToWorkspace(E,w){const p=this.workspaceStorage,y=p?.items??new Map;await p?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1,w)}}e.NativeStorageService=P}),define(ne[255],se([0,1,3,2,17,15,94,28]),function(X,e,R,r,k,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends r.Disposable{constructor(E,w,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=E.map(y=>(0,b.reviveProfile)(y,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(y=>{const d=y.added.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),S=y.removed.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),C=y.updated.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme));this._profiles=y.all.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(E,w,p){const y=await this.channel.call("createProfile",[E,w,p]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}async createTransientProfile(E){const w=await this.channel.call("createTransientProfile",[E]);return(0,b.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(E,w){await this.channel.call("setProfileForWorkspace",[E,w])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,w,p){const y=await this.channel.call("updateProfile",[E,w,p]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};P=pe([K(1,A.IMainProcessService),K(2,T.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(ne[45],se([0,1,18,6,16,21,3,35,2,24,14,7,158,19,15,13,8,47,23,22,33,26,28]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=s;let t=class extends P.Disposable{constructor(h,v,D,M,F,O,L,N,$,V,J){super(),this.resource=h,this.fileService=v,this.environmentService=D,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=L,this.telemetryService=N,this.logService=$,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(D.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(h,D,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(D,v,M)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?await this.hasRemoteChanged(h):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){this._status!==h&&(this._status=h,this._onDidChangStatus.fire(h))}async sync(h,v={}){await this._sync(h,!0,this.getUserDataSyncConfiguration(),v)}async preview(h,v,D={}){return this._sync(h,!1,v,D)}async apply(h,v={}){try{this.syncHeaders={...v};const D=await this.doApply(h);return this.setStatus(D),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,v,D,M){try{if(this.syncHeaders={...M},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let F="idle";try{const O=await this.getLastSyncUserData(),L=await this.getLatestRemoteUserData(h,O);return F=await this.performSync(L,O,v,D),F==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(F)}}finally{this.syncHeaders={}}}async replace(h){const v=await this.resolveContent(h);if(!v)return!1;const D=this.parseSyncData(v);if(!D)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const M=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(null,M),O=await this.isRemoteDataFromCurrentMachine(F),L=await this.generateSyncPreview({ref:F.ref,syncData:D},M,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const $ of L){const V=await this.getAcceptResult($,$.remoteResource,void 0,T.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,T.CancellationToken.None);N.push([$,{...V,remoteChange:J!==0?J:2}])}await this.applyResult(F,M,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(h){const v=await this.currentMachineIdPromise;return!!h.syncData?.machineId&&h.syncData.machineId===v}async getLatestRemoteUserData(h,v){if(v){const D=h&&h.latest?h.latest[this.resource]:void 0;if(v.ref===D||D===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(h,v,D,M){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,h.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(h,v,D,M)}catch(F){if(F instanceof c.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,v,D,M);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(h,v,D,M)}throw F}}async doSync(h,v,D,M){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(h,v,D,M,O)));const F=await this.syncPreviewPromise;return this.updateConflicts(F.resourcePreviews),F.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":D?await this.doApply(!1):"syncing"}catch(F){throw this.syncPreviewPromise=null,F}}async merge(h){return await this.updateSyncResourcePreview(h,async v=>{const D=await this.getMergeResult(v,T.CancellationToken.None);await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(D?.content||""));const M=D&&!D.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,T.CancellationToken.None):void 0;return v.acceptResult=M,v.mergeState=D.hasConflicts?"conflict":M?"accepted":"preview",v.localChange=M?M.localChange:D.localChange,v.remoteChange=M?M.remoteChange:D.remoteChange,v}),this.syncPreviewPromise}async accept(h,v){return await this.updateSyncResourcePreview(h,async D=>{const M=await this.getAcceptResult(D,h,v,T.CancellationToken.None);return D.acceptResult=M,D.mergeState="accepted",D.localChange=M.localChange,D.remoteChange=M.remoteChange,D}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async v=>{const D=await this.getMergeResult(v,T.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,k.VSBuffer.fromString(D.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=D.localChange,v.remoteChange=D.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(h,v){if(!this.syncPreviewPromise)return;let D=await this.syncPreviewPromise;const M=D.resourcePreviews.findIndex(({localResource:F,remoteResource:O,previewResource:L})=>this.extUri.isEqual(F,h)||this.extUri.isEqual(O,h)||this.extUri.isEqual(L,h));M!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async F=>{const O=[...D.resourcePreviews];return O[M]=await v(O[M]),{...D,resourcePreviews:O}}),D=await this.syncPreviewPromise,this.updateConflicts(D.resourcePreviews),D.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(h){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:D})=>D==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:D})=>D!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(D=>[D,D.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(h){const v=h.filter(({mergeState:D})=>D==="conflict");(0,R.equals)(this._conflicts,v,(D,M)=>this.extUri.isEqual(D.previewResource,M.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){const h=await this.getLastSyncUserData();return!!h&&h.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:D})=>({created:v,uri:this.toRemoteBackupResource(D)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:D})=>({created:v,uri:this.toLocalBackupResource(D)}))}toRemoteBackupResource(h){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const v=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(v))){const{content:D}=await this.getUserData(v);if(D)return this.parseSyncData(D)?.machineId}}async resolveContent(h){const v=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(v))){const{content:D}=await this.getUserData(v);return D}return this.extUri.isEqual(h,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(h){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const D of v.resourcePreviews){if(this.extUri.isEqual(D.acceptedResource,h))return D.acceptResult?D.acceptResult.content:null;if(this.extUri.isEqual(D.remoteResource,h))return D.remoteContent;if(this.extUri.isEqual(D.localResource,h))return D.localContent;if(this.extUri.isEqual(D.baseResource,h))return D.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(h,v,D,M,F){const O=await this.isRemoteDataFromCurrentMachine(h),L=await this.generateSyncPreview(h,v,O,M,F),N=[];for(const $ of L){const V=$.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)N.push({...$,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=D?await this.getMergeResult($,F):void 0;if(F.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,k.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,F):void 0;N.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{remoteUserData:h,lastSyncUserData:v,resourcePreviews:N,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(h.value.toString()),D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&D&&v.version!==D,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${D}.`),await this.resetLocal(),null;const M=v;if(M.content===null)return{ref:v.ref,syncData:null};const F=JSON.parse(M.content);if(s(F))return{...v,syncData:F,content:void 0}}catch(h){h instanceof S.FileOperationError&&h.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(h)}return null}async updateLastSyncUserData(h,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),M={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:D,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(M)))}async getRemoteUserData(h){const{ref:v,content:D}=await this.getUserData(h);let M=null;return D!==null&&(M=this.parseSyncData(D)),{ref:v,syncData:M}}parseSyncData(h){try{const v=JSON.parse(h);if(s(v))return v}catch(v){this.logService.error(v)}throw new c.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(h){if((0,E.isString)(h)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:v}}else{const v=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,void 0,this.syncHeaders)}}async updateRemoteUserData(h,v){const D=await this.currentMachineIdPromise,M={version:this.version,machineId:D,content:h};return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(M),v,void 0,this.syncHeaders),{ref:v,syncData:M}}async backupLocal(h){const v={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([K(1,S.IFileService),K(2,d.IEnvironmentService),K(3,g.IStorageService),K(4,c.IUserDataSyncStoreService),K(5,c.IUserDataSyncBackupStoreService),K(6,c.IUserDataSyncEnablementService),K(7,l.ITelemetryService),K(8,c.IUserDataSyncLogService),K(9,y.IConfigurationService),K(10,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let i=class extends t{constructor(h,v,D,M,F,O,L,N,$,V,J,H){super(v,D,M,F,O,L,N,$,V,J,H),this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(h,v,D){try{v?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(h),D?void 0:v):await this.fileService.createFile(this.file,k.VSBuffer.fromString(h),{overwrite:D})}catch(M){throw M instanceof S.FileOperationError&&M.fileOperationResult===1||M instanceof S.FileOperationError&&M.fileOperationResult===3?new c.UserDataSyncError(M.message,"LocalPreconditionFailed"):M}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};i=pe([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,g.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncBackupStoreService),K(7,c.IUserDataSyncEnablementService),K(8,l.ITelemetryService),K(9,c.IUserDataSyncLogService),K(10,y.IConfigurationService),K(11,f.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(h,v,D,M,F,O,L,N,$,V,J,H,G){super(h,v,D,M,F,O,L,N,$,V,H,G),this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(h,v){const D=[],M=(0,b.parse)(h,D,{allowEmptyContent:!0,allowTrailingComma:!0});return D.length>0||!(0,E.isUndefined)(M)&&v!==Array.isArray(M)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=pe([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,g.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncBackupStoreService),K(7,c.IUserDataSyncEnablementService),K(8,l.ITelemetryService),K(9,c.IUserDataSyncLogService),K(10,c.IUserDataSyncUtilService),K(11,y.IConfigurationService),K(12,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let u=class{constructor(h,v,D,M,F,O){this.resource=h,this.userDataProfilesService=v,this.environmentService=D,this.logService=M,this.fileService=F,this.extUri=O.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,D,this.extUri)}async initialize({ref:h,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const D=this.parseSyncData(v);if(!!D)try{await this.doInitialize({ref:h,syncData:D})}catch(M){this.logService.error(M)}}parseSyncData(h){try{const v=JSON.parse(h);if(s(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,v={}){const D={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,...v};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(D)))}};u=pe([K(1,n.IUserDataProfilesService),K(2,d.IEnvironmentService),K(3,C.ILogService),K(4,S.IFileService),K(5,f.IUriIdentityService)],u),e.AbstractInitializer=u}),define(ne[256],se([0,1,6,21,10,3,52,24,7,19,15,29,32,72,13,8,23,22,33,28,45,236,107,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(u,a){const h=JSON.parse(u.content);if(u.version===1||u.version===2){const v=(await a.getInstalled(0)).filter(D=>D.isBuiltin);for(const D of h)u.version===1&&(D.enabled===!1&&(D.disabled=!0),delete D.enabled),u.version===2&&v.every(M=>!(0,p.areSameExtensions)(M.identifier,D.identifier))&&(D.installed=!0)}return h}let i=class mt extends f.AbstractSynchroniser{constructor(a,h,v,D,M,F,O,L,N,$,V,J,H,G,q){super("extensions",h,a,v,D,M,J,H,N,V,q),this.extensionManagementService=F,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=$,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:Y})=>!!Y)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(a,h){const v=a.syncData?await t(a.syncData,this.extensionManagementService):null,D=h?.skippedExtensions||[],M=h?.syncData?await t(h.syncData,this.extensionManagementService):null,F=await this.extensionManagementService.getInstalled(void 0),O=this.getLocalExtensions(F),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(F);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:$}=(0,c.merge)(O,v,M,D,L),V={local:N,remote:$,content:this.getPreviewContent(O,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(O,!1);return[{skippedExtensions:D,baseResource:this.baseResource,baseContent:M?this.stringify(M,!1):J,localResource:this.localResource,localContent:J,localExtensions:O,remoteResource:this.remoteResource,remoteContent:v?this.stringify(v,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const h=a.syncData?await t(a.syncData,this.extensionManagementService):null,v=await this.extensionManagementService.getInstalled(void 0),D=this.getLocalExtensions(v),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),{remote:F}=(0,c.merge)(D,h,h,a.skippedExtensions||[],M);return F!==null}getPreviewContent(a,h,v,D){const M=[...h,...v],F=new Set,O=L=>{F.add(L.id.toLowerCase()),L.uuid&&F.add(L.uuid)};M.forEach(({identifier:L})=>O(L)),D.forEach(O);for(const L of a)F.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&F.has(L.identifier.uuid)||M.push(L);return this.stringify(M,!1)}async getMergeResult(a,h){return{...a.previewResult,hasConflicts:!1}}async getAcceptResult(a,h,v,D){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(a);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(a);if(this.extUri.isEqual(h,this.previewResource))return a.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(a){const h=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),D=(0,c.merge)(a.localExtensions,null,null,a.skippedExtensions,v),{local:M,remote:F}=D;return{content:a.localContent,local:M,remote:F,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:F!==null?2:0}}async acceptRemote(a){const h=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),D=a.remoteContent?JSON.parse(a.remoteContent):null;if(D!==null){const M=(0,c.merge)(a.localExtensions,D,a.localExtensions,[],v),{local:F,remote:O}=M;return{content:a.remoteContent,local:F,remote:O,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:a.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(a,h,v,D){let{skippedExtensions:M,localExtensions:F}=v[0][0];const{local:O,remote:L,localChange:N,remoteChange:$}=v[0][1];if(N===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(F)),M=await this.updateLocalExtensions(O.added,O.removed,O.updated,M)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(L.all);a=await this.updateRemoteUserData(V,D?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(J=>J.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(J=>J.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(J=>J.identifier.id))}.`:""}`)}h?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(a,{skippedExtensions:M}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${M.length?` Skipped: ${JSON.stringify(M.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:a}){return[{resource:this.extUri.joinPath(a,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(a){if(this.extUri.isEqual(a,mt.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),D=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),M=this.getLocalExtensions(v).filter(F=>!D.some(O=>(0,p.areSameExtensions)({id:O},F.identifier)));return this.stringify(M,!0)}if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.baseResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a)){const v=await this.resolvePreviewContent(a);return v&&this.stringify(JSON.parse(v),!0)}let h=await super.resolveContent(a);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(a)),h){const v=this.parseSyncData(h);if(v)switch(this.extUri.basename(a)){case"extensions.json":return this.stringify(this.parseExtensions(v),!0)}}return null}stringify(a,h){return a.sort((v,D)=>!v.identifier.uuid&&D.identifier.uuid?-1:v.identifier.uuid&&!D.identifier.uuid?1:(0,b.compare)(v.identifier.id,D.identifier.id)),h?(0,A.toFormattedString)(a,{}):JSON.stringify(a)}async hasLocalData(){try{const a=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(a).some(v=>v.installed||v.disabled))return!0}catch{}return!1}async updateLocalExtensions(a,h,v,D){const M=[],F=[],O=await this.extensionManagementService.getInstalled();if(h.length){const N=O.filter(({identifier:$,isBuiltin:V})=>!V&&h.some(J=>(0,p.areSameExtensions)($,J)));await R.Promises.settled(N.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),M.push($.identifier)}))}(a.length||v.length)&&await R.Promises.settled([...a,...v].map(async N=>{const $=O.find(J=>(0,p.areSameExtensions)(J.identifier,N.identifier));if($&&$.isBuiltin){N.state&&$.manifest.version===N.version&&this.updateExtensionState(N.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id))),M.push(N.identifier);return}const V=(await this.extensionGalleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],r.CancellationToken.None))[0];if(N.state&&($?$.manifest.version===N.version:!!V)&&this.updateExtensionState(N.state,$||V,$?.manifest.version),V)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,V.version))),(!$||$.preRelease!==N.preRelease)&&(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:N.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,V.version),M.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),F.push(N)))}catch(J){F.push(N),J instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id))}else F.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const L=[];for(const N of D)M.some($=>(0,p.areSameExtensions)($,N.identifier))||L.push(N);for(const N of F)L.some($=>(0,p.areSameExtensions)($.identifier,N.identifier))||L.push(N);return L}updateExtensionState(a,h,v){const D=this.extensionStorageService.getExtensionState(h,!0)||{},M=v?this.extensionStorageService.getKeysForSync({id:h.identifier.id,version:v}):void 0;M?M.forEach(F=>{D[F]=a[F]}):Object.keys(a).forEach(F=>D[F]=a[F]),this.extensionStorageService.setExtensionState(h,D,!0)}parseExtensions(a){return JSON.parse(a.content)}getLocalExtensions(a){const h=this.extensionEnablementService.getDisabledExtensions();return a.map(v=>{const{identifier:D,isBuiltin:M,manifest:F,preRelease:O}=v,L={identifier:D,preRelease:O,version:F.version};h.some(N=>(0,p.areSameExtensions)(N,D))&&(L.disabled=!0),M||(L.installed=!0);try{const N=this.extensionStorageService.getKeysForSync({id:D.id,version:F.version});if(N){const $=this.extensionStorageService.getExtensionState(v,!0)||{};L.state=Object.keys($).reduce((V,J)=>(N.includes(J)&&(V[J]=$[J]),V),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(N))}return L})}};i.EXTENSIONS_DATA_URI=P.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=pe([K(0,E.IEnvironmentService),K(1,d.IFileService),K(2,C.IStorageService),K(3,s.IUserDataSyncStoreService),K(4,s.IUserDataSyncBackupStoreService),K(5,w.IExtensionManagementService),K(6,w.IGlobalExtensionEnablementService),K(7,n.IIgnoredExtensionsManagementService),K(8,s.IUserDataSyncLogService),K(9,w.IExtensionGalleryService),K(10,I.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,m.ITelemetryService),K(13,y.IExtensionStorageService),K(14,g.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let o=class extends f.AbstractInitializer{constructor(a,h,v,D,M,F,O){super("extensions",D,M,F,v,O),this.extensionManagementService=a,this.ignoredExtensionsManagementService=h}async parseExtensions(a){return a.syncData?await t(a.syncData,this.extensionManagementService):null}generatePreview(a,h){const v=[],D=[],M=[];for(const F of a){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(F.identifier.id))continue;const O=h.find(L=>(0,p.areSameExtensions)(L.identifier,F.identifier));O?(v.push(O),F.disabled&&M.push(F.identifier)):F.installed&&(D.push({...F.identifier,preRelease:!!F.preRelease}),F.disabled&&M.push(F.identifier))}return{installedExtensions:v,newExtensions:D,disabledExtensions:M,remoteExtensions:a}}};o=pe([K(0,w.IExtensionManagementService),K(1,n.IIgnoredExtensionsManagementService),K(2,d.IFileService),K(3,l.IUserDataProfilesService),K(4,E.IEnvironmentService),K(5,S.ILogService),K(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[257],se([0,1,16,10,3,35,52,4,7,30,19,15,13,8,47,23,22,33,45,59,239,26,28]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function i(v,D){const M=v.storage?Object.keys(v.storage).sort():[],F={};return M.forEach(O=>F[O]=v.storage[O]),v.storage=F,D?(0,A.toFormattedString)(v,{}):JSON.stringify(v)}const o=1;let u=class pt extends g.AbstractSynchroniser{constructor(D,M,F,O,L,N,$,V,J,H){super("globalState",D,L,J,M,F,N,$,O,V,H),this.storageService=J,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(D.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),k.Event.filter(J.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:J.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(D,M,F){const O=D.syncData?JSON.parse(D.syncData.content):null;M=M===null&&F?D:M;const L=M&&M.syncData?JSON.parse(M.syncData.content):null,N=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(L),{local:V,remote:J}=(0,f.merge)(N.storage,O?O.storage:null,L?L.storage:null,$,this.logService),H={content:null,local:V,remote:J,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:J!==null?2:0},G=i(N,!1);return[{baseResource:this.baseResource,baseContent:L?i(L,!1):G,localResource:this.localResource,localContent:G,localUserData:N,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async hasRemoteChanged(D){const M=D.syncData?JSON.parse(D.syncData.content):null;if(M===null)return!0;const F=await this.getLocalGlobalState(),O=this.getStorageKeys(M),{remote:L}=(0,f.merge)(F.storage,M.storage,M.storage,O,this.logService);return L!==null}async getMergeResult(D,M){return{...D.previewResult,hasConflicts:!1}}async getAcceptResult(D,M,F,O){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(D);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(D);if(this.extUri.isEqual(M,this.previewResource))return D.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:D.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(D){if(D.remoteContent!==null){const M=JSON.parse(D.remoteContent),{local:F,remote:O}=(0,f.merge)(D.localUserData.storage,M.storage,null,D.storageKeys,this.logService);return{content:D.remoteContent,local:F,remote:O,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(D,M,F,O){const{localUserData:L}=F[0][0],{local:N,remote:$,localChange:V,remoteChange:J}=F[0][1];if(V===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(L)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),J!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:$});D=await this.updateRemoteUserData(H,O?null:D.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}M?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:D}){return[{resource:this.extUri.joinPath(D,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(D){if(this.extUri.isEqual(D,pt.GLOBAL_STATE_DATA_URI)){const F=await this.getLocalGlobalState();return i(F,!0)}if(this.extUri.isEqual(this.remoteResource,D)||this.extUri.isEqual(this.baseResource,D)||this.extUri.isEqual(this.localResource,D)||this.extUri.isEqual(this.acceptedResource,D)){const F=await this.resolvePreviewContent(D);return F&&i(JSON.parse(F),!0)}let M=await super.resolveContent(D);if(M)return M;if(M=await super.resolveContent(this.extUri.dirname(D)),M){const F=this.parseSyncData(M);if(F)switch(this.extUri.basename(D)){case"globalState.json":return i(JSON.parse(F.content),!0)}}return null}async hasLocalData(){try{const{storage:D}=await this.getLocalGlobalState();if(Object.keys(D).length>1||D[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const D={},M=await this.getLocalArgvContent(),F=(0,T.parse)(M);for(const O of t)F[O]!==void 0&&(D[`${s}${O}`]={version:1,value:F[O]});for(const O of this.storageService.keys(0,0)){const L=this.storageService.get(O,0);L&&(D[O]={version:1,value:L})}return{storage:D}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const D=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),D.value.toString()}catch(D){this.logService.debug((0,r.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:M,updated:F}){const O={},L={},N=(V,J)=>{for(const H of V){if(H.startsWith(s)){O[H.substring(s.length)]=J?J[H].value:void 0;continue}if(J){const G=J[H];G.value!==String(this.storageService.get(H,0))&&(L[H]=G.value)}else this.storageService.get(H,0)!==void 0&&(L[H]=void 0)}};if(N(Object.keys(D),D),N(Object.keys(F),F),N(M),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(L).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(L))this.storageService.store(V,L[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(L))}}async updateArgv(D){const M=await this.getLocalArgvContent();let F=M;for(const O of Object.keys(D))F=(0,l.edit)(F,[O],D[O],{});M!==F&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(F)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(D){const M=this.storageService.keys(0,0),F=this.storageService.keys(0,1),O=[...M,...F],L=D?.storage?Object.keys(D.storage).filter(N=>!N.startsWith(s)&&!O.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!b.isWeb){const N=[...c.ALL_SYNC_RESOURCES.map($=>(0,c.getEnablementKey)($)),c.SYNC_SERVICE_URL_TYPE];L.push(...N),F.push(...N)}return{user:M,machine:F,unregistered:L}}};u.GLOBAL_STATE_DATA_URI=P.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),u=pe([K(0,p.IFileService),K(1,c.IUserDataSyncStoreService),K(2,c.IUserDataSyncBackupStoreService),K(3,c.IUserDataSyncLogService),K(4,w.IEnvironmentService),K(5,c.IUserDataSyncEnablementService),K(6,C.ITelemetryService),K(7,E.IConfigurationService),K(8,S.IStorageService),K(9,m.IUriIdentityService)],u),e.GlobalStateSynchroniser=u;let a=class extends g.AbstractInitializer{constructor(D,M,F,O,L,N){super("globalState",F,O,L,M,N),this.storageService=D}async doInitialize(D){const M=D.syncData?JSON.parse(D.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},O={};for(const L of Object.keys(M.storage))L.startsWith(s)?F[L.substring(s.length)]=M.storage[L].value:this.storageService.get(L,0)===void 0&&(O[L]=M.storage[L].value);if(Object.keys(F).length){let L="{}";try{L=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const N of Object.keys(F))L=(0,l.edit)(L,[N],F[N],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(L))}if(Object.keys(O).length)for(const L of Object.keys(O))this.storageService.store(L,O[L],0,0)}};a=pe([K(0,S.IStorageService),K(1,p.IFileService),K(2,n.IUserDataProfilesService),K(3,w.IEnvironmentService),K(4,c.IUserDataSyncLogService),K(5,m.IUriIdentityService)],a),e.GlobalStateInitializer=a;let h=class{constructor(D,M,F,O,L){this.userDataSyncStoreClient=D,this.storageService=M,this.environmentService=F,this.fileService=O,this.logService=L}getSyncStoreType(D){return this.parseGlobalState(D)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const M=(0,c.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(D,M)}catch(F){if(F instanceof c.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(D,M)}throw F}}async doSync(D,M){const F=await this.userDataSyncStoreClient.readResource("globalState",null,M),O=this.parseGlobalState(F)||{storage:{}};O.storage[c.SYNC_SERVICE_URL_TYPE]={value:D,version:o};const L=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:o,machineId:L,content:i(O,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(N),F.ref,M)}parseGlobalState({content:D}){if(!D)return null;const M=JSON.parse(D);if((0,g.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};h=pe([K(1,S.IStorageService),K(2,w.IEnvironmentService),K(3,p.IFileService),K(4,y.ILogService)],h),e.UserDataSyncStoreTypeSynchronizer=h}),define(ne[258],se([0,1,18,16,3,35,4,14,159,19,15,13,23,22,33,28,45,237,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function l(n,s,t){try{const i=JSON.parse(n);if(!s)return(0,b.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,b.isUndefined)(i.mac)?null:i.mac;case 3:return(0,b.isUndefined)(i.linux)?null:i.linux;case 1:return(0,b.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=l;let f=class extends C.AbstractJsonFileSynchroniser{constructor(s,t,i,o,u,a,h,v,D,M,F,O){super(h.defaultProfile.keybindingsResource,"keybindings",a,v,D,s,t,u,F,i,M,o,O),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(o.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,i,o){const u=s.syncData?l(s.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?s:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,h=await this.getLocalFileContent(),v=await this.getFormattingOptions();let D=null,M=!1,F=!1,O=!1;if(u){let $=h?h.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==$||a!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,m.merge)($,u,a,v,this.userDataSyncUtilService);V.hasChanges&&(D=V.mergeContent,O=V.hasConflicts,M=O||V.mergeContent!==$,F=O||V.mergeContent!==u)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),D=h.value.toString(),F=!0);const L={content:D,localChange:M?h?2:1:0,remoteChange:F?2:0,hasConflicts:O},N=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:a!==null?a:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString():"",u=await this.getFormattingOptions(),a=await(0,m.merge)(o||"[]",t,t,u,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,i,o){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,o){const{fileContent:u}=i[0][0];let{content:a,localChange:h,remoteChange:v}=i[0][1];if(h===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(a||"[]",u,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const D=this.toSyncContent(a||"[]",s.syncData?.content);s=await this.updateRemoteUserData(D,o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,T.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(s)){case"keybindings.json":return l(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:l(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let i={};try{i=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=s,A.OS){case 2:i.mac=s;break;case 3:i.linux=s;break;case 1:i.windows=s;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=pe([K(0,g.IUserDataSyncStoreService),K(1,g.IUserDataSyncBackupStoreService),K(2,g.IUserDataSyncLogService),K(3,I.IConfigurationService),K(4,g.IUserDataSyncEnablementService),K(5,w.IFileService),K(6,S.IUserDataProfilesService),K(7,E.IEnvironmentService),K(8,p.IStorageService),K(9,g.IUserDataSyncUtilService),K(10,y.ITelemetryService),K(11,d.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends C.AbstractInitializer{constructor(s,t,i,o,u){super("keybindings",t,i,o,s,u)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return l(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};c=pe([K(0,w.IFileService),K(1,S.IUserDataProfilesService),K(2,E.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,d.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[259],se([0,1,16,3,160,19,68,15,29,13,23,22,33,28,45,59,240,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function l(n){const s=JSON.parse(n);return g(s)?s:{settings:n}}e.parseSettingsSyncContent=l;let f=class extends d.AbstractJsonFileSynchroniser{constructor(s,t,i,o,u,a,h,v,D,M,F,O,L){super(t.defaultProfile.settingsResource,"settings",s,i,o,u,a,M,F,h,v,D,L),this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,t),o=this.getSettingsSyncContent(i),u=new A.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&u.parse(o.settings),u.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,i){const o=await this.getLocalFileContent(),u=await this.getFormattingOptions(),a=this.getSettingsSyncContent(s);t=t===null&&i?s:t;const h=t?this.getSettingsSyncContent(t):null,v=await this.getIgnoredSettings();let D=null,M=!1,F=!1,O=!1;if(a){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,C.merge)($,a.settings,h?h.settings:null,v,[],u);D=V.localContent||V.remoteContent,M=V.localContent!==null,F=V.remoteContent!==null,O=V.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),D=o.value.toString().trim()||"{}",this.validateContent(D),F=!0);const L={content:D,localChange:M?2:0,remoteChange:F?2:0,hasConflicts:O},N=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:h?h.settings:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString().trim():"",u=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,C.merge)(o||"{}",t.settings,t.settings,u,[],a).remoteContent!==null}async getMergeResult(s,t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,C.updateIgnoredSettings)(s.previewResult.content,"{}",o,i):null}}async getAcceptResult(s,t,i,o){const u=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,C.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",a,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,C.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,C.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,o){const{fileContent:u}=i[0][0];let{content:a,localChange:h,remoteChange:v}=i[0][1];if(h===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(a,u,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const D=await this.getFormattingOptions(),M=this.getSettingsSyncContent(s),F=await this.getIgnoredSettings(a);a=(0,C.updateIgnoredSettings)(a,M?M.settings:"{}",F,D),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),i=(0,S.edit)(s.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const i=this.parseSyncData(t);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",o,i)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return l(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:u})=>!!u)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new m.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};f=pe([K(0,I.IFileService),K(1,y.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,E.IStorageService),K(4,m.IUserDataSyncStoreService),K(5,m.IUserDataSyncBackupStoreService),K(6,m.IUserDataSyncLogService),K(7,m.IUserDataSyncUtilService),K(8,T.IConfigurationService),K(9,m.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,P.IExtensionManagementService),K(12,p.IUriIdentityService)],f),e.SettingsSynchroniser=f;let c=class extends d.AbstractInitializer{constructor(s,t,i,o,u){super("settings",t,i,o,s,u)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return l(s)}catch(t){this.logService.error(t)}return null}};c=pe([K(0,I.IFileService),K(1,y.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,p.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[260],se([0,1,16,3,31,19,15,13,23,22,33,28,45,238,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(g,l,f,c,n,s,t,i,o,u,a){super("snippets",l,g,c,n,s,o,u,t,i,a),this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,h=>h.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,l,f){const c=await this.getSnippetsFileContents(),n=this.toSnippetsContents(c),s=g.syncData?this.parseSnippets(g.syncData):null;l=l===null&&f?g:l;const t=l&&l.syncData?this.parseSnippets(l.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(n,s,t);return this.getResourcePreviews(i,c,s||{},t||{})}async hasRemoteChanged(g){const l=g.syncData?this.parseSnippets(g.syncData):null;if(l===null)return!0;const f=await this.getSnippetsFileContents(),c=this.toSnippetsContents(f),n=(0,y.merge)(c,l,l);return Object.keys(n.remote.added).length>0||Object.keys(n.remote.updated).length>0||n.remote.removed.length>0||n.conflicts.length>0}async getMergeResult(g,l){return g.previewResult}async getAcceptResult(g,l,f,c){if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(l,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async applyResult(g,l,f,c){const n=f.map(([s,t])=>({...s,acceptResult:t}));n.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),n.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(n),await this.updateLocalSnippets(n,c)),n.some(({remoteChange:s})=>s!==0)&&(g=await this.updateRemoteSnippets(n,g,c)),l?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of n)try{await this.fileService.del(s)}catch{}}getResourcePreviews(g,l,f,c){const n=new Map;for(const s of Object.keys(g.local.added)){const t={content:g.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.local.updated)){const t={content:g.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.added)){const t={content:g.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.updated)){const t={content:g.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.conflicts){const t={content:l[s]?l[s].value.toString():null,hasConflicts:!0,localChange:l[s]?2:1,remoteChange:f[s]?2:1},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(l))if(!n.has(s)){const t={content:l[s]?l[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=l[s]?l[s].value.toString():null;n.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[s]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:l[s]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...n.values()]}async getAssociatedResources({uri:g}){const l=await super.resolveContent(g);if(l){const f=this.parseSyncData(l);if(f){const c=this.parseSnippets(f),n=[];for(const s of Object.keys(c)){const t=this.extUri.joinPath(g,s),i=this.extUri.joinPath(this.snippetsFolder,s),o=await this.fileService.exists(i);n.push({resource:t,comparableResource:o?i:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return n}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let l=await super.resolveContent(g);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(g)),l){const f=this.parseSyncData(l);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const l={};for(const f of g)f.fileContent&&(l[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(l)))}async updateLocalSnippets(g,l){for(const{fileContent:f,acceptResult:c,localResource:n,remoteResource:s,localChange:t}of g)if(t!==0){const i=s?this.extUri.basename(s):this.extUri.basename(n),o=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(c.content),{overwrite:l}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(c.content),l?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,l,f){const c=l.syncData?this.parseSnippets(l.syncData):{},n=(0,k.deepClone)(c);for(const{acceptResult:s,localResource:t,remoteResource:i,remoteChange:o}of g)if(o!==0){const u=t?this.extUri.basename(t):this.extUri.basename(i);o===3?delete n[u]:n[u]=s.content}return(0,y.areSame)(c,n)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),l=await this.updateRemoteUserData(JSON.stringify(n),f?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),l}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const l={};for(const f of Object.keys(g))l[f]=g[f].value.toString();return l}async getSnippetsFileContents(){const g={};let l;try{l=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof b.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of l.children||[]){const c=f.resource,n=this.extUri.extname(c);if(n===".json"||n===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,c),t=await this.fileService.readFile(c);g[s]=t}}return g}};S=pe([K(0,A.IEnvironmentService),K(1,b.IFileService),K(2,w.IUserDataProfilesService),K(3,P.IStorageService),K(4,d.IUserDataSyncStoreService),K(5,d.IUserDataSyncBackupStoreService),K(6,d.IUserDataSyncLogService),K(7,T.IConfigurationService),K(8,d.IUserDataSyncEnablementService),K(9,I.ITelemetryService),K(10,E.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends p.AbstractInitializer{constructor(g,l,f,c,n){super("snippets",l,f,c,g,n)}async doInitialize(g){const l=g.syncData?JSON.parse(g.syncData.content):null;if(!l){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(l)){const n=l[c];if(n){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,c);await this.fileService.createFile(s,R.VSBuffer.fromString(n)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=pe([K(0,b.IFileService),K(1,w.IUserDataProfilesService),K(2,A.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,E.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[261],se([0,1,16,19,15,13,23,22,33,28,45,26]),function(X,e,R,r,k,T,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(C,m){try{return JSON.parse(C).tasks}catch(g){return m.error(g),null}}e.getTasksContentFromSyncContent=p;let y=class extends E.AbstractFileSynchroniser{constructor(m,g,l,f,c,n,s,t,i,o,u){super(u.defaultProfile.tasksResource,"tasks",n,s,t,m,g,c,i,l,f,o),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(m,g,l,f){const c=m.syncData?p(m.syncData.content,this.logService):null;g=g===null&&l?m:g;const n=g?.syncData?p(g.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,i=!1,o=!1,u=!1;if(c){const v=s?s.value.toString():null;if(!n||n!==v||n!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const D=S(v,c,n);t=D.content,u=D.hasConflicts,i=D.hasLocalChanged,o=D.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const a={content:t,localChange:i?s?2:1:0,remoteChange:o?2:0,hasConflicts:u},h=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:n!==null?n:h,localResource:this.localResource,localContent:h,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?p(m.syncData.content,this.logService):null;if(g===null)return!0;const l=await this.getLocalFileContent(),f=l?l.value.toString():null,c=S(f,g,g);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,l,f){if(this.extUri.isEqual(g,this.localResource))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return l===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,l,f){const{fileContent:c}=l[0][0],{content:n,localChange:s,remoteChange:t}=l[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),await this.updateLocalFileContent(n||"{}",c,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(n||"{}"));m=await this.updateRemoteUserData(i,f?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:m}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(m,"tasks.json"),comparableResource:g}]}async resolveContent(m){if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const l=this.parseSyncData(g);if(l)switch(this.extUri.basename(m)){case"tasks.json":return p(l.content,this.logService)}}return null}toTasksSyncContent(m){return{tasks:m}}};y=pe([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,r.IConfigurationService),K(4,w.IUserDataSyncEnablementService),K(5,T.IFileService),K(6,k.IEnvironmentService),K(7,A.IStorageService),K(8,b.ITelemetryService),K(9,P.IUriIdentityService),K(10,I.IUserDataProfilesService)],y),e.TasksSynchroniser=y;let d=class extends E.AbstractInitializer{constructor(m,g,l,f,c){super("tasks",g,l,f,m,c),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(m){const g=m.syncData?p(m.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(m)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=pe([K(0,T.IFileService),K(1,I.IUserDataProfilesService),K(2,k.IEnvironmentService),K(3,w.IUserDataSyncLogService),K(4,P.IUriIdentityService)],d),e.TasksInitializer=d;function S(C,m,g){if(C===null&&m===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=g!==C,f=g!==m;return!l&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!f?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!l?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],se([0,1,3,2,4,15,23,22,26]),function(X,e,R,r,k,T,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const I="sync.enable";let E=class extends r.Disposable{constructor(p,y,d,S){super(),this.storageService=p,this.telemetryService=y,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(I,{enabled:p}),this.storageService.store(I,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,P.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,y){if(this.isResourceEnabled(p)!==y){const d=(0,P.getEnablementKey)(p);this.storeResourceEnablement(d,y)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,y){this.storageService.store(p,y,-1,k.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(I===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===p.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};E=pe([K(0,A.IStorageService),K(1,b.ITelemetryService),K(2,T.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(ne[73],se([0,1,3,2,4,24,163,15,13,5,25,47,23,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",C="Chrome",m="Edge",g="Firefox",l="Android";function f(s){switch(s){case S:case C:case m:case g:case l:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function c(){return k.isSafari?S:k.isChrome?C:k.isEdge?m:k.isFirefox?g:k.isAndroid?l:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let n=class nt extends r.Disposable{constructor(t,i,o,u,a,h){super(),this.storageService=o,this.userDataSyncStoreService=u,this.logService=a,this.productService=h,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,i,o)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(u=>({...u,isCurrent:u.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:u})=>u===i)||(o.machines.push({id:i,name:this.computeCurrentMachineName(o.machines),platform:c()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t),u=o.machines.filter(({id:a})=>a!==i);u.length!==o.machines.length&&(o.machines=u,await this.writeMachinesData(o))}async renameMachine(t,i,o){const u=await this.readMachinesData(o),a=u.machines.find(({id:h})=>h===t);if(a){a.name=i,await this.writeMachinesData(u);const h=await this.currentMachineIdPromise;t===h&&this.storageService.store(d,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[o,u]of t){const a=i.machines.find(h=>h.id===o);a&&(a.disabled=u?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(d,-1);if(i)return i;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,u=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const h of t){const v=u.exec(h.name),D=v?parseInt(v[1]):0;a=D>a?D:a}return`${o} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==nt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),o=await this.userDataSyncStoreService.write(nt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:o,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:nt.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=pe([K(0,b.IEnvironmentService),K(1,P.IFileService),K(2,p.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,E.IProductService)],n),e.UserDataSyncMachinesService=n}),define(ne[263],se([0,1,6,61,38,10,3,2,4,17,7,161,25,23,22,26,70,73]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",l="sync.sessionId",f="sync.storeUrl",c="sync.productQuality";let n=class extends b.Disposable{constructor(i,o,u,a,h,v,D,M,F,O){super(),this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=u,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=v,this.userDataSyncAccountService=D,this.telemetryService=M,this.userDataSyncMachinesService=F,this.storageService=O,this.autoSync=this._register(new b.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(D.onDidChangeAccount(()=>this.updateAutoSync())),this._register(u.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(L=>this.triggerSync([L],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,L])=>L)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const i=this.storageService.get(f,-1);return i?E.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(f,i.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(c,-1)}set productQuality(i){i?this.storageService.store(c,i,-1,1):this.storageService.remove(c,-1)}updateAutoSync(){const{enabled:i,message:o}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(u=>this.onDidFinishSync(u))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,o,u){try{this.userDataSyncAccountService.account&&!u&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(i);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(i,o,u){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",u)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=pe([K(0,p.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncEnablementService),K(4,S.IUserDataSyncService),K(5,S.IUserDataSyncLogService),K(6,C.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,m.IUserDataSyncMachinesService),K(9,y.IStorageService)],n),e.UserDataAutoSyncService=n;class s extends b.Disposable{constructor(i,o,u,a,h,v,D,M){super(),this.lastSyncUrl=i,this.interval=o,this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=v,this.logService=D,this.storageService=M,this.intervalHandler=this._register(new b.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,b.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(i,o){const u=(0,R.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,T.isCancellationError)(h))return}return this.doSync(i,o,a)});return this.syncPromise=u,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!i&&(!(0,I.isEqual)(o.defaultUrl,i.defaultUrl)||!(0,I.isEqual)(o.insidersUrl,i.insidersUrl)||!(0,I.isEqual)(o.stableUrl,i.stableUrl))}async doSync(i,o,u){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),u.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const h=this.storageService.get(l,-1);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(u.isCancellationRequested)return;const D=v.find(M=>M.isCurrent);if(D?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(M),M instanceof S.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(l,this.manifest.session,-1,1),u.isCancellationRequested)return;D||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}s.INTERVAL_SYNCING="Interval"}),define(ne[264],se([0,1,18,6,38,3,2,17,14,30,19,29,5,23,22,256,257,258,259,260,261,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let s=class extends A.Disposable{constructor(a,h,v,D,M,F,O,L){super(),this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=h,this.instantiationService=v,this.configurationService=D,this.logService=M,this.telemetryService=F,this.storageService=O,this.userDataSyncEnablementService=L,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(n,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,h){this.checkEnablement();const v=(0,I.generateUuid)();try{const L=(0,c.createSyncHeaders)(v);h&&(L["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,L)}catch(L){const N=c.UserDataSyncError.toUserDataSyncError(L);throw this.reportUserDataSyncError(N,v),N}const D=!1,M=this,F=this.getEnabledSynchronizers();let O;return{manifest:a,async run(){if(D)throw new Error("Can run a task only once");return O=(0,r.createCancelablePromise)(L=>M.sync(F,a,v,L)),O.finally(()=>O=void 0)},async stop(){if(O?.cancel(),M.status!=="idle")return M.stop(F)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,I.generateUuid)(),h=(0,c.createSyncHeaders)(a);let v;try{v=await this.userDataSyncStoreService.manifest(null,h)}catch(F){const O=c.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(O,a),O}await this.resetLocal();const D=this.getEnabledSynchronizers(),M=async()=>{await this.stop(D),await this.resetLocal()};return new t(a,v,h,D,M,this.configurationService,this.logService)}async sync(a,h,v,D){if(D.isCancellationRequested||!a.length)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const F=(0,c.createSyncHeaders)(v);for(const O of a){if(D.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(h,F)}catch(L){let N=!1;if(L instanceof c.UserDataSyncError)switch(L.code){case"TooLarge":L=new c.UserDataSyncError(L.message,L.code,O.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const $=c.UserDataSyncError.toUserDataSyncError(L);if(this.reportUserDataSyncError($,v),N)throw $;this.logService.error(L),this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(L)}`),this._syncErrors.push([O.resource,$])}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}catch(F){const O=c.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError(O,v),O}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const h of a)try{h.status!=="idle"&&await h.stop()}catch(v){this.logService.error(v)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async h=>{if(await h.replace(a))return!0})}async accept(a,h,v,D){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(M.resource===a)return await M.accept(h,v),D&&await M.apply(!1,(0,c.createSyncHeaders)((0,I.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async h=>{const v=await h.resolveContent(a);if(v)return v})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,h){return await this.performSynchronizerAction(async D=>{if(D.resource===a)return D.getAssociatedResources(h)})||[]}async getMachineId(a,h){return await this.performSynchronizerAction(async D=>{if(D.resource===a)return await D.getMachineId(h)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async h=>{if(h.resource!=="globalState"&&await h.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async h=>{if(await h.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(n,-1),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(h){this.logService.error(`${a.resource}: ${(0,k.toErrorMessage)(h)}`),this.logService.error(h)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const h=new A.DisposableStore;try{const v=this.synchronizers.value||h.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),D=[...v.enabled,...v.disabled.map(M=>h.add(v.createSynchronizer(M)))];for(const M of D){const F=await a(M);if(!(0,P.isUndefined)(F))return F}return null}finally{h.dispose()}}setStatus(a){const h=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),h==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const h=this.computeStatus(a);this.setStatus(h)}updateConflicts(a){const h=this.computeConflicts(a);(0,R.equals)(this._conflicts,h,([v,D],[M,F])=>v===v&&(0,R.equals)(D,F,(O,L)=>(0,b.isEqual)(O.previewResource,L.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(h))}computeConflicts(a){return a.filter(h=>h.status==="hasConflicts").map(h=>[h.resource,h.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(h=>h.status==="hasConflicts")?"hasConflicts":a.some(h=>h.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(n,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,h){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof c.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof c.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:h,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=pe([K(0,c.IUserDataSyncStoreService),K(1,c.IUserDataSyncStoreManagementService),K(2,p.IInstantiationService),K(3,E.IConfigurationService),K(4,c.IUserDataSyncLogService),K(5,d.ITelemetryService),K(6,y.IStorageService),K(7,c.IUserDataSyncEnablementService)],s),e.UserDataSyncService=s;class t extends A.Disposable{constructor(a,h,v,D,M,F,O){super(),this.id=a,this.manifest=h,this.syncHeaders=v,this.synchronisers=D,this.onStop=M,this.configurationService=F,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,r.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,h){try{return await this.performAction(a,v=>v.accept(a,h))}catch(v){throw this.logService.error(v),v}}async merge(a){try{return a?await this.performAction(a,h=>h.merge(a)):await this.mergeAll()}catch(h){throw this.logService.error(h),h}}async discard(a){try{return await this.performAction(a,h=>h.discard(a))}catch(h){throw this.logService.error(h),h}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,h]of this.previews)for(const v of h.resourcePreviews)v.mergeState==="conflict"&&a.push(v.previewResource);for(const h of a)await this.discard(h);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[h,v]of this.previews){this.synchronizingResources.push([h,v.resourcePreviews.map(F=>F.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find(F=>F.resource===h);for(const F of v.resourcePreviews)(F.localChange!==0||F.remoteChange!==0)&&F.mergeState==="preview"&&await D.merge(F.previewResource);const M=await D.apply(!1,this.syncHeaders);M&&a.push(this.toSyncResourcePreview(D.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(F=>F[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(D=>D.resource===a);for(const D of h.resourcePreviews)await v.accept(D.remoteResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(D=>D.resource===a);for(const D of h.resourcePreviews)await v.accept(D.localResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,h){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const v=this.previews.findIndex(([,V])=>V.resourcePreviews.some(({localResource:J,previewResource:H,remoteResource:G})=>(0,b.isEqual)(a,J)||(0,b.isEqual)(a,H)||(0,b.isEqual)(a,G)));if(v===-1)return this.previews;const[D,M]=this.previews[v],F=M.resourcePreviews.find(({localResource:V,remoteResource:J,previewResource:H})=>(0,b.isEqual)(V,a)||(0,b.isEqual)(J,a)||(0,b.isEqual)(H,a));if(!F)return this.previews;let O=this.synchronizingResources.find(V=>V[0]===D);O||(O=[D,[]],this.synchronizingResources.push(O)),O[1].some(V=>(0,b.isEqual)(V,F.localResource))||(O[1].push(F.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const L=this.synchronisers.find(V=>V.resource===this.previews[v][0]),N=await h(L);N?this.previews.splice(v,1,this.toSyncResourcePreview(L.resource,N)):this.previews.splice(v,1);const $=this.synchronizingResources.findIndex(V=>V[0]===D);return this.synchronizingResources[$][1].splice(O[1].findIndex(V=>(0,b.isEqual)(V,F.localResource)),1),O[1].length||(this.synchronizingResources.splice($,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[h,v]of this.previews){this.synchronizingResources.push([h,v.resourcePreviews.map(F=>F.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find(F=>F.resource===h);let M=v;for(const F of v.resourcePreviews)(F.localChange!==0||F.remoteChange!==0)&&F.mergeState==="preview"&&(M=await D.merge(F.previewResource));M&&a.push(this.toSyncResourcePreview(D.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(F=>F[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const h=[],v=await this.getUserDataSyncConfiguration();for(const D of this.synchronisers){if(a.isCancellationRequested)return[];const M=await D.preview(this.manifest,v,this.syncHeaders);M&&h.push(this.toSyncResourcePreview(D.resource,M))}return h}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),h=this.synchronisers.find(v=>v instanceof g.SettingsSynchroniser);if(h){const v=await h.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...v}}return a}toSyncResourcePreview(a,h){return[a,{isLastSyncFromCurrentMachine:h.isLastSyncFromCurrentMachine,resourcePreviews:h.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(a,h,v,D,M,F,O){super(),this.onDidChangeStatus=a,this.onDidChangeConflicts=h,this.onDidChangeLocal=v,this.userDataSyncEnablementService=D,this.instantiationService=M,this.extensionGalleryService=F,this.logService=O,this._enabled=[],this._register(D.onDidChangeResourceEnablement(([L,N])=>this.onDidChangeResourceEnablement(L,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,L])=>L.dispose())));for(const L of c.ALL_SYNC_RESOURCES)D.isResourceEnabled(L)&&this.registerSynchronizer(L)}get enabled(){return this._enabled.sort((a,h)=>a[1]-h[1]).map(([a])=>a)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,h){h?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([M])=>M.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const h=new A.DisposableStore,v=h.add(this.createSynchronizer(a));h.add(v.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),h.add(v.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),h.add(v.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const D=this.getOrder(a);this._enabled.push([v,D,h])}deRegisterSynchronizer(a){const h=this._enabled.findIndex(([v])=>v.resource===a);if(h!==-1){const v=this._enabled.splice(h,1);for(const[D,,M]of v){if(D.status!=="idle"){const F=D.conflicts.length>0;D.stop(),F&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}M.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(g.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(l.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(C.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};i=pe([K(3,c.IUserDataSyncEnablementService),K(4,p.IInstantiationService),K(5,w.IExtensionGalleryService),K(6,c.IUserDataSyncLogService)],i);function o(u){return{baseResource:u.baseResource,localResource:u.localResource,previewResource:u.previewResource,remoteResource:u.remoteResource,acceptedResource:u.acceptedResource,localChange:u.localChange,remoteChange:u.remoteChange,mergeState:u.mergeState}}}),define(ne[265],se([0,1,6,21,10,3,2,123,4,17,9,14,7,30,19,15,13,25,44,47,23,26]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const n="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",o=100,u=1e3*60*5;let a=class extends A.Disposable{constructor(O,L,N){super(),this.productService=O,this.configurationService=L,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(N.onDidChangeValue,$=>$.key===c.SYNC_SERVICE_URL_TYPE&&$.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,-1,P.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,L){O=P.isWeb&&O?.web?{...O,...O.web}:O;const N={...O||{},...L||{}};if(N&&(0,w.isString)(N.url)&&(0,w.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every($=>Array.isArray(N.authenticationProviders[$].scopes))){const $=N,V=!!$.canSwitch&&!L?.url,J=$.url===$.insidersUrl?"insiders":"stable",H=(V?this.userDataSyncStoreType:void 0)||J,G=L?.url||(H==="insiders"?$.insidersUrl:H==="stable"?$.stableUrl:$.url);return{url:p.URI.parse(G),type:H,defaultType:J,defaultUrl:p.URI.parse($.url),stableUrl:p.URI.parse($.stableUrl),insidersUrl:p.URI.parse($.insidersUrl),canSwitch:V,authenticationProviders:Object.keys($.authenticationProviders).reduce((q,x)=>(q.push({id:x,scopes:$.authenticationProviders[x].scopes}),q),[])}}}};a=pe([K(0,m.IProductService),K(1,d.IConfigurationService),K(2,f.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let h=class extends a{constructor(O,L,N){super(O,L,N);const $=this.storageService.get(n,-1);$&&(this.previousConfigurationSyncStore=JSON.parse($));const V=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(n,JSON.stringify(V),-1,1):this.storageService.remove(n,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=pe([K(0,m.IProductService),K(1,d.IConfigurationService),K(2,f.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let v=class extends A.Disposable{constructor(O,L,N,$,V,J,H){super(),this.requestService=N,this.logService=$,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,l.getServiceMachineId)(V,J,H).then(G=>{const q={"X-Client-Name":`${L.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":L.version};return L.commit&&(q["X-Client-Commit"]=L.commit),q}),this.session=new M(o,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,L){this.authToken={token:O,type:L}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(s,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(L=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),L).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,L=>null)):this.storageService.remove(s,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllResourceRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),N={},$=await this.request(L.toString(),{type:"GET",headers:N},[],r.CancellationToken.None);return(await(0,g.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,I.relativePath)(L,L.with({path:J})),created:H*1e3}))}async resolveResourceContent(O,L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,L).toString();N={...N},N["Cache-Control"]="no-cache";const V=await this.request($,{type:"GET",headers:N},[],r.CancellationToken.None);return await(0,g.asTextOrError)(V)}async deleteResource(O,L){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=L!==null?(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,L).toString():(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],r.CancellationToken.None)}async readResource(O,L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();N={...N},N["Cache-Control"]="no-cache",L&&(N["If-None-Match"]=L.ref);const V=await this.request($,{type:"GET",headers:N},[304],r.CancellationToken.None);let J=null;if(V.res.statusCode===304&&(J=L),J===null){const H=V.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",V.res.statusCode,V.res.headers[c.HEADER_OPERATION_ID]);const G=await(0,g.asTextOrError)(V);if(!G&&V.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",V.res.statusCode,V.res.headers[c.HEADER_OPERATION_ID]);J={ref:H,content:G}}return J}async writeResource(O,L,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();$={...$},$["Content-Type"]=b.Mimes.text,N&&($["If-Match"]=N);const J=await this.request(V,{type:"POST",data:L,headers:$},[],r.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",J.res.statusCode,J.res.headers[c.HEADER_OPERATION_ID]);return H}async manifest(O,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();L={...L},L["Content-Type"]="application/json",O&&(L["If-None-Match"]=O.ref);const $=await this.request(N,{type:"GET",headers:L},[304],r.CancellationToken.None);let V=null;if($.res.statusCode===304&&(V=O),!V){const H=$.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const G=await(0,g.asTextOrError)($);if(!G&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);G&&(V={...JSON.parse(G),ref:H})}const J=this.storageService.get(t,-1);return J&&V&&J!==V.session&&this.clearSession(),V===null&&J&&this.clearSession(),V&&this.storageService.store(t,V.session,-1,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),L={"Content-Type":b.Mimes.text};await this.request(O,{type:"DELETE",headers:L},[],r.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,-1),this.storageService.remove(i,-1)}async request(O,L,N,$){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;L.headers={...L.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(L.headers),this.logService.trace("Sending request to server",{url:O,type:L.type,headers:{...L.headers,authorization:void 0}});let J;try{J=await this.session.request(O,L,$)}catch(x){if(!(x instanceof c.UserDataSyncStoreError)){let Y="RequestFailed";const te=(0,k.getErrorMessage)(x).toLowerCase();te.includes("xhr timeout")?Y="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?Y="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?Y="RequestPathNotEscaped":te.includes("headers must be an object")?Y="RequestHeadersNotObject":(0,k.isCancellationError)(x)&&(Y="RequestCanceled"),x=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,Y,void 0,void 0)}throw this.logService.info("Request failed",O),x}const H=J.res.headers[c.HEADER_OPERATION_ID],G={url:O,status:J.res.statusCode,"execution-id":L.headers[c.HEADER_EXECUTION_ID],"operation-id":H},q=(0,g.isSuccess)(J)||J.res.statusCode&&N.indexOf(J.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),J.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",J.res.statusCode,H);if(this._onTokenSucceed.fire(),J.res.statusCode===409)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",J.res.statusCode,H);if(J.res.statusCode===410)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",J.res.statusCode,H);if(J.res.statusCode===412)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",J.res.statusCode,H);if(J.res.statusCode===413)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",J.res.statusCode,H);if(J.res.statusCode===426)throw new c.UserDataSyncStoreError(`${L.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",J.res.statusCode,H);if(J.res.statusCode===429){const x=J.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",J.res.statusCode,H)):new c.UserDataSyncStoreError(`${L.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",J.res.statusCode,H)}if(!q)throw new c.UserDataSyncStoreError("Server returned "+J.res.statusCode,O,"Unknown",J.res.statusCode,H);return J}addSessionHeaders(O){let L=this.storageService.get(i,-1);L===void 0&&(L=(0,y.generateUuid)(),this.storageService.store(i,L,-1,1)),O["X-Machine-Session-Id"]=L;const N=this.storageService.get(t,-1);N!==void 0&&(O["X-User-Session-Id"]=N)}};v=pe([K(1,m.IProductService),K(2,g.IRequestService),K(3,c.IUserDataSyncLogService),K(4,S.IEnvironmentService),K(5,C.IFileService),K(6,f.IStorageService)],v),e.UserDataSyncStoreClient=v;let D=class extends v{constructor(O,L,N,$,V,J,H){super(O.userDataSyncStore?.url,L,N,$,V,J,H),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}getAllRefs(O,L){return this.getAllResourceRefs(L?this.getProfileResource(O,L):O)}read(O,L,N,$){return this.readResource(N?this.getProfileResource(O,N):O,L,$)}write(O,L,N,$,V){return this.writeResource($?this.getProfileResource(O,$):O,L,N,V)}delete(O,L,N){return this.deleteResource(N?this.getProfileResource(O,N):O,L)}resolveContent(O,L,N,$){return this.resolveResourceContent(N?this.getProfileResource(O,N):O,L,$)}getProfileResource(O,L){if(O==="profiles")throw new Error(`Invalid Resource Argument: ${O}`);return(0,E.join)("profiles",L,O)}};D=pe([K(0,c.IUserDataSyncStoreManagementService),K(1,m.IProductService),K(2,g.IRequestService),K(3,c.IUserDataSyncLogService),K(4,S.IEnvironmentService),K(5,C.IFileService),K(6,f.IStorageService)],D),e.UserDataSyncStoreService=D;class M{constructor(O,L,N,$){this.limit=O,this.interval=L,this.requestService=N,this.logService=$,this.requests=[],this.startTime=void 0}request(O,L,N){if(this.isExpired()&&this.reset(),L.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(L,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=M}),define(ne[266],se([0,1,3,67,25,23,22,263,26,70,73]),function(X,e,R,r,k,T,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends b.UserDataAutoSyncService{constructor(y,d,S,C,m,g,l,f,c,n,s){super(y,d,S,C,m,l,f,c,n,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=pe([K(0,k.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,r.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,I.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,T.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[108],se([0,1,53,6,9,14,27,135,275,276]),function(X,e,R,r,k,T,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(n,s){let t=s.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=s}}e.ExtractError=E;function w(c){const n=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,t)=>s+t,n&61440)}function p(c){if(c instanceof E)return c;let n;return/end of central directory record signature not found/.test(c.message)&&(n="CorruptZip"),new E(n,c)}function y(c,n,s,t,i,o){const u=k.dirname(n),a=k.join(t,u);if(!a.startsWith(t))return Promise.reject(new Error(b.localize(0,null,n)));const h=k.join(t,n);let v;return o.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((D,M)=>{if(!o.isCancellationRequested)try{v=(0,R.createWriteStream)(h,{mode:s}),v.once("close",()=>D()),v.once("error",M),c.once("error",M),c.pipe(v)}catch(F){M(F)}}))}function d(c,n,s,t){let i=(0,r.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{i.cancel(),c.close()}),new Promise((u,a)=>{const h=new r.Sequencer,v=D=>{D.isCancellationRequested||(o++,c.readEntry())};c.once("error",a),c.once("close",()=>i.then(()=>{t.isCancellationRequested||c.entryCount===o?u():a(new E("Incomplete",new Error(b.localize(1,null,o,c.entryCount))))},a)),c.readEntry(),c.on("entry",D=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(D.fileName)){v(t);return}const M=D.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(M)){const L=k.join(n,M);i=(0,r.createCancelablePromise)(N=>A.Promises.mkdir(L,{recursive:!0}).then(()=>v(N)).then(void 0,a));return}const F=C(c,D),O=w(D);i=(0,r.createCancelablePromise)(L=>h.queue(()=>F.then(N=>y(N,M,O,n,s,L).then(()=>v(L)))).then(null,a))})})}function S(c,n=!1){return new Promise((s,t)=>{(0,P.open)(c,n?{lazyEntries:!0}:void 0,(i,o)=>{i?t(p(i)):s((0,T.assertIsDefined)(o))})})}function C(c,n){return new Promise((s,t)=>{c.openReadStream(n,(i,o)=>{i?t(p(i)):s((0,T.assertIsDefined)(o))})})}function m(c,n){return new Promise((s,t)=>{const i=new I.ZipFile;n.forEach(u=>{u.contents?i.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&i.addFile(u.localPath,u.path)}),i.end();const o=(0,R.createWriteStream)(c);i.outputStream.pipe(o),i.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(c))})}e.zip=m;function g(c,n,s={},t){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=S(c,!0);return s.overwrite&&(o=o.then(u=>A.Promises.rm(n).then(()=>u))),o.then(u=>d(u,n,{sourcePathRegex:i},t))}e.extract=g;function l(c,n){return S(c).then(s=>new Promise((t,i)=>{s.on("entry",o=>{o.fileName===n&&C(s,o).then(u=>t(u),u=>i(u))}),s.once("close",()=>i(new Error(b.localize(2,null,n))))}))}function f(c,n){return l(c,n).then(s=>new Promise((t,i)=>{const o=[];s.once("error",i),s.on("data",u=>o.push(u)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[267],se([0,1,108,145]),function(X,e,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,R.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=k}),define(ne[109],se([0,1,6,38,10,2,20,9,4,17,55,14,7,30,27,108,144,90,15,248,29,32,48,71,201,249,267,202,233,43,65,13,5,8,25,22,33,28]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n,s,t,i,o,u,a,h,v,D,M,F,O,L,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(f.IServerExtensionManagementService);let V=class extends l.AbstractExtensionManagementService{constructor(z,B,_,U,W,j,Z,oe,Q,ie,re,ue){super(z,B,_,ie,ue),this.extensionsScannerService=W,this.extensionsProfileScannerService=j,this.downloadService=Z,this.fileService=Q,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new u.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,Q,U,_,re));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const B=await this.collectFiles(z),_=await(0,S.zip)((0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,B);return p.URI.file(_)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:B,cleanup:_}=await this.downloadVsix(z),U=b.resolve(B.fsPath);try{return await(0,o.getManifest)(U)}finally{await _()}}getInstalled(z,B){return this.extensionsScanner.scanExtensions(z??null,B)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,B={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:_,cleanup:U}=await this.downloadVsix(z);try{const W=await(0,o.getManifest)(b.resolve(_.fsPath));if(W.engines&&W.engines.vscode&&!(0,v.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,c.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return await this.installExtension(W,_,B)}finally{await U()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,B){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const _={...B};return B.isPreReleaseVersion&&(_.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,_),this.manifestCache.invalidate(),z}async updateExtensionScope(z,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:B}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===A.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const B=(0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(z,B),this.logService.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.fileService.del(B)}catch(U){this.logService.error(U)}}}}doCreateInstallExtensionTask(z,B,_){let U;if(p.URI.isUri(B))U=new q(z,B,_,this.galleryService,this.extensionsScanner,this.logService);else{const W=c.ExtensionKey.create(B).toString();U=this.installGalleryExtensionsTasks.get(W),U||(this.installGalleryExtensionsTasks.set(W,U=new G(z,B,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(W)))}return _.profileLocation?new x(U,_.profileLocation,this.extensionsProfileScannerService):U}doCreateUninstallExtensionTask(z,B){return B.profileLocation?new te(z,B.profileLocation,this.extensionsProfileScannerService):new Y(z,B,this.extensionsScanner)}async collectFiles(z){const B=async U=>{let W=await d.Promises.readdir(U);W=W.map(oe=>b.join(U,oe));const j=await Promise.all(W.map(oe=>d.Promises.stat(oe)));let Z=Promise.resolve([]);return j.forEach((oe,Q)=>{const ie=W[Q];oe.isFile()&&(Z=Z.then(re=>[...re,ie])),oe.isDirectory()&&(Z=Z.then(re=>B(ie).then(ue=>[...re,...ue])))}),Z};return(await B(z.location.fsPath)).map(U=>({path:`extension/${b.relative(z.location.fsPath,U)}`,localPath:U}))}};V=pe([K(0,f.IExtensionGalleryService),K(1,L.ITelemetryService),K(2,F.ILogService),K(3,g.INativeEnvironmentService),K(4,s.IExtensionsScannerService),K(5,n.IExtensionsProfileScannerService),K(6,m.IDownloadService),K(7,M.IInstantiationService),K(8,D.IFileService),K(9,O.IProductService),K(10,N.IUriIdentityService),K(11,$.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let J=class extends T.Disposable{constructor(z,B,_,U){super(),this.beforeRemovingExtension=z,this.fileService=B,this.extensionsScannerService=_,this.logService=U,this.uninstalledPath=(0,I.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,B){const _={includeInvalid:!0,profileLocation:B};let U=[];return z===null||z===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):z===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(_)),U=z!==null?U.filter(W=>W.type===z):U,Promise.all(U.map(W=>this.toLocalExtension(W)))}async scanUserExtensions(z){const B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(B.map(_=>this.toLocalExtension(_)))}async extractUserExtension(z,B,_,U){const W=z.toString(),j=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,W);try{await d.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(C.localize(1,null,Z,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,B,j,U),_={..._,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(p.URI.file(j),_);try{await this.rename(z,j,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await d.Promises.rm(j)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(oe)}. Deleted from extracted location`,j),oe}return this.scanLocalExtension(p.URI.file(Z),1)}async updateMetadata(z,B){return await this.extensionsScannerService.updateMetadata(z.location,B),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const B=z.map(_=>c.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{B.forEach(U=>_[U.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(U=>delete U[z.toString()]);const _=(await this.scanUserExtensions(!0)).find(U=>c.ExtensionKey.create(U).equals(z))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(z,B){this.logService.trace(`Deleting ${B} extension from disk`,z.identifier.id,z.location.fsPath),await d.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(B=>delete B[c.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let B;try{B=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let _={};if(B)try{_=JSON.parse(B)}catch{}return z&&(z(_),Object.keys(_).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await d.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(z,B,_,U){this.logService.trace(`Started extracting the extension from ${B} to ${_}`);try{await d.Promises.rm(_)}catch(W){throw new f.ExtensionManagementError(this.joinErrors(W).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(B,_,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${_}:`,z.id)}catch(W){try{await d.Promises.rm(_)}catch{}let j=f.ExtensionManagementErrorCode.Extract;throw W instanceof S.ExtractError&&(W.type==="CorruptZip"?j=f.ExtensionManagementErrorCode.CorruptZip:W.type==="Incomplete"&&(j=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(W.message,j)}}async rename(z,B,_,U){try{await d.Promises.rename(B,_)}catch(W){if(P.isWindows&&W&&W.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${B} to ${_} with 'EPERM' error. Trying again...`,z.id),this.rename(z,B,_,U);throw new f.ExtensionManagementError(W.message||C.localize(2,null,B,_),W.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,B){const _=await this.extensionsScannerService.scanExistingExtension(z,B,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(C.localize(3,null,z.path))}async toLocalExtension(z){const B=await this.fileService.resolve(z.location);let _,U;return B.children&&(_=B.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,U=B.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const j of B)z[c.ExtensionKey.create(j).toString()]||_.add(j.identifier.id.toLowerCase());const U=(0,c.groupByExtension)(B,j=>j.identifier);await R.Promises.settled(U.map(async j=>{const Z=j.sort((oe,Q)=>E.rcompare(oe.manifest.version,Q.manifest.version))[0];_.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const W=B.filter(j=>z[c.ExtensionKey.create(j).toString()]);await R.Promises.settled(W.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),B=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],U=await this.extensionsScannerService.getTargetPlatform(),W=(0,c.groupByExtension)(B,j=>j.identifier);for(const j of W)if(j.length>1&&_.push(...j.sort((Z,oe)=>{const Q=E.rcompare(Z.manifest.version,oe.manifest.version);return Q!==0?Q:Z.targetPlatform===U?-1:1}).slice(1)),j[0].type===0){const Z=z.find(oe=>(0,c.areSameExtensions)(oe.identifier,j[0].identifier));(!Z||E.gte(Z.manifest.version,j[0].manifest.version))&&_.push(j[0])}await R.Promises.settled(_.map(j=>this.removeExtension(j,"outdated")))}joinErrors(z){const B=Array.isArray(z)?z:[z];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((_,U)=>new Error(`${_.message}${_.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};J=pe([K(1,D.IFileService),K(2,s.IExtensionsScannerService),K(3,F.ILogService)],J);class H extends l.AbstractExtensionTask{constructor(z,B,_,U,W){super(),this.identifier=z,this.source=B,this.options=_,this.extensionsScanner=U,this.logService=W,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,B){try{const _=await this.unsetUninstalledAndGetLocal(z.key);if(_)return z.metadata?this.extensionsScanner.updateMetadata(_,z.metadata):_}catch{throw P.isMacintosh?new f.ExtensionManagementError(C.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(C.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,B)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const _=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),_}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:B,metadata:_},U){const W=await this.extensionsScanner.extractUserExtension(B,z,_,U);return this.logService.info("Extracting completed.",B.id),W}}class G extends H{constructor(z,B,_,U,W,j){super(B.identifier,B,_,W,j),this.manifest=z,this.gallery=B,this.extensionsDownloader=U}async doRun(z){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,c.areSameExtensions)(j.identifier,this.gallery.identifier));_&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,h.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,U),metadata:U};const W=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:W,key:c.ExtensionKey.create(this.gallery),metadata:U},z);return _&&!this.options.profileLocation&&(_.targetPlatform!==j.targetPlatform||E.neq(_.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:j,metadata:U}}catch(j){throw await this.deleteDownloadedVSIX(W),j}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(p.URI.file(z))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(B))}}async downloadExtension(z,B){let _;try{this.logService.trace("Started downloading extension:",z.identifier.id),_=(await this.extensionsDownloader.downloadExtension(z,B)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,_)}catch(U){throw new f.ExtensionManagementError((0,l.joinErrors)(U).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(_),_}catch(U){throw await this.deleteDownloadedVSIX(_),new f.ExtensionManagementError((0,l.joinErrors)(U).message,f.ExtensionManagementErrorCode.Invalid)}}}class q extends H{constructor(z,B,_,U,W,j){super({id:(0,c.getGalleryExtensionId)(z.publisher,z.name)},B,_,W,j),this.manifest=z,this.location=B,this.galleryService=U}async doRun(z){const B=new c.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,c.areSameExtensions)(this.identifier,Z.identifier)),W=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(W.isApplicationScoped=(0,h.isApplicationScopedExtension)(this.manifest),W.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,W.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=3,B.equals(new c.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&E.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const Z=await this.unsetUninstalledAndGetLocal(B);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:b.resolve(this.location.fsPath),key:B,metadata:W},z),metadata:W}}async getMetadata(z,B,_){try{let[U]=await this.galleryService.getExtensions([{id:z,version:B}],_);if(U||([U]=await this.galleryService.getExtensions([{id:z}],_)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class x{constructor(z,B,_){this.task=z,this.profileLocation=B,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends l.AbstractExtensionTask{constructor(z,B,_){super(),this.extension=z,this.options=B,this.extensionsScanner=_}async doRun(z){const B=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=c.ExtensionKey.create(this.extension);B.push(..._.filter(W=>U.equals(c.ExtensionKey.create(W))))}else B.push(..._.filter(U=>(0,c.areSameExtensions)(U.identifier,this.extension.identifier)));if(!B.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const U of B)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(W){throw new Error(C.localize(9,null,(0,r.toErrorMessage)(W)))}}}class te extends l.AbstractExtensionTask{constructor(z,B,_){super(),this.extension=z,this.profileLocation=B,this.extensionsProfileScannerService=_}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[268],se([0,1,2,29,32,48,72,200,109,43,5,8,23,33,28]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends R.Disposable{constructor(l,f,c,n,s,t,i,o){super(),this.userDataProfilesService=f,l.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,b.migrateUnsupportedExtensions)(l,c,n,s,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(l,i),this._register(t.createInstance(m))}};C=pe([K(0,P.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,r.IExtensionGalleryService),K(3,A.IExtensionStorageService),K(4,r.IGlobalExtensionEnablementService),K(5,E.IInstantiationService),K(6,p.IStorageService),K(7,w.ILogService)],C),e.ExtensionsCleaner=C;let m=class extends R.Disposable{constructor(l,f,c,n,s){super(),this.extensionManagementService=l,this.userDataProfilesService=f,this.extensionsProfileScannerService=c,this.uriIdentityService=n,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:l,removed:f,all:c}){try{await Promise.all(f.map(n=>n.extensionsResource?this.removeExtensionsFromProfile(n.extensionsResource):Promise.resolve()))}catch(n){this.logService.error(n)}if(c.length===1){this.profileModeDisposables.clear();const n=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{n.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{l.length&&(await Promise.all(l.map(n=>n.extensionsResource?this.populateExtensionsFromProfile(n.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(n=>this.onDidChangeProfiles(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(n=>this.onDidUninstallExtension(n))),await this.uninstallExtensionsNotInProfiles()))}catch(n){this.logService.error(n)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(c=>!this.profileExtensionsLocations.has(this.getKey(c.identifier,c.manifest.version)));f.length&&await Promise.all(f.map(c=>this.extensionManagementService.uninstall(c,S)))}async onDidInstallExtensions(l){for(const{local:f,profileLocation:c}of l)!f||!c||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),c)}async onDidUninstallExtension(l){!l.profileLocation||!l.version||this.removeExtensionWithKey(this.getKey(l.identifier,l.version),l.profileLocation)&&await this.uninstallExtensions([{identifier:l.identifier,version:l.version}])}async populateExtensionsFromProfile(l){const f=await this.extensionsProfileScannerService.scanProfileExtensions(l);for(const c of f)this.addExtensionWithKey(this.getKey(c.identifier,c.version),l)}async removeExtensionsFromProfile(l){const f=[];for(const c of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(c,l))continue;const n=this.fromKey(c);n&&f.push(n)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(l,f){let c=this.profileExtensionsLocations.get(l);c||(c=[],this.profileExtensionsLocations.set(l,c)),c.push(f)}removeExtensionWithKey(l,f){const c=this.profileExtensionsLocations.get(l);if(c){const n=c.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,f));n>-1&&c.splice(n,1)}return c?.length?!1:(this.profileExtensionsLocations.delete(l),!0)}async uninstallExtensions(l){const c=(await this.extensionManagementService.getAllUserInstalled()).filter(n=>l.some(s=>this.getKey(n.identifier,n.manifest.version)===this.getKey(s.identifier,s.version)));c.length&&await Promise.all(c.map(n=>this.extensionManagementService.uninstall(n,S)))}getKey(l,f){return`${I.ExtensionIdentifier.toKey(l.id)}@${f}`}fromKey(l){const[f,c]=(0,k.getIdAndVersion)(l);return c?{identifier:{id:f},version:c}:void 0}};m=pe([K(0,P.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,T.IExtensionsProfileScannerService),K(3,y.IUriIdentityService),K(4,w.ILogService)],m)}),define(ne[277],se([0,1,85,37,38,10,2,20,17,7,39,133,193,268,194,185,186,187,173,176,19,198,89,218,90,208,15,214,251,252,29,175,253,109,91,171,13,189,191,56,5,183,93,184,94,66,203,8,95,67,96,25,44,23,254,101,22,102,103,104,49,222,105,224,230,72,107,26,70,241,242,243,73,262,264,244,265,266,245,100,216,69,232,205,231,99,213,33,234,4,235,178,196,195,71,250,28,48,192,58,255,211,221,247]),function(X,e,R,r,k,T,A,b,P,I,E,w,p,y,d,S,C,m,g,l,f,c,n,s,t,i,o,u,a,h,v,D,M,F,O,L,N,$,V,J,H,G,q,x,Y,te,ce,z,B,_,U,W,j,Z,oe,Q,ie,re,ue,he,ve,we,Ee,Pe,Ue,ze,Ve,We,ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,Re,Te,qe,Le,Ne,je,Xe,Ze,Pt,It,Rt,vt,Dt,St,kt,Lt,Tt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class _t extends A.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",xe=(He,et)=>{this.onDisposeWorker(et)};R.ipcRenderer.on(Oe,xe),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,xe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const xe=Oe.get(z.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(xe)}),this._register((0,A.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(d.LanguagePackCachedDataCleaner),ye.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(C.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(y.ExtensionsCleaner),ye.createInstance(At.UserDataProfilesCleaner)))}async initServices(){const ye=new q.ServiceCollection,Oe={_serviceBrand:void 0,...U.default};ye.set(W.IProductService,Oe);const xe=new E.StaticRouter(Ye=>Ye==="main"),He=new x.MessagePortMainProcessService(this.server,xe);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new Dt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new St.NullPolicyService;ye.set(St.IPolicyService,et);const Be=new u.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,Be);const ot=new B.LogLevelChannelClient(this.server.getChannel("logLevel",xe)),tt=new B.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(z.ILoggerService,tt);const lt=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,P.joinPath)(I.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new B.FollowerLogService(ot,lt));ye.set(z.ILogService,Ge),this.sharedProcessWorkerService=new Re.SharedProcessWorkerService(Ge),ye.set(be.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(N.IFileService,Je);const ut=this._register(new V.DiskFileSystemProvider(Ge));Je.registerProvider(b.Schemas.file,ut);const ht=this._register(new Ne.FileUserDataProvider(b.Schemas.file,this._register(new je.DiskFileSystemProviderClient(He.getChannel(je.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Le.isLinux})),b.Schemas.vscodeUserData,Ge));Je.registerProvider(b.Schemas.vscodeUserData,ht);const it=this._register(new kt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(Rt.IUserDataProfilesService,it);const Ke=this._register(new c.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(f.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,A.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Te.IUriIdentityService,new qe.UriIdentityService(Je)),ye.set(j.IRequestService,new Lt.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(l.ChecksumService)),ye.set(Ze.IV8InspectProfilingService,new J.SyncDescriptor(Xe.InspectProfilingService));const at=E.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(_.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(i.DownloadService));const dt=this._register(new _e.ActiveWindowManager(at)),Ut=new E.StaticRouter(Ye=>dt.getActiveClientId().then(ft=>Ye===ft));ye.set(O.IExtensionRecommendationNotificationService,new L.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ut)));let ct;const st=[],wt=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:ft}=Be;if(Oe.aiConfig?.ariaKey){const bt=new Tt.OneDataSystemAppender(wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>bt.flush())),st.push(bt)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,Q.resolveCommonProperties)(Je,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt,ft),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new re.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Mt=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Mt),ye.set(vt.IExtensionsProfileScannerService,new J.SyncDescriptor(vt.ExtensionsProfileScannerService)),ye.set(Pt.IExtensionsScannerService,new J.SyncDescriptor(It.ExtensionsScannerService)),ye.set(F.INativeServerExtensionManagementService,new J.SyncDescriptor(F.ExtensionManagementService)),ye.set(v.IExtensionGalleryService,new J.SyncDescriptor(h.ExtensionGalleryService)),ye.set(v.IExtensionTipsService,new J.SyncDescriptor(M.ExtensionTipsService)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService)),ye.set(n.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService)),ye.set(We.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(v.IGlobalExtensionEnablementService,new J.SyncDescriptor(a.GlobalExtensionEnablementService)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService)),ye.set(ze.IExtensionStorageService,new J.SyncDescriptor(ze.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(de.UserDataSyncBackupStoreService)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService));const Et=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return Et.initialize(),ye.set(Pe.ILocalPtyService,this._register(Et)),ye.set(ke.ISignService,new J.SyncDescriptor(ee.SignService)),ye.set(le.ISharedTunnelsService,new J.SyncDescriptor(me.SharedTunnelsService)),ye.set(ge.ISharedProcessTunnelService,new J.SyncDescriptor(Se.SharedProcessTunnelService)),new G.InstantiationService(ye)}initChannels(ye){const Oe=new D.ExtensionManagementChannel(ye.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const xe=E.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",xe);const He=E.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new D.ExtensionTipsChannel(ye.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=E.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=E.ProxyChannel.fromService(ye.get(Ze.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=E.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new fe.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=E.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=E.ProxyChannel.fromService(ye.get(ge.ISharedProcessTunnelService));this.server.registerChannel(ge.ipcSharedProcessTunnelChannelName,at);const dt=E.ProxyChannel.fromService(ye.get(be.ISharedProcessWorkerService));this.server.registerChannel(be.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const xe=(0,k.toErrorMessage)(Oe,!0);!xe||ye.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Ot(yt){const ye=new _t(yt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ot})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b7c86dcc30ef2e94d7f679586bb65d37c87d0876/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
