/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var i=[],D=0,I=B.length;D<I;D++)i[D]=Q[B[D]];return i};define(Q[68],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.assertNever=i.ok=void 0;function D(w,R){if(!w)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}i.ok=D;function I(w,R="Unreachable"){throw new Error(R)}i.assertNever=I}),define(Q[49],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(T){return(p,c,d)=>{let C=null,E=null;if(typeof d.value=="function"?(C="value",E=d.value):typeof d.get=="function"&&(C="get",E=d.get),!E)throw new Error("not supported");d[C]=T(E,c)}}i.createDecorator=D;function I(T,p,c){let d=null,C=null;if(typeof c.value=="function"?(d="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",C=c.get),!C)throw new Error("not supported");const E=`$memoize$${p}`;c[d]=function(...h){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,h)}),this[E]}}i.memoize=I;function w(T,p,c){return D((d,C)=>{const E=`$debounce$${C}`,h=`$debounce$result$${C}`;return function(...v){this[h]||(this[h]=c?c():void 0),clearTimeout(this[E]),p&&(this[h]=p(this[h],...v),v=[this[h]]),this[E]=setTimeout(()=>{d.apply(this,v),this[h]=c?c():void 0},T)}})}i.debounce=w;function R(T,p,c){return D((d,C)=>{const E=`$throttle$timer$${C}`,h=`$throttle$result$${C}`,v=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...m){if(this[h]||(this[h]=c?c():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...m)),this[f])return;const S=this[v]+T;S<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0},S-Date.now()))}})}i.throttle=R}),define(Q[50],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function T(e,r=!1){let t=0;const n=e.length;let o="",y=0,P=16,b=0;function k(ne){let ge=0,ue=0;for(;ge<ne;){const se=e.charCodeAt(t);if(se>=48&&se<=57)ue=ue*16+se-48;else if(se>=65&&se<=70)ue=ue*16+se-65+10;else if(se>=97&&se<=102)ue=ue*16+se-97+10;else break;t++,ge++}return ge<ne&&(ue=-1),ue}function W(ne){t=ne,o="",y=0,P=16,b=0}function _(){const ne=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&d(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&d(e.charCodeAt(t)))for(t++;t<e.length&&d(e.charCodeAt(t));)t++;else return b=3,e.substring(ne,t);let ge=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&d(e.charCodeAt(t))){for(t++;t<e.length&&d(e.charCodeAt(t));)t++;ge=t}else b=3;return e.substring(ne,ge)}function q(){let ne="",ge=t;for(;;){if(t>=n){ne+=e.substring(ge,t),b=2;break}const ue=e.charCodeAt(t);if(ue===34){ne+=e.substring(ge,t),t++;break}if(ue===92){if(ne+=e.substring(ge,t),t++,t>=n){b=2;break}switch(e.charCodeAt(t++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const V=k(4);V>=0?ne+=String.fromCharCode(V):b=4;break}default:b=5}ge=t;continue}if(ue>=0&&ue<=31)if(c(ue)){ne+=e.substring(ge,t),b=2;break}else b=6;t++}return ne}function Y(){if(o="",b=0,y=t,t>=n)return y=n,P=17;let ne=e.charCodeAt(t);if(p(ne)){do t++,o+=String.fromCharCode(ne),ne=e.charCodeAt(t);while(p(ne));return P=15}if(c(ne))return t++,o+=String.fromCharCode(ne),ne===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),P=14;switch(ne){case 123:return t++,P=1;case 125:return t++,P=2;case 91:return t++,P=3;case 93:return t++,P=4;case 58:return t++,P=6;case 44:return t++,P=5;case 34:return t++,o=q(),P=10;case 47:{const ge=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<n&&!c(e.charCodeAt(t));)t++;return o=e.substring(ge,t),P=12}if(e.charCodeAt(t+1)===42){t+=2;const ue=n-1;let se=!1;for(;t<ue;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,se=!0;break}t++}return se||(t++,b=1),o=e.substring(ge,t),P=13}return o+=String.fromCharCode(ne),t++,P=16}case 45:if(o+=String.fromCharCode(ne),t++,t===n||!d(e.charCodeAt(t)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),P=11;default:for(;t<n&&ie(ne);)t++,ne=e.charCodeAt(t);if(y!==t){switch(o=e.substring(y,t),o){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return o+=String.fromCharCode(ne),t++,P=16}}function ie(ne){if(p(ne)||c(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let ne;do ne=Y();while(ne>=12&&ne<=15);return ne}return{setPosition:W,getPosition:()=>t,scan:r?ae:Y,getToken:()=>P,getTokenValue:()=>o,getTokenOffset:()=>y,getTokenLength:()=>t-y,getTokenError:()=>b}}i.createScanner=T;function p(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function E(e,r){const t=[],n=new Object;let o;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function b(k,W,_,q){y.value=k,y.offset=W,y.length=_,y.type=q,y.colonOffset=void 0,o=y}try{g(e,{onObjectBegin:(k,W)=>{if(r<=k)throw n;o=void 0,P=r>k,t.push("")},onObjectProperty:(k,W,_)=>{if(r<W||(b(k,W,_,"property"),t[t.length-1]=k,r<=W+_))throw n},onObjectEnd:(k,W)=>{if(r<=k)throw n;o=void 0,t.pop()},onArrayBegin:(k,W)=>{if(r<=k)throw n;o=void 0,t.push(0)},onArrayEnd:(k,W)=>{if(r<=k)throw n;o=void 0,t.pop()},onLiteralValue:(k,W,_)=>{if(r<W||(b(k,W,_,s(k)),r<=W+_))throw n},onSeparator:(k,W,_)=>{if(r<=W)throw n;if(k===":"&&o&&o.type==="property")o.colonOffset=W,P=!1,o=void 0;else if(k===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(P=!0,t[t.length-1]=""),o=void 0}}})}catch(k){if(k!==n)throw k}return{path:t,previousNode:o,isAtPropertyKey:P,matches:k=>{let W=0;for(let _=0;W<k.length&&_<t.length;_++)if(k[W]===t[_]||k[W]==="*")W++;else if(k[W]!=="**")return!1;return W===k.length}}}i.getLocation=E;function h(e,r=[],t=R.DEFAULT){let n=null,o=[];const y=[];function P(k){Array.isArray(o)?o.push(k):n!==null&&(o[n]=k)}return g(e,{onObjectBegin:()=>{const k={};P(k),y.push(o),o=k,n=null},onObjectProperty:k=>{n=k},onObjectEnd:()=>{o=y.pop()},onArrayBegin:()=>{const k=[];P(k),y.push(o),o=k,n=null},onArrayEnd:()=>{o=y.pop()},onLiteralValue:P,onError:(k,W,_)=>{r.push({error:k,offset:W,length:_})}},t),o[0]}i.parse=h;function v(e,r=[],t=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){n.type==="property"&&(n.length=k-n.offset,n=n.parent)}function y(k){return n.children.push(k),k}g(e,{onObjectBegin:k=>{n=y({type:"object",offset:k,length:-1,parent:n,children:[]})},onObjectProperty:(k,W,_)=>{n=y({type:"property",offset:W,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:k,offset:W,length:_,parent:n})},onObjectEnd:(k,W)=>{n.length=k+W-n.offset,n=n.parent,o(k+W)},onArrayBegin:(k,W)=>{n=y({type:"array",offset:k,length:-1,parent:n,children:[]})},onArrayEnd:(k,W)=>{n.length=k+W-n.offset,n=n.parent,o(k+W)},onLiteralValue:(k,W,_)=>{y({type:s(k),offset:W,length:_,parent:n,value:k}),o(W+_)},onSeparator:(k,W,_)=>{n.type==="property"&&(k===":"?n.colonOffset=W:k===","&&o(W))},onError:(k,W,_)=>{r.push({error:k,offset:W,length:_})}},t);const b=n.children[0];return b&&delete b.parent,b}i.parseTree=v;function f(e,r){if(!e)return;let t=e;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const y of t.children)if(Array.isArray(y.children)&&y.children[0].value===n){t=y.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=f;function m(e){if(!e.parent||!e.parent.children)return[];const r=m(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;r.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&r.push(t)}return r}i.getNodePath=m;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":{const r=Object.create(null);for(const t of e.children){const n=t.children[1];n&&(r[t.children[0].value]=S(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=S;function l(e,r,t=!1){return r>=e.offset&&r<e.offset+e.length||t&&r===e.offset+e.length}i.contains=l;function u(e,r,t=!1){if(l(e,r,t)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const y=u(n[o],r,t);if(y)return y}return e}}i.findNodeAtOffset=u;function g(e,r,t=R.DEFAULT){const n=T(e,!1);function o(A){return A?()=>A(n.getTokenOffset(),n.getTokenLength()):()=>!0}function y(A){return A?U=>A(U,n.getTokenOffset(),n.getTokenLength()):()=>!0}const P=o(r.onObjectBegin),b=y(r.onObjectProperty),k=o(r.onObjectEnd),W=o(r.onArrayBegin),_=o(r.onArrayEnd),q=y(r.onLiteralValue),Y=y(r.onSeparator),ie=o(r.onComment),ae=y(r.onError),ne=t&&t.disallowComments,ge=t&&t.allowTrailingComma;function ue(){for(;;){const A=n.scan();switch(n.getTokenError()){case 4:se(14);break;case 5:se(15);break;case 3:se(13);break;case 1:ne||se(11);break;case 2:se(12);break;case 6:se(16);break}switch(A){case 12:case 13:ne?se(10):ie();break;case 16:se(1);break;case 15:case 14:break;default:return A}}}function se(A,U=[],O=[]){if(ae(A),U.length+O.length>0){let L=n.getToken();for(;L!==17;){if(U.indexOf(L)!==-1){ue();break}else if(O.indexOf(L)!==-1)break;L=ue()}}}function V(A){const U=n.getTokenValue();return A?q(U):b(U),ue(),!0}function N(){switch(n.getToken()){case 11:{let A=0;try{A=JSON.parse(n.getTokenValue()),typeof A!="number"&&(se(2),A=0)}catch{se(2)}q(A);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return ue(),!0}function F(){return n.getToken()!==10?(se(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(Y(":"),ue(),J()||se(4,[],[2,5])):se(5,[],[2,5]),!0)}function z(){P(),ue();let A=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(A||se(4,[],[]),Y(","),ue(),n.getToken()===2&&ge)break}else A&&se(6,[],[]);F()||se(4,[],[2,5]),A=!0}return k(),n.getToken()!==2?se(7,[2],[]):ue(),!0}function $(){W(),ue();let A=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(A||se(4,[],[]),Y(","),ue(),n.getToken()===4&&ge)break}else A&&se(6,[],[]);J()||se(4,[],[4,5]),A=!0}return _(),n.getToken()!==4?se(8,[4],[]):ue(),!0}function J(){switch(n.getToken()){case 3:return $();case 1:return z();case 10:return V(!0);default:return N()}}return ue(),n.getToken()===17?t.allowEmptyContent?!0:(se(4,[],[]),!1):J()?(n.getToken()!==17&&se(9,[],[]),!0):(se(4,[],[]),!1)}i.visit=g;function a(e,r){const t=T(e),n=[];let o,y=0,P;do switch(P=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:y!==P&&n.push(e.substring(y,P)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),y=t.getPosition();break}while(o!==17);return n.join("")}i.stripComments=a;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(w){const R=[];typeof w=="number"&&R.push("code/timeOrigin",w);function T(c){R.push(c,Date.now())}function p(){const c=[];for(let d=0;d<R.length;d+=2)c.push({name:R[d],startTime:R[d+1]});return c}return{mark:T,getMarks:p}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(w+T.startTime)});return R}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=i()),w.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=D(I))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var I in D)(typeof exports=="object"?exports:B)[I]=D[I]}}(typeof self<"u"?self:this,function(){return function(B){var i={};function D(I){if(i[I])return i[I].exports;var w=i[I]={i:I,l:!1,exports:{}};return B[I].call(w.exports,w,w.exports,D),w.l=!0,w.exports}return D.m=B,D.c=i,D.d=function(I,w,R){D.o(I,w)||Object.defineProperty(I,w,{enumerable:!0,get:R})},D.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},D.t=function(I,w){if(1&w&&(I=D(I)),8&w||4&w&&typeof I=="object"&&I&&I.__esModule)return I;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:I}),2&w&&typeof I!="string")for(var T in I)D.d(R,T,function(p){return I[p]}.bind(null,T));return R},D.n=function(I){var w=I&&I.__esModule?function(){return I.default}:function(){return I};return D.d(w,"a",w),w},D.o=function(I,w){return Object.prototype.hasOwnProperty.call(I,w)},D.p="",D(D.s=0)}([function(B,i,D){(function(I){var w;i=B.exports=O,w=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,p=i.re=[],c=i.src=[],d=0,C=d++;c[C]="0|[1-9]\\d*";var E=d++;c[E]="[0-9]+";var h=d++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;c[v]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var f=d++;c[f]="("+c[E]+")\\.("+c[E]+")\\.("+c[E]+")";var m=d++;c[m]="(?:"+c[C]+"|"+c[h]+")";var S=d++;c[S]="(?:"+c[E]+"|"+c[h]+")";var l=d++;c[l]="(?:-("+c[m]+"(?:\\."+c[m]+")*))";var u=d++;c[u]="(?:-?("+c[S]+"(?:\\."+c[S]+")*))";var g=d++;c[g]="[0-9A-Za-z-]+";var a=d++;c[a]="(?:\\+("+c[g]+"(?:\\."+c[g]+")*))";var s=d++,e="v?"+c[v]+c[l]+"?"+c[a]+"?";c[s]="^"+e+"$";var r="[v=\\s]*"+c[f]+c[u]+"?"+c[a]+"?",t=d++;c[t]="^"+r+"$";var n=d++;c[n]="((?:<|>)?=?)";var o=d++;c[o]=c[E]+"|x|X|\\*";var y=d++;c[y]=c[C]+"|x|X|\\*";var P=d++;c[P]="[v=\\s]*("+c[y]+")(?:\\.("+c[y]+")(?:\\.("+c[y]+")(?:"+c[l]+")?"+c[a]+"?)?)?";var b=d++;c[b]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[u]+")?"+c[a]+"?)?)?";var k=d++;c[k]="^"+c[n]+"\\s*"+c[P]+"$";var W=d++;c[W]="^"+c[n]+"\\s*"+c[b]+"$";var _=d++;c[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=d++;c[q]="(?:~>?)";var Y=d++;c[Y]="(\\s*)"+c[q]+"\\s+",p[Y]=new RegExp(c[Y],"g");var ie=d++;c[ie]="^"+c[q]+c[P]+"$";var ae=d++;c[ae]="^"+c[q]+c[b]+"$";var ne=d++;c[ne]="(?:\\^)";var ge=d++;c[ge]="(\\s*)"+c[ne]+"\\s+",p[ge]=new RegExp(c[ge],"g");var ue=d++;c[ue]="^"+c[ne]+c[P]+"$";var se=d++;c[se]="^"+c[ne]+c[b]+"$";var V=d++;c[V]="^"+c[n]+"\\s*("+r+")$|^$";var N=d++;c[N]="^"+c[n]+"\\s*("+e+")$|^$";var F=d++;c[F]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[P]+")",p[F]=new RegExp(c[F],"g");var z=d++;c[z]="^\\s*("+c[P]+")\\s+-\\s+("+c[P]+")\\s*$";var $=d++;c[$]="^\\s*("+c[b]+")\\s+-\\s+("+c[b]+")\\s*$";var J=d++;c[J]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)w(A,c[A]),p[A]||(p[A]=new RegExp(c[A]));function U(x,H){if(x instanceof O)return x;if(typeof x!="string"||x.length>R||!(H?p[t]:p[s]).test(x))return null;try{return new O(x,H)}catch{return null}}function O(x,H){if(x instanceof O){if(x.loose===H)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof O))return new O(x,H);w("SemVer",x,H),this.loose=H;var X=x.trim().match(H?p[t]:p[s]);if(!X)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(ce){if(/^[0-9]+$/.test(ce)){var me=+ce;if(me>=0&&me<T)return me}return ce}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}i.parse=U,i.valid=function(x,H){var X=U(x,H);return X?X.version:null},i.clean=function(x,H){var X=U(x.trim().replace(/^[=v]+/,""),H);return X?X.version:null},i.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(x){return w("SemVer.compare",this.version,this.loose,x),x instanceof O||(x=new O(x,this.loose)),this.compareMain(x)||this.comparePre(x)},O.prototype.compareMain=function(x){return x instanceof O||(x=new O(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},O.prototype.comparePre=function(x){if(x instanceof O||(x=new O(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],ce=x.prerelease[H];if(w("prerelease compare",H,X,ce),X===void 0&&ce===void 0)return 0;if(ce===void 0)return 1;if(X===void 0)return-1;if(X!==ce)return M(X,ce)}while(++H)},O.prototype.inc=function(x,H){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,H,X,ce){typeof X=="string"&&(ce=X,X=void 0);try{return new O(x,X).inc(H,ce).version}catch{return null}},i.diff=function(x,H){if(oe(x,H))return null;var X=U(x),ce=U(H);if(X.prerelease.length||ce.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ce[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ce[me])return me},i.compareIdentifiers=M;var L=/^[0-9]+$/;function M(x,H){var X=L.test(x),ce=L.test(H);return X&&ce&&(x=+x,H=+H),X&&!ce?-1:ce&&!X?1:x<H?-1:x>H?1:0}function j(x,H,X){return new O(x,X).compare(new O(H,X))}function G(x,H,X){return j(x,H,X)>0}function K(x,H,X){return j(x,H,X)<0}function oe(x,H,X){return j(x,H,X)===0}function le(x,H,X){return j(x,H,X)!==0}function pe(x,H,X){return j(x,H,X)>=0}function ve(x,H,X){return j(x,H,X)<=0}function te(x,H,X,ce){var me;switch(H){case"===":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x===X;break;case"!==":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x!==X;break;case"":case"=":case"==":me=oe(x,X,ce);break;case"!=":me=le(x,X,ce);break;case">":me=G(x,X,ce);break;case">=":me=pe(x,X,ce);break;case"<":me=K(x,X,ce);break;case"<=":me=ve(x,X,ce);break;default:throw new TypeError("Invalid operator: "+H)}return me}function re(x,H){if(x instanceof re){if(x.loose===H)return x;x=x.value}if(!(this instanceof re))return new re(x,H);w("comparator",x,H),this.loose=H,this.parse(x),this.semver===he?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}i.rcompareIdentifiers=function(x,H){return M(H,x)},i.major=function(x,H){return new O(x,H).major},i.minor=function(x,H){return new O(x,H).minor},i.patch=function(x,H){return new O(x,H).patch},i.compare=j,i.compareLoose=function(x,H){return j(x,H,!0)},i.rcompare=function(x,H,X){return j(H,x,X)},i.sort=function(x,H){return x.sort(function(X,ce){return i.compare(X,ce,H)})},i.rsort=function(x,H){return x.sort(function(X,ce){return i.rcompare(X,ce,H)})},i.gt=G,i.lt=K,i.eq=oe,i.neq=le,i.gte=pe,i.lte=ve,i.cmp=te,i.Comparator=re;var he={};function de(x,H){if(x instanceof de)return x.loose===H?x:new de(x.raw,H);if(x instanceof re)return new de(x.value,H);if(!(this instanceof de))return new de(x,H);if(this.loose=H,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Se(x){return!x||x.toLowerCase()==="x"||x==="*"}function Le(x,H,X,ce,me,Ce,we,Te,be,De,Me,Re,Oe){return((H=Se(X)?"":Se(ce)?">="+X+".0.0":Se(me)?">="+X+"."+ce+".0":">="+H)+" "+(Te=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Te)).trim()}function Fe(x,H){for(var X=0;X<x.length;X++)if(!x[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<x.length;X++)if(w(x[X].semver),x[X].semver!==he&&x[X].semver.prerelease.length>0){var ce=x[X].semver;if(ce.major===H.major&&ce.minor===H.minor&&ce.patch===H.patch)return!0}return!1}return!0}function Ue(x,H,X){try{H=new de(H,X)}catch{return!1}return H.test(x)}function xe(x,H,X,ce){var me,Ce,we,Te,be;switch(x=new O(x,ce),H=new de(H,ce),X){case">":me=G,Ce=ve,we=K,Te=">",be=">=";break;case"<":me=K,Ce=pe,we=G,Te="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,H,ce))return!1;for(var De=0;De<H.set.length;++De){var Me=H.set[De],Re=null,Oe=null;if(Me.forEach(function(Ae){Ae.semver===he&&(Ae=new re(">=0.0.0")),Re=Re||Ae,Oe=Oe||Ae,me(Ae.semver,Re.semver,ce)?Re=Ae:we(Ae.semver,Oe.semver,ce)&&(Oe=Ae)}),Re.operator===Te||Re.operator===be||(!Oe.operator||Oe.operator===Te)&&Ce(x,Oe.semver)||Oe.operator===be&&we(x,Oe.semver))return!1}return!0}re.prototype.parse=function(x){var H=this.loose?p[V]:p[N],X=x.match(H);if(!X)throw new TypeError("Invalid comparator: "+x);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new O(X[2],this.loose):this.semver=he},re.prototype.toString=function(){return this.value},re.prototype.test=function(x){return w("Comparator.test",x,this.loose),this.semver===he||(typeof x=="string"&&(x=new O(x,this.loose)),te(x,this.operator,this.semver,this.loose))},re.prototype.intersects=function(x,H){if(!(x instanceof re))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new de(x.value,H),Ue(this.value,X,H);if(x.operator==="")return X=new de(this.value,H),Ue(x.semver,X,H);var ce=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ce=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Te=te(this.semver,"<",x.semver,H)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,H)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ce||me||Ce&&we||Te||be},i.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(x){var H=this.loose;x=x.trim(),w("range",x,H);var X=H?p[$]:p[z];x=x.replace(X,Le),w("hyphen replace",x),x=x.replace(p[F],"$1$2$3"),w("comparator trim",x,p[F]),x=(x=(x=x.replace(p[Y],"$1~")).replace(p[ge],"$1^")).split(/\s+/).join(" ");var ce=H?p[V]:p[N],me=x.split(" ").map(function(Ce){return function(we,Te){return w("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){w("caret",Re,Oe);var Ae=Oe?p[se]:p[ue];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(w("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),w("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Te),w("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){var Ae=Oe?p[ae]:p[ie];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",w("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Te),w("tildes",we),we=function(be,De){return w("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Oe){Re=Re.trim();var Ae=Oe?p[W]:p[k];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,ke){w("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=Se(Ee),ze=We||Se(Pe),je=ze||Se(Ie);return ye==="="&&je&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),w("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Te),w("xrange",we),we=function(be,De){return w("replaceStars",be,De),be.trim().replace(p[J],"")}(we,Te),w("stars",we),we}(Ce,H)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ce)})),me=me.map(function(Ce){return new re(Ce,H)})},de.prototype.intersects=function(x,H){if(!(x instanceof de))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(ce){return x.set.some(function(me){return me.every(function(Ce){return ce.intersects(Ce,H)})})})})},i.toComparators=function(x,H){return new de(x,H).set.map(function(X){return X.map(function(ce){return ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new O(x,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],x))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(x,H,X){var ce=null,me=null;try{var Ce=new de(H,X)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ce&&me.compare(we)!==-1||(me=new O(ce=we,X)))}),ce},i.minSatisfying=function(x,H,X){var ce=null,me=null;try{var Ce=new de(H,X)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ce&&me.compare(we)!==1||(me=new O(ce=we,X)))}),ce},i.validRange=function(x,H){try{return new de(x,H).range||"*"}catch{return null}},i.ltr=function(x,H,X){return xe(x,H,"<",X)},i.gtr=function(x,H,X){return xe(x,H,">",X)},i.outside=xe,i.prerelease=function(x,H){var X=U(x,H);return X&&X.prerelease.length?X.prerelease:null},i.intersects=function(x,H,X){return x=new de(x,X),H=new de(H,X),x.intersects(H)},i.coerce=function(x){if(x instanceof O)return x;if(typeof x!="string")return null;var H=x.match(p[_]);return H==null?null:U((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,D(1))},function(B,i){var D,I,w=B.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function p(S){if(D===setTimeout)return setTimeout(S,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(S,0);try{return D(S,0)}catch{try{return D.call(null,S,0)}catch{return D.call(this,S,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch{I=T}})();var c,d=[],C=!1,E=-1;function h(){C&&c&&(C=!1,c.length?d=c.concat(d):E=-1,d.length&&v())}function v(){if(!C){var S=p(h);C=!0;for(var l=d.length;l;){for(c=d,d=[];++E<l;)c&&c[E].run();E=-1,l=d.length}c=null,C=!1,function(u){if(I===clearTimeout)return clearTimeout(u);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(u);try{I(u)}catch{try{return I.call(null,u)}catch{return I.call(this,u)}}}(S)}}function f(S,l){this.fun=S,this.array=l}function m(){}w.nextTick=function(S){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];d.push(new f(S,l)),d.length!==1||C||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=m,w.addListener=m,w.once=m,w.off=m,w.removeListener=m,w.removeAllListeners=m,w.emit=m,w.prependListener=m,w.prependOnceListener=m,w.listeners=function(S){return[]},w.binding=function(S){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(S){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(p,c,d){this.level=p,this.key=c,this.value=d,this.forward=[]}}const w=void 0;class R{constructor(p,c=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new I(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,w,w)}has(p){return Boolean(R._search(this,p,this.comparator))}get(p){return R._search(this,p,this.comparator)?.value}set(p,c){return R._insert(this,p,c,this.comparator)&&(this._size+=1),this}delete(p){const c=R._delete(this,p,this.comparator);return c&&(this._size-=1),c}forEach(p,c){let d=this._header.forward[0];for(;d;)p.call(c,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",c=this._header.forward[0];for(;c;)p+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return p}static _search(p,c,d){let C=p._header;for(let E=p._level-1;E>=0;E--)for(;C.forward[E]&&d(C.forward[E].key,c)<0;)C=C.forward[E];if(C=C.forward[0],C&&d(C.key,c)===0)return C}static _insert(p,c,d,C){const E=[];let h=p._header;for(let v=p._level-1;v>=0;v--){for(;h.forward[v]&&C(h.forward[v].key,c)<0;)h=h.forward[v];E[v]=h}if(h=h.forward[0],h&&C(h.key,c)===0)return h.value=d,!1;{const v=R._randomLevel(p);if(v>p._level){for(let f=p._level;f<v;f++)E[f]=p._header;p._level=v}h=new I(v,c,d);for(let f=0;f<v;f++)h.forward[f]=E[f].forward[f],E[f].forward[f]=h;return!0}}static _randomLevel(p,c=.5){let d=1;for(;Math.random()<c&&d<p._maxLevel;)d+=1;return d}static _delete(p,c,d){const C=[];let E=p._header;for(let h=p._level-1;h>=0;h--){for(;E.forward[h]&&d(E.forward[h].key,c)<0;)E=E.forward[h];C[h]=E}if(E=E.forward[0],!E||d(E.key,c)!==0)return!1;for(let h=0;h<p._level&&C[h].forward[h]===E;h++)C[h].forward[h]=E.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===w;)p._level-=1;return!0}}i.SkipList=R}),define(Q[43],Z([0,1,12,2]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function w(a){const s=a;return s?typeof s.read=="function":!1}i.isReadable=w;function R(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=R;function T(a){const s=a;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=T;function p(a,s){return new c(a,s)}i.newWriteableStream=p;class c{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(e);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(a,s){const e=[];let r;for(;(r=a.read())!==null;)e.push(r);return s(e)}i.consumeReadable=d;function C(a,s,e){const r=[];let t;for(;(t=a.read())!==null&&r.length<e;)r.push(t);return t===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return a.read()}}}i.peekReadable=C;function E(a,s){return new Promise((e,r)=>{const t=[];h(a,{onData:n=>{s&&t.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=E;function h(a,s){let e=!1;return a.on("error",r=>{e||s.onError(r)}),a.on("end",()=>{e||s.onEnd()}),a.on("data",r=>{e||s.onData(r)}),(0,I.toDisposable)(()=>e=!0)}i.listenStream=h;function v(a,s){return new Promise((e,r)=>{const t=new I.DisposableStore,n=[],o=b=>{if(n.push(b),n.length>s)return t.dispose(),a.pause(),e({stream:a,buffer:n,ended:!1})},y=b=>r(b),P=()=>e({stream:a,buffer:n,ended:!0});t.add((0,I.toDisposable)(()=>a.removeListener("error",y))),a.on("error",y),t.add((0,I.toDisposable)(()=>a.removeListener("end",P))),a.on("end",P),t.add((0,I.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}i.peekStream=v;function f(a,s){const e=p(s);return e.end(a),e}i.toStream=f;function m(){const a=p(()=>{throw new Error("not supported")});return a.end(),a}i.emptyStream=m;function S(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}i.toReadable=S;function l(a,s,e){const r=p(e);return h(a,{onData:t=>r.write(s.data(t)),onError:t=>r.error(s.error?s.error(t):t),onEnd:()=>r.end()}),r}i.transform=l;function u(a,s,e){let r=!1;return{read:()=>{const t=s.read();return r?t:(r=!0,t!==null?e([a,t]):a)}}}i.prefixedReadable=u;function g(a,s,e){let r=!1;const t=p(e);return h(s,{onData:n=>r?t.write(n):(r=!0,t.write(e([a,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(a)),t.end()}}),t}i.prefixedStream=g}),define(Q[15],Z([0,1,43]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer<"u";let w,R;class T{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return I?new T(Buffer.allocUnsafe(b)):new T(new Uint8Array(b))}static wrap(b){return I&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new T(b)}static fromString(b,k){return!(k?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(b)):(w||(w=new TextEncoder),new T(w.encode(b)))}static fromByteArray(b){const k=T.alloc(b.length);for(let W=0,_=b.length;W<_;W++)k.buffer[W]=b[W];return k}static concat(b,k){if(typeof k>"u"){k=0;for(let q=0,Y=b.length;q<Y;q++)k+=b[q].byteLength}const W=T.alloc(k);let _=0;for(let q=0,Y=b.length;q<Y;q++){const ie=b[q];W.set(ie,_),_+=ie.byteLength}return W}clone(){const b=T.alloc(this.byteLength);return b.set(this),b}toString(){return I?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,k){return new T(this.buffer.subarray(b,k))}set(b,k){if(b instanceof T)this.buffer.set(b.buffer,k);else if(b instanceof Uint8Array)this.buffer.set(b,k);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),k);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,k){C(this.buffer,b,k)}readUInt32LE(b){return E(this.buffer,b)}writeUInt32LE(b,k){h(this.buffer,b,k)}readUInt8(b){return v(this.buffer,b)}writeUInt8(b,k){f(this.buffer,b,k)}}i.VSBuffer=T;function p(P,b){return P[b+0]<<0>>>0|P[b+1]<<8>>>0}i.readUInt16LE=p;function c(P,b,k){P[k+0]=b&255,b=b>>>8,P[k+1]=b&255}i.writeUInt16LE=c;function d(P,b){return P[b]*2**24+P[b+1]*2**16+P[b+2]*2**8+P[b+3]}i.readUInt32BE=d;function C(P,b,k){P[k+3]=b,b=b>>>8,P[k+2]=b,b=b>>>8,P[k+1]=b,b=b>>>8,P[k]=b}i.writeUInt32BE=C;function E(P,b){return P[b+0]<<0>>>0|P[b+1]<<8>>>0|P[b+2]<<16>>>0|P[b+3]<<24>>>0}i.readUInt32LE=E;function h(P,b,k){P[k+0]=b&255,b=b>>>8,P[k+1]=b&255,b=b>>>8,P[k+2]=b&255,b=b>>>8,P[k+3]=b&255}i.writeUInt32LE=h;function v(P,b){return P[b]}i.readUInt8=v;function f(P,b,k){P[k]=b}i.writeUInt8=f;function m(P){return D.consumeReadable(P,b=>T.concat(b))}i.readableToBuffer=m;function S(P){return D.toReadable(P)}i.bufferToReadable=S;function l(P){return D.consumeStream(P,b=>T.concat(b))}i.streamToBuffer=l;async function u(P){return P.ended?T.concat(P.buffer):T.concat([...P.buffer,await l(P.stream)])}i.bufferedStreamToBuffer=u;function g(P){return D.toStream(P,b=>T.concat(b))}i.bufferToStream=g;function a(P){return D.transform(P,{data:b=>typeof b=="string"?T.fromString(b):T.wrap(b)},b=>T.concat(b))}i.streamToBufferReadableStream=a;function s(P){return D.newWriteableStream(b=>T.concat(b),P)}i.newWriteableBufferStream=s;function e(P,b){return D.prefixedReadable(P,b,k=>T.concat(k))}i.prefixedBufferReadable=e;function r(P,b){return D.prefixedStream(P,b,k=>T.concat(k))}i.prefixedBufferStream=r;function t(P){let b=0,k=0,W=0;const _=new Uint8Array(Math.floor(P.length/4*3)),q=ie=>{switch(k){case 3:_[W++]=b|ie,k=0;break;case 2:_[W++]=b|ie>>>2,b=ie<<6,k=3;break;case 1:_[W++]=b|ie>>>4,b=ie<<4,k=2;break;default:b=ie<<2,k=1}};for(let ie=0;ie<P.length;ie++){const ae=P.charCodeAt(ie);if(ae>=65&&ae<=90)q(ae-65);else if(ae>=97&&ae<=122)q(ae-97+26);else if(ae>=48&&ae<=57)q(ae-48+52);else if(ae===43||ae===45)q(62);else if(ae===47||ae===95)q(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${P[ie]}`)}}const Y=W;for(;k>0;)q(0);return T.wrap(_).slice(0,Y)}i.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:P},b=!0,k=!1){const W=k?o:n;let _="";const q=P.byteLength%3;let Y=0;for(;Y<P.byteLength-q;Y+=3){const ie=P[Y+0],ae=P[Y+1],ne=P[Y+2];_+=W[ie>>>2],_+=W[(ie<<4|ae>>>4)&63],_+=W[(ae<<2|ne>>>6)&63],_+=W[ne&63]}if(q===1){const ie=P[Y+0];_+=W[ie>>>2],_+=W[ie<<4&63],b&&(_+="==")}else if(q===2){const ie=P[Y+0],ae=P[Y+1];_+=W[ie>>>2],_+=W[(ie<<4|ae>>>4)&63],_+=W[ae<<2&63],b&&(_+="=")}return _}i.encodeBase64=y}),define(Q[26],Z([0,1,5]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.keys(l).forEach(g=>{l[g]&&typeof l[g]=="object"?u[g]=I(l[g]):u[g]=l[g]}),u}i.deepClone=I;function w(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const a in g)if(R.call(g,a)){const s=g[a];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&u.push(s)}}return l}i.deepFreeze=w;const R=Object.prototype.hasOwnProperty;function T(l,u){return p(l,u,new Set)}i.cloneAndChange=T;function p(l,u,g){if((0,D.isUndefinedOrNull)(l))return l;const a=u(l);if(typeof a<"u")return a;if(Array.isArray(l)){const s=[];for(const e of l)s.push(p(e,u,g));return s}if((0,D.isObject)(l)){if(g.has(l))throw new Error("Cannot clone recursive data-structure");g.add(l);const s={};for(const e in l)R.call(l,e)&&(s[e]=p(l[e],u,g));return g.delete(l),s}return l}function c(l,u,g=!0){return(0,D.isObject)(l)?((0,D.isObject)(u)&&Object.keys(u).forEach(a=>{a in l?g&&((0,D.isObject)(l[a])&&(0,D.isObject)(u[a])?c(l[a],u[a],g):l[a]=u[a]):l[a]=u[a]}),l):u}i.mixin=c;function d(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let g,a;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(g=0;g<l.length;g++)if(!d(l[g],u[g]))return!1}else{const s=[];for(a in l)s.push(a);s.sort();const e=[];for(a in u)e.push(a);if(e.sort(),!d(s,e))return!1;for(g=0;g<s.length;g++)if(!d(l[s[g]],u[s[g]]))return!1}return!0}i.equals=d;function C(l){const u=new Set;return JSON.stringify(l,(g,a)=>{if((0,D.isObject)(a)||Array.isArray(a)){if(u.has(a))return"[Circular]";u.add(a)}return a})}i.safeStringify=C;function E(l,u){const g=Object.create(null);return!l||!u||Object.keys(u).forEach(s=>{const e=l[s],r=u[s];d(e,r)||(g[s]=r)}),g}i.distinct=E;function h(l,u){const g=u.toLowerCase(),a=Object.keys(l).find(s=>s.toLowerCase()===g);return a?l[a]:l[u]}i.getCaseInsensitive=h;function v(l,u){const g=Object.create(null);for(const[a,s]of Object.entries(l))u(a,s)&&(g[a]=s);return g}i.filter=v;function f(l){let u=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}i.getAllPropertyNames=f;function m(l){const u=[];for(const g of f(l))typeof l[g]=="function"&&u.push(g);return u}i.getAllMethodNames=m;function S(l,u){const g=s=>function(){const e=Array.prototype.slice.call(arguments,0);return u(s,e)},a={};for(const s of l)a[s]=g(s);return a}i.createProxyObject=S}),define(Q[30],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(w){return D.test(w)}i.isUUID=I,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(p){for(let c=0;c<p.length;c++)p[c]=Math.floor(Math.random()*256);return p};const R=new Uint8Array(16),T=[];for(let p=0;p<256;p++)T.push(p.toString(16).padStart(2,"0"));return function(){w(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let c=0,d="";return d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d+="-",d+=T[R[c++]],d+=T[R[c++]],d+="-",d+=T[R[c++]],d+=T[R[c++]],d+="-",d+=T[R[c++]],d+=T[R[c++]],d+="-",d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d+=T[R[c++]],d}}()}),define(Q[70],Z([6,7]),function(B,i){return B.create("vs/base/common/date",i)}),define(Q[71],Z([0,1,70]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,w=I*60,R=w*24,T=R*7,p=R*30,c=R*365;function d(E,h,v){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,D.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let m;return f<I?(m=f,h?m===1?v?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):v?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?v?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):v?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):f<w?(m=Math.floor(f/I),h?m===1?v?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):v?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?v?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):v?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):f<R?(m=Math.floor(f/w),h?m===1?v?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):v?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?v?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):v?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):f<T?(m=Math.floor(f/R),h?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):f<p?(m=Math.floor(f/T),h?m===1?v?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):v?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?v?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):v?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):f<c?(m=Math.floor(f/p),h?m===1?v?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):v?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?v?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):v?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(f/c),h?m===1?v?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):v?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?v?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):v?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}i.fromNow=d;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Q[72],Z([6,7]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Q[31],Z([0,1,19,5,72]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function R(E,h){return h&&(E.stack||E.stacktrace)?w.localize(0,null,p(E),T(E.stack)||T(E.stacktrace)):p(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function p(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?w.localize(1,null,E.message):E.message||w.localize(2,null)}function c(E=null,h=!1){if(!E)return w.localize(3,null);if(Array.isArray(E)){const v=D.coalesce(E),f=c(v[0],h);return v.length>1?w.localize(4,null,f,v.length):f}if(I.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return R(v.error,h);if(v.exception)return R(v.exception,h)}return E.stack?R(E,h):E.message?E.message:w.localize(5,null)}i.toErrorMessage=c;function d(E){const h=E;return h instanceof Error&&Array.isArray(h.actions)}i.isErrorWithActions=d;function C(E,h){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=h,v}i.createErrorWithActions=C}),define(Q[73],Z([6,7]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Q[74],Z([0,1,73]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(w){switch(w){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(Q[51],Z([0,1,13]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(I=i.Source||(i.Source={}));var w;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(w=i.TerminateResponseCode||(i.TerminateResponseCode={}));function R(p,...c){const d=c.reduce((h,v)=>(h[v]=!0,h),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!d[h]).forEach(h=>{for(let v=0;v<C.length;v++)if(h.search(C[v])!==-1){delete p[h];break}})}i.sanitizeProcessEnvironment=R;function T(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}i.removeDangerousEnvVariables=T}),define(Q[52],Z([0,1,4,2]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const w=T=>({onDidChange:D.Event.None,value:T});i.staticObservableValue=w;class R extends I.Disposable{constructor(p){super(),this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}i.MutableObservableValue=R}),define(Q[53],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(l){return w(l,0)}i.hash=I;function w(l,u){switch(typeof l){case"object":return l===null?R(349,u):Array.isArray(l)?c(l,u):d(l,u);case"string":return p(l,u);case"boolean":return T(l,u);case"number":return R(l,u);case"undefined":return R(937,u);default:return R(617,u)}}i.doHash=w;function R(l,u){return(u<<5)-u+l|0}i.numberHash=R;function T(l,u){return R(l?433:863,u)}function p(l,u){u=R(149417,u);for(let g=0,a=l.length;g<a;g++)u=R(l.charCodeAt(g),u);return u}i.stringHash=p;function c(l,u){return u=R(104579,u),l.reduce((g,a)=>w(a,g),u)}function d(l,u){return u=R(181387,u),Object.keys(l).sort().reduce((g,a)=>(g=p(a,g),w(l[a],g)),u)}class C{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=w(u,this._value),this._value}}i.Hasher=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function h(l,u,g=32){const a=g-u,s=~((1<<a)-1);return(l<<u|(s&l)>>>a)>>>0}function v(l,u=0,g=l.byteLength,a=0){for(let s=0;s<g;s++)l[u+s]=a}function f(l,u,g="0"){for(;l.length<u;)l=g+l;return l}function m(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),u/4)}i.toHexString=m;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const a=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,t;for(e!==0?(r=e,t=-1,e=0):(r=u.charCodeAt(0),t=0);;){let n=r;if(D.isHighSurrogate(r))if(t+1<g){const o=u.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,n=D.computeCodePoint(r,o)):n=65533}else{e=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(a,s,n),t++,t<g)r=u.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,g,a){return a<128?u[g++]=a:a<2048?(u[g++]=192|(a&1984)>>>6,u[g++]=128|(a&63)>>>0):a<65536?(u[g++]=224|(a&61440)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0):(u[g++]=240|(a&1835008)>>>18,u[g++]=128|(a&258048)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=S._bigBlock32,g=this._buffDV;for(let P=0;P<64;P+=4)u.setUint32(P,g.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)u.setUint32(P,h(u.getUint32(P-12,!1)^u.getUint32(P-32,!1)^u.getUint32(P-56,!1)^u.getUint32(P-64,!1),1),!1);let a=this._h0,s=this._h1,e=this._h2,r=this._h3,t=this._h4,n,o,y;for(let P=0;P<80;P++)P<20?(n=s&e|~s&r,o=1518500249):P<40?(n=s^e^r,o=1859775393):P<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),y=h(a,5)+n+t+o+u.getUint32(P*4,!1)&4294967295,t=r,r=e,e=h(s,30),s=a,a=y;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(I||(I={})),function(w){const R="error",T="warning",p="warn",c="info",d="ignore";function C(h){return h?D.equalsIgnoreCase(R,h)?w.Error:D.equalsIgnoreCase(T,h)||D.equalsIgnoreCase(p,h)?w.Warning:D.equalsIgnoreCase(c,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=C;function E(h){switch(h){case w.Error:return R;case w.Warning:return T;case w.Info:return c;default:return d}}w.toString=E}(I||(I={})),i.default=I}),define(Q[75],Z([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=I;function w(d){const C=[];let E;try{const h=JSON.parse(d.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),E=v.__$stack),C.push(...h)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:E}}i.parse=w;function R(d){if(typeof d!="string")return R(w(d).stack);const C=d;if(C){const E=T(C),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=R;function T(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function p(d,C){const{args:E,stack:h}=w(d),v=typeof E[0]=="string"&&E.length===1;let f=T(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof E[0]=="string"?f&&v?m=[`%c[${C}] %c${E[0]} %c${f}`,c("blue"),c(""),c("grey")]:m=[`%c[${C}] %c${E[0]}`,c("blue"),c(""),...E.slice(1)]:m=[`%c[${C}]%`,c("blue"),...E],f&&!v&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}i.log=p;function c(d){return`color: ${d}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function R(d){return JSON.stringify(d,p)}i.stringify=R;function T(d){let C=JSON.parse(d);return C=c(C),C}i.parse=T;function p(d,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,I.regExpFlags)(C)}:C}function c(d,C=0){if(!d||C>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return w.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof D.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let E=0;E<d.length;++E)d[E]=c(d[E],C+1);else for(const E in d)Object.hasOwnProperty.call(d,E)&&(d[E]=c(d[E],C+1))}return d}i.revive=c}),define(Q[76],Z([0,1,38,14,20]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var c;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:a});if(!e)return null;const r=I.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const P of await w.Promises.readdir(r)){let b=-1;if(s){const W=P.indexOf("-");if(W<0)continue;const _=P.substring(0,W);if(!R.test(_)||P.substring(W+1)!=="preview")continue;b=parseInt(_,10)}else{if(!R.test(P))continue;b=parseInt(P,10)}if(b<=t)continue;const k=I.join(r,P,"pwsh.exe");!await w.SymlinkSupport.existsFile(k)||(n=k,t=b)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",y=s?" Preview":"";return new E(n,`PowerShell${y}${o}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=a?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await w.Promises.readdir(s))if(e.test(t)){const n=I.join(s,t,"pwsh.exe");return new E(n,r)}return null}function m(){const a=I.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function S(){const a=I.join(process.env.windir,d===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*l(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await f(),a&&(yield a),a=m(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await f({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=S(),a&&(yield a)}async function*u(){for await(const a of l())await a.exists()&&(yield a)}i.enumeratePowerShellInstallations=u;async function g(){for await(const a of u())return a;return null}i.getFirstAvailablePowerShellInstallation=g}),define(Q[55],Z([0,1,14,13,32,51,5,20]),function(B,i,D,I,w,R,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function c(E=w.env){return E.comspec||"cmd.exe"}i.getWindowsShell=c;function d(E){let h=[],v=!1;const f=function(m){if(v){h.push(m);return}(!E.send(m,l=>{if(l&&console.error(l),v=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||I.isWindows)&&(v=!0)};return{send:f}}i.createQueuedSender=d;var C;(function(E){async function h(v,f,m){if(D.isAbsolute(v))return v;if(f===void 0&&(f=w.cwd()),D.dirname(v)!=="."||(m===void 0&&T.isString(w.env.PATH)&&(m=w.env.PATH.split(D.delimiter)),m===void 0||m.length===0))return D.join(f,v);async function l(u){if(await p.Promises.exists(u)){let g;try{g=await p.Promises.stat(u)}catch(a){a.message.startsWith("EACCES")&&(g=await p.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(D.isAbsolute(u)?g=D.join(u,v):g=D.join(f,u,v),await l(g))return g;let a=g+".com";if(await l(a)||(a=g+".exe",await l(a)))return a}return D.join(f,v)}E.findExecutable=h})(C=i.win32||(i.win32={}))}),define(Q[77],Z([0,1,38,13,76,55]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function T(v,f){return v===1?I.isWindows?E():R.getWindowsShell(f):d(v,f)}i.getSystemShell=T;function p(v,f){return v===1?I.isWindows?h(f):R.getWindowsShell(f):d(v,f)}i.getSystemShellSync=p;let c=null;function d(v,f){if(I.isLinux&&v===2||I.isMacintosh&&v===3)return"/bin/bash";if(!c){let m;if(I.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}c=m}return c}let C=null;async function E(){return C||(C=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),C}function h(v){if(C)return C;const f=I.isWindows&&parseFloat((0,D.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?S:R.getWindowsShell(v)}});var fe=this&&this.__decorate||function(B,i,D,I){var w=arguments.length,R=w<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,D):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(B,i,D,I);else for(var p=B.length-1;p>=0;p--)(T=B[p])&&(R=(w<3?T(R):w>3?T(i,D,R):T(i,D))||R);return w>3&&R&&Object.defineProperty(i,D,R),R};define(Q[56],Z([0,1,19,3,15,24,49,12,4,2,44,27,5]),function(B,i,D,I,w,R,T,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var v;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(v=i.RequestType||(i.RequestType={}));function f(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(m=i.ResponseType||(i.ResponseType={}));function S(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(l||(l={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class g{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(a||(a={}));function s(N){const F=w.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function r(N){const F=w.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const t={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},n=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(t.Undefined);else if(typeof F=="string"){const z=w.VSBuffer.fromString(F);N.write(t.String),N.write(s(z.byteLength)),N.write(z)}else if(n&&Buffer.isBuffer(F)){const z=w.VSBuffer.wrap(F);N.write(t.Buffer),N.write(s(z.byteLength)),N.write(z)}else if(F instanceof w.VSBuffer)N.write(t.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(t.Array),N.write(s(F.length));for(const z of F)o(N,z)}else{const z=w.VSBuffer.fromString(JSON.stringify(F));N.write(t.Object),N.write(s(z.byteLength)),N.write(z)}}function y(N){switch(N.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return N.read(e(N)).toString();case a.Buffer:return N.read(e(N)).buffer;case a.VSBuffer:return N.read(e(N));case a.Array:{const z=e(N),$=[];for(let J=0;J<z;J++)$.push(y(N));return $}case a.Object:return JSON.parse(N.read(e(N)).toString())}}class P{constructor(F,z,$=null,J=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,S(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,S(F.type),F.data);return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new u(F),$=y(z),J=y(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new R.CancellationTokenSource;let J;try{J=z.call(this.ctx,F.name,F.arg,$.token)}catch(O){J=Promise.reject(O)}const A=F.id;J.then(O=>{this.sendResponse({id:A,data:O,type:201}),this.activeRequests.delete(F.id)},O=>{O instanceof Error?this.sendResponse({id:A,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:A,data:O,type:203}),this.activeRequests.delete(F.id)});const U=(0,d.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=P;var b;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(b=i.RequestInitiator||(i.RequestInitiator={}));class k{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,J,A){return z.isDisposed?Promise.reject(new p.CancellationError):z.requestPromise(F,$,J,A)},listen($,J){return z.isDisposed?c.Event.None:z.requestEvent(F,$,J)}}}requestPromise(F,z,$,J=R.CancellationToken.None){const A=this.lastRequestId++,O={id:A,type:100,channelName:F,name:z,arg:$};if(J.isCancellationRequested)return Promise.reject(new p.CancellationError);let L;return new Promise((j,G)=>{if(J.isCancellationRequested)return G(new p.CancellationError);const K=()=>{const ve=te=>{switch(te.type){case 201:this.handlers.delete(A),j(te.data);break;case 202:{this.handlers.delete(A);const re=new Error(te.data.message);re.stack=te.data.stack,re.name=te.data.name,G(re);break}case 203:this.handlers.delete(A),G(te.data);break}};this.handlers.set(A,ve),this.sendRequest(O)};let oe=null;this.state===l.Idle?K():(oe=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,K()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:A,type:101}),G(new p.CancellationError)},pe=J.onCancellationRequested(le);L=(0,d.combinedDisposable)((0,d.toDisposable)(le),pe),this.activeRequests.add(L)}).finally(()=>{this.activeRequests.delete(L)})}requestEvent(F,z,$){const J=this.lastRequestId++,U={id:J,type:102,channelName:F,name:z,arg:$};let O=null;const L=new c.Emitter({onFirstListenerAdd:()=>{O=(0,I.createCancelablePromise)(j=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(L),this.sendRequest(U)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(L),this.sendRequest({id:J,type:103}))}}),M=j=>L.fire(j.data);return this.handlers.set(J,M),L.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,f(F.type));return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new u(F),$=y(z),J=y(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,S(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,S(A),J),this.onResponse({type:$[0],id:$[1],data:J})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([T.memoize],k.prototype,"onDidInitializePromise",null),i.ChannelClient=k;class W{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{c.Event.once(z.onMessage)(A=>{const U=new u(A),O=y(U),L=new P(z,O),M=new k(z);this.channels.forEach((G,K)=>L.registerChannel(K,G));const j={channelServer:L,channelClient:M,ctx:O};this._connections.add(j),this._onDidAddConnection.fire(j),$(()=>{L.dispose(),M.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}getChannel(F,z){const $=this;return{call(J,A,U){let O;if((0,h.isFunction)(z)){const M=(0,D.getRandomElement)($.connections.filter(z));O=M?Promise.resolve(M):c.Event.toPromise(c.Event.filter($.onDidAddConnection,z))}else O=z.routeCall($,J,A);const L=O.then(M=>M.channelClient.getChannel(F));return q(L).call(J,A,U)},listen(J,A){if((0,h.isFunction)(z))return $.getMulticastEvent(F,z,J,A);const U=z.routeEvent($,J,A).then(O=>O.channelClient.getChannel(F));return q(U).listen(J,A)}}}getMulticastEvent(F,z,$,J){const A=this;let U=new d.DisposableStore;const O=new c.Emitter({onFirstListenerAdd:()=>{U=new d.DisposableStore;const L=new c.EventMultiplexer,M=new Map,j=K=>{const le=K.channelClient.getChannel(F).listen($,J),pe=L.add(le);M.set(K,pe)},G=K=>{const oe=M.get(K);!oe||(oe.dispose(),M.delete(K))};A.connections.filter(z).forEach(j),c.Event.filter(A.onDidAddConnection,z)(j,void 0,U),A.onDidRemoveConnection(G,void 0,U),L.event(O.fire,O,U),U.add(L)},onLastListenerRemove:()=>{U.dispose()}});return O.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=W;class _{constructor(F,z,$=null){const J=new g;o(J,z),F.send(J.buffer),this.channelClient=new k(F,$),this.channelServer=new P(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=_;function q(N){return{call(F,z,$){return N.then(J=>J.call(F,z,$))},listen(F,z){const $=new c.Relay;return N.then(J=>$.input=J.listen(F,z)),$.event}}}i.getDelayedChannel=q;function Y(N){let F=!1;return{call(z,$,J){return F?N.call(z,$,J):(0,I.timeout)(0).then(()=>F=!0).then(()=>N.call(z,$,J))},listen(z,$){if(F)return N.listen(z,$);const J=new c.Relay;return(0,I.timeout)(0).then(()=>F=!0).then(()=>J.input=N.listen(z,$)),J.event}}}i.getNextTickChannel=Y;class ie{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(F.onDidAddConnection),await this.route(F)}}i.StaticRouter=ie;var ae;(function(N){function F(A,U){const O=A,L=U&&U.disableMarshalling,M=new Map;for(const j in O)$(j)&&M.set(j,c.Event.buffer(O[j],!0));return new class{listen(j,G,K){const oe=M.get(G);if(oe)return oe;if(J(G)){const le=O[G];if(typeof le=="function")return le.call(O,K)}throw new Error(`Event not found: ${G}`)}call(j,G,K){const oe=O[G];if(typeof oe=="function"){if(!L&&Array.isArray(K))for(let le=0;le<K.length;le++)K[le]=(0,C.revive)(K[le]);return oe.apply(O,K)}throw new Error(`Method not found: ${G}`)}}}N.fromService=F;function z(A,U){const O=U&&U.disableMarshalling;return new Proxy({},{get(L,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):J(M)?function(j){return A.listen(M,j)}:$(M)?A.listen(M):async function(...j){let G;U&&!(0,h.isUndefinedOrNull)(U.context)?G=[U.context,...j]:G=j;const K=await A.call(M,G);return O?K:(0,C.revive)(K)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&E.isUpperAsciiLetter(A.charCodeAt(2))}function J(A){return/^onDynamic/.test(A)&&E.isUpperAsciiLetter(A.charCodeAt(9))}})(ae=i.ProxyChannel||(i.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function ue(N){return Array.isArray(N)?N.map(ge):ge(N)}function se(N,F,z,$,J,A,U){U=ue(U);const O=ne[J],L=O[$%O.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}i.logWithColors=se;class V{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,J,A){this._totalOutgoing+=F,se(this._outgoingPrefix,this._totalOutgoing,F,z,$,J,A)}logIncoming(F,z,$,J,A){this._totalIncoming+=F,se(this._incomingPrefix,this._totalIncoming,F,z,$,J,A)}}i.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,12,4,2,26,55,51,56]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class f extends v.ChannelServer{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>w.VSBuffer.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}i.Server=f;class m{constructor(l,u){this.modulePath=l,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new I.Delayer(g),this.child=null,this._client=null}getChannel(l){const u=this;return{call(g,a,s){return u.requestPromise(l,g,a,s)},listen(g,a){return u.requestEvent(l,g,a)}}}requestPromise(l,u,g,a=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),e=(0,I.createCancelablePromise)(n=>s.call(u,g,n)),r=a.onCancellationRequested(()=>e.cancel()),t=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(l,u,g){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let a;const s=new c.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(l).listen(u,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,l,u);const g=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=g.event,t={send:e,onMessage:r};this._client=new v.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,y)=>{process.removeListener("exit",n),this.activeRequests.forEach(P=>(0,d.dispose)(P)),this.activeRequests.clear(),o!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+y),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:y})})}return this._client}getCachedChannel(l){let u=this.channels.get(l);return u||(u=this.client.getChannel(l),this.channels.set(l,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=m}),define(Q[79],Z([0,1,3,4,2,5]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var T;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=i.StorageHint||(i.StorageHint={}));function p(E){const h=E;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=p;var c;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(c=i.StorageState||(i.StorageState={}));class d extends w.Disposable{constructor(h,v=Object.create(null)){super(),this.database=h,this.options=v,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,f)=>this.accept(f,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===c.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(v)?f=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const f=this.cache.get(h);return(0,R.isUndefinedOrNull)(f)?v:f}getBoolean(h,v){const f=this.get(h);return(0,R.isUndefinedOrNull)(f)?v:f==="true"}getNumber(h,v){const f=this.get(h);return(0,R.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(h,v){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(v))return this.delete(h);const f=String(v);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((v,f)=>this.items.set(f,v)),h.delete?.forEach(v=>this.items.delete(v))}async close(){}}i.InMemoryStorageDatabase=C}),define(Q[80],Z([6,7]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Q[81],Z([6,7]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[82],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[83],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[84],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Q[85],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionNls",i)}),define(Q[86],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([6,7]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Q[91],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Q[92],Z([6,7]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[93],Z([6,7]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[94],Z([6,7]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Q[95],Z([6,7]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Q[96],Z([6,7]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[97],Z([6,7]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Q[98],Z([6,7]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Q[99],Z([0,1,71,49,16,14,32,17,10]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(m,S,l){this._args=m,this.paths=S,this.productService=l,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(w.FileAccess.asFileUri("",B).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return c.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=T.env.VSCODE_PORTABLE;return m?c.URI.file((0,R.join)(m,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.resolve)(m):(0,R.normalize)((0,R.join)(w.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,R.resolve)(m):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.resolve)(m);const S=T.env.VSCODE_EXTENSIONS;if(S)return S;const l=T.env.VSCODE_PORTABLE;return l?(0,R.join)(l,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(S=>/^[^:/?#]+?:\/\//.test(S)?c.URI.parse(S):c.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,R.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=T.env.VSCODE_PORTABLE;return m?c.URI.file((0,R.join)(m,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([I.memoize],d.prototype,"appRoot",null),fe([I.memoize],d.prototype,"userHome",null),fe([I.memoize],d.prototype,"userDataPath",null),fe([I.memoize],d.prototype,"appSettingsHome",null),fe([I.memoize],d.prototype,"tmpDir",null),fe([I.memoize],d.prototype,"cacheHome",null),fe([I.memoize],d.prototype,"stateResource",null),fe([I.memoize],d.prototype,"userRoamingDataHome",null),fe([I.memoize],d.prototype,"userDataSyncHome",null),fe([I.memoize],d.prototype,"userDataSyncLogResource",null),fe([I.memoize],d.prototype,"editSessionsLogResource",null),fe([I.memoize],d.prototype,"sync",null),fe([I.memoize],d.prototype,"machineSettingsResource",null),fe([I.memoize],d.prototype,"workspaceStorageHome",null),fe([I.memoize],d.prototype,"localHistoryHome",null),fe([I.memoize],d.prototype,"keyboardLayoutResource",null),fe([I.memoize],d.prototype,"argvResource",null),fe([I.memoize],d.prototype,"isExtensionDevelopment",null),fe([I.memoize],d.prototype,"untitledWorkspacesHome",null),fe([I.memoize],d.prototype,"installSourcePath",null),fe([I.memoize],d.prototype,"builtinExtensionsPath",null),fe([I.memoize],d.prototype,"extensionsPath",null),fe([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([I.memoize],d.prototype,"extensionDevelopmentKind",null),fe([I.memoize],d.prototype,"extensionTestsLocationURI",null),fe([I.memoize],d.prototype,"debugExtensionHost",null),fe([I.memoize],d.prototype,"serviceMachineIdResource",null),fe([I.memoize],d.prototype,"telemetryLogResource",null),fe([I.memoize],d.prototype,"disableWorkspaceTrust",null),fe([I.memoize],d.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=d;function C(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}i.parseExtensionHostPort=C;function E(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}i.parseSearchPort=E;function h(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}i.parsePtyHostPort=h;function v(f,m,S,l,u,g){const s=Number(m||f)||(l?null:S),e=s?Boolean(!!m):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:s,break:e,debugId:u,env:r}}}),function(){"use strict";function B(i,D,I,w){function R(p){const c=T(p),d=[c];return i.isAbsolute(c)||d.unshift(w),i.resolve(...d)}function T(p){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return i.join(d,I);const C=p["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=i.join(E,"AppData","Roaming")}break;case"darwin":d=i.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(d,I)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[100],Z([0,149,38,16,17,32]),function(i,D,I,w,R,T){const p=R.dirname(w.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(R.joinPath(p,"package.json").fsPath);return B(D,I,c.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),I=require("os");module.exports=B(D,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends I.AbstractNativeEnvironmentService{constructor(p,c){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,w.getUserDataPath)(p)},c)}}i.NativeEnvironmentService=R}),define(Q[102],Z([0,1,5,85]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;function w(T,p,c){try{R(T,p,c)}catch{}return T}i.localizeManifest=w;function R(T,p,c){const d=(C,E,h)=>{const v=C[E];if((0,D.isString)(v)){const f=v,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const S=f.substr(1,m-2);let l=p[S];l===void 0&&c&&(l=c[S]);const u=typeof l=="string"?l:l.message;if(u!==void 0){const g=c?.[S],a=typeof g=="string"?g:g?.message;if(h&&(E==="title"||E==="category")&&a&&a!==u){const s={value:u,original:a};C[E]=s}else C[E]=u}else console.warn(`[${T.name}]: ${(0,I.localize)(0,null,S)}`)}}else if((0,D.isObject)(v))for(const f in v)v.hasOwnProperty(f)&&(f==="commands"?d(v,f,!0):d(v,f,h));else if(Array.isArray(v))for(let f=0;f<v.length;f++)d(v,f,h)};for(const C in T)T.hasOwnProperty(C)&&d(T,C)}}),define(Q[45],Z([0,1,17,54,89,39]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function c(l){return l=l.trim(),l==="*"||T.test(l)}i.isValidVersionStr=c;function d(l){if(!c(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=d;function C(l){if(!l)return null;const u=l.majorBase,g=l.majorMustEqual,a=l.minorBase;let s=l.minorMustEqual;const e=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(u===0||(s=!1),r=!1);let t=0;if(l.preRelease){const n=p.exec(l.preRelease);if(n){const[,o,y,P]=n;t=Date.UTC(Number(o),Number(y)-1,Number(P))}}return{majorBase:u,majorMustEqual:g,minorBase:a,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}i.normalizeVersion=C;function E(l,u,g){let a;typeof l=="string"?a=C(d(l)):a=l;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof g=="string"?e=C(d(g)):e=g,!a||!e)return!1;const r=a.majorBase,t=a.minorBase,n=a.patchBase;let o=e.majorBase,y=e.minorBase,P=e.patchBase;const b=e.notBefore;let k=e.majorMustEqual,W=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:t>y?!0:t<y||s&&s<b?!1:n>=P:(r===1&&o===0&&(!k||!W||!_)&&(o=1,y=0,P=0,k=!0,W=!1,_=!1),r<o?!1:r>o?!k:t<y?!1:t>y?!W:n<P?!1:n>P?!_:!(s&&s<b))}i.isValidVersion=E;function h(l,u,g,a,s){const e=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return e.push([I.default.Error,w.localize(0,null)]),e;if(typeof a.name!="string")return e.push([I.default.Error,w.localize(1,null,"name")]),e;if(typeof a.version!="string")return e.push([I.default.Error,w.localize(2,null,"version")]),e;if(!a.engines)return e.push([I.default.Error,w.localize(3,null,"engines")]),e;if(typeof a.engines.vscode!="string")return e.push([I.default.Error,w.localize(4,null,"engines.vscode")]),e;if(typeof a.extensionDependencies<"u"&&!S(a.extensionDependencies))return e.push([I.default.Error,w.localize(5,null,"extensionDependencies")]),e;if(typeof a.activationEvents<"u"){if(!S(a.activationEvents))return e.push([I.default.Error,w.localize(6,null,"activationEvents")]),e;if(typeof a.main>"u"&&typeof a.browser>"u")return e.push([I.default.Error,w.localize(7,null,"activationEvents","main")]),e}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&e.push([I.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return e.push([I.default.Error,w.localize(9,null,"main")]),e;{const n=(0,D.joinPath)(g,a.main);(0,D.isEqualOrParent)(n,g)||e.push([I.default.Warning,w.localize(10,null,n.path,g.path)])}if(typeof a.activationEvents>"u")return e.push([I.default.Error,w.localize(11,null,"activationEvents","main")]),e}if(typeof a.browser<"u"){if(typeof a.browser!="string")return e.push([I.default.Error,w.localize(12,null,"browser")]),e;{const n=(0,D.joinPath)(g,a.browser);(0,D.isEqualOrParent)(n,g)||e.push([I.default.Warning,w.localize(13,null,n.path,g.path)])}if(typeof a.activationEvents>"u")return e.push([I.default.Error,w.localize(14,null,"activationEvents","browser")]),e}if(!R.valid(a.version))return e.push([I.default.Error,w.localize(15,null)]),e;const r=[];if(!v(l,u,a,s,r))for(const n of r)e.push([I.default.Error,n]);return e}i.validateExtensionManifest=h;function v(l,u,g,a,s){return a||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(l,u,g.engines.vscode,s)}i.isValidExtensionVersion=v;function f(l,u,g){return l==="*"||m(u,g,l)}i.isEngineValid=f;function m(l,u,g,a=[]){const s=C(d(g));if(!s)return a.push(w.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(w.localize(17,null,g)),!1}else if(!s.majorMustEqual)return a.push(w.localize(18,null,g)),!1;return E(l,u,s)?!0:(a.push(w.localize(19,null,l,g)),!1)}function S(l){if(!Array.isArray(l))return!1;for(let u=0,g=l.length;u<g;u++)if(typeof l[u]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function w(R,T,p){let c=p&&p.get("storage.serviceMachineId",-1)||null;if(c)return c;try{const C=(await T.readFile(R.serviceMachineIdResource)).value.toString();c=(0,I.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,I.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,D.VSBuffer.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,-1,1),c}i.getServiceMachineId=w}),define(Q[46],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(w,R=[],T=!1){this.ctor=w,this.staticArguments=R,this.supportsDelayedInstantiation=T}}i.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function w(T,p,c){p instanceof D.SyncDescriptor||(p=new D.SyncDescriptor(p,[],c)),I.push([T,p])}i.registerSingleton=w;function R(){return I}i.getSingletonServiceDescriptors=R}),define(Q[105],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=D;class I{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const p=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(T);p.outgoing.set(this._hashFn(T),c),c.incoming.set(this._hashFn(R),p)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(const p of this._nodes.values())p.outgoing.delete(T),p.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let p=this._nodes.get(T);return p||(p=new D(R),this._nodes.set(T,p)),p}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[T,p]of this._nodes)R.push(`${T}, (incoming)[${[...p.incoming.keys()].join(", ")}], (outgoing)[${[...p.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this._nodes){const p=new Set([R]),c=this._findCycle(T,p);if(c)return c}}_findCycle(R,T){for(const[p,c]of R.outgoing){if(T.has(p))return[...T,p].join(" -> ");T.add(p);const d=this._findCycle(c,T);if(d)return d;T.delete(p)}}}i.Graph=I}),define(Q[21],Z([0,1,5,10,8]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,w.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationOverrides=R;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=T;var p;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(p=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=c;function d(l,u){const g=Object.create(null);for(const a in l)C(g,a,l[a],u);return g}i.toValuesTree=d;function C(l,u,g,a){const s=u.split("."),e=s.pop();let r=l;for(let t=0;t<s.length;t++){const n=s[t];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:a(`Ignoring ${u} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=g}catch{a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}else a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=C;function E(l,u){const g=u.split(".");h(l,g)}i.removeFromValueTree=E;function h(l,u){const g=u.shift();if(u.length===0){delete l[g];return}if(Object.keys(l).indexOf(g)!==-1){const a=l[g];typeof a=="object"&&!Array.isArray(a)&&(h(a,u),Object.keys(a).length===0&&delete l[g])}}function v(l,u,g){function a(r,t){let n=r;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=u.split("."),e=a(l,s);return typeof e>"u"?g:e}i.getConfigurationValue=v;function f(l,u,g){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in l?D.isObject(l[a])&&D.isObject(u[a])?f(l[a],u[a],g):g&&(l[a]=u[a]):l[a]=u[a])})}i.merge=f;function m(l,u,g){const a=l.inspect(u),s=l.inspect(g);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:a.defaultValue}i.getMigratedSettingValue=m;function S(l){return l.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=S}),define(Q[58],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[18],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IServerExtensionManagementService=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function w(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=w;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=R;function T(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function p(l,u){return u==="web"&&!l.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function c(l,u,g){return p(u,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:d(g).includes(l)}i.isTargetPlatformCompatible=c;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=d;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}i.isIExtensionIdentifier=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=i.SortOrder||(i.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=i.StatisticType||(i.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.IServerExtensionManagementService=(0,I.refineServiceDecorator)(i.IExtensionManagementService),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Q[59],Z([0,1,15,12,91,11]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function T(C,E,h,v,f,m){let S;try{await p(C,E,h,v,f,m)}catch(l){S=l}finally{S&&f.errorTransformer&&(S=f.errorTransformer(S)),typeof S<"u"&&h.error(S),h.end()}}i.readFileIntoStream=T;async function p(C,E,h,v,f,m){c(m);const S=await C.open(E,{create:!1});try{c(m);let l=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,a=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,e=0;do u=await C.read(S,s,a.buffer,e,a.byteLength-e),s+=u,e+=u,l+=u,typeof g=="number"&&(g-=u),e===a.byteLength&&(await h.write(v(a)),a=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),e=0);while(u>0&&(typeof g!="number"||g>0)&&c(m)&&d(l,f));if(e>0){let r=e;typeof g=="number"&&(r=Math.min(e,g)),h.write(v(a.slice(0,r)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await C.close(S)}}function c(C){if(C.isCancellationRequested)throw(0,I.canceled)();return!0}function d(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,R.createFileSystemProviderError)((0,w.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,R.createFileSystemProviderError)((0,w.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,13,151]),function(B,i,D,I,w,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class p extends w.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const C=this.normalizeRequests(d),E=C.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,I.patternsEquals)(f.request.excludes,v.excludes)||!(0,I.patternsEquals)(f.request.includes,v.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!C.find(f=>f.path===v.path&&(0,I.patternsEquals)(f.excludes,v.excludes)&&(0,I.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.trace(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of E)this.startWatching(v)}startWatching(d){const C=new T.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),E={request:d,instance:C};this.watchers.set(d.path,E)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const C=this.watchers.get(d);C&&(this.watchers.delete(d),C.instance.dispose())}normalizeRequests(d){const C=new Map;for(const E of d){const h=R.isLinux?E.path:E.path.toLowerCase();C.set(h,E)}return Array.from(C.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,C]of this.watchers)C.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,C){return C?`[File Watcher (node.js)] ${d} (path: ${C.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=p}),define(Q[107],Z([0,1,60,106]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class w extends D.AbstractNonRecursiveWatcherClient{constructor(T,p,c){super(T,p,c),this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=w}),define(Q[108],Z([0,1,16,56,78,60]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class T extends R.AbstractUniversalWatcherClient{constructor(c,d,C){super(c,d,C),this.init()}createWatcher(c){const d=c.add(new w.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:C,signal:E})=>this.onError(`terminated by itself with code ${C}, signal: ${E}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=T}),define(Q[61],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...w){this._entries=new Map;for(const[R,T]of w)this.set(R,T)}set(w,R){const T=this._entries.get(w);return this._entries.set(w,R),T}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}i.ServiceCollection=D}),define(Q[109],Z([0,1,3,12,46,105,8,61]),function(B,i,D,I,w,R,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class d extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class C{constructor(f=new p.ServiceCollection,m=!1,S){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=S,this._services.set(T.IInstantiationService,this)}createChild(f){return new C(f,this._strict,this)}invokeFunction(f,...m){const S=h.traceInvocation(f);let l=!1;try{return f({get:g=>{if(l)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,S);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...m)}finally{l=!0,S.stop()}}createInstance(f,...m){let S,l;return f instanceof w.SyncDescriptor?(S=h.traceCreation(f.ctor),l=this._createInstance(f.ctor,f.staticArguments.concat(m),S)):(S=h.traceCreation(f),l=this._createInstance(f,m,S)),S.stop(),l}_createInstance(f,m=[],S){const l=T._util.getServiceDependencies(f).sort((a,s)=>a.index-s.index),u=[];for(const a of l){const s=this._getOrCreateServiceInstance(a.id,S);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),u.push(s)}const g=l.length>0?l[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const a=g-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,g)}return new f(...m,...u)}_setServiceInstance(f,m){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){const S=this._getServiceInstanceOrDescriptor(f);return S instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,S,m.branch(f,!0)):(m.branch(f,!1),S)}_safeCreateAndCacheServiceInstance(f,m,S){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,S)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,S){const l=new R.Graph(a=>a.id.toString());let u=0;const g=[{id:f,desc:m,_trace:S}];for(;g.length;){const a=g.pop();if(l.lookupOrInsertNode(a),u++>1e3)throw new d(l);for(const s of T._util.getServiceDependencies(a.desc.ctor)){const e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),e instanceof w.SyncDescriptor){const r={id:s.id,desc:e,_trace:a._trace.branch(s.id,!0)};l.insertEdge(a,r),g.push(r)}}}for(;;){const a=l.roots();if(a.length===0){if(!l.isEmpty())throw new d(l);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,S=[],l,u){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(m,S,l,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,S,l,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],S,l){if(S){const u=new D.IdleValue(()=>this._createInstance(f,m,l));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];const s=u.value;let e=s[a];return typeof e!="function"||(e=e.bind(s),g[a]=e),e},set(g,a,s){return u.value[a]=s,!0}})}else return this._createInstance(f,m,l)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}i.InstantiationService=C;var E;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(E||(E={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return c?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return c?new h(0,f.name):h._None}branch(f,m){const S=new h(2,f.toString());return this._dep.push([f,m,S]),S}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function S(u,g){const a=[],s=new Array(u+1).join("	");for(const[e,r,t]of g._dep)if(r&&t){m=!0,a.push(`${s}CREATES -> ${e}`);const n=S(u+1,t);n&&a.push(n)}else a.push(`${s}uses -> ${e}`);return a.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(l.join(`
`))}}i.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var ee=this&&this.__param||function(B,i){return function(D,I){i(D,I,B)}};define(Q[62],Z([0,1,24,2,13,93,22,8]),function(B,i,D,I,w,R,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,p.createDecorator)("languagePackService");let c=class extends I.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new D.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const v=E.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],S=this.getLocale(f);return{...this.createQuickPickItem(S,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,E,h){const v=E??C;let f;if(v!==C&&(f=`(${C})`),C.toLowerCase()===w.language.toLowerCase()&&(f??="",f+=(0,R.localize)(0,null)),h?.installCount){f??="";const m=h.installCount;let S;m>1e6?S=`${Math.floor(m/1e5)/10}M`:m>1e3?S=`${Math.floor(m/1e3)}K`:S=String(m),f+=` $(cloud-download) ${S}`}return{id:C,label:v,description:f}}};c=fe([ee(0,T.IExtensionGalleryService)],c),i.LanguagePackBaseService=c}),define(Q[9],Z([0,1,31,4,2,13,8]),function(B,i,D,I,w,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,T.createDecorator)("logService"),i.ILoggerService=(0,T.createDecorator)("loggerService");function p(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function d(r,t,n){switch(t){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=d;function C(r){let t="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}i.format=C;class E extends w.Disposable{constructor(){super(...arguments),this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=E;class h extends E{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([t,...n]))}debug(t,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([t,...n]))}info(t,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,C([t,...n]))}warn(t,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([t,...n]))}error(t,...n){if(this.checkLogLevel(c.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(c.Error,C(o))}else this.log(c.Error,C([t,...n]))}critical(t,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([t,...n]))}flush(){}}i.AbstractMessageLogger=h;class v extends E{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!R.isWindows}trace(t,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}debug(t,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}info(t,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.log(`[main ${p()}]`,t,...n))}warn(t,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,t,...n):console.warn(`[main ${p()}]`,t,...n))}error(t,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,t,...n):console.error(`[main ${p()}]`,t,...n))}critical(t,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`\x1B[90m[main ${p()}]\x1B[0m`,t,...n):console.error(`[main ${p()}]`,t,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=v;class f extends E{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}i.ConsoleLogger=f;class m extends E{constructor(t,n=i.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=m;class S extends E{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=S;class l extends w.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}i.LogService=l;class u extends w.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(y=>y.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?c.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return c.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}i.NullLogService=g;function a(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const t=s(r.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=a;function s(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=s;function e(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,12,4,2,14,60,9]),function(B,i,D,I,w,R,T,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(h,v){super(),this.logService=h,this.options=v,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,c.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,16,112,17,43,90,11,59,9]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let g=class extends d.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const r=new d.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new S.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,d.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await I.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return c.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new S.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e)||(0,S.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(e)||(0,S.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,S.toFileSystemProviderErrorCode)(r)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),t=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,y=e?.resolveMetadata,P=await r.stat(s);let b;return this.toFileStat(r,s,P,void 0,!!y,(k,W)=>(b||(b=C.TernarySearchTree.forUris(()=>!t),b.set(s,!0),n&&b.fill(!0,n)),b.get(k.resource)||b.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?W===1:!1))}async toFileStat(s,e,r,t,n,o){const{providerExtUri:y}=this.getExtUri(s),P={resource:e,name:y.basename(e),isFile:(r.type&S.FileType.File)!==0,isDirectory:(r.type&S.FileType.Directory)!==0,isSymbolicLink:(r.type&S.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(P.isDirectory&&o(P,t)){try{const b=await s.readdir(e),k=await I.Promises.settled(b.map(async([W,_])=>{try{const q=y.joinPath(e,W),Y=n?await s.stat(q):{type:_};return await this.toFileStat(s,q,Y,b.length,n,o)}catch(q){return this.logService.trace(q),null}}));P.children=(0,D.coalesce)(k)}catch(b){this.logService.trace(b),P.children=[]}return P}return P}async resolveAll(s){return I.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new S.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=w.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,t)),t}async writeFile(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,s,r)||await this.mkdirp(t,n.dirname(s));let y;if((0,S.hasReadWriteCapability)(t)&&!(e instanceof w.VSBuffer))if((0,f.isReadableStream)(e)){const P=await(0,f.peekStream)(e,3);P.ended?y=w.VSBuffer.concat(P.buffer):y=P}else y=(0,f.peekReadable)(e,P=>w.VSBuffer.concat(P),3);else y=e;!(0,S.hasOpenReadWriteCloseCapability)(t)||(0,S.hasReadWriteCapability)(t)&&y instanceof w.VSBuffer?await this.doWriteUnbuffered(t,s,r,y):await this.doWriteBuffered(t,s,r,y instanceof w.VSBuffer?(0,w.bufferToReadable)(y):y),this._onDidRunOperation.fire(new S.FileOperationEvent(s,4))}catch(o){throw new S.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&S.FileType.Directory)!==0)throw new S.FileOperationError((0,m.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,S.etag)({mtime:r.mtime,size:n.size}))throw new S.FileOperationError((0,m.localize)(7,null),3,r);return n}async readFile(s,e,r){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,r):this.doReadFile(t,s,e,r)}async doReadFileAtomic(s,e,r,t){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const y=await this.doReadFile(s,e,r,t);n(y)}catch(y){o(y)}})})}async doReadFile(s,e,r,t){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},t);return{...n,value:await(0,w.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,r)}async doReadFileStream(s,e,r,t){const n=new R.CancellationTokenSource(t),o=this.validateReadFile(e,r).then(P=>P,P=>{throw n.cancel(),P});let y;try{return typeof r?.etag=="string"&&r.etag!==S.ETAG_DISABLED&&await o,r?.atomic&&(0,S.hasFileAtomicReadCapability)(s)||!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&r?.preferUnbuffered?y=this.readFileUnbuffered(s,e,r):(0,S.hasFileReadStreamCapability)(s)?y=this.readFileStreamed(s,e,n.token,r):y=this.readFileBuffered(s,e,n.token,r),{...await o,value:y}}catch(P){y&&await(0,f.consumeStream)(y);const b=(0,m.localize)(8,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(P).toString());throw P instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(b,P.stat,r):new S.FileOperationError(b,(0,S.toFileOperationResult)(P),r)}}readFileStreamed(s,e,r,t=Object.create(null)){const n=s.readFileStream(e,t,r);return(0,f.transform)(n,{data:o=>o instanceof w.VSBuffer?o:w.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,m.localize)(9,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},o=>w.VSBuffer.concat(o))}readFileBuffered(s,e,r,t=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,e,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,m.localize)(10,null,this.resourceForError(e),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},r),n}readFileUnbuffered(s,e,r){const t=(0,f.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,S.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),t.end(w.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new S.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==S.ETAG_DISABLED&&e.etag===r.etag)throw new S.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&e>r.limits.size&&(t=7),typeof t=="number")throw new S.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,t){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,t)}catch(n){return n}return!0}async move(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"move",!!r),y=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="move"?2:3,y)),y}async copy(s,e,r){const t=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"copy",!!r),y=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="copy"?3:2,y)),y}async doMoveCopy(s,e,r,t,n,o){if(e.toString()===t.toString())return n;const{exists:y,isSameResourceWithDifferentPathCase:P}=await this.doValidateMoveCopy(s,e,r,t,n,o);if(y&&!P&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n==="copy"){if(s===r&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const b=await this.resolve(e);b.isDirectory?await this.doCopyFolder(s,b,r,t):await this.doCopyFile(s,e,r,t)}return n}else return s===r?(await s.rename(e,t,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,t){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,t);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,t)}async doCopyFolder(s,e,r,t){await r.mkdir(t),Array.isArray(e.children)&&await I.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,t,n,o){let y=!1;if(s===r){const{providerExtUri:b,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(y=b.isEqual(e,t)),y&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!y&&b.isEqualOrParent(t,e))throw new Error((0,m.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const P=await this.exists(t);if(P&&!y){if(!o)throw new S.FileOperationError((0,m.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===r){const{providerExtUri:b}=this.getExtUri(s);if(b.isEqualOrParent(e,t))throw new Error((0,m.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:P,isSameResourceWithDifferentPathCase:y}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&S.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(t.basename(e)),e=t.dirname(e)}for(let n=r.length-1;n>=0;n--){e=t.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new S.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const y=await this.resolve(s);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),t=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===t&&(0,S.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===t&&(0,S.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new d.DisposableStore;let t=!1,n=()=>{t=!0};return r.add((0,d.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,d.dispose)(o):n=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),t=(0,p.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(t,n)),n.count+=1,(0,d.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,n,t):await this.doWriteReadableBufferedQueued(s,n,t)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let t=0,n;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=w.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,y)=>{(0,f.listenStream)(n,{onData:async P=>{n.pause();try{await this.doWriteBuffer(s,e,P,P.byteLength,t,0)}catch(b){return y(b)}t+=P.byteLength,setTimeout(()=>n.resume())},onError:P=>y(P),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let t=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(s,e,r,t,n,o){let y=0;for(;y<t;)y+=await s.write(e,n+y,r.buffer,o+y,t-y)}async doWriteUnbuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,t))}async doWriteUnbufferedQueued(s,e,r,t){let n;t instanceof w.VSBuffer?n=t:(0,f.isReadableStream)(t)?n=await(0,w.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?n=await(0,w.bufferedStreamToBuffer)(t):n=(0,w.readableToBuffer)(t),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,t))}async doPipeBufferedQueued(s,e,r,t){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const y=w.VSBuffer.alloc(this.BUFFER_SIZE);let P=0,b=0,k=0;do k=await s.read(n,P,y.buffer,b,y.byteLength-b),await this.doWriteBuffer(r,o,y,k,P,b),P+=k,b+=k,b===y.byteLength&&(b=0);while(k>0)}catch(y){throw(0,S.ensureFileSystemProviderError)(y)}finally{await I.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,t))}async doPipeUnbufferedQueued(s,e,r,t){return r.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,t))}async doPipeUnbufferedToBufferedQueued(s,e,r,t){const n=await r.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,w.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,t){const n=await(0,w.streamToBuffer)(this.readFileBuffered(s,e,R.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new S.FileOperationError((0,m.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===E.Schemas.file?s.fsPath:s.toString(!0)}};g=fe([ee(0,u.ILogService)],g),i.FileService=g}),define(Q[113],Z([0,1,114,152,3,36,15,4,153,2,14,13,17,43,20,92,11,59,110,31,108,107]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u,g,a,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new R.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async y=>{try{let P;y.isSymbolicLink()?P=(await this.stat((0,h.joinPath)(t,y.name))).type:P=this.toType(y),o.push([y.name,P])}catch(P){this.logService.trace(P)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=S.FileType.Unknown:t.isFile()?o=S.FileType.File:t.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,n&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const y=new w.Barrier;return this.resourceLocks.set(t,y),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===y&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),y.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const y=this.toFilePath(t);return await f.Promises.readFile(y)}catch(y){throw this.toFileSystemProviderError(y)}finally{o?.dispose()}}readFileStream(t,n,o){const y=(0,v.newWriteableStream)(P=>T.VSBuffer.concat(P.map(b=>T.VSBuffer.wrap(b))).buffer);return(0,l.readFileIntoStream)(this,t,y,P=>P.buffer,{...n,bufferSize:256*1024},o),y}async writeFile(t,n,o){let y;try{const P=this.toFilePath(t);if(!o.create||!o.overwrite){if(await f.Promises.exists(P)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,m.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,m.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(y,0,n,0,n.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(t,P)}finally{typeof y=="number"&&await this.close(y)}}static configureFlushOnWrite(t){e.canFlush=t}async open(t,n){const o=this.toFilePath(t);let y;(0,S.isFileOpenForWriteOptions)(n)&&(y=await this.createResourceLock(t));let P;try{if((0,S.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(o);k.mode&128||await f.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let b;if((0,S.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await f.Promises.truncate(o,0),b="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}b||(b="w")}else b="r";P=await f.Promises.open(o,b)}catch(b){throw y?.dispose(),(0,S.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(P,0),(0,S.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(P,t),y){const b=this.mapHandleToLock.get(P);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.mapHandleToLock.set(P,y),b&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),b.dispose())}return P}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&e.canFlush)try{await f.Promises.fdatasync(t)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,y,P){const b=this.normalizePos(t,n);let k=null;try{k=(await f.Promises.read(t,o,y,P,b)).bytesRead}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(t,b,k)}return k}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const y=this.mapHandleToPos.get(t);typeof y=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,y+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,y,P){return(0,w.retry)(()=>this.doWrite(t,n,o,y,P),100,3)}async doWrite(t,n,o,y,P){const b=this.normalizePos(t,n);let k=null;try{k=(await f.Promises.write(t,o,y,P,b)).bytesWritten}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),W)}finally{this.updatePos(t,b,k)}return k}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const y=this.toFilePath(t),P=this.toFilePath(n);if(y!==P)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await f.Promises.move(y,P)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(2,null,(0,C.basename)(y),(0,C.basename)((0,C.dirname)(P)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(t,n,o){const y=this.toFilePath(t),P=this.toFilePath(n);if(y!==P)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await f.Promises.copy(y,P,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(3,null,(0,C.basename)(y),(0,C.basename)((0,C.dirname)(P)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(t,n,o,y){const P=this.toFilePath(t),b=this.toFilePath(n);let k=!1;if(!!(this.capabilities&1024)||(k=(0,c.isEqual)(P,b,!0)),k&&o==="copy")throw(0,S.createFileSystemProviderError)((0,m.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!k&&await f.Promises.exists(b)){if(!y)throw(0,S.createFileSystemProviderError)((0,m.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const y=this.toFilePath(t),P=this.toFilePath(n),b=!!(this.capabilities&1024);if((0,c.isEqual)(y,P,!b))return;const k=new d.DisposableStore;try{const[W,_]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);k.add(W),k.add(_),o&&await f.Promises.mkdir((0,C.dirname)(P),{recursive:!0}),await f.Promises.copyFile(y,P)}catch(W){if(W.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(W)}finally{k.dispose()}}createUniversalWatcher(t,n,o){return new a.UniversalWatcherClient(y=>t(y),y=>n(y),o)}createNonRecursiveWatcher(t,n,o){return new s.NodeJSWatcherClient(y=>t(y),y=>n(y),o)}toFileSystemProviderError(t){if(t instanceof S.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=S.FileSystemProviderErrorCode.NoPermissions;break;default:n=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await f.SymlinkSupport.stat(this.toFilePath(t));y.mode&128||(o=(0,S.createFileSystemProviderError)(n,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.logService.trace(y)}return o}}i.DiskFileSystemProvider=e,e.canFlush=!0}),define(Q[115],Z([0,1,11,9]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function w(p,c,d,C,E){try{const h=await new Promise((f,m)=>{B(["spdlog"],f,m)});h.setFlushOn(I.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(p,c,d,C);return E&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function R(p,c,d){switch(c){case I.LogLevel.Trace:p.trace(d);break;case I.LogLevel.Debug:p.debug(d);break;case I.LogLevel.Info:p.info(d);break;case I.LogLevel.Warning:p.warn(d);break;case I.LogLevel.Error:p.error(d);break;case I.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class T extends I.AbstractMessageLogger{constructor(c,d,C,E,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,d,C,E),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(c,d,C,E){const h=C?6:1,v=30/h*D.ByteSize.MB,f=await w(c,d,v,h,E);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:S}of this.buffer)R(this._logger,m,S);this.buffer=[]}}log(c,d){this._logger?R(this._logger,c,d):this.getLevel()<=c&&this.buffer.push({level:c,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=T}),define(Q[37],Z([0,1,4,63,2,8]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,R.createDecorator)("policy");class T extends w.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),I.Iterable.reduce(this.policies.entries(),(E,[h,v])=>({...E,[h]:v}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[C,E])=>({...d,[C]:{definition:E,value:this.policies.get(C)}}),{})}}i.AbstractPolicyService=T;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=p}),define(Q[116],Z([0,1,3,4,63,5,11,9,37]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function d(E,h){const v=[];for(const f of w.Iterable.concat(E.keys(),h.keys()))E.get(f)!==h.get(f)&&v.push(f);return v}let C=class extends c.AbstractPolicyService{constructor(h,v,f){super(),this.file=h,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const m=I.Event.filter(v.onDidFilesChange,S=>S.affects(h));this._register(v.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return h}async refresh(){const h=await this.read(),v=d(this.policies,h);this.policies=h,v.length>0&&this._onDidChange.fire(v)}};C=fe([ee(1,T.IFileService),ee(2,p.ILogService)],C),i.FilePolicyService=C}),define(Q[28],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class w{constructor(){this.data=new Map}add(T,p){D.ok(I.isString(T)),D.ok(I.isObject(p)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,p)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}i.Registry=new w}),define(Q[117],Z([0,1,4,33]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function w(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[w(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;I.Registry.add(i.Extensions.JSONContribution,T)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var C;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=c.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const t=this.doRegisterConfigurations(e,r);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(e,!1)),E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(e){const r=[],t=[];for(const{overrides:n,source:o}of e)for(const y in n)if(r.push(y),i.OVERRIDE_PROPERTY_REGEX.test(y)){const P=this.configurationDefaultsOverrides.get(y),b=P?.valuesSources??new Map;if(o)for(const q of Object.keys(n[y]))b.set(q,o);const k={...P?.value||{},...n[y]};this.configurationDefaultsOverrides.set(y,{source:o,value:k,valuesSources:b});const W=(0,T.getLanguageTagSettingPlainKey)(y),_={type:"object",default:k,description:R.localize(1,null,W),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:w.isString(o)?void 0:o,defaultValueSource:o};t.push(...m(y)),this.configurationProperties[y]=_,this.defaultLanguageConfigurationOverridesNode.properties[y]=_}else{this.configurationDefaultsOverrides.set(y,{value:n[y],source:o});const P=this.configurationProperties[y];P&&(this.updatePropertyDefaultValue(y,P),this.updateSchema(y,P))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:t,source:n}of e)for(const o in t){const y=this.configurationDefaultsOverrides.get(o),P=w.isString(n)?n:n?.id,b=w.isString(y?.source)?y?.source:y?.source?.id;if(P===b)if(r.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const t=[];return e.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(e){const r=[],t=n=>{if(n.properties)for(const o in n.properties){r.push(o);const y=this.configurationProperties[o];y?.policy?.name&&this.policyConfigurations.delete(y.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>t(o))};for(const n of e){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,t,n,o=3){o=w.isUndefinedOrNull(e.scope)?o:e.scope;const y=[],P=e.properties;if(P)for(const k in P){const W=P[k];if(r&&g(k,W)){delete P[k];continue}if(W.source=t,W.defaultDefaultValue=P[k].default,this.updatePropertyDefaultValue(k,W),i.OVERRIDE_PROPERTY_REGEX.test(k)?W.scope=void 0:(W.scope=w.isUndefinedOrNull(W.scope)?o:W.scope,W.restricted=w.isUndefinedOrNull(W.restricted)?!!n?.includes(k):W.restricted),P[k].hasOwnProperty("included")&&!P[k].included){this.excludedConfigurationProperties[k]=P[k],delete P[k];continue}else this.configurationProperties[k]=P[k],P[k].policy?.name&&this.policyConfigurations.set(P[k].policy.name,k);!P[k].deprecationMessage&&P[k].markdownDeprecationMessage&&(P[k].deprecationMessage=P[k].markdownDeprecationMessage),y.push(k)}const b=e.allOf;if(b)for(const k of b)y.push(...this.validateAndRegisterProperties(k,r,t,n,o));return y}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=t=>{const n=t.properties;if(n)for(const y in n)this.updateSchema(y,n[y]);t.allOf?.forEach(r)};r(e)}updateSchema(e,r){switch(i.allSettings.properties[e]=r,r.scope){case 1:i.applicationSettings.properties[e]=r;break;case 2:i.machineSettings.properties[e]=r;break;case 6:i.machineOverridableSettings.properties[e]=r;break;case 3:i.windowSettings.properties[e]=r;break;case 4:i.resourceSettings.properties[e]=r;break;case 5:i.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete i.allSettings.properties[e],r.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,t={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),i.allSettings.properties[r]=t,i.applicationSettings.properties[r]=t,i.machineSettings.properties[r]=t,i.machineOverridableSettings.properties[r]=t,i.windowSettings.properties[r]=t,i.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const t=this.configurationDefaultsOverrides.get(e);let n=t?.value,o=t?.source;w.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),w.isUndefined(n)&&(n=l(r.type)),r.default=n,r.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function m(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let r=f.exec(s);for(;r?.length;){const t=r[1].trim();t&&e.push(t),r=f.exec(s)}}return(0,D.distinct)(e)}i.overrideIdentifiersFromKey=m;function S(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}i.keyFromOverrideIdentifiers=S;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=l;const u=new h;c.Registry.add(i.Extensions.Configuration,u);function g(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?R.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):e.policy?.name&&u.getPolicyConfigurations().get(e.policy?.name)!==void 0?R.localize(9,null,s,e.policy?.name,u.getPolicyConfigurations().get(e.policy?.name)):null:R.localize(6,null)}i.validateProperty=g;function a(){const s=[],e=u.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=a}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,i,D,I,w,R,T,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class v{constructor(e={},r=[],t=[]){this._contents=e,this._keys=r,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,C.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,r){const t=this.getContentsForOverrideIdentifer(r);return t?e?(0,C.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const r=[];for(const t of this.overrides)t.identifiers.includes(e)&&r.push(...t.keys);return D.distinct(r)}getAllOverrideIdentifiers(){const e=[];for(const r of this.overrides)e.push(...r.identifiers);return D.distinct(e)}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=p.deepClone(this.contents),t=p.deepClone(this.overrides),n=[...this.keys];for(const o of e)if(!o.isEmpty()){this.mergeContents(r,o.contents);for(const y of o.overrides){const[P]=t.filter(b=>D.equals(b.identifiers,y.identifiers));P?(this.mergeContents(P.contents,y.contents),P.keys.push(...y.keys),P.keys=D.distinct(P.keys)):t.push(p.deepClone(y))}for(const y of o.keys)n.indexOf(y)===-1&&n.push(y)}return new v(r,n,t)}freeze(){return this.frozen=!0,this}clone(){return new v(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const t={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n];const y=r[n];y&&(typeof o=="object"&&typeof y=="object"?(o=p.deepClone(o),this.mergeContents(o,y)):o=y),t[n]=o}return new v(t,this.keys,this.overrides)}mergeContents(e,r){for(const t of Object.keys(r)){if(t in e&&c.isObject(e[t])&&c.isObject(r[t])){this.mergeContents(e[t],r[t]);continue}e[t]=p.deepClone(r[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?p.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let r=null,t=null;const n=o=>{o&&(t?this.mergeContents(t,o):t=p.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?r=o.contents:o.identifiers.includes(e)&&n(o.contents);return n(r),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,C.addToValueTree)(this.contents,e,r,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,C.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let t=0;t<r;t++)e.indexOf(this.keys[t])===0&&(r=t);this.keys.splice(r,1,e)}removeKey(e){const r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}i.ConfigurationModel=v;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!c.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:t,keys:n,overrides:o,restricted:y}=this.doParseRaw(e,r);this._configurationModel=new v(t,n,o),this._restrictedConfigurations=y||[]}doParseContent(e){let r={},t=null,n=[];const o=[],y=[];function P(k){Array.isArray(n)?n.push(k):t!==null&&(n[t]=k)}const b={onObjectBegin:()=>{const k={};P(k),o.push(n),n=k,t=null},onObjectProperty:k=>{t=k},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const k=[];P(k),o.push(n),n=k,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:P,onError:(k,W,_)=>{y.push({error:k,offset:W,length:_})}};if(e)try{w.visit(e,b),r=n[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return r}doParseRaw(e,r){const t=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,t,!0,r);e=n.raw;const o=(0,C.toValuesTree)(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),y=Object.keys(e),P=this.toOverrides(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:o,keys:y,overrides:P,restricted:n.restricted}}filter(e,r,t,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const o={},y=[];for(const P in e)if(E.OVERRIDE_PROPERTY_REGEX.test(P)&&t){const b=this.filter(e[P],r,!1,n);o[P]=b.raw,y.push(...b.restricted)}else{const b=r[P],k=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&y.push(P),(k===void 0||n.scopes===void 0||n.scopes.includes(k))&&(n.skipRestricted&&b?.restricted||(o[P]=e[P]))}return{raw:o,restricted:y}}toOverrides(e,r){const t=[];for(const n of Object.keys(e))if(E.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const y in e[n])o[y]=e[n][y];t.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,C.toValuesTree)(o,r)})}return t}}i.ConfigurationModelParser=f;class m extends R.Disposable{constructor(e,r,t,n){super(),this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=m;class S{constructor(e,r,t,n,o=new v,y=new v,P=new T.ResourceMap,b=new v,k=new T.ResourceMap,W=!0){this._defaultConfiguration=e,this._policyConfiguration=r,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=y,this._folderConfigurations=P,this._memoryConfiguration=b,this._memoryConfigurationByResource=k,this._freeze=W,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,r,t){return this.getConsolidatedConfigurationModel(e,r,t).getValue(e)}updateValue(e,r,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new v,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,t){const n=this.getConsolidatedConfigurationModel(e,r,t),o=this.getFolderConfigurationModelForResource(r.resource,t),y=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,P=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),b=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(e),k=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(e),W=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),_=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),q=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),Y=t?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ie=o?r.overrideIdentifier?o.freeze().override(r.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,ae=r.overrideIdentifier?y.override(r.overrideIdentifier).getValue(e):y.getValue(e),ne=n.getValue(e),ge=D.distinct(n.overrides.map(ue=>ue.identifiers).flat()).filter(ue=>n.getOverrideValue(e,ue)!==void 0);return{defaultValue:P,policyValue:b,applicationValue:k,userValue:W,userLocalValue:_,userRemoteValue:q,workspaceValue:Y,workspaceFolderValue:ie,memoryValue:ae,value:ne,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,policy:b!==void 0?{value:b}:void 0,application:k!==void 0?{value:k,override:r.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,user:W!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userRemote:q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspaceFolder:ie!==void 0?{value:o?.freeze().getValue(e),override:r.overrideIdentifier?o?.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:y.getValue(e),override:r.overrideIdentifier?y.getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ge.length?ge:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const t=[];if(!r){const{added:n,updated:o,removed:y}=g(this._defaultConfiguration,e);r=[...n,...o,...y]}for(const n of r)for(const o of(0,E.overrideIdentifiersFromKey)(n)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(o),P=e.getKeysForOverrideIdentifier(o),b=[...P.filter(k=>y.indexOf(k)===-1),...y.filter(k=>P.indexOf(k)===-1),...y.filter(k=>!p.equals(this._defaultConfiguration.override(o).getValue(k),e.override(o).getValue(k)))];t.push([o,b])}return this.updateDefaultConfiguration(e),{keys:r,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:r,updated:t,removed:n}=g(this._policyConfiguration,e),o=[...r,...t,...n];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=g(this.applicationConfiguration,e),y=[...r,...t,...n];return y.length&&this.updateApplicationConfiguration(e),{keys:y,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=g(this.localUserConfiguration,e),y=[...r,...t,...n];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=g(this.remoteUserConfiguration,e),y=[...r,...t,...n];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=g(this.workspaceConfiguration,e),y=[...r,...t,...n];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const t=this.folderConfigurations.get(e),{added:n,updated:o,removed:y,overrides:P}=g(t,r),b=[...n,...o,...y];return(b.length||!t)&&this.updateFolderConfiguration(e,r),{keys:b,overrides:P}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:n,removed:o,overrides:y}=g(r,void 0);return{keys:[...t,...n,...o],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,r,t){let n=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:e},r){let t=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=t.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=t}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const t=r.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:t,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:t,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),n=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),y=this.parseConfigurationModel(e.workspace),P=e.folders.reduce((b,k)=>(b.set(d.URI.revive(k[0]),this.parseConfigurationModel(k[1])),b),new T.ResourceMap);return new S(r,t,n,o,new v,y,P,new v,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=S;function l(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const n of s)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,y])=>{const P=(0,T.getOrSet)(r,o,new Set);y.forEach(b=>P.add(b))});const t=[];return r.forEach((n,o)=>t.push([o,[...n.values()]])),{keys:[...e.values()],overrides:t}}i.mergeChanges=l;class u{constructor(e,r,t,n){this.change=e,this.previous=r,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(P=>o.add(P)),e.overrides.forEach(([,P])=>P.forEach(b=>o.add(b))),this.affectedKeys=[...o.values()];const y=new v;this.affectedKeys.forEach(P=>y.setValue(P,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!p.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let t=(0,C.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(e=e[n],!e)return!1;t=t[n]}return!0}}i.ConfigurationChangeEvent=u;function g(s,e){const{added:r,removed:t,updated:n}=a(e,s),o=[],y=s?.getAllOverrideIdentifiers()||[],P=e?.getAllOverrideIdentifiers()||[];if(e){const b=P.filter(k=>!y.includes(k));for(const k of b)o.push([k,e.getKeysForOverrideIdentifier(k)])}if(s){const b=y.filter(k=>!P.includes(k));for(const k of b)o.push([k,s.getKeysForOverrideIdentifier(k)])}if(e&&s){for(const b of y)if(P.includes(b)){const k=a({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:e.getOverrideValue(void 0,b)||{},keys:e.getKeysForOverrideIdentifier(b)});o.push([b,[...k.added,...k.removed,...k.updated]])}}return{added:r,removed:t,updated:n,overrides:o}}function a(s,e){const r=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],t=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],n=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const y=(0,C.getConfigurationValue)(e.contents,o),P=(0,C.getConfigurationValue)(s.contents,o);p.equals(y,P)||n.push(o)}}return{added:r,removed:t,updated:n}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,i,D,I,w,R,T,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class v extends w.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=v;class f extends c.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(g),s=Object.create(null),e=[];for(const r in g){const t=u[r],n=t!==void 0?t:g[r].default;(0,p.addToValueTree)(s,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(r)&&e.push({identifiers:(0,d.overrideIdentifiersFromKey)(r),keys:Object.keys(s[r]),contents:(0,p.toValuesTree)(s[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,a,e)}}i.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new c.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=m;let S=class extends w.Disposable{constructor(u,g,a){super(),this.defaultConfiguration=u,this.policyService=g,this.logService=a,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new c.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},a=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const e of u){const r=s[e];if(!r){a.push(e);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}a.push(e),g[r.policy.name]={type:r.type}}}return(0,T.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),a}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),a=(0,D.coalesce)(u.map(s=>g.get(s)));this.update(a,!0)}update(u,g){const a=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const r of u){const t=a[r]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(e?n!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),n))&&s.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&s.push([r,void 0])}if(s.length){const r=this._configurationModel;this._configurationModel=new c.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,n]of s)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};S=fe([ee(1,E.IPolicyService),ee(2,C.ILogService)],S),i.PolicyConfiguration=S}),define(Q[119],Z([0,1,3,4,2,17,21,64,118,37]),function(B,i,D,I,w,R,T,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends w.Disposable{constructor(h,v,f,m){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new c.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new c.NullPolicyConfiguration:this._register(new c.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,v)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:l})=>this.onDidDefaultConfigurationChange(S,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,v,new p.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const f=typeof h=="string"?h:void 0,m=(0,T.isConfigurationOverrides)(h)?h:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,v,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,v,2)}onDidDefaultConfigurationChange(h,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,v,7)}trigger(h,v,f){const m=new p.ConfigurationChangeEvent(h,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Q[120],Z([0,1,16]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function I(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}i.getRemoteAuthority=I;function w(d){if(!d)return;const C=d.indexOf("+");return C<0?d:d.substr(0,C)}i.getRemoteName=w;function R(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}i.getRemoteServerRootPath=R;function T(d){const{host:C,port:E}=c(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}i.parseAuthorityWithPort=T;function p(d,C){let{host:E,port:h}=c(d);return typeof h>"u"&&(h=C),{host:E,port:h}}i.parseAuthorityWithOptionalPort=p;function c(d){const C=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}i.getWorkspaceSupportTypeMessage=R;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=T,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(p=i.ExtensionType||(i.ExtensionType={}));var c;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,S){if(typeof m>"u"||m===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof m=="string"||typeof S=="string"){const l=typeof m=="string"?m:m.value,u=typeof S=="string"?S:S.value;return D.equalsIgnoreCase(l,u)}return m._lower===S._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}i.ExtensionIdentifier=d;function C(f){return E(f)}i.isApplicationScopedExtension=C;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}i.isLanguagePackExtension=E;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=h;function v(f,m){if(m){const S=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return f.activationEvents?.indexOf(S)!==-1}return!1}i.isResolverExtension=v,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,13,10,12,32]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function d(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}i.areSameExtensions=d;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,n,o)}static parse(t){const n=C.exec(t);return n&&n[1]&&n[2]?new E({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}i.ExtensionKey=E;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const t=h.exec(r);return t&&t[1]?[m(t[1]),t[2]]:[m(r),void 0]}i.getIdAndVersion=v;function f(r,t){return`${r}.${t}`}i.getExtensionId=f;function m(r){return r.toLocaleLowerCase()}i.adoptToGalleryExtensionId=m;function S(r,t){return m(f(r,t))}i.getGalleryExtensionId=S;function l(r,t){const n=[],o=y=>{for(const P of n)if(P.some(b=>d(t(b),t(y))))return P;return null};for(const y of r){const P=o(y);P?P.push(y):n.push([y])}return n}i.groupByExtension=l;function u(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function g(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}i.getGalleryExtensionTelemetryData=g,i.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const y=o.shift();if(y&&n.every(P=>!d(P.identifier,{id:y}))){const P=r.filter(b=>d(b.identifier,{id:y}));P.length===1&&(n.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}i.getExtensionDependencies=a;async function s(r,t){if(!R.isLinux)return!1;let n;try{n=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){t.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(y))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function e(r,t){const n=await s(r,t),o=(0,I.getTargetPlatform)(n?"alpine":R.platform,c.arch);return t.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,12,16,17,39,10,84,22,23,34]),function(B,i,D,I,w,R,T,p,c,d,C,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const h=S=>(0,c.localize)(0,null,S),v=(0,c.localize)(1,null,"ms-dotnettools.csharp");function f(S,l){return l?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}let m=class{constructor(l,u){this.extensionManagementService=l,this.extensionGalleryService=u}get location(){}async listExtensions(l,u,g=console){let a=await this.extensionManagementService.getInstalled(1);const s=E.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){g.log("Possible Categories: "),s.forEach(r=>{g.log(r)});return}this.location&&g.log((0,c.localize)(2,null,this.location)),a=a.sort((r,t)=>r.identifier.id.localeCompare(t.identifier.id));let e;for(const r of a)e!==r.identifier.id&&(e=r.identifier.id,g.log(f(r.manifest,l)))}async installExtensions(l,u,g,a,s=console){const e=[],r=[];l.length&&s.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),n=(b,k)=>{const W=t.find(_=>(0,C.areSameExtensions)(_.identifier,{id:b}));if(W){if(!a&&(!k||k==="prerelease"&&W.preRelease))return s.log((0,c.localize)(5,null,b,W.manifest.version,b)),!1;if(k&&W.manifest.version===k)return s.log((0,c.localize)(6,null,`${b}@${k}`)),!1}return!0},o=(b,k,W)=>{P.push({id:b,version:k!=="prerelease"?k:void 0,installOptions:{...g,isBuiltin:W,installPreReleaseVersion:k==="prerelease"||g.installPreReleaseVersion}})},y=[],P=[];for(const b of l)if(b instanceof p.URI)y.push(b);else{const[k,W]=(0,C.getIdAndVersion)(b);n(k,W)&&o(k,W,!1)}for(const b of u){const[k,W]=(0,C.getIdAndVersion)(b);n(k,W)&&o(k,W,!0)}if(y.length&&await Promise.all(y.map(async b=>{try{const k=await this.installVSIX(b,{...g,isBuiltin:!1},a,s);k&&r.push(k)}catch(k){s.error(k.message||k.stack||k),e.push(b.toString())}})),P.length){const b=await this.getGalleryExtensions(P);await Promise.all(P.map(async k=>{const W=b.get(k.id.toLowerCase());if(W)try{const _=await this.installFromGallery(k,W,t,a,s);_&&r.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(k.id)}else s.error(`${h(k.version?`${k.id}@${k.version}`:k.id)}
${v}`),e.push(k.id)}))}if(e.length)throw new Error((0,c.localize)(7,null,e.join(", ")))}async installVSIX(l,u,g,a){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,a))try{return await this.extensionManagementService.install(l,u),a.log((0,c.localize)(8,null,(0,R.basename)(l))),s}catch(r){if((0,I.isCancellationError)(r))return a.log((0,c.localize)(9,null,(0,R.basename)(l))),null;throw r}return null}async getGalleryExtensions(l){const u=new Map,g=l.some(s=>s.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:g})),D.CancellationToken.None);for(const s of a)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:l,version:u,installOptions:g},a,s,e,r){const t=await this.extensionGalleryService.getManifest(a,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,r))return null;const n=s.find(o=>(0,C.areSameExtensions)(o.identifier,a.identifier));if(n){if(a.version===n.manifest.version)return r.log((0,c.localize)(10,null,u?`${l}@${u}`:l)),null;r.log((0,c.localize)(11,null,l,a.version))}try{g.isBuiltin?r.log(u?(0,c.localize)(12,null,l,u):(0,c.localize)(13,null,l)):r.log(u?(0,c.localize)(14,null,l,u):(0,c.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(a,{...g,installGivenVersion:!!u});return r.log((0,c.localize)(16,null,l,o.manifest.version)),t}catch(o){if((0,I.isCancellationError)(o))return r.log((0,c.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,u){return!0}async validateVSIX(l,u,g){const a={id:(0,C.getGalleryExtensionId)(l.publisher,l.name)},e=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,C.areSameExtensions)(a,r.identifier)&&(0,T.gt)(r.manifest.version,l.version));return e&&!u?(g.log((0,c.localize)(18,null,e.identifier.id,e.manifest.version,l.version)),!1):this.validateExtensionKind(l,g)}async uninstallExtensions(l,u,g=console){const a=async e=>{if(e instanceof p.URI){const r=await this.extensionManagementService.getManifest(e);return f(r)}return e},s=[];for(const e of l){const r=await a(e),n=(await this.extensionManagementService.getInstalled()).filter(o=>(0,C.areSameExtensions)(o.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${v}`);if(n.some(o=>o.type===0)){g.log((0,c.localize)(19,null,r));return}if(!u&&n.some(o=>o.isBuiltin)){g.log((0,c.localize)(20,null,r));return}g.log((0,c.localize)(21,null,r));for(const o of n)await this.extensionManagementService.uninstall(o),s.push(o);this.location?g.log((0,c.localize)(22,null,r,this.location)):g.log((0,c.localize)(23,null,r))}}async locateExtension(l,u=console){const g=await this.extensionManagementService.getInstalled();l.forEach(a=>{g.forEach(s=>{if(s.identifier.id===a&&s.location.scheme===w.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,c.localize)(24,null,l,this.location):(0,c.localize)(25,null,l)}};m=fe([ee(0,d.IExtensionManagementService),ee(1,d.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(Q[41],Z([0,1,3,15,2,36,10,23,11,8,9]),function(B,i,D,I,w,R,T,p,c,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let E=class extends w.Disposable{constructor(v,f){super(),this.fileService=v,this.logService=f,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,f){return this.withProfileExtensions(f,m=>(m=m.filter(S=>v.some(([l])=>!(0,p.areSameExtensions)(S.identifier,l.identifier))),m.push(...v.map(([S,l])=>({identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:l}))),m))}removeExtensionFromProfile(v,f){return this.withProfileExtensions(f,m=>m.filter(S=>!(0,p.areSameExtensions)(S.identifier,v)))}async withProfileExtensions(v,f){return this.getResourceAccessQueue(v).queue(async()=>{let m=[];try{const S=await this.fileService.readFile(v),l=JSON.parse(S.value.toString());for(const u of l){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:T.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}if(f){m=f(m);const S=m.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(v,I.VSBuffer.fromString(JSON.stringify(S)))}return m})}getResourceAccessQueue(v){let f=this.resourcesAccessQueueMap.get(v);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(v,f)),f}};E=fe([ee(0,c.IFileService),ee(1,C.ILogService)],E),i.ExtensionsProfileScannerService=E}),define(Q[122],Z([0,1,3,12,2,13,17,39,10,30,20,18,22,23,11,9]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let S=class extends w.Disposable{constructor(u,g,a,s){super(),this.fileService=g,this.extensionGalleryService=a,this.logService=s,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const a=this.getName(u),s=(0,T.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(s)){const e=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,g);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,a){try{await C.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(R.isWindows&&s&&s.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,a);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],a=[];for(const r of u.children){const t=v.ExtensionKey.parse(r.name);t&&a.push([t,r])}const s=(0,v.groupByExtension)(a,([r])=>r),e=[];for(const r of s)r.sort((t,n)=>p.rcompare(t[0].version,n[0].version)),g.push(...r.slice(1).map(t=>t[1].resource)),e.push(r[0][1]);e.sort((r,t)=>r.mtime-t.mtime),g.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(g.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?v.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};S=fe([ee(0,E.INativeEnvironmentService),ee(1,f.IFileService),ee(2,h.IExtensionGalleryService),ee(3,m.ILogService)],S),i.ExtensionsDownloader=S}),define(Q[123],Z([0,1,2,14,20,34]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(c,d){super(),this.environmentService=c,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(d.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=T}),define(Q[124],Z([0,1,154,19,3,2,16,14,20,18,22,23,9,62]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let f=class extends v.LanguagePackBaseService{constructor(u,g,a,s){super(a),this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(a=>{const s=u[a];return{...this.createQuickPickItem(a,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((a,s)=>a.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(a=>g[a]&&g[a].extensions.some(s=>(0,E.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(g);return!(0,I.equals)(Object.keys(u),Object.keys(a))}};f=fe([ee(0,C.IExtensionManagementService),ee(1,d.INativeEnvironmentService),ee(2,C.IExtensionGalleryService),ee(3,h.ILogService)],f),i.NativeLanguagePackService=f;let m=class extends R.Disposable{constructor(u,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(a=>delete g[a]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const a of g)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,a);Object.keys(u).forEach(a=>this.updateHash(u[a]))}createLanguagePacksFromExtension(u,g){const a=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const e of s)if(g.location.scheme===T.Schemas.file&&S(e)){let r=u[e.languageId];r||(r={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},u[e.languageId]=r);const t=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,a))[0];t?t.version=g.manifest.version:r.extensions.push({extensionIdentifier:a,version:g.manifest.version});for(const n of e.translations)r.translations[n.id]=(0,p.join)(g.location.fsPath,n.path)}}updateHash(u){if(u){const g=(0,D.createHash)("md5");for(const a of u.extensions)g.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(g=u(a),a)).then(a=>{for(const e of Object.keys(a))a[e]||delete a[e];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,a=>this.logService.error(a))})}};m=fe([ee(0,d.INativeEnvironmentService),ee(1,h.ILogService)],m);function S(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,i,D,I,w,R,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function p(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}i.isSuccess=p;function c(m){return m.res.statusCode===204}async function d(m){return c(m)?null:(await(0,D.streamToBuffer)(m.stream)).toString()}i.asText=d;async function C(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}i.asTextOrError=C;async function E(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);if(c(m))return null;const l=(await(0,D.streamToBuffer)(m.stream)).toString();try{return JSON.parse(l)}catch(u){throw u.message+=`:
`+l,u}}i.asJson=E;function h(m){f(m)}i.updateProxyConfigurationsScope=h;let v;function f(m){const S=T.Registry.as(w.Extensions.Configuration),l=v;v={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[v],remove:l?[l]:[]})}f(2)}),define(Q[125],Z([0,1,24,16,11,47]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let T=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,C=D.CancellationToken.None){if(c.scheme===I.Schemas.file||c.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const E={type:"GET",url:c.toString(!0)},h=await this.requestService.request(E,C);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const v=await(0,R.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};T=fe([ee(0,R.IRequestService),ee(1,w.IFileService)],T),i.DownloadService=T}),define(Q[126],Z([0,1,127,5]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function w(T,p){return T.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:T.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function R(T,p,c={}){const d=(0,D.parse)(T),C=c.proxyUrl||w(d,p);if(!C)return null;const E=(0,D.parse)(C);if(!/^https?:$/.test(E.protocol||""))return null;const h={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,I.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,f)=>{B(["http-proxy-agent"],v,f)}))(h):new(await new Promise((v,f)=>{B(["https-proxy-agent"],v,f)}))(h)}i.getProxyAgent=R}),define(Q[128],Z([0,1,57,14,95,24,31,12,13,30,77,155,3]),function(B,i,D,I,w,R,T,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(l,u,g){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(a,s)=>{const e=new R.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,w.localize)(0,null)))},v);try{a(await S(l,e.token))}catch(t){!(0,p.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,T.toErrorMessage)(t)))):a({})}finally{clearTimeout(r),e.dispose()}})),f)}i.getResolvedShellEnv=m;async function S(l,u){const g=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",a);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(c.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const y=(0,I.basename)(t);let P,b;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(y)?(P=`& '${process.execPath}' ${k} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,b=["-Login","-Command"]):(P=`'${process.execPath}' ${k} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,y==="tcsh"?b=["-ic"]:b=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),P);const W=(0,D.spawn)(t,[...b,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(W.kill(),o((0,p.canceled)()))),W.on("error",Y=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Y)),o(Y)});const _=[];W.stdout.on("data",Y=>_.push(Y));const q=[];W.stderr.on("data",Y=>q.push(Y)),W.on("close",(Y,ie)=>{const ae=Buffer.concat(_).toString("utf8");l.trace("getUnixShellEnvironment#raw",ae);const ne=Buffer.concat(q).toString("utf8");if(ne.trim()&&l.trace("getUnixShellEnvironment#stderr",ne),Y||ie)return o(new Error((0,w.localize)(2,null,Y,ie)));const ge=e.exec(ae),ue=ge?ge[1]:"{}";try{const se=JSON.parse(ue);g?se.ELECTRON_RUN_AS_NODE=g:delete se.ELECTRON_RUN_AS_NODE,a?se.ELECTRON_NO_ATTACH_CONSOLE=a:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",se),n(se)}catch(se){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(se)),o(se)}})})}}),define(Q[65],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,18,11,9]),function(B,i,D,I,w,R,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class c{constructor(E,h,v){this.storagePath=E,this.logService=h,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}}getItem(E,h){const v=this.storage[E];return(0,w.isUndefinedOrNull)(v)?h:v}setItem(E,h){this.setItems([{key:E,data:h}])}setItems(E){let h=!1;for(const{key:v,data:f}of E)this.storage[v]!==f&&((0,w.isUndefinedOrNull)(f)?(0,w.isUndefined)(this.storage[v])||(this.storage[v]=void 0,h=!0):(this.storage[v]=f,h=!0));h&&this.save()}removeItem(E){(0,w.isUndefined)(this.storage[E])||(this.storage[E]=void 0,this.save())}async save(E){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){if(!this.initializing)return;await this.initializing;const E=JSON.stringify(this.storage,null,4);if(E!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,I.VSBuffer.fromString(E)),this.lastSavedStorageContents=E}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=c;let d=class{constructor(E,h,v){this.fileStorage=new c(E.stateResource,h,v)}async init(){await this.fileStorage.init()}getItem(E,h){return this.fileStorage.getItem(E,h)}};d=fe([ee(0,R.IEnvironmentService),ee(1,p.ILogService),ee(2,T.IFileService)],d),i.StateService=d}),define(Q[66],Z([0,1,13,32,10,30]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function T(d){if(D.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,C,E,h,v,f,m,S,l,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=v,g.version=f,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=I.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",S&&(g["common.msftInternal"]=S);let a=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const e=T(E);e&&(g["common.platformDetail"]=e);try{const r=await d.readFile(w.URI.file(l));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}i.resolveCommonProperties=p;function c(d){const C=I.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return d.some(h=>E===h)}i.verifyMicrosoftInternalDomain=c}),define(Q[35],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var w;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(w=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,i,D,I,w,R,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class c{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(e,r){return Promise.resolve(void 0)}publicLog2(e,r){return this.publicLog(e,r)}publicLogError(e,r){return Promise.resolve(void 0)}publicLogError2(e,r){return this.publicLogError(e,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=c,i.NullTelemetryService=new c;class d{async publicLog(e,r,t){}async publicLogError(e,r,t){}}i.NullEndpointTelemetryService=d,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(s,e){return e.onDidChangeConfiguration(r=>{r.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:l(r.sourceConfig)})})}i.configurationTelemetry=C;function E(s,e){return!(e.disableTelemetry||!s.enableTelemetry||e.extensionTestsLocationURI)}i.supportsTelemetry=E;function h(s){const e=s.getValue(p.TELEMETRY_SETTING_ID),r=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(e??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=h;function v(s){const e={},r={},t={};S(s,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),e[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(e[n]=o)}return{properties:e,measurements:r}}i.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const e of f)if(s.startsWith(`${e}+`))return e;return"other"}i.cleanRemoteAuthority=m;function S(s,e,r=0,t){if(!!s)for(const n of Object.getOwnPropertyNames(s)){const o=s[n],y=t?t+n:n;Array.isArray(o)?e[y]=(0,D.safeStringify)(o):o instanceof Date?e[y]=o.toISOString():(0,w.isObject)(o)?r<2?S(o,e,r+1,y+"."):e[y]=(0,D.safeStringify)(o):e[y]=o}}function l(s){if(!s)return[];const e=[];return u(e,"",s),e}function u(s,e,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(t=>u(s,e?`${e}.${t}`:t,r[t])):s.push(e)}function g(s,e){const r=s.msftInternalDomains||[],t=e.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(r)||t}i.isInternalTelemetry=g;function a(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}i.getPiiPathsFromEnvironment=a}),define(Q[130],Z([0,1,103,42]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function w(R,T,p,c,d,C,E){const h={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${T.nameShort})`},v=await(0,D.getServiceMachineId)(p,d,C),{sessionId:f}=await E.getTelemetryInfo();return(0,I.supportsTelemetry)(T,p)&&(0,I.getTelemetryLevel)(c)===3&&(h["X-Market-User-Id"]=v,h["VSCode-SessionId"]=f),h}i.resolveMarketplaceHeaders=w}),define(Q[131],Z([0,1,12,26,42]),function(B,i,D,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(c,d,C){const E=await new Promise((S,l)=>{B(["@microsoft/1ds-core-js"],S,l)}),h=await new Promise((S,l)=>{B(["@microsoft/1ds-post-js"],S,l)}),v=new E.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:c,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(C){m.extensionConfig={};const S={alwaysUseXhrOverride:!0,httpXHROverride:C};m.extensionConfig[f.identifier]=S}return v.initialize(m,[]),v.addTelemetryInitializer(S=>{d&&(S.ext=S.ext??{},S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),v}class p{constructor(d,C,E,h,v){this._isInternalTelemetry=d,this._eventPrefix=C,this._defaultData=E,this._xhrOverride=v,this.endPointUrl=R,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{d(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(d,C){if(!this._aiCoreOrKey)return;C=(0,I.mixin)(C,this._defaultData),C=(0,w.validateTelemetryData)(C);const E=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=C?.properties.version??"Unknown",h.track({name:E,baseData:{name:E,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=p}),define(Q[132],Z([0,1,2,26,52,13,27,96,21,40,133,28,33,35,42]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let m=class{constructor(u,g,a){this._configurationService=g,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const a=g.usage?3:g.error?2:0;u=Math.min(u,a)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,a=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:g,machineId:a,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,g,a,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(e=>{a=(0,I.mixin)(a,e),a=(0,I.mixin)(a,this._experimentProperties),a=(0,I.cloneAndChange)(a,r=>{if(typeof r=="string")return this._cleanupInfo(r,s)}),this._appenders.forEach(r=>r.log(u,a))},e=>{console.error(e)})}publicLog(u,g,a){return this._log(u,3,g,a)}publicLog2(u,g,a){return this.publicLog(u,g,a)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const a=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(u);if(!n)break;a.push([n.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const t=e.exec(u);if(!t)break;!s.test(t[0])&&a.every(([n,o])=>t.index<n||t.index>=o)&&(g+=u.substring(r,t.index)+"<REDACTED: user-file-path>",r=e.lastIndex)}return r<u.length&&(g+=u.substr(r)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of a)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let a=u;g&&(a=this._anonymizeFilePaths(a));for(const s of this._cleanupPatterns)a=a.replace(s,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([ee(1,c.IConfigurationService),ee(2,E.IProductService)],m),i.TelemetryService=m;function S(){const l=(0,p.localize)(0,null,C.default.nameLong),u=C.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,p.localize)(3,null),a=(0,p.localize)(4,null),s=(0,p.localize)(5,null),e=(0,p.localize)(6,null),r=(0,p.localize)(7,null),t=`
|       | ${a} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,p.localize)(8,null);return`
${l} ${u} ${g}

&nbsp;

${r}
${t}

&nbsp;

${n}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,p.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,p.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,156,131]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class w extends I.AbstractOneDataSystemAppender{constructor(T,p,c,d){const C={sendPOST:(E,h)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const f=D.request(E.urlString,v,m=>{m.on("data",function(S){h(m.statusCode??200,m.headers,S.toString())}),m.on("error",function(S){h(0,{})})});f.write(E.data),f.end()}catch{h(0,{})}}};super(T,p,c,d,C)}}i.OneDataSystemAppender=w}),define(Q[135],Z([0,1,14,20]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function w(R,T){const p=Object.create(null),c=(C,E)=>{const h=JSON.parse(C);p[E]=h};if(T){const C=[],E=await I.Promises.readdir(T);for(const v of E)try{(await I.Promises.stat((0,D.join)(T,v))).isDirectory()&&C.push(v)}catch{}const h=[];for(const v of C)(await I.Promises.readdir((0,D.join)(T,v))).filter(m=>m==="telemetry.json").length===1&&h.push(v);for(const v of h){const f=(await I.Promises.readFile((0,D.join)(T,v,"telemetry.json"))).toString();c(f,v)}}let d=(await I.Promises.readFile((0,D.join)(R,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await I.Promises.readFile((0,D.join)(R,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(p,null,4)}i.buildTelemetryMessage=w}),define(Q[29],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,18,23,11,9,29]),function(B,i,D,I,w,R,T,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends I.Disposable{constructor(h,v,f,m,S){super(),this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const l=w.URI.file(f.extensionsPath);this._register(v.watch(l)),this._register(D.Event.filter(v.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,l)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),v=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,T.areSameExtensions)(S,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(S=>(0,T.areSameExtensions)(S,m))?!1:h.every(S=>!(0,T.areSameExtensions)(S.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(v.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:f})}}};C=fe([ee(1,p.IFileService),ee(2,R.INativeEnvironmentService),ee(3,c.ILogService),ee(4,d.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Q[137],Z([0,1,29,104,11,17,69,4,2]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let C=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let S=v.get(m.scheme);return S===void 0&&(S=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,S)),S};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new T.SkipList((m,S)=>this.extUri.compare(m,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));const v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};C=fe([ee(0,w.IFileService)],C),i.UriIdentityService=C,(0,I.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Q[138],Z([0,1,98,14,36,17,10,8,16]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(t){const n=t;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}i.isSingleFolderWorkspaceIdentifier=d;function C(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}i.toWorkspaceIdentifier=C;function E(t){const n=t;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}i.isWorkspaceIdentifier=E;function h(t){const n=t;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}i.reviveIdentifier=h;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v=i.WorkbenchState||(i.WorkbenchState={}));function f(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}i.isWorkspace=f;function m(t){const n=t;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}i.isWorkspaceFolder=m;class S{constructor(n,o,y,P,b){this._id=n,this._transient=y,this._configuration=P,this._ignorePathCasing=b,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=S;class l{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=l;function u(t){return new l({uri:t,index:0,name:(0,R.basenameOrAuthority)(t)},{uri:t.toString()})}i.toWorkspaceFolder=u,i.WORKSPACE_EXTENSION="code-workspace";const g=`.${i.WORKSPACE_EXTENSION}`;i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function a(t,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(t,n.untitledWorkspacesHome)}i.isUntitledWorkspace=a;function s(t){let n;return T.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===c.Schemas.tmp}i.isTemporaryWorkspace=s;function e(t,n){return!a(t,n)&&!s(t)}i.isSavedWorkspace=e;function r(t){return(typeof t=="string"?(0,I.extname)(t):(0,R.extname)(t))===g}i.hasWorkspaceFileExtension=r}),define(Q[25],Z([0,1,53,4,2,17,5,10,97,18,11,8,9,138,36,29,3,30,27]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function g(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&p.URI.isUri(t.location)&&p.URI.isUri(t.globalStorageHome)&&p.URI.isUri(t.settingsResource)&&p.URI.isUri(t.keybindingsResource)&&p.URI.isUri(t.tasksResource)&&p.URI.isUri(t.snippetsHome)&&((0,T.isUndefined)(t.extensionsResource)||p.URI.isUri(t.extensionsResource)))}i.isUserDataProfile=g,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function a(r,t){return{id:r.id,isDefault:r.isDefault,name:r.name,location:p.URI.revive(r.location).with({scheme:t}),globalStorageHome:p.URI.revive(r.globalStorageHome).with({scheme:t}),settingsResource:p.URI.revive(r.settingsResource).with({scheme:t}),keybindingsResource:p.URI.revive(r.keybindingsResource).with({scheme:t}),tasksResource:p.URI.revive(r.tasksResource).with({scheme:t}),snippetsHome:p.URI.revive(r.snippetsHome).with({scheme:t}),extensionsResource:p.URI.revive(r.extensionsResource)?.with({scheme:t}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}i.reviveProfile=a,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(r,t,n,o){return{id:(0,D.hash)(t.path).toString(16),name:r,location:t,isDefault:!1,globalStorageHome:(0,R.joinPath)(t,"globalStorage"),settingsResource:(0,R.joinPath)(t,"settings.json"),keybindingsResource:(0,R.joinPath)(t,"keybindings.json"),tasksResource:(0,R.joinPath)(t,"tasks.json"),snippetsHome:(0,R.joinPath)(t,"snippets"),extensionsResource:(0,R.joinPath)(t,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:n,isTransient:o}}i.toUserDataProfile=s;let e=class extends w.Disposable{constructor(t,n,o,y){super(),this.environmentService=t,this.fileService=n,this.uriIdentityService=o,this.logService=y,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new I.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new I.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new I.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new I.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(P=>s(P.name,P.location,P.useDefaultFlags)):[];let n;const o=new f.ResourceMap,y=s((0,c.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...y,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?y.extensionsResource:void 0}),t.length){const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[b,k]of Object.entries(P.workspaces)){const W=p.URI.parse(b),_=p.URI.parse(k),q=t.find(Y=>this.uriIdentityService.extUri.isEqual(Y.location,_));q&&o.set(W,q)}if(P.emptyWindow){const b=p.URI.parse(P.emptyWindow);n=t.find(k=>this.uriIdentityService.extUri.isEqual(k.location,b))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:n}}return this._profilesObject}async createTransientProfile(t){const n="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(n)}\\s(\\d+)`);let y=0;for(const b of this.profiles){const k=o.exec(b.name),W=k?parseInt(k[1]):0;y=W>y?W:y}const P=`${n} ${y+1}`;return this.createProfile(P,void 0,t,!0)}async createProfile(t,n,o,y){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const P=await this.doCreateProfile(t,n,y);return o&&await this.setProfileForWorkspace(o,P),P}async doCreateProfile(t,n,o){let y=this.profileCreationPromises.get(t);return y||(y=(async()=>{try{const P=this.profiles.find(W=>W.name===t);if(P)return P;const b=s(t,(0,R.joinPath)(this.profilesHome,(0,D.hash)((0,l.generateUuid)()).toString(16)),n,o);await this.fileService.createFolder(b.location);const k=[];return this._onWillCreateProfile.fire({profile:b,join(W){k.push(W)}}),await S.Promises.settled(k),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(t)}})(),this.profileCreationPromises.set(t,y)),y}async updateProfile(t,n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let y=this.profiles.find(P=>P.id===t.id);if(!y)throw new Error(`Profile '${t.name}' does not exist`);return y=s(n,y.location,o),this.updateProfiles([],[],[y]),y}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(y=>y.id===t.id);if(!n)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:n,join(y){o.push(y)}}),await S.Promises.settled(o),n.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const y of[...this.profilesObject.workspaces.keys()])n.id===this.profilesObject.workspaces.get(y)?.id&&this.profilesObject.workspaces.delete(y);this.updateStoredProfileAssociations(),this.updateProfiles([],[n],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(n.location,{recursive:!0})}catch(y){this.logService.error(y)}}getOrSetProfileForWorkspace(t,n=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=n,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,n){this.setProfileForWorkspaceSync(t,n)}setProfileForWorkspaceSync(t,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,n)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(n=>n.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,n.resource))).map(n=>this.fileService.del(n.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(n=>!this.isProfileAssociatedToWorkspace(n));await Promise.allSettled(t.map(n=>this.removeProfile(n)))}getProfileForWorkspace(t){const n=this.getWorkspace(t);return p.URI.isUri(n)?this.transientProfilesObject.workspaces.get(n)??this.profilesObject.workspaces.get(n):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(n=>this.uriIdentityService.extUri.isEqual(n.location,t.location)))}updateProfiles(t,n,o){const y=[...this.profiles,...t],P=[];this.transientProfilesObject.profiles=[];for(let b of y)b.isDefault||n.some(k=>b.id===k.id)||(b=o.find(k=>b.id===k.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):P.push({location:b.location,name:b.name,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(t,n,o)}triggerProfilesChanges(t,n,o){this._onDidChangeProfiles.fire({added:t,removed:n,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,n,o){o=n?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const y=this.getWorkspace(t),P=o?this.transientProfilesObject:this.profilesObject;p.URI.isUri(y)?(P.workspaces.delete(y),n&&P.workspaces.set(y,n)):P.emptyWindow=n,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,y]of this.profilesObject.workspaces.entries())t[o.toString()]=y.location.toString();const n=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:n}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=fe([ee(0,d.IEnvironmentService),ee(1,C.IFileService),ee(2,m.IUriIdentityService),ee(3,h.ILogService)],e),i.UserDataProfilesService=e}),define(Q[139],Z([0,1,19,3,24,12,4,2,13,10,82,22,23,34,9,28,35,25]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{constructor(t,n,o,y,P){super(),this.galleryService=t,this.telemetryService=n,this.logService=o,this.productService=y,this.userDataProfilesService=P,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(b=>b.cancel()),this.uninstallingExtensions.forEach(b=>b.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(C.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),a(o)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},w.CancellationToken.None);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,o){const y=_=>`${h.ExtensionKey.create(_).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(n)){const _=this.installingExtensions.get(y(n));if(_){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:q}=await _.waitUntilTaskIsFinished();return q}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const P=[],b=[],k=this.createInstallExtensionTask(t,n,o);d.URI.isUri(n)||this.installingExtensions.set(y(n),k),this._onInstallExtension.fire({identifier:k.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",k.identifier.id),P.push({task:k,manifest:t});let W=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const q=await this.getAllDepsAndPackExtensionsToInstall(k.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:Y,manifest:ie}of q){W=W||!!ie.extensionDependencies?.some(ne=>(0,h.areSameExtensions)({id:ne},k.identifier));const ae=y(Y);if(this.installingExtensions.has(ae))this.logService.info("Extension is already requested to install",Y.identifier.id);else{const ne=this.createInstallExtensionTask(ie,Y,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ae,ne),this._onInstallExtension.fire({identifier:ne.identifier,source:Y,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ne.identifier.id),P.push({task:ne,manifest:ie})}}}catch(q){if(d.URI.isUri(k.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,q.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),q}const _=P.reduce((q,{task:Y,manifest:ie})=>(q.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:ie}),q),new Map);for(;_.size;){let q;const Y=[..._.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(ae=>_.has(ae.toLowerCase())));Y.length?q=_.size===1?Y:Y.filter(({task:ie})=>!(ie===k&&!W)):(this.logService.info("Found extensions with circular dependencies",Y.map(({task:ie})=>ie.identifier.id)),q=[..._.values()]),await this.joinAllSettled(q.map(async({task:ie})=>{const ae=new Date().getTime();try{const{local:ne}=await ie.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(ne,ie.source,o,w.CancellationToken.None))),!d.URI.isUri(ie.source)){const ge=ie.operation===3,ue=ge?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(s(this.telemetryService,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ie.source),duration:new Date().getTime()-ae,durationSinceUpdate:ue}),c.isWeb&&ie.operation!==3)try{await this.galleryService.reportStatistic(ne.manifest.publisher,ne.manifest.name,ne.manifest.version,"install")}catch{}}b.push({local:ne,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:ne.isApplicationScoped})}catch(ne){throw d.URI.isUri(ie.source)||s(this.telemetryService,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ie.source),duration:new Date().getTime()-ae,error:ne}),this.logService.error("Error while installing the extension:",ie.identifier.id),ne}finally{_.delete(ie.identifier.id.toLowerCase())}}))}return b.forEach(({identifier:q})=>this.logService.info("Extension installed successfully:",q.id)),this._onDidInstallExtensions.fire(b),b.filter(({identifier:q})=>(0,h.areSameExtensions)(q,k.identifier))[0].local}catch(_){if(P.forEach(({task:q})=>q.cancel()),b.length)try{const q=await Promise.allSettled(b.map(({local:Y})=>this.createUninstallExtensionTask(Y,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let Y=0;Y<q.length;Y++){const ie=q[Y],{identifier:ae}=b[Y];ie.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ae.id):this.logService.warn("Rollback: Error while uninstalling extension",ae.id,(0,R.getErrorMessage)(ie.reason))}}catch(q){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(q),b.map(({identifier:Y})=>Y.id))}throw this._onDidInstallExtensions.fire(P.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:o.context,profileLocation:o.profileLocation}))),_}finally{for(const{task:_}of P)if(!d.URI.isUri(_.source)){const q=y(_.source);this.installingExtensions.delete(q)||this.logService.warn("Installation task is not found in the cache",q)}}}async joinAllSettled(t){const n=[],o=[],y=await Promise.allSettled(t);for(const P of y)P.status==="fulfilled"?n.push(P.value):o.push(P.reason);if(o.length)throw g(o);return n}async getAllDepsAndPackExtensionsToInstall(t,n,o,y,P){if(!this.galleryService.isEnabled())return[];let b=await this.getInstalled(void 0,P);const k=[t,...b.map(q=>q.identifier)],W=[],_=async(q,Y)=>{const ie=Y.extensionDependencies||[],ae=[...ie];if(Y.extensionPack){const ne=o?b.find(ge=>(0,h.areSameExtensions)(ge.identifier,q)):void 0;for(const ge of Y.extensionPack)ne&&ne.manifest.extensionPack&&ne.manifest.extensionPack.some(ue=>(0,h.areSameExtensions)({id:ue},{id:ge}))||ae.every(ue=>!(0,h.areSameExtensions)({id:ue},{id:ge}))&&ae.push(ge)}if(ae.length){const ne=[...k,...W.map(ue=>ue.gallery.identifier)],ge=ae.filter(ue=>ne.every(se=>!(0,h.areSameExtensions)(se,{id:ue})));if(ge.length){const ue=await this.galleryService.getExtensions(ge.map(se=>({id:se,preRelease:y})),w.CancellationToken.None);for(const se of ue){if(ne.find(F=>(0,h.areSameExtensions)(F,se.identifier)))continue;const V=ie.some(F=>(0,h.areSameExtensions)({id:F},se.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(se,!1,y)}catch(F){if(F instanceof E.ExtensionManagementError&&F.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",se.identifier.id);continue}else throw F}W.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(t,n),b=await this.getInstalled(void 0,P),W.filter(q=>!b.some(Y=>(0,h.areSameExtensions)(Y.identifier,q.gallery.identifier)))}async checkAndGetCompatibleVersion(t,n,o){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,h.areSameExtensions)(t.identifier,k)))throw new E.ExtensionManagementError(C.localize(3,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const k=await this.getTargetPlatform();throw new E.ExtensionManagementError(C.localize(4,null,t.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(k)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const P=await this.getCompatibleVersion(t,n,o);if(P){if(o&&!n&&t.hasPreReleaseVersion&&!P.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],w.CancellationToken.None))[0]?new E.ExtensionManagementError(C.localize(6,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(C.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",P.identifier.id);const b=await this.galleryService.getManifest(P,w.CancellationToken.None);if(b===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(b.version!==P.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:b}}async getCompatibleVersion(t,n,o){const y=await this.getTargetPlatform();let P=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(P=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:y,compatible:!0},w.CancellationToken.None))[0]||null),!P&&await this.galleryService.isExtensionCompatible(t,o,y)&&(P=t),P||(n?P=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:y,compatible:!0},w.CancellationToken.None))[0]||null:P=await this.galleryService.getCompatibleExtension(t,o,y)),P}async uninstallExtension(t,n){const o=_=>`${_.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,y=this.uninstallingExtensions.get(o(t.identifier));if(y)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const P=(_,q)=>{const Y=this.createUninstallExtensionTask(_,q);return this.uninstallingExtensions.set(o(Y.extension.identifier),Y),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped}),Y},b=(_,q)=>{q?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString(),q.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,q.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:q}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:q?.code,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped})},k=[],W=[];try{k.push(P(t,n));const _=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const q=this.getAllPackExtensionsToUninstall(t,_);for(const Y of q)this.uninstallingExtensions.has(o(Y.identifier))?this.logService.info("Extensions is already requested to uninstall",Y.identifier.id):k.push(P(Y,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(k.map(q=>q.extension),_,t),await this.joinAllSettled(k.map(async q=>{try{if(await q.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postUninstall(q.extension,n,w.CancellationToken.None))),q.extension.identifier.uuid)try{await this.galleryService.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}b(q.extension)}catch(Y){const ie=Y instanceof E.ExtensionManagementError?Y:new E.ExtensionManagementError((0,R.getErrorMessage)(Y),E.ExtensionManagementErrorCode.Internal);throw b(q.extension,ie),ie}finally{W.push(q)}}))}catch(_){const q=_ instanceof E.ExtensionManagementError?_:new E.ExtensionManagementError((0,R.getErrorMessage)(_),E.ExtensionManagementErrorCode.Internal);for(const Y of k){try{Y.cancel()}catch{}W.includes(Y)||b(Y.extension,q)}throw q}finally{for(const _ of k)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,n,o){for(const y of t){const P=this.getDependents(y,n);if(P.length){const b=P.filter(k=>!t.some(W=>(0,h.areSameExtensions)(W.identifier,k.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(y,b,o))}}}getDependentsErrorMessage(t,n,o){return o===t?n.length===1?C.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?C.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?C.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):C.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const y=t.manifest.extensionPack?t.manifest.extensionPack:[];if(y.length){const P=n.filter(k=>!k.isBuiltin&&y.some(W=>(0,h.areSameExtensions)({id:W},k.identifier))),b=[];for(const k of P)b.push(...this.getAllPackExtensionsToUninstall(k,n,o));return[...P,...b]}return[]}getDependents(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(y=>(0,h.areSameExtensions)({id:y},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,o)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};u=fe([ee(0,E.IExtensionGalleryService),ee(1,S.ITelemetryService),ee(2,f.ILogService),ee(3,m.IProductService),ee(4,l.IUserDataProfilesService)],u),i.AbstractExtensionManagementService=u;function g(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=g;function a(r){if(r instanceof E.ExtensionManagementError)return r;const t=new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function s(r,t,{extensionData:n,duration:o,error:y,durationSinceUpdate:P}){const b=y?y instanceof E.ExtensionManagementError?y.code:E.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...n,success:!y,duration:o,errorcode:b,durationSinceUpdate:P})}i.reportTelemetry=s;class e{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>new Promise((n,o)=>{const y=t.onCancellationRequested(()=>{y.dispose(),o(new R.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,12,50,74,2,16,14,13,17,39,54,5,10,86,18,23,34,45,11,8,9,28,4,44,41,25,29,102]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u,g,a,s,e,r,t,n,o,y,P,b,k,W,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var q;(function(se){function V(N,F){if(N===F)return!0;const z=Object.keys(N),$=new Set;for(const J of Object.keys(F))$.add(J);if(z.length!==$.size)return!1;for(const J of z){if(N[J]!==F[J])return!1;$.delete(J)}return $.size===0}se.equals=V})(q=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let Y=class extends d.Disposable{constructor(V,N,F,z,$,J,A,U,O,L,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=J,this.fileService=A,this.logService=U,this.environmentService=O,this.productService=L,this.instantiationService=M,this._onDidChangeCache=this._register(new y.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ae,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[z,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),J=F?await this.scanExtensionsUnderDevelopment(V,[...z,...$]):[];return this.dedupExtensions(z,$,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,z]=await Promise.all(N);return this.applyScanOptions([...F,...z],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let z=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return z=await this.applyScanOptions(z,1,V,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===C.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,a.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,v.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,v.joinPath)(V,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,v.joinPath)(V,"package.json"),R.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,z){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,J)=>{const A=E.basename($.location.fsPath),U=E.basename(J.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(V,N,F,z,$){const J=(U,O,L)=>{if(U.isValid&&!O.isValid)return!1;if(U.isValid===O.isValid){if($&&f.gt(U.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(f.eq(U.manifest.version,O.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${U.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${O.location.path}.`),!0},A=new Map;return V?.forEach(U=>{const O=s.ExtensionIdentifier.toKey(U.identifier.id),L=A.get(O);(!L||J(L,U,!1))&&A.set(O,U)}),N?.forEach(U=>{const O=s.ExtensionIdentifier.toKey(U.identifier.id),L=A.get(O);if(!L&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!L||J(L,U,!1))&&A.set(O,U)}),F?.forEach(U=>{const O=s.ExtensionIdentifier.toKey(U.identifier.id),L=A.get(O);(!L||J(L,U,!0))&&A.set(O,U),A.set(O,U)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=N?await this.getBuiltInExtensionControl():{},$=[],J=l.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const O=z[U.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(J,U.name));break;default:$.push(l.URI.file(O));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,z,$,J=!0){const A=await this.getTranslations($??h.language),U=await this.getMtime(V),O=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=O?await this.getMtime(O):void 0;return new ie(V,U,O,L,N,F,z,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};Y=fe([ee(4,k.IUserDataProfilesService),ee(5,b.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,n.ILogService),ee(8,g.IEnvironmentService),ee(9,o.IProductService),ee(10,t.IInstantiationService)],Y),i.AbstractExtensionsScannerService=Y;class ie{constructor(V,N,F,z,$,J,A,U,O,L,M,j,G,K){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=J,this.excludeObsolete=A,this.validate=U,this.productVersion=O,this.productDate=L,this.productCommit=M,this.devMode=j,this.language=G,this.translations=K}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,v.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,v.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&q.equals(V.translations,N.translations)}}let ae=class extends d.Disposable{constructor(V,N,F,z,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,S.isEmptyObject)(F)?N:N.filter(z=>!F[a.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||V.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new ie(z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!z.length)return[];const $=await Promise.all(z.map(async J=>{if(N(J)){const A=new ie(J.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,J.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,v.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,T.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const z=(0,a.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:z,uuid:N.id}:{id:z},J=N?.isSystem?0:V.type,A=J===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,ie.createNlsConfiguration(V));const U={type:J,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const z=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,J]of z)$===m.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,J)));return V.isValid=F,V.validations=z,V}async scanExtensionManifest(V){const N=(0,v.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,r.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,u.localize)(0,null,N.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const J=[];(0,p.parse)(F,J);for(const A of J)this.logService.error(this.formatMessage(V,(0,u.localize)(1,null,N.path,A.offset,A.length,(0,c.getParseErrorMessage)(A.error))));return null}return(0,p.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(V,(0,u.localize)(2,null,N.path))),null):z}async translateManifest(V,N,F){const z=await this.getLocalizedMessages(V,N,F);if(z)try{const $=[],J=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(V,(0,u.localize)(3,null,z.default?.path,(0,c.getParseErrorMessage)(U.error))))}),N;if((0,p.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(V,(0,u.localize)(4,null,z.default?.path))),N;const A=z.values||Object.create(null);return(0,_.localizeManifest)(N,A,J)}catch{}return N}async getLocalizedMessages(V,N,F){const z=(0,v.joinPath)(V,"package.nls.json"),$=(O,L)=>{L.forEach(M=>{this.logService.error(this.formatMessage(V,(0,u.localize)(5,null,O?.path,(0,c.getParseErrorMessage)(M.error))))})},J=O=>{this.logService.error(this.formatMessage(V,(0,u.localize)(6,null,O?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const O=l.URI.file(U),L=(await this.fileService.readFile(O)).value.toString(),M=[],j=(0,p.parse)(L,M);return M.length>0?($(O,M),{values:void 0,default:z}):(0,p.getNodeType)(j)!=="object"?(J(O),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let L;try{L=await this.findMessageBundles(V,F)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const M=(await this.fileService.readFile(L.localized)).value.toString(),j=[],G=(0,p.parse)(M,j);return j.length>0?($(L.localized,j),{values:void 0,default:L.original}):(0,p.getNodeType)(G)!=="object"?(J(L.localized),{values:void 0,default:L.original}):{values:G,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,p.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,z)=>{const $=J=>{const A=(0,v.joinPath)(V,`package.nls.${J}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,v.joinPath)(V,"package.nls.json")});const O=J.lastIndexOf("-");O===-1?F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null}):(J=J.substring(0,O),$(J))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};ae=fe([ee(1,b.IExtensionsProfileScannerService),ee(2,W.IUriIdentityService),ee(3,r.IFileService),ee(4,n.ILogService)],ae);let ne=class extends ae{constructor(V,N,F,z,$,J){super(N,F,z,$,J),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new y.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&ie.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(z=>(z.location=l.URI.revive(z.location),z));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,P.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};ne=fe([ee(2,b.IExtensionsProfileScannerService),ee(3,W.IUriIdentityService),ee(4,r.IFileService),ee(5,n.ILogService)],ne);function ge(se,V){const N=(0,a.getExtensionId)(se.manifest.publisher,se.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:se.type===0,isUserBuiltin:se.type===1&&se.isBuiltin,isUnderDevelopment:V,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,...se.manifest}}i.toExtensionDescription=ge;class ue extends Y{constructor(V,N,F,z,$,J,A,U,O,L,M){super(V,N,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,J,A,U,O,L,M),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const j=await this.fileService.readFile(l.URI.file(h.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}i.NativeExtensionsScannerService=ue}),define(Q[140],Z([0,1,57,3,31,4,2,16,14,20,9,25]),function(B,i,D,I,w,R,T,p,c,d,C,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends T.Disposable{constructor(f,m){super(),this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new I.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${S}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(f,m){const S=`vscode:${m}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[S]=="string"){const l=f.manifest.scripts[S].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${S} should be a node script`),null):{script:(0,c.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(f,m,S,l,u){return new Promise((g,a)=>{const s=this.start(f,m,S,u);let e;const r=t=>{e&&(clearTimeout(e),e=null),t?a(t):g(void 0)};s.on("error",t=>{r((0,w.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,n)=>{r(t?`post-${m} process exited with code ${t}`:void 0)}),l&&(e=setTimeout(()=>{e=null,s.kill(),a("timed out")},5e3))})}start(f,m,S,l){const u={silent:!0,execArgv:void 0},g=(0,D.fork)(f,[`--type=extension-post-${m}`,...S],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=R.Event.fromNodeEventEmitter(g.stdout,"data"),s=R.Event.fromNodeEventEmitter(g.stderr,"data");a(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${m}`,t)),s(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${m}`,t));const e=R.Event.any(R.Event.map(a,t=>({data:`%c${t}`,format:[""]})),R.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return R.Event.debounce(e,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,c.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=fe([ee(0,E.IUserDataProfilesService),ee(1,C.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[141],Z([0,1,10,18,41,48,11,8,9,28,25]),function(B,i,D,I,w,R,T,p,c,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let E=class extends R.NativeExtensionsScannerService{constructor(v,f,m,S,l,u,g){super(D.URI.file(l.builtinExtensionsPath),D.URI.file(l.extensionsPath),l.userHome,D.URI.file(l.userDataPath),v,f,m,S,l,u,g)}};E=fe([ee(0,C.IUserDataProfilesService),ee(1,w.IExtensionsProfileScannerService),ee(2,T.IFileService),ee(3,c.ILogService),ee(4,I.INativeEnvironmentService),ee(5,d.IProductService),ee(6,p.IInstantiationService)],E),i.ExtensionsScannerService=E}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,i,D,I,w,R,T,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E=i.WillSaveStateReason||(i.WillSaveStateReason={}));var h;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(h=i.StorageScope||(i.StorageScope={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v=i.StorageTarget||(i.StorageTarget={}));class f extends w.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,a){if(a===C){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:a,target:this.getKeyTargets(g)[a]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,a,s){return this.getStorage(a)?.get(g,s)}getBoolean(g,a,s){return this.getStorage(a)?.getBoolean(g,s)}getNumber(g,a,s){return this.getStorage(a)?.getNumber(g,s)}store(g,a,s,e){if((0,T.isUndefinedOrNull)(a)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,e),this.getStorage(s)?.set(g,a)})}remove(g,a){this.withPausedEmitters(()=>{this.updateKeyTarget(g,a,void 0),this.getStorage(a)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,a){const s=[],e=this.getKeyTargets(g);for(const r of Object.keys(e))e[r]===a&&s.push(r);return s}updateKeyTarget(g,a,s){const e=this.getKeyTargets(a);typeof s=="number"?e[g]!==s&&(e[g]=s,this.getStorage(a)?.set(C,JSON.stringify(e))):typeof e[g]=="number"&&(delete e[g],this.getStorage(a)?.set(C,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const a=this.get(C,g);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(i.IS_NEW_KEY,g)===!0}async flush(g=E.NONE){this._onWillSaveState.fire({reason:g});const a=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(g){case E.NONE:await D.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,a=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(g,a,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,a){return this.emitWillSaveState(E.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,a):this.switchToWorkspace(g,a)}canSwitchProfile(g,a){return!(g.id===a.id||m(a)&&m(g))}switchData(g,a,s,e){this.withPausedEmitters(()=>{if(e)for(const[r,t]of g)a.set(r,t);else{const r=new Set;for(const[t,n]of g)r.add(t),a.get(t)!==n&&this.emitDidChangeValue(s,t);for(const[t]of a.items)r.has(t)||this.emitDidChangeValue(s,t)}})}}i.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=m;class S extends f{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}i.InMemoryStorageService=S;async function l(u,g,a,s,e,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},n=new Map,o=new Map;u.forEach((q,Y)=>{n.set(Y,q),o.set(Y,t(q))});const y=new Map,P=new Map;g.forEach((q,Y)=>{y.set(Y,q),P.set(Y,t(q))});const b=new Map,k=new Map;a.forEach((q,Y)=>{b.set(Y,q),k.set(Y,t(q))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const W=[];if(n.forEach((q,Y)=>{W.push({key:Y,value:q})}),console.table(W),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const q=[];y.forEach((Y,ie)=>{q.push({key:ie,value:Y})}),console.table(q),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${r})`);const _=[];b.forEach((q,Y)=>{_.push({key:Y,value:q})}),console.table(_),console.groupEnd(),console.log(k)}i.logStorage=l}),define(Q[143],Z([0,1,19,24,12,13,32,5,10,21,18,22,23,45,11,9,28,47,130,142,35]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=R.isWeb?"web":(0,E.getTargetPlatform)(R.platform,T.arch);var e;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function r(...O){return String(O.reduce((L,M)=>L|M,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class b{constructor(L=P){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(L,M=this.state.pageSize){return new b({...this.state,pageNumber:L,pageSize:M})}withFilter(L,...M){const j=[...this.state.criteria,...M.length?M.map(G=>({filterType:L,value:G})):[{filterType:L}]];return new b({...this.state,criteria:j})}withSortBy(L){return new b({...this.state,sortBy:L})}withSortOrder(L){return new b({...this.state,sortOrder:L})}withFlags(...L){return new b({...this.state,flags:L.reduce((M,j)=>M|j,0)})}withAssetTypes(...L){return new b({...this.state,assetTypes:L})}withSource(L){return new b({...this.state,source:L})}get raw(){const{criteria:L,pageNumber:M,pageSize:j,sortBy:G,sortOrder:K,flags:oe,assetTypes:le}=this.state;return{filters:[{criteria:L,pageNumber:M,pageSize:j,sortBy:G,sortOrder:K}],assetTypes:le,flags:oe}}get searchText(){const L=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(O,L){const M=(O||[]).filter(j=>j.statisticName===L)[0];return M?M.value:0}function W(O){const L="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(j=>j.assetType.indexOf(L)===0).reduce((j,G)=>{const K=Y(O,G.assetType);return K&&j.push([G.assetType.substring(L.length),K]),j},[])}function _(O){if(O.properties){const L=O.properties.filter(G=>G.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=L.filter(G=>M.test(G.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return Y(O,n.Repository)}function q(O){return{uri:`${O.fallbackAssetUri}/${n.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${n.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function Y(O,L){return O.files.filter(j=>j.assetType===L)[0]?{uri:`${O.assetUri}/${L}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${L}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ie(O,L){const M=O.properties?O.properties.filter(G=>G.key===L):[],j=M.length>0&&M[0].value;return j?j.split(",").map(G=>(0,h.adoptToGalleryExtensionId)(G)):[]}function ae(O){const L=O.properties?O.properties.filter(M=>M.key===o.Engine):[];return L.length>0&&L[0].value||""}function ne(O){const L=O.properties?O.properties.filter(M=>M.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function ge(O){const L=O.properties?O.properties.filter(j=>j.key===o.LocalizedLanguages):[],M=L.length>0&&L[0].value||"";return M?M.split(","):[]}function ue(O){return O.properties?.find(L=>L.key===o.SponsorLink)?.value}function se(O){return O.indexOf("preview")!==-1}function V(O){return O.targetPlatform?(0,E.toTargetPlatform)(O.targetPlatform):"undefined"}function N(O){const L=(0,D.distinct)(O.versions.map(V)),M=!!O.tags?.includes(E.WEB_EXTENSION_TAG),j=L.indexOf("web");return M?j===-1&&L.push("web"):j!==-1&&L.splice(j,1),L}function F(O,L){const M=(0,E.getFallbackTargetPlarforms)(L);for(let j=0;j<O.length;j++){const G=O[j];if(G.version===O[j-1]?.version){let K=j;const oe=V(G);if(oe===L)for(;K>0&&O[K-1].version===G.version;)K--;else if(M.includes(oe))for(;K>0&&O[K-1].version===G.version&&V(O[K-1])!==L;)K--;K!==j&&(O.splice(j,1),O.splice(K,0,G))}}return O}i.sortExtensionVersions=F;function z(O,L,M){O.telemetryData={index:L,querySource:M}}function $(O,L,M){const j=O.versions[0],G={manifest:Y(L,n.Manifest),readme:Y(L,n.Details),changelog:Y(L,n.Changelog),license:Y(L,n.License),repository:_(L),download:q(L),icon:Y(L,n.Icon),coreTranslations:W(L)};return{identifier:{id:(0,h.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:L.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:ue(j),description:O.shortDescription||"",installCount:k(O.statistics,"install"),rating:k(O.statistics,"averagerating"),ratingCount:k(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:M,assets:G,properties:{dependencies:ie(L,o.Dependency),extensionPack:ie(L,o.ExtensionPack),engine:ae(L),localizedLanguages:ge(L),targetPlatform:V(L),isPreReleaseVersion:ne(L)},hasPreReleaseVersion:ne(j),hasReleaseVersion:!0,preview:se(O.flags)}}let J=class{constructor(L,M,j,G,K,oe,le,pe){this.requestService=M,this.logService=j,this.environmentService=G,this.telemetryService=K,this.fileService=oe,this.productService=le,this.configurationService=pe;const ve=le.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,L,this.telemetryService)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,M,j){const G=I.CancellationToken.isCancellationToken(M)?{}:M,K=I.CancellationToken.isCancellationToken(M)?M:j,oe=[],le=[],pe=[],ve=[];let te=!0;for(const de of L){de.uuid?le.push(de.uuid):oe.push(de.id);const Se=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:Se}),de.version&&ve.push({id:de.id,uuid:de.uuid,version:de.version}),te=te&&!!de.hasPreRelease&&!Se}if(!le.length&&!oe.length)return[];let re=new b().withPage(1,L.length);le.length&&(re=re.withFilter(t.ExtensionId,...le)),oe.length&&(re=re.withFilter(t.ExtensionName,...oe)),(G.queryAllVersions||te)&&(re=re.withFlags(re.flags,e.IncludeVersions)),G.source&&(re=re.withSource(G.source));const{extensions:he}=await this.queryGalleryExtensions(re,{targetPlatform:G.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!G.compatible},K);return G.source&&he.forEach((de,Se)=>z(de,Se,G.source)),he}async getCompatibleExtension(L,M,j){if((0,E.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(L,M,j))return L;const G=new b().withFlags(e.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,L.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(G,{targetPlatform:j,compatible:!0,includePreRelease:M},I.CancellationToken.None);return K[0]||null}async isExtensionCompatible(L,M,j){if(!(0,E.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,j)||!M&&L.properties.isPreReleaseVersion)return!1;let G=L.properties.engine;if(!G){const K=await this.getManifest(L,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");G=K.engines.vscode}return(0,v.isEngineValid)(G,this.productService.version,this.productService.date)}async isValidVersion(L,M,j,G,K){if(!(0,E.isTargetPlatformCompatible)(V(L),G,K)||M!=="any"&&ne(L)!==(M==="prerelease"))return!1;if(j)try{const oe=await this.getEngine(L);if(!(0,v.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${L.version}.`,(0,w.getErrorMessage)(oe)),!1}return!0}async query(L,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=L.text||"";const G=L.pageSize??50;let K=new b().withPage(1,G);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,re,he)=>(K=K.withFilter(t.Category,he||re),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,re,he)=>(K=K.withFilter(t.Tag,he||re),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),K=K.withFilter(t.SearchText,j)),K=K.withSortBy(0)):L.ids?K=K.withFilter(t.ExtensionId,...L.ids):L.names?K=K.withFilter(t.ExtensionName,...L.names):K=K.withSortBy(4),typeof L.sortBy=="number"&&(K=K.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(K=K.withSortOrder(L.sortOrder)),L.source&&(K=K.withSource(L.source));const oe=async(te,re)=>{const{extensions:he,total:de}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!L.includePreRelease},re);return he.forEach((Se,Le)=>z(Se,(te.pageNumber-1)*te.pageSize+Le,L.source)),{extensions:he,total:de}},{extensions:le,total:pe}=await oe(K,M),ve=async(te,re)=>{if(re.isCancellationRequested)throw new w.CancellationError;const{extensions:he}=await oe(K.withPage(te+1),re);return he};return{firstPage:le,total:pe,pageSize:K.pageSize,getPage:ve}}async queryGalleryExtensions(L,M,j){const G=L.flags;!!(L.flags&e.IncludeLatestVersionOnly)&&!!(L.flags&e.IncludeVersions)&&(L=L.withFlags(L.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(L.flags&e.IncludeLatestVersionOnly)&&!(L.flags&e.IncludeVersions)&&(L=L.withFlags(L.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(L=L.withFlags(L.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),L=L.withFlags(L.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:K,total:oe}=await this.queryRawGalleryExtensions(L,j);if(!(L.flags&e.IncludeLatestVersionOnly)){const te=[];for(const re of K){const he=await this.toGalleryExtensionWithCriteria(re,M);he&&te.push(he)}return{extensions:te,total:oe}}const pe=[],ve=new Map;for(let te=0;te<K.length;te++){const re=K[te],he={id:(0,h.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},de=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Le=>(0,h.areSameExtensions)(Le,he))?.includePreRelease;if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(N(re),M.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(re,M);!Se||Se.properties.isPreReleaseVersion&&(!de||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==M.targetPlatform&&Se.hasPreReleaseVersion?ve.set(re.extensionId,te):pe.push([te,Se])}if(ve.size){const te=new Date().getTime(),re=new b().withFlags(G&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,ve.size).withFilter(t.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(re,M,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:ve.size});for(const de of he){const Se=ve.get(de.identifier.uuid);pe.push([Se,de])}}return{extensions:pe.sort((te,re)=>te[0]-re[0]).map(([,te])=>te),total:oe}}async toGalleryExtensionWithCriteria(L,M){const j={id:(0,h.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},G=M.versions?.find(pe=>(0,h.areSameExtensions)(pe,j))?.version,K=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,j))?.includePreRelease,oe=N(L),le=F(L.versions,M.targetPlatform);if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(oe,M.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const ve=le[pe];if(!(G&&ve.version!==G)){if(await this.isValidVersion(ve,K?"any":"release",M.compatible,oe,M.targetPlatform))return $(L,ve,oe);if(G&&ve.version===G)return null}}return G||M.compatible?null:$(L,L.versions[0],oe)}async queryRawGalleryExtensions(L,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,e.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(e.Unpublished));const j=await this.commonHeadersPromise,G=JSON.stringify(L.raw),K={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},oe=new Date().getTime();let le,pe,ve=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:G,headers:K},M),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ve};const te=await(0,l.asJson)(le);if(te){const re=te.results[0],he=re.extensions,de=re.resultMetadata&&re.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=de&&de.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-oe,success:!!le&&(0,l.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(L,M,j,G){if(!this.isEnabled())return;const K=R.isWeb?this.api(`/itemName/${L}.${M}/version/${j}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${L}/extensions/${M}/${j}/stats?statType=${G}`),oe=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:K,headers:pe},I.CancellationToken.None)}catch{}}async download(L,M,j){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const G=(0,h.getGalleryExtensionTelemetryData)(L),K=new Date().getTime(),oe=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...G,duration:te}),le=j===2?"install":j===3?"update":"",pe=le?{uri:`${L.assets.download.uri}${c.URI.parse(L.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${L.assets.download.fallbackUri}${c.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:L.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(M,ve.stream),oe(new Date().getTime()-K)}async getReadme(L,M){if(L.assets.readme){const j=await this.getAsset(L.assets.readme,{},M);return await(0,l.asTextOrError)(j)||""}return""}async getManifest(L,M){if(L.assets.manifest){const j=await this.getAsset(L.assets.manifest,{},M),G=await(0,l.asTextOrError)(j);return G?JSON.parse(G):null}return null}async getManifestFromRawExtensionVersion(L,M){const j=Y(L,n.Manifest);if(!j)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},K=await this.getAsset(j,{headers:G});return await(0,l.asJson)(K)}async getCoreTranslation(L,M){const j=L.assets.coreTranslations.filter(G=>G[0]===M.toUpperCase())[0];if(j){const G=await this.getAsset(j[1]),K=await(0,l.asTextOrError)(G);return K?JSON.parse(K):null}return null}async getChangelog(L,M){if(L.assets.changelog){const j=await this.getAsset(L.assets.changelog,{},M);return await(0,l.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(L,M,j){let G=new b().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?G=G.withFilter(t.ExtensionId,L.identifier.uuid):G=G.withFilter(t.ExtensionName,L.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(G,I.CancellationToken.None);if(!K.length)return[];const oe=N(K[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(oe,j))return[];const le=[];await Promise.all(K[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,oe,j)&&le.push(te)}catch{}}));const pe=[],ve=new Set;for(const te of F(le,j))ve.has(te.version)||(ve.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:ne(te)}));return pe}async getAsset(L,M={},j=I.CancellationToken.None){const G=await this.commonHeadersPromise,K={type:"GET"},oe={...G,...M.headers||{}};M={...M,...K,headers:oe};const le=L.uri,pe=L.fallbackUri,ve={...M,url:le};try{const te=await this.requestService.request(ve,j);if(te.res.statusCode===200)return te;const re=await(0,l.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${re}`)}catch(te){if((0,w.isCancellationError)(te))throw te;const re=(0,w.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:re});const he={...M,url:pe};return this.requestService.request(he,j)}}async getEngine(L){let M=ae(L);if(!M){const j=await this.getManifestFromRawExtensionVersion(L,I.CancellationToken.None);if(!j)throw new Error("Manifest was not found");M=j.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.asJson)(L),j=[],G={};if(M){for(const K of M.malicious)j.push({id:K});if(M.migrateToPreRelease)for(const[K,oe]of Object.entries(M.migrateToPreRelease))(!oe.engine||(0,v.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(G[K.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[K,oe]of Object.entries(M.deprecated))oe&&(G[K.toLowerCase()]=(0,p.isBoolean)(oe)?{}:oe)}return{malicious:j,deprecated:G}}};J=fe([ee(1,l.IRequestService),ee(2,m.ILogService),ee(3,C.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,f.IFileService),ee(6,S.IProductService),ee(7,d.IConfigurationService)],J);let A=class extends J{constructor(L,M,j,G,K,oe,le,pe){super(L,M,j,G,K,oe,le,pe)}};A=fe([ee(0,g.IStorageService),ee(1,l.IRequestService),ee(2,m.ILogService),ee(3,C.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,f.IFileService),ee(6,S.IProductService),ee(7,d.IConfigurationService)],A),i.ExtensionGalleryService=A;let U=class extends J{constructor(L,M,j,G,K,oe,le){super(void 0,L,M,j,G,K,oe,le)}};U=fe([ee(0,l.IRequestService),ee(1,m.ILogService),ee(2,C.IEnvironmentService),ee(3,a.ITelemetryService),ee(4,f.IFileService),ee(5,S.IProductService),ee(6,d.IConfigurationService)],U),i.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,18,11,9,65,29,25]),function(B,i,D,I,w,R,T,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let d=class Ve extends c.UserDataProfilesService{constructor(E,h,v,f,m){super(v,f,h,m),this.stateService=E}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILE_ASSOCIATIONS_KEY,{}))}};d=fe([ee(0,T.IStateService),ee(1,p.IUriIdentityService),ee(2,I.IEnvironmentService),ee(3,w.IFileService),ee(4,R.ILogService)],d),i.UserDataProfilesService=d}),define(Q[145],Z([0,1,37,3,157,2]),function(B,i,D,I,w,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class T extends D.AbstractPolicyService{constructor(c){super(),this.productName=c,this.throttler=new I.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(c){await this.throttler.queue(()=>new Promise((d,C)=>{try{this.watcher.value=(0,w.createWatcher)(this.productName,c,E=>{for(const h in E){const v=E[h];v===void 0?this.policies.delete(h):this.policies.set(h,v)}this._onDidChange.fire(Object.keys(E)),d()})}catch(E){C(E)}}))}}i.NativePolicyService=T}),define(Q[67],Z([0,1,114,3,14,5,20,80,158,159]),function(B,i,D,I,w,R,T,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(e,r){let t=r.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=e,this.cause=r}}i.ExtractError=C;function E(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,t)=>r+t,e&61440)}function h(s){if(s instanceof C)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new C(e,s)}function v(s,e,r,t,n,o){const y=w.dirname(e),P=w.join(t,y);if(!P.startsWith(t))return Promise.reject(new Error(p.localize(0,null,e)));const b=w.join(t,e);let k;return o.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(T.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((W,_)=>{if(!o.isCancellationRequested)try{k=(0,D.createWriteStream)(b,{mode:r}),k.once("close",()=>W()),k.once("error",_),s.once("error",_),s.pipe(k)}catch(q){_(q)}}))}function f(s,e,r,t){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((y,P)=>{const b=new I.Sequencer,k=W=>{W.isCancellationRequested||(o++,s.readEntry())};s.once("error",P),s.once("close",()=>n.then(()=>{t.isCancellationRequested||s.entryCount===o?y():P(new C("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},P)),s.readEntry(),s.on("entry",W=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(W.fileName)){k(t);return}const _=W.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(_)){const ie=w.join(e,_);n=(0,I.createCancelablePromise)(ae=>T.Promises.mkdir(ie,{recursive:!0}).then(()=>k(ae)).then(void 0,P));return}const q=S(s,W),Y=E(W);n=(0,I.createCancelablePromise)(ie=>b.queue(()=>q.then(ae=>v(ae,_,Y,e,r,ie).then(()=>k(ie)))).then(null,P))})})}function m(s,e=!1){return new Promise((r,t)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?t(h(n)):r((0,R.assertIsDefined)(o))})})}function S(s,e){return new Promise((r,t)=>{s.openReadStream(e,(n,o)=>{n?t(h(n)):r((0,R.assertIsDefined)(o))})})}function l(s,e){return new Promise((r,t)=>{const n=new d.ZipFile;e.forEach(y=>{y.contents?n.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&n.addFile(y.localPath,y.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(s))})}i.zip=l;function u(s,e,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=m(s,!0);return r.overwrite&&(o=o.then(y=>T.Promises.rm(e).then(()=>y))),o.then(y=>f(y,e,{sourcePathRegex:n},t))}i.extract=u;function g(s,e){return m(s).then(r=>new Promise((t,n)=>{r.on("entry",o=>{o.fileName===e&&S(r,o).then(y=>t(y),y=>n(y))}),r.once("close",()=>n(new Error(p.localize(2,null,e))))}))}function a(s,e){return g(s,e).then(r=>new Promise((t,n)=>{const o=[];r.once("error",n),r.on("data",y=>o.push(y)),r.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=a}),define(Q[146],Z([0,1,67,88]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function w(R){return(0,D.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=w}),define(Q[147],Z([0,1,3,31,12,2,16,14,13,17,39,5,10,30,20,67,87,58,18,139,22,23,41,48,122,140,146,123,136,34,45,11,8,9,28,35,29,25]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u,g,a,s,e,r,t,n,o,y,P,b,k,W,_,q,Y,ie,ae,ne){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(a.IServerExtensionManagementService);let ge=class extends g.AbstractExtensionManagementService{constructor(A,U,O,L,M,j,G,K,oe,le,pe,ve){super(A,U,O,le,ve),this.extensionsScannerService=M,this.extensionsProfileScannerService=j,this.downloadService=G,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const te=this._register(K.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(ue,he=>te.postUninstall(he))),this.manifestCache=this._register(new y.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(K.createInstance(t.ExtensionsDownloader));const re=this._register(new P.ExtensionsWatcher(this,oe,L,O,pe));this._register(re.onDidChangeExtensionsByAnotherSource(({added:he,removed:de})=>{he.length&&this._onDidInstallExtensions.fire(he.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),de.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),O=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,U);return h.URI.file(O)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:O}=await this.downloadVsix(A),L=p.resolve(U.fsPath);try{return await(0,o.getManifest)(L)}finally{await O()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:O,cleanup:L}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(p.resolve(O.fsPath));if(M.engines&&M.engines.vscode&&!(0,k.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(S.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,O,U)}finally{await L()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const O={...U};return U.isPreReleaseVersion&&(O.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,O),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===T.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(L){this.logService.error(L)}}}}doCreateInstallExtensionTask(A,U,O){let L;if(h.URI.isUri(U))L=new N(A,U,O,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();L=this.installGalleryExtensionsTasks.get(M),L||(this.installGalleryExtensionsTasks.set(M,L=new V(A,U,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),L.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return O.profileLocation?new F(L,O.profileLocation,this.extensionsProfileScannerService):L}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new z(A,U,this.extensionsScanner)}async collectFiles(A){const U=async L=>{let M=await f.Promises.readdir(L);M=M.map(K=>p.join(L,K));const j=await Promise.all(M.map(K=>f.Promises.stat(K)));let G=Promise.resolve([]);return j.forEach((K,oe)=>{const le=M[oe];K.isFile()&&(G=G.then(pe=>[...pe,le])),K.isDirectory()&&(G=G.then(pe=>U(le).then(ve=>[...pe,...ve])))}),G};return(await U(A.location.fsPath)).map(L=>({path:`extension/${p.relative(A.location.fsPath,L)}`,localPath:L}))}};ge=fe([ee(0,a.IExtensionGalleryService),ee(1,ie.ITelemetryService),ee(2,q.ILogService),ee(3,u.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,l.IDownloadService),ee(7,_.IInstantiationService),ee(8,W.IFileService),ee(9,Y.IProductService),ee(10,ae.IUriIdentityService),ee(11,ne.IUserDataProfilesService)],ge),i.ExtensionManagementService=ge;let ue=class extends R.Disposable{constructor(A,U,O,L){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=O,this.logService=L,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const O={includeInvalid:!0,profileLocation:U};let L=[];return A===null||A===0?L.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):A===1&&L.push(...await this.extensionsScannerService.scanUserExtensions(O)),L=A!==null?L.filter(M=>M.type===A):L,Promise.all(L.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(O=>this.toLocalExtension(O)))}async extractUserExtension(A,U,O,L){const M=A.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),G=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await f.Promises.rm(G)}catch{throw new a.ExtensionManagementError(S.localize(1,null,G,A.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,j,L),O={...O,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(h.URI.file(j),O);try{await this.rename(A,j,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(K){try{await f.Promises.rm(j)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(K)}. Deleted from extracted location`,j),K}return this.scanLocalExtension(h.URI.file(G),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(O=>s.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{U.forEach(L=>O[L.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(L=>delete L[A.toString()]);const O=(await this.scanUserExtensions(!0)).find(L=>s.ExtensionKey.create(L).equals(A))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await f.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(L){if(L.code!=="ENOENT")throw L}let O={};if(U)try{O=JSON.parse(U)}catch{}return A&&(A(O),Object.keys(O).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await f.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(A,U,O,L){this.logService.trace(`Started extracting the extension from ${U} to ${O}`);try{await f.Promises.rm(O)}catch(M){throw new a.ExtensionManagementError(this.joinErrors(M).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(U,O,{sourcePath:"extension",overwrite:!0},L),this.logService.info(`Extracted extension to ${O}:`,A.id)}catch(M){try{await f.Promises.rm(O)}catch{}let j=a.ExtensionManagementErrorCode.Extract;throw M instanceof m.ExtractError&&(M.type==="CorruptZip"?j=a.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(j=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(M.message,j)}}async rename(A,U,O,L){try{await f.Promises.rename(U,O)}catch(M){if(c.isWindows&&M&&M.code==="EPERM"&&Date.now()<L)return this.logService.info(`Failed renaming ${U} to ${O} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,O,L);throw new a.ExtensionManagementError(M.message||S.localize(2,null,U,O),M.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const O=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(S.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let O,L;return U.children&&(O=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,L=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:O,changelogUrl:L,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const j of U)A[s.ExtensionKey.create(j).toString()]||O.add(j.identifier.id.toLowerCase());const L=(0,s.groupByExtension)(U,j=>j.identifier);await D.Promises.settled(L.map(async j=>{const G=j.sort((K,oe)=>C.rcompare(K.manifest.version,oe.manifest.version))[0];O.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}));const M=U.filter(j=>A[s.ExtensionKey.create(j).toString()]);await D.Promises.settled(M.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],L=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,j=>j.identifier);for(const j of M)if(j.length>1&&O.push(...j.sort((G,K)=>{const oe=C.rcompare(G.manifest.version,K.manifest.version);return oe!==0?oe:G.targetPlatform===L?-1:1}).slice(1)),j[0].type===0){const G=A.find(K=>(0,s.areSameExtensions)(K.identifier,j[0].identifier));(!G||C.gte(G.manifest.version,j[0].manifest.version))&&O.push(j[0])}await D.Promises.settled(O.map(j=>this.removeExtension(j,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((O,L)=>new Error(`${O.message}${O.message?",":""}${L instanceof Error?L.message:L}`),new Error(""))}};ue=fe([ee(1,W.IFileService),ee(2,r.IExtensionsScannerService),ee(3,q.ILogService)],ue);class se extends g.AbstractExtensionTask{constructor(A,U,O,L,M){super(),this.identifier=A,this.source=U,this.options=O,this.extensionsScanner=L,this.logService=M,this._operation=2}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(A,U){try{const O=await this.unsetUninstalledAndGetLocal(A.key);if(O)return A.metadata?this.extensionsScanner.updateMetadata(O,A.metadata):O}catch{throw c.isMacintosh?new a.ExtensionManagementError(S.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(S.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const O=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),O}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:O},L){const M=await this.extensionsScanner.extractUserExtension(U,A,O,L);return this.logService.info("Extracting completed.",U.id),M}}class V extends se{constructor(A,U,O,L,M,j){super(U.identifier,U,O,M,j),this.manifest=A,this.gallery=U,this.extensionsDownloader=L}async doRun(A){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));O&&(this._operation=3);const L={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,b.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,L),metadata:L};const M=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:L},A);return O&&!this.options.profileLocation&&(O.targetPlatform!==j.targetPlatform||C.neq(O.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:j,metadata:L}}catch(j){throw await this.deleteDownloadedVSIX(M),j}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(h.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,w.getErrorMessage)(U))}}async downloadExtension(A,U){let O;try{this.logService.trace("Started downloading extension:",A.identifier.id),O=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,O)}catch(L){throw new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(O),O}catch(L){throw await this.deleteDownloadedVSIX(O),new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Invalid)}}}class N extends se{constructor(A,U,O,L,M,j){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,O,M,j),this.manifest=A,this.location=U,this.galleryService=L}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),L=(await this.extensionsScanner.scanExtensions(1,void 0)).find(G=>(0,s.areSameExtensions)(this.identifier,G.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,b.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||L?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||L?.isBuiltin,L)if(this._operation=3,U.equals(new s.ExtensionKey(L.identifier,L.manifest.version)))try{await this.extensionsScanner.removeExtension(L,"existing")}catch{throw new Error(S.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(L.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(L);else{const G=await this.unsetUninstalledAndGetLocal(U);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(S.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,O){try{let[L]=await this.galleryService.getExtensions([{id:A,version:U}],O);if(L||([L]=await this.galleryService.getExtensions([{id:A}],O)),L)return{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,O){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends g.AbstractExtensionTask{constructor(A,U,O){super(),this.extension=A,this.options=U,this.extensionsScanner=O}async doRun(A){const U=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const L=s.ExtensionKey.create(this.extension);U.push(...O.filter(M=>L.equals(s.ExtensionKey.create(M))))}else U.push(...O.filter(L=>(0,s.areSameExtensions)(L.identifier,this.extension.identifier)));if(!U.length)throw new Error(S.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const L of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(L)}catch(M){throw new Error(S.localize(9,null,(0,I.toErrorMessage)(M)))}}}class $ extends g.AbstractExtensionTask{constructor(A,U,O){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=O}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,12,2,5,21,18,128,9,126,160]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let f=class extends T.Disposable{constructor(S,l,u){super(),this.environmentService=l,this.logService=u,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,l){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:u,strictSSL:g}=this;let a;try{a=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...a},e=S.agent?S.agent:await(0,h.getProxyAgent)(S.url||"",s,{proxyUrl:u,strictSSL:g});S.agent=e,S.strictSSL=g,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(S,l);return this.logService.trace("RequestService#request (node) - success",S.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",S.url,r),r}}async getNodeRequest(S){return((0,D.parse)(S.url).protocol==="https:"?await new Promise((g,a)=>{B(["https"],g,a)}):await new Promise((g,a)=>{B(["http"],g,a)})).request}_request(S,l){return I.Promises.withAsyncBody(async(u,g)=>{const a=(0,D.parse)(S.url),s=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),e={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,p.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(e.auth=S.user+":"+S.password);const r=s(e,t=>{const n=(0,p.isNumber)(S.followRedirects)?S.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)this._request({...S,url:t.headers.location,followRedirects:n-1},l).then(u,g);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,v.createGunzip)())),u({res:t,stream:(0,w.streamToBufferReadableStream)(o)})}});r.on("error",g),S.timeout&&r.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&r.write(S.data),r.end(),l.onCancellationRequested(()=>{r.abort(),g(new R.CancellationError)})})}async resolveProxy(S){}};f=fe([ee(0,c.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,E.ILogService)],f),i.RequestService=f}),define(Q[161],Z([0,1,38,3,15,31,12,2,16,14,13,32,10,20,21,119,58,125,18,101,143,22,121,41,48,147,141,11,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,i,D,I,w,R,T,p,c,d,C,E,h,v,f,m,S,l,u,g,a,s,e,r,t,n,o,y,P,b,k,W,_,q,Y,ie,ae,ne,ge,ue,se,V,N,F,z,$,J,A,U,O,L,M,j,G,K,oe){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class le extends p.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,re]=await this.initServices();return te.invokeFunction(async he=>{const de=he.get(ie.ILogService),Se=he.get(y.IFileService),Le=he.get(u.INativeEnvironmentService),Fe=he.get(s.IExtensionManagementCLIService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(Le,Fe,Se),await Promise.all(re.map(Ue=>{(0,I.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,re={_serviceBrand:void 0,...se.default};te.set(V.IProductService,re);const he=new g.NativeEnvironmentService(this.argv,re);te.set(u.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ie.getLogLevel)(he),Se=[];Se.push(new ae.SpdLogLogger("cli",(0,d.join)(he.logsPath,"cli.log"),!0,!1,de)),de===ie.LogLevel.Trace&&Se.push(new ie.ConsoleLogger(de));const Le=this._register(new ie.MultiplexLogService(Se));te.set(ie.ILogService,Le);const Fe=this._register(new P.FileService(Le));te.set(y.IFileService,Fe);const Ue=this._register(new b.DiskFileSystemProvider(Le));Fe.registerProvider(c.Schemas.file,Ue);const xe=new $.StateService(he,Le,Fe);te.set(z.IStateService,xe);const x=new G.UriIdentityService(Fe);te.set(j.IUriIdentityService,x);const H=new oe.UserDataProfilesService(xe,x,he,Fe,Le);te.set(K.IUserDataProfilesService,H);const X=C.isWindows&&re.win32RegValueName?this._register(new ue.NativePolicyService(re.win32RegValueName)):he.policyFile?this._register(new ne.FilePolicyService(he.policyFile,Fe,Le)):new ge.NullPolicyService;te.set(ge.IPolicyService,X);const ce=this._register(new m.ConfigurationService(H.defaultProfile.settingsResource,Fe,X,Le));te.set(f.IConfigurationService,ce),await Promise.all([xe.init(),ce.initialize()]),H.setEnablement(re.quality!=="stable"||ce.getValue(K.PROFILES_ENABLEMENT_CONFIG)),te.set(j.IUriIdentityService,new G.UriIdentityService(Fe)),te.set(N.IRequestService,new k.SyncDescriptor(F.RequestService)),te.set(S.IDownloadService,new k.SyncDescriptor(l.DownloadService)),te.set(r.IExtensionsProfileScannerService,new k.SyncDescriptor(r.ExtensionsProfileScannerService)),te.set(t.IExtensionsScannerService,new k.SyncDescriptor(o.ExtensionsScannerService)),te.set(n.INativeServerExtensionManagementService,new k.SyncDescriptor(n.ExtensionManagementService)),te.set(s.IExtensionGalleryService,new k.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),te.set(s.IExtensionManagementCLIService,new k.SyncDescriptor(e.ExtensionManagementCLIService)),te.set(q.ILanguagePackService,new k.SyncDescriptor(Y.NativeLanguagePackService));const me=[],Ce=(0,O.isInternalTelemetry)(re,ce);if((0,O.supportsTelemetry)(re,he)){re.aiConfig&&re.aiConfig.ariaKey&&me.push(new L.OneDataSystemAppender(Ce,"monacoworkbench",null,re.aiConfig.ariaKey));const{installSourcePath:we}=he,Te={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await v.Promises.readFile(he.stateResource.fsPath);be=JSON.parse(De.toString())[A.machineIdKey]}catch(De){De.code!=="ENOENT"&&Le.error(De)}return(0,J.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,re.commit,re.version,be,Ce,we)})(),piiPaths:(0,O.getPiiPathsFromEnvironment)(he)};te.set(A.ITelemetryService,new k.SyncDescriptor(U.TelemetryService,[Te]))}else te.set(A.ITelemetryService,O.NullTelemetryService);return[new W.InstantiationService(te),me]}registerErrorHandler(te){(0,T.setUnexpectedErrorHandler)(re=>{const he=(0,R.toErrorMessage)(re,!0);!he||te.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",re=>(0,T.onUnexpectedError)(re)),process.on("unhandledRejection",re=>(0,T.onUnexpectedError)(re))}async doRun(te,re,he){if(this.argv["install-source"])return this.setInstallSource(te,he,this.argv["install-source"]);if(this.argv["list-extensions"])return re.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const de={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return re.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],de,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return re.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return re.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(re=>/\.vsix$/i.test(re)?h.URI.file((0,d.isAbsolute)(re)?re:(0,d.join)((0,E.cwd)(),re)):re)}async setInstallSource(te,re,he){await re.writeFile(h.URI.file(te.installSourcePath),w.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const te=new le(ve);try{await te.run()}finally{te.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b7c86dcc30ef2e94d7f679586bb65d37c87d0876/core/vs/code/node/cliProcessMain.js.map
